max v2;
#N vpatcher 311 216 803 723;
#P comment 13 161 441 1 Qlist (version 0.02) \, by Miller Puckette \, outputs and executes sequences of events found in its queue. Qlist accepts three messages: 'next' and 'rewind'. Qlist outputs integers and floating-point numbers as a list. Qlist recognizes the semicolon as a separator between lists of numbers. Variable names can also be included in qlist \, and qlist sends values associated with a variable \, that is to say \, any values following a variable name and succeeded by a semicolon \, to corresponding receives.;
#P comment 133 351 191 1 open these patchers to continue:;
#N vpatcher 269 296 743 587;
#P comment 18 187 443 1 In example 2 \, variables are used. Their corresponding receives print their values in the MAX window. The lists of numbers not associated with a variable are also printed as in the first example. (Note that qlist itelf does not output the values associated with a variable \, but that the corresponding receive is connected to a print object which prints the values.);
#P message 61 62 50 1 rewind;
#P message 16 62 41 1 next;
#P newex 123 110 67 1 print qlist2;
#N qlist qlist;
#X append 0 1 2 \; variable1 200 300 400 500 \; 0 2 1 \; var33 9999 \; 1;
#X append \; variable1 3.14159 \; var1 1 2 3 4 5 6 7 8 9 \; 3 0 42.900002;
#X append \; var1 sends text also \; 300 777 3.14159 0.1 999 0.999 27 \;;
#P newobj 123 81 40 1 qlist;
#P newex 312 45 60 1 r var33;
#P newex 210 42 87 1 r variable1;
#P newex 210 75 88 1 print variable1;
#P newex 312 77 81 1 print var33;
#P comment 121 134 106 4 EXAMPLE 2;
#P connect 5 0 6 0;
#P connect 4 0 1 0;
#P connect 8 0 5 0;
#P connect 7 0 5 0;
#P connect 3 0 2 0;
#P pop;
#P newobj 158 373 120 1 patcher EXAMPLE2;
#P comment 384 356 75 1 this help window is adapted from one for the Macintosh by Cort Lippe;
#P comment 14 254 441 1 Double-click on the qlist object box above and the qlist text subwindow will open. This text window can be edited \, but must be closed before any changes take effect. Note that a patch must be saved in order to save any changes made to the contents of its qlist. After clicking on 'rewind' \, advance through the qlist by clicking successively on 'next'. The values separated by a semicolon are output as lists and printed in the MAX window.;
#P message 114 83 53 1 rewind;
#P message 66 83 41 1 next;
#P comment 183 25 203 1 Arguments: none \; Inlet: 'next' and 'rewind' \, as messages Outlet: lists of ints and floats;
#P comment 13 26 56 6 qlist;
#N qlist qlist;
#X append 0 1 2 \; 0 2 1 \; 1 \; 3 0 42.900002 \; 300 777 3.14159 0.1;
#X append 999 0.999 27 \;;
#P newobj 184 100 41 1 qlist;
#P newex 184 127 78 1 print qlist1;
#P comment 227 102 121 1 << double-click here;
#P comment 72 126 108 4 EXAMPLE 1;
#N vpatcher 268 45 743 733;
#P comment 22 424 443 1 Note also that you can click through the events at any speed you like. If you advance to a succeeding event before all the timed delays have been triggered in the present event \, the delay times will automatically be set to zero and the variable sends will be done immediately. In this way \, variable 'state' is always kept up to date. For instance: in event 2 there is a time delay of 2 seconds before var2 will be sent the value 20. If event 3 is triggered after event 2 \, but BEFORE 2 seconds have elapsed \, var2 will immediately be sent the value of 20 with a delay time of zero \, ignoring the original delay time of 2 seconds. Note the extra dummy event at the end of qlist. The patcher 'qlist_control' expects an extra event in order to stop looping at the end of the events. The last "real" event in this example is event number 10. Event number 11 is a dummy event. The dashed lines: (-----------------------) with the event number following \, simply act as visual separators for events in the queue.;
#P comment 151 33 319 1 0 = 'next' message advances and executes (See Nota Bene);
#P comment 150 56 275 1 1 = 'next' message advances but does not executes;
#P comment 20 250 443 1 A final example shows one possible MAX interface to qlist for sending variable values to corresponding receives and for separating groups of variables and their values into successive events. This example also allows for time-delayed variable sends within an event. The syntax created via the patcher 'qlist_control' is the following: in the qlist object connected to 'qlist_control' \, if there are two numbers at the beginning of a line which are not related to a variable send \, they represent a delay time in milliseconds and an event number. A single number at the beginning of a line \, before any variable send on the same line \, represents a delay time in milliseconds. Thus \, event 2 starts at time 0 with a send of the value 7500 to var1. After a delay of 2000 milliseconds \, var2 is sent the value 20. Click successively from event 0 \, which rewinds the qlist \, through event 10 and compare the values in the MAX print window with the values in the qlist. Note that events 2 \, 5 \, and 9 all have time-delayed sends after time zero.;
#P comment 158 81 289 1 click on event numbers (zero does a rewind of qlist);
#P message 369 103 24 1 8;
#P message 343 103 24 1 7;
#P message 316 103 25 1 6;
#P message 290 103 24 1 5;
#P message 262 103 25 1 4;
#P message 236 103 24 1 3;
#P message 210 103 24 1 2;
#P message 183 103 24 1 1;
#P message 157 103 24 1 0;
#P message 396 103 24 1 9;
#P message 423 103 31 1 10;
#N qlist qlist;
#X append ------------------------ 1 \; 0 1 var1 0 \; var2 10 \; ------------------------ 2 \; 0 2 var1 7500;
#X append \; 2000 var2 20 \; ------------------------ 3 \; 0 3 var1 6400 \; ------------------------ 4 \; 0 4;
#X append var2 8600 \; ------------------------ 5 \; 0 5 var2 7100 \; 1000 var1 1 \; ------------------------ 6 \;;
#X append 0 6 var1 8400 \; ------------------------ 7 \; 0 7 var2 6800 \; ------------------------ 8 \; 0 8;
#X append var1 9100 \; ------------------------ 9 \; 0 9 var1 7300 \; 2500 var2 100 \; ------------------------ 10 \;;
#X append 0 10 var1 7200 \; var2 3 \; ------------------------ 11 \; 0 11 \;;
#P newobj 8 151 42 1 qlist;
#N vpatcher 211 20 751 560;
#P newex 110 245 121 1 t b i b;
#P newex 110 221 93 1 split 0 100000;
#P newex 110 198 128 1 -;
#P newex 165 273 51 1 split 1 100000;
#P message 46 157 38 1 stop;
#P newex 46 81 75 1 sel 0;
#P newex 138 101 99 1 t b b;
#P message 138 133 78 1 rewind \, next;
#P comment 354 66 71 1 events inlet;
#P inlet 331 65 15;
#P message 165 367 21 1 0;
#P message 220 314 47 1 next \$1;
#P newex 220 283 43 1 i 0;
#P comment 50 413 74 1 gets time delays from the qlist;
#P inlet 236 343 15;
#P newex 236 365 114 1 unpack;
#P comment 366 314 126 1 outlet for 'rewind' and 'next' messages which are sent to the qlist;
#P comment 262 171 217 1 If negative \, do nothing. If zero \, send a 'next' to the qlist and 'bang' the delay object. If positive \, send a 'next' to the qlist \, a delay time of zero to the delay object \, and 'bang' the delay object.;
#P comment 291 262 224 1 executable or nonexecutable 'next' inlet;
#P comment 194 502 257 1 dummy variable which should not be removed!;
#P newex 18 499 172 1 r ------------------------;
#P comment 136 392 164 1 separate the time delays and event numbers being output from the qlist and send time delays to the delay object;
#P comment 304 392 139 1 send the present event number for comparison with any incoming event numbers;
#P comment 257 105 172 1 if the event number is 0 \, initalize by sending a 'rewind' and 'next' message to qlist;
#P message 227 128 24 1 0;
#P newex 46 385 34 1 del;
#P inlet 253 261 15;
#P outlet 343 332 15;
#P connect 13 0 12 0;
#P connect 1 0 15 1;
#P connect 26 0 27 0;
#P connect 25 0 26 0;
#P connect 24 0 17 0;
#P connect 22 0 23 0;
#P connect 22 1 25 0;
#P connect 22 0 21 0;
#P connect 21 1 3 0;
#P connect 21 0 20 0;
#P connect 15 0 16 0;
#P connect 12 0 2 1;
#P connect 2 0 25 0;
#P connect 12 1 25 1;
#P connect 27 0 2 0;
#P connect 27 1 24 0;
#P connect 27 2 15 0;
#P connect 23 0 2 0;
#P connect 18 0 22 0;
#P connect 20 0 0 0;
#P connect 3 0 25 1;
#P connect 17 0 2 1;
#P connect 16 0 0 0;
#P pop;
#P newobj 27 121 121 1 patcher qlist_control;
#P comment 19 212 104 4 EXAMPLE 3;
#P newex 286 150 64 1 r var2;
#P newex 183 148 64 1 r var1;
#P newex 183 181 65 1 print var1;
#P newex 286 182 64 1 print var2;
#P message 120 33 24 1 0;
#P message 121 56 25 1 1;
#P comment 25 583 443 1 Nota Bene: The next message can act as a "goto" in two ways. The first way is to send 'next' or 'next 0' to qlist \, and qlist will execute everything in its queue up through the event clicked upon \, thereby keeping state. 'Next' can also be used to jump or 'goto' an event without executing the events preceding the designated event. To use 'next' in a non-executable fashion \, send 'next' followed by any nonzero number \, e.g. 'next 1' \, and qlist will not send values to the corresponding receives.;
#P connect 2 0 8 1;
#P connect 1 0 8 1;
#P connect 20 0 8 2;
#P connect 19 0 8 2;
#P connect 18 0 8 2;
#P connect 17 0 8 2;
#P connect 16 0 8 2;
#P connect 15 0 8 2;
#P connect 8 0 9 0;
#P connect 6 0 3 0;
#P connect 5 0 4 0;
#P connect 14 0 8 2;
#P connect 13 0 8 2;
#P connect 12 0 8 2;
#P connect 9 0 8 0;
#P connect 11 0 8 2;
#P connect 10 0 8 2;
#P pop;
#P newobj 158 398 120 1 patcher EXAMPLE3;
#N vpatcher 130 245 692 680;
#N qlist qlist;
#P newobj 167 112 42 1 qlist;
#P comment 26 219 104 4 EXAMPLE 4;
#P message 179 57 79 2 append baz;
#P message 101 61 33 2 set;
#P message 9 61 59 2 set foo 1;
#P comment 6 24 57 2 set contents;
#P comment 92 11 57 2 set with no args clears it;
#P comment 178 32 81 2 add to end;
#P message 269 57 145 2 append 1 walk the cat \\\;;
#P message 474 60 50 2 flush;
#P comment 268 14 156 2 To put in a semi or comma you must backslash it:;
#P comment 453 8 103 2 Finally \, "flush" if you want to see what's inside;
#P comment 27 257 443 1 Qlist was modified in 0.23 to be able to record and recall a sequence of Max messages. If you want to use this in real time \, it would be best to keep the qlists short since the memory allocation scheme isn't optimized for adding to big ones. (This will get improved later...);
#P comment 27 316 443 1 This is the only easy way to play a chord on a keyboard and get it in text form \, for instance.;
#P connect 11 0 13 0;
#P connect 9 0 13 0;
#P connect 5 0 13 0;
#P connect 4 0 13 0;
#P connect 10 0 13 0;
#P pop;
#P newobj 157 423 120 1 patcher EXAMPLE4;
#P comment 282 476 189 2 last modified for version 0.23.;
#P connect 10 0 6 0;
#P connect 9 0 6 0;
#P connect 6 0 5 0;
#P pop;
