max v2 uselib=1;
#N vpatcher 90 30 1031 779;
#P comment 13 364 309 2 Creates a parameter bank of 44 columns by 100 rows;
#P comment 8 29 86 3 Arugments:;
#P comment 456 79 216 1 note: Do not forget that the this outlet is only used by pbank if argument 4 undefined (omitted) -see arguments;
#P comment 1 1 65 5 pbank;
#P comment 411 28 56 3 Outlets;
#P comment 425 117 86 3 Messages;
#P comment 422 46 256 2 The left-hand outlet outputs lists of the form: columnNo <int> item <int \, float or symbol>;
#P newex 550 556 179 5 pbank 3 5 "" wireless;
#P number 639 633 59 5;
#P flonum 555 635 75 5;
#P comment 28 49 387 2 argument1 gives the number of columns (X axis): <int> \; argument2 gives the number of rows (Y axis): <int> \; argument3 is the name of the pbank: <symbol>;
#P comment 63 5 388 3 --2 dimensional parameter bank for ints \, floats or symbols;
#P comment 15 423 311 2 Creates a parameter bank of 44 columns by 100 rows \, reading in the contents of the file name \, and sharing data with any other pbanks with the same name;
#P comment 16 516 322 2 Creates a named pbank whose output is sent to receives based on the symbol "mysynth". Since there are 44 columns \, pbank will be sending its output to 44 receives each one corresponding to the column number included in its name. This provides an alterative (and faster) way of getting data from a pbank.;
#P comment 15 648 311 2 Creates an unnamed parameter bank of 44 columns by 100 rows \, whose output will be sent to the 44 corresponding receives based on the symbol "mysynth". Note that the argument3 has been set to the empty string: "".;
#P newex 17 621 221 5 pbank 44 100 "" mysynth;
#P newex 554 602 77 2 r 0-wireless;
#P newex 638 602 77 2 r 1-wireless;
#P newex 723 603 77 2 r 2-wireless;
#P newex 551 520 63 1 r toPbanks;
#P comment 803 600 80 1 (first receive to be updated);
#P message 454 142 106 5 0 1 1.234;
#P message 465 179 50 5 0 1;
#P comment 563 138 108 2 write 1.234 to colum 0 of row 1;
#P comment 520 176 108 2 read value at colum 0 of row 0;
#P message 478 209 106 5 2 0 coptox;
#P comment 593 207 206 2 write symbol "coptox" in colum 2 of row 0;
#P message 490 241 50 5 2 0;
#P comment 542 238 108 2 read value at colum 0 of row 0;
#P comment 752 269 164 2 set list of elements starting at colum 1 in row 2;
#P message 502 272 245 5 set 1 2 100 3.14159 shupsh;
#P message 534 395 72 5 store 1;
#P comment 777 328 164 2 puts list of elements starting at colum 0 in edit buffer;
#P comment 628 398 146 2 copy editbuffer to row 2;
#P comment 631 369 229 2 output row 2 (and copy it to editbuffer);
#P message 532 364 74 5 recall 1;
#P message 529 332 245 5 put 0 100 3.14159 shupsh;
#P comment 503 311 206 2 edit buffer manipulation:;
#P comment 531 431 77 2 file writing:;
#P comment 553 672 314 2 note: output order for receives is n-name \, (n-1)-name \, (n-2)-name .... 0-name;
#P message 723 626 41 1 set \$1;
#P message 723 647 72 5 coptox;
#P newex 20 334 130 5 pbank 44 100;
#P comment 20 280 408 2 note: The structure of pbank includes an additional row that serves as an edit buffer. - see Messages;
#P newex 19 489 270 5 pbank 44 100 pbdata mysynth;
#P newex 19 396 215 5 pbank 44 100 pbdata;
#N vpatcher 139 178 922 775;
#P comment 5 -3 65 5 pbank;
#P comment 93 -3 290 3 Using pbank in a synth/editor configuration;
#P comment 9 20 404 2 Pbank may be used as a component in a DSP configuration for managing parameters. The example below demonstrates an approach:;
#P message 5 64 50 1 \; max dsp 1;
#P message 6 111 50 1 \; max dsp 0;
#P number 203 256 58 5;
#P button 266 213;
#P message 266 175 50 5 store;
#P newex 226 227 28 1 0;
#P comment 86 126 122 4 select memory:;
#P comment 172 288 126 4 current memory:;
#P newex 60 293 83 1 s toSynthPbank;
#P message 114 269 50 1 store \$1;
#P message 60 268 50 1 recall \$1;
#P button 123 211;
#P message 122 168 58 5 recall;
#P newex 159 228 64 1 0;
#P message 348 62 20 1 9;
#P message 326 62 20 1 8;
#P message 303 62 20 1 7;
#P message 281 62 20 1 6;
#P message 143 62 20 1 0;
#P message 165 62 20 1 1;
#P message 188 62 20 1 2;
#P message 210 62 20 1 3;
#P message 233 62 20 1 4;
#P message 257 61 20 1 5;
#P comment 74 62 66 2 memorys:;
#P number 213 128 28 3;
#P newex 16 331 83 1 r toSynthPbank;
#P newex 16 353 191 5 pbank 4 12 pbankhelp.data synth;
#P newex 222 386 83 1 s toSynthPbank;
#N vpatcher 350 265 750 665;
#P outlet 149 267 15;
#P message 166 233 50 1 write \$1;
#P message 112 233 50 1 read \$1;
#P inlet 80 38 15;
#P newex 80 74 112 1 route open save;
#P newex 88 158 58 1 openpanel;
#P newex 172 160 58 1 savepanel;
#P connect 5 0 6 0;
#P connect 4 0 6 0;
#P connect 0 0 5 0;
#P connect 1 0 4 0;
#P connect 2 1 0 0;
#P connect 3 0 2 0;
#P connect 2 0 1 0;
#P pop;
#P newobj 222 362 79 1 patcher fileIO;
#P message 280 317 52 5 save;
#P message 222 318 52 5 open;
#P comment 7 411 291 2 pbank sends parameters to receives based on the symbol "synth" (optional 4th argument to pbank);
#P newex 16 504 190 5 pbank 4 12 pbankhelp.data name;
#P message 16 484 101 0 0 \$1 \, 1 \$1 \, 2 \$1 \, 3 \$1;
#P message 192 457 33 5 11;
#P message 143 456 33 5 10;
#P comment 12 461 127 2 set parameter lables:;
#P newex 706 480 50 1 r 3-synth;
#P newex 702 456 50 1 r 2-synth;
#P newex 699 430 50 1 r 1-synth;
#P newex 692 406 50 1 r 0-synth;
#P message 431 452 50 1 put 1 \$1;
#P message 472 520 47 1 put 3 \$1;
#P message 452 487 50 1 put 2 \$1;
#P message 408 419 50 1 put 0 \$1;
#N vpatcher 83 73 483 473;
#P newex 288 65 29 1 f;
#P newex 329 37 29 1 t b f;
#P newex 265 222 52 1 +~;
#P flonum 359 101 43 1;
#P newex 359 155 50 1 sig~;
#P newex 266 127 31 1 sig~;
#P newex 307 187 61 1 *~;
#P newex 307 98 29 1 * 1.;
#P newex 306 127 31 1 sig~;
#P newex 307 156 44 1 osc1~;
#P slider 460 150 15 128;
#P inlet 465 107 15;
#P comment 475 130 43 1 volume;
#P comment 392 63 43 1 index;
#P flonum 327 77 35 1;
#P inlet 375 29 15;
#P inlet 329 15 15;
#P inlet 260 7 15;
#P comment 326 7 73 1 modFQscaler;
#P comment 276 7 29 1 fq;
#P flonum 268 20 35 1;
#P newex 265 334 99 1 gain1~.abs;
#P newex 266 368 99 1 dac~;
#P newex 265 259 52 1 osc1~;
#P newex 422 315 50 1 * 0.65;
#P connect 23 0 24 0;
#P connect 24 0 17 0;
#P connect 4 0 24 0;
#P connect 23 1 10 0;
#P connect 8 0 23 0;
#P connect 13 0 14 0;
#P connect 9 0 21 0;
#P connect 7 0 4 0;
#P connect 16 0 15 0;
#P connect 17 0 16 0;
#P connect 15 0 18 0;
#P connect 19 0 22 0;
#P connect 18 0 22 1;
#P connect 3 0 2 0;
#P connect 3 0 2 1;
#P connect 21 0 20 0;
#P connect 20 0 18 1;
#P connect 22 0 1 0;
#P connect 1 0 3 0;
#P connect 4 0 19 0;
#P connect 10 0 17 1;
#P connect 14 0 0 0;
#P connect 0 0 3 1;
#P pop;
#P newobj 626 508 66 4 patcher SYNTH;
#P newex 408 544 83 1 s toSynthPbank;
#P comment 566 378 23 1 hz.;
#P message 698 179 58 1 Gain;
#P message 680 73 50 1 set \$1;
#P newex 681 49 50 1 r 3-synth;
#P newex 697 93 50 0 r 3-name;
#P message 697 116 50 0 set \$1;
#P message 609 180 53 1 FMindex;
#P message 519 179 72 1 ModulatorFQ;
#P message 422 178 64 1 CarrierFQ;
#P newex 520 110 50 0 r 1-name;
#P message 520 132 50 0 set \$1;
#P message 609 136 50 0 set \$1;
#P newex 609 113 50 0 r 2-name;
#P message 513 90 39 1 set \$1;
#P message 601 92 39 1 set \$1;
#P message 415 91 39 1 set \$1;
#P newex 421 112 50 0 r 0-name;
#P message 421 135 50 0 set \$1;
#P slider 689 200 46 128;
#P slider 601 204 23 128;
#P newex 512 338 62 1 scale 0 127 0 20.;
#P slider 512 201 23 128;
#P number 594 377 53 5;
#P flonum 505 375 61 5;
#P flonum 407 375 69 5;
#P newex 414 337 76 1 scale 0 127 50 15000;
#P slider 414 200 23 128;
#P flonum 681 374 61 5;
#P newex 601 341 62 1 scale 0 127 0 10000;
#P newex 602 -6 50 1 r 2-synth;
#P newex 515 -6 50 1 r 1-synth;
#P newex 415 -5 50 1 r 0-synth;
#P message 593 28 39 1 set \$1;
#P message 504 24 39 1 set \$1;
#P message 407 23 39 1 set \$1;
#P newex 601 56 74 1 scale 0 10000 0 127;
#P newex 415 55 74 1 scale 50 15000 0 127.;
#P newex 513 54 74 1 scale 0 20 0 127.;
#P comment 477 378 23 1 hz.;
#P comment 223 569 191 1 also see the MultiEffects.pat example;
#P connect 51 0 53 0;
#P connect 52 0 53 0;
#P connect 35 0 34 0;
#P connect 27 0 28 0;
#P connect 30 0 29 0;
#P connect 23 0 22 0;
#P connect 49 0 41 3;
#P connect 48 0 41 2;
#P connect 47 0 41 1;
#P connect 46 0 41 0;
#P connect 36 0 37 0;
#P connect 10 0 4 0;
#P connect 10 0 7 0;
#P connect 9 0 2 0;
#P connect 9 0 6 0;
#P connect 8 0 3 0;
#P connect 8 0 5 0;
#P connect 57 0 58 0;
#P connect 56 0 58 0;
#P connect 58 0 59 0;
#P connect 34 0 38 0;
#P connect 28 0 33 0;
#P connect 29 0 32 0;
#P connect 22 0 31 0;
#P connect 37 0 12 0;
#P connect 7 0 17 0;
#P connect 6 0 16 0;
#P connect 5 0 15 0;
#P connect 74 0 85 0;
#P connect 73 0 62 0;
#P connect 72 0 62 0;
#P connect 71 0 62 0;
#P connect 70 0 62 0;
#P connect 64 0 62 0;
#P connect 65 0 62 0;
#P connect 68 0 62 0;
#P connect 67 0 62 0;
#P connect 66 0 62 0;
#P connect 69 0 62 0;
#P connect 4 0 25 0;
#P connect 11 0 17 0;
#P connect 20 0 11 0;
#P connect 77 0 79 0;
#P connect 78 0 79 0;
#P connect 75 0 76 0;
#P connect 83 0 84 0;
#P connect 76 0 74 0;
#P connect 84 0 82 0;
#P connect 62 0 74 1;
#P connect 74 0 77 0;
#P connect 82 0 78 0;
#P connect 62 0 82 1;
#P connect 37 0 21 0;
#P connect 21 0 12 0;
#P connect 12 0 44 0;
#P connect 12 0 41 3;
#P connect 25 0 20 0;
#P connect 2 0 26 0;
#P connect 26 0 18 0;
#P connect 24 0 13 0;
#P connect 3 0 24 0;
#P connect 44 0 40 0;
#P connect 43 0 40 0;
#P connect 45 0 40 0;
#P connect 42 0 40 0;
#P connect 17 0 43 0;
#P connect 16 0 45 0;
#P connect 15 0 42 0;
#P connect 14 0 15 0;
#P connect 13 0 14 0;
#P connect 17 0 41 2;
#P connect 16 0 41 1;
#P connect 18 0 19 0;
#P connect 19 0 16 0;
#P connect 15 0 41 0;
#P connect 61 0 60 0;
#P connect 53 0 54 0;
#P pop;
#P newobj 357 357 85 5 patcher MORE;
#P comment 708 453 146 2 read pbank data file;
#P comment 711 487 146 2 write pbank data file;
#P message 759 516 158 5 read /tmp/shupsh;
#P message 759 547 159 5 write /tmp/shupsh;
#P message 545 450 158 5 read /tmp/killthis;
#P message 545 481 159 5 write /tmp/killthis;
#P comment 58 94 354 1 The arg3 (pbank 'name') is used by pbank in two ways: when a patch using a pbank is loaded \, a pbank data file corresponding to arg3 will be searched for and loaded if found. The 'name' also allows other pbanks with the same name to share data -in the way that tables do. If these two features are not wanted \, Arg3 (the 'name') can be set to the empty string: "" (two quotes) - see example below-;
#P comment 18 174 388 2 argument4 is the symbol that pbank uses when directing its output to receives based on this symbol: <optional symbol>;
#P comment 56 209 356 1 Arg4 is optional. If it is not specified \, Pbank's output will be sent out of its outlet. If arg4 is specified \, pbank's outlet will be inactive and output will be directed to a number of receive objects whose names are based on arg4 (receive symbol). For each column \, there is a corresponding receive whose name includes the column number -see example below.;
#P newex 350 700 100 1 declare uselib=1;
#P number 419 661 51 5;
#P flonum 353 662 63 5;
#P newex 366 558 102 5 pbank 3 5;
#P newex 445 508 61 1 s toPbanks;
#P newex 480 720 61 1 print;
#P newex 365 596 120 5 route 0 1;
#P message 475 631 59 1 set \$3;
#P message 476 658 78 5 coptox;
#P connect 42 0 4 0;
#P connect 43 0 4 0;
#P connect 34 0 4 0;
#P connect 33 0 4 0;
#P connect 13 0 4 0;
#P connect 12 0 4 0;
#P connect 29 0 4 0;
#P connect 39 0 4 0;
#P connect 37 0 4 0;
#P connect 28 0 4 0;
#P connect 45 0 57 0;
#P connect 45 0 5 0;
#P connect 48 0 55 0;
#P connect 47 0 56 0;
#P connect 46 0 24 0;
#P connect 24 0 23 0;
#P connect 1 0 0 0;
#P connect 2 2 1 0;
#P connect 5 0 2 0;
#P connect 2 1 7 0;
#P connect 2 0 6 0;
#P pop;
