/* sigrsqrt - reciprocal square root good to 8 mantissa bits  */


#include "m_extern.h"
#include "d_graph.h"
#include "d_ugen.h"
#include "math.h"

/* quick and dirty square root */

#define DUMTAB1SIZE 256
#define DUMTAB2SIZE 1024
static float dumbtab1[DUMTAB1SIZE], dumbtab2[DUMTAB2SIZE];

static void init_sqrt()
{
    int i;
    for (i = 0; i < DUMTAB1SIZE; i++)
    {
	float f;
	long l = (i ? (i == DUMTAB1SIZE-1 ? DUMTAB1SIZE-2 : i) : 1)<< 23;
	*(long *)(&f) = l;
	dumbtab1[i] = sqrt(f);	
    }
    for (i = 0; i < DUMTAB2SIZE; i++)
    {
	float f = 1 + (1./DUMTAB2SIZE) * i;
	dumbtab2[i] = sqrt(f);	
    }
}

typedef struct sigsqrt
{
	t_head x_h;
	t_sig *x_io[IN1+OUT1];
} t_sigsqrt;

#ifndef I860
void cu_sigsqrt(in, out, n)
 long n;
 float *in, *out;
{
    while (n--)
    {	
	float f = *in;
	long l = *(long *)(in++);
	if (f < 0) *out++ = 0;
	else *out++ =
	    (dumbtab1[(l >> 23) & 0xff] * dumbtab2[(l >> 13) & 0x3ff]);
    }
}
#else 
void cu_sigsqrt();
#endif

void sigsqrt_put(x, whether)
 t_sigsqrt *x;
 long whether;
{
	if (whether)
	{
		u_stdout(x);
		dspchain_addc(cu_sigsqrt, 3,
			x->x_io[0]->s_shit, x->x_io[1]->s_shit,	x->x_io[0]->s_n);
	}
}

t_externclass *sigsqrt_class;

void *sigsqrt_new()
{
	t_sigsqrt *x = (t_sigsqrt *)obj_new(&sigsqrt_class, 0);
	u_setup(x, IN1, OUT1);
	return (x);
}

sigsqrt_setup()
{
#ifndef I860
	post("sqrt -msp 5/92");
	init_sqrt();
#endif
	c_extern(&sigsqrt_class, sigsqrt_new, u_clean,
		gensym("sqrt~"), sizeof(t_sigsqrt), 0, 0);
	c_addmess(sigsqrt_put, gensym("put"), A_CANT, 0);
	u_inletmethod(0);
}

