/*
 *                      Copyright (c) 1996 UC REGENTS
 *      Derived from code Copyright 1993 IRCAM
 *                          All rights reserved.
 *
 * X/Motif implementation of the "wind" object for Max
 * Originally by Paul Foley.
 *
 */

#include <stdio.h>
#include <stdarg.h>

#define POSTBUFSIZE 1024
char *post_buf;
int post_nchars = 0, post_cache = 0;

void post_flush()
{
    /* same as NeXT */
#if 0
    if (post_nchars)
    {
        pdodisplay(post_buf);
        post_nchars = 0;
        post_buf[0] = 0;
    }
#endif
}

int post_setcache(int n)
{
    /* same as NeXT */
#if 0
    int was = post_cache;
    post_cache = n;
    if (!n)
        post_flush();
    return was;
#endif
}

void pwind_init(char *s)
{
}

void pdodisplay(char *s)
{
    fprintf(stderr, "%s\n", s);
}

static int post_amcopyingtostd = 0;
static int initted = 0;

void pdisplay(char *s)
{
    int n;
    if (post_amcopyingtostd)
        fprintf(stderr, "%s", s);
    else
        console_msg(s);         /* FTS messages on console */
#if 0
    if (!initted)
    {
        pwind_init(s);
        initted = 1;
    }
    else if (!post_cache)
        pdodisplay(s);
    else
    {
        int n = strlen(s);
        if (n > POSTBUFSIZE - 2)
        {
            post_flush();
            pdodisplay(s);
        }
        else
        {
            if (n + post_nchars > POSTBUFSIZE - 2)
                post_flush();
            strcat(post_buf + post_nchars, s);
            post_nchars += n;
        }
    }
#endif
}

void poststring(char *s)
{
    /* same as NeXT */
    pdisplay(s);
}

void post(char *fmt, ...)
{
    va_list args;
    char boo[BUFSIZ];

    sprintf(boo, "\n(h): ");
    va_start(args, fmt);
    vsprintf(boo + strlen(boo), fmt, args);
    va_end(args);

    poststring(boo);
}

void post_copytostd()
{
    /* same as NeXT */
    post_amcopyingtostd = 1;
}

/* end of nx_post.m */
/* ================ */
