#ifndef lint
static char rcsid[] =
    "$Revision: 2.2 $ IRCAM $Date: 1993/11/17 14:31:18 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.2 $ IRCAM $Date: 1993/11/17 14:31:18 $
 *
 * FTS by Miller Puckette
 *
 */


char *getbytes(int n);

typedef struct key {
    long k_a;
    void *k_b;
    struct key *k_next;
} t_key;

typedef struct alist {
    t_key **a_shit;
    int a_mask;
} t_alist;


void *alist_get(t_alist *x, long int a)
{
    t_key *k;
    for (k = x->a_shit[a & x->a_mask]; k; k = k->k_next)
        if (k->k_a == a)
            return (k->k_b);
    return (0);
}

void alist_put(t_alist *x, long int a, void *b)
{
    t_key *k, *k2, **kk = &x->a_shit[a & x->a_mask];
    t_key kstub;
    kstub.k_next = *kk;
    for (k = &kstub; k2 = k->k_next; k = k2)
        if (k2->k_a == a)
            error("%lx: duplicate entry in alist", a);
    k->k_next = k2 = (t_key *) getbytes(sizeof(t_key));
    k2->k_a = a;
    k2->k_b = b;
    k2->k_next = 0;
    *kk = kstub.k_next;
}

void alist_bag(t_alist *x, long int a)
{
    t_key *k, *k2, **kk = &x->a_shit[a & x->a_mask];
    t_key kstub;
    kstub.k_next = *kk;
    for (k = &kstub; k2 = k->k_next; k = k2)
        if (k2->k_a == a)
        {
            freebytes(k2, sizeof(t_key));
            k->k_next = k2->k_next;
            break;
        }
    *kk = kstub.k_next;
}

void alist_free(t_alist *x)
{
    t_key *k, **kk;
    int nitems = x->a_mask + 1;
    for (kk = x->a_shit; nitems--; kk++)
        for (k = *kk; k; k = k->k_next)
            freebytes(k, sizeof(t_key));
    DisposPtr(x->a_shit);
    freebytes(x, sizeof(t_alist));
}

void *alist_new(int bits)
{
    t_alist *x = (t_alist *) getbytes(sizeof(t_alist));
    int nitems = 1 << bits;
    t_key **k;
    if (!x)
        hate("can't get alist");
    if (!(x->a_shit = (t_key **) t_newptr(nitems * sizeof(t_key *))))
        hate("can't get alist space");
    x->a_mask = nitems - 1;
    for (k = x->a_shit; nitems--; k++)
        *k = (t_key *) 0;
    return (x);
}
