#ifndef lint
static char rcsid[] =
    "$Revision: 2.13 $ IRCAM $Date: 1994/05/10 10:49:25 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.13 $ IRCAM $Date: 1994/05/10 10:49:25 $
 */

#ifdef __alpha
#define AUDIOFILE /**/
/*#define MIDI          /**/
/*#define REALTIME        /**/
#endif
#ifdef __unix
#define SGI_NATIVE_AUDIO 1
#include <sys/lock.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/prctl.h>
#include <sys/schedctl.h>
#endif                          /* Alter ../Makefile.def.sgi accordingly. */
#ifdef REALTIME
#define _POSIX_4SOURCE 1
#include <standards.h>          /* Must be first include file ... */
#endif
#ifdef NEXTSTEP
#define STDIN_FILENO 0
#define STDOUT_FILENO 1
#else
#include <unistd.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/resource.h>
#ifdef __alpha
    /* Need all this for serial port crap */
#include <sys/ioctl.h>
#include <sys/devio.h>
#include <termio.h>
#include <termios.h>
#include <fcntl.h>
#endif
#include "m_mess.h"
#include "cp_mess.h"
#include "d_ugen.h"
#ifdef AUDIOFILE
#include <AF/AFlib.h>
#endif
#ifdef SGI_NATIVE_AUDIO
#include <fcntl.h>
#include "audio.h"
#endif
#ifdef __alpha
#define HZ 50
#endif
#ifdef NEXTSTEP
#define HZ 60
#endif
#ifdef unix
#include <sys/time.h>
#include <sys/times.h>
#include <sys/param.h>
#endif
/*
 * Globals
 */
char *progname = "fts";
int infile;                     /* input to Max */
int outfile;                    /* output from Max */

int cp_quit = 0;                /* quit flag; can be set from sched_tick */
int cp_this = 0;                /* ID number of this CP */
int cp_nproc = 1;               /* number of CPs */
int cp_usedacs;
int cp_slotno;
int cp_sr = 44100;              /* integer sampling rate use in dac_timefwd */
int cp_nchans;
int cp_use_audiofile;
static int cp_audio_open;       /* true if audio is open */

extern float dsp_sr;
#define NSPINCOUNT 16
int cp_spincount[NSPINCOUNT], cp_spinphase, cp_nextspin;
static long dactime = 1;
extern int dsp_ticks;

static long ticktime = 0;
extern long logicaltime;

extern float soundout[], soundin[];

#define DACVS 64                /* vector size for a/d/a and inter-CP signal paths */
#define NCHAN 8                 /* maximum number of DACs and ADCs */
#define XFERSIZE 64             /* number of samples we pass to dacs */
#define DACALIGN 16

int cp_xferframes;

#ifdef AUDIOFILE

#define BIAS 0x84               /* define the add-in bias for 16 bit samples */
#define CLIP 32635

/* AudioFile globals */
AFAudioConn *aud;
AC audio_context;
ATime playtime;
int sample_rate;                /* sample rate, per second */
int nchannels;                  /* number of sound channels */
float toffset = 0.05;           /* seconds delay to start play */

static unsigned char *linear_to_ulaw(short *samples, int len)
{
    static int exp_lut[256] =
        { 0, 0, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
        4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
        5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
        5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
        6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
        6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
        6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
        6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
        7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
        7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
        7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
        7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
        7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
        7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
        7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
        7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7
    };
    int sign, exponent, mantissa;
    unsigned char ulawbyte;
    short *samp_pt;
    char *ulaw_pt;
    short sample;

    samp_pt = samples;
    ulaw_pt = (char *) samples;
    while (len-- > 0)
    {
        sample = *samp_pt++;
        /* Get the sample into sign-magnitude. */
        sign = (sample >> 8) & 0x80;    /* set aside the sign */
        if (sign != 0)
            sample = -sample;   /* get magnitude */
        if (sample > CLIP)
            sample = CLIP;      /* clip the magnitude */

        /* Convert from 16 bit linear to ulaw. */
        sample = sample + BIAS;
        exponent = exp_lut[(sample >> 7) & 0xFF];
        mantissa = (sample >> (exponent + 3)) & 0x0F;
        ulawbyte = ~(sign | (exponent << 4) | mantissa);
        if (ulawbyte == 0)
            ulawbyte = 0x02;    /* optional CCITT trap */
        *ulaw_pt++ = ulawbyte;
    }
}

static int buffer_nonzero(short *buf, int nsamples)
{
    /* return 1 if a the buffer contains a non-zero value */
    short *p = buf;
    while (nsamples--)
        if (*p++)
            return 1;
    return 0;                   /* all values were zero */
}

/*
 * audiofile_play()
 *
 * Playing sound consists in converting the samples to ulaw format and
 * handing them to the AudioFile server.  The only difficulty arises in
 * scheduling the samples.  The AudioFile server time is used and advanced
 * by the number of samples.  Later, dac_poll() will ensure that FTS
 * stays in sync with the DACs by checking io_dacshungry().
 */

static void audiofile_play(short *buf, int nsamples)
{
    /* First time through set time for first samples to be played */
    if (!playtime)
    {
        /* time is offset by slight delay */
        playtime = AFGetTime(audio_context) + (toffset * sample_rate);
    }

    if (buffer_nonzero(buf, nsamples))
    {                           /* do not `play' silence */
        linear_to_ulaw(buf, nsamples);  /* convert buffer */
        AFPlaySamples(audio_context, playtime, nsamples, buf);
    }
    playtime += nsamples;       /* advance sample time */
}

/*
 * find_default_device()
 *
 * Find a suitable default device (the first device not connected to the phone).
 * Returns device number, or -1 if no suitable device can be found.
 */

static int find_default_device(AFAudioConn *aud)
{
    AFDeviceDescriptor *aDev;
    int i;

    for (i = 0; i < ANumberOfAudioDevices(aud); i++)
    {
        aDev = AAudioDeviceDescriptor(aud, i);
        if (aDev->inputsFromPhone == 0 && aDev->outputsToPhone == 0)
            return i;
    }
    return -1;
}

/*
 * Open an AudioFile connection
 *
 */

int open_audiofile_connection()
{
    AFSetACAttributes audio_attributes;
    int device;

    /*
     * The server to connect to is taken from the environment variable
     * AUDIOFILE, or failing that, DISPLAY.
     */
    if ((aud = AFOpenAudioConn("")) == NULL)
    {
        post("Can't open connection to AudioFile server\n");
        return (1);
    }

    if ((device = find_default_device(aud)) == -1)
    {
        post("Can't access an AudioFile device\n");
        return (1);
    }

    /* set up audio context, find sample size and sample rate */
    audio_attributes.preempt = Mix;
    audio_attributes.start_timeout = 0;
    audio_attributes.end_silence = 0;
    audio_attributes.play_gain = 0;
    audio_attributes.rec_gain = 0;
    audio_context = AFCreateAC(aud, device, ACPlayGain, &audio_attributes);
    sample_rate = audio_context->device->playSampleFreq;
    nchannels = audio_context->device->playNchannels;
    cp_use_audiofile = 1;
    return (0);
}
#endif                          /* AUDIOFILE */

#ifdef SGI_NATIVE_AUDIO
static ALport iport;
static ALport oport;
static int sgi_opened;
static ALconfig sgi_config;
#define BUFTIME 50              /* .1 sec buffering -- should depend on sched advance */

int sgi_open_audio()
{
    long pvbuf[4];
    long pvbuflen;
    int samplerate;
    /*
     *  get current sample rate -- should initialize to this...
     */
    pvbuf[0] = AL_INPUT_RATE;
    pvbuf[2] = AL_OUTPUT_RATE;
    pvbuflen = 4;

    ALgetparams(AL_DEFAULT_DEVICE, pvbuf, pvbuflen);

    if (pvbuf[1] < 1)
        pvbuf[1] = 44100;
    post("sample rate = %ld", pvbuf[1]);

    alpha_setchans(2);
    alpha_setsamplerate((int) (samplerate = pvbuf[1]));

    pvbuf[3] = pvbuf[1];
    ALsetparams(AL_DEFAULT_DEVICE, pvbuf, pvbuflen);


    sgi_config = ALnewconfig();

    /* this is not good.  the queue size should reflect scheduler
       addvance; we should use 24 bit samples; and number of channels
       should be configurable. */
    ALsetqueuesize(sgi_config, (2 * samplerate * BUFTIME) / 1000);
    ALsetwidth(sgi_config, AL_SAMPLE_16);
    ALsetchannels(sgi_config, 2);

    oport = ALopenport("the ouput port", "w", sgi_config);
    if (!oport)
    {
        fprintf(stderr, "FTS: failed to open audio write port\n");
        return (1);
    }

    iport = ALopenport("the input port", "r", sgi_config);
    if (!iport)
    {
        fprintf(stderr, "FTS: failed to open audio read port\n");
        return (1);
    }
    sgi_opened = 1;
    return (0);
}

void sgi_reset_sample_rate(n)
{
    if (n < 1)
        n = 44100;
    if (sgi_config)
    {
        long pvbuf[4];
        long pvbuflen;

        pvbuf[0] = AL_INPUT_RATE;
        pvbuf[2] = AL_OUTPUT_RATE;
        pvbuf[3] = pvbuf[1] = n;
        pvbuflen = 4;
        ALsetparams(AL_DEFAULT_DEVICE, pvbuf, pvbuflen);

        ALgetparams(AL_DEFAULT_DEVICE, pvbuf, pvbuflen);

        n = pvbuf[1];
        if (n < 1)
            n = 44100;
        post("sample rate = %ld", n);

        alpha_setsamplerate(n);
    }
}

void sgi_close_audio()
{
    if (iport)
        ALcloseport(iport);
    if (oport)
        ALcloseport(oport);
}

void sgi_senddacs(short *buffer)
{
    ALwritesamps(oport, buffer, XFERSIZE);
    ALreadsamps(iport, buffer, XFERSIZE);
}
#endif                          /* SGI_NATIVE_AUDIO */

static struct timeval fake_starttime;
static long fake_logicaltime;

void fake_openconnection()
{
    struct timezone tz;
    gettimeofday(&fake_starttime, &tz);
    cp_use_audiofile = 0;
    fake_logicaltime = 0;
}

int fake_dacshungry()
{
    struct timeval timenow;
    struct timezone tz;
    long elapsedtime;
    gettimeofday(&timenow, &tz);
    elapsedtime = 1000 * (timenow.tv_sec - fake_starttime.tv_sec) +
        (timenow.tv_usec - fake_starttime.tv_usec) / 1000;
    return (elapsedtime > fake_logicaltime);
    /* return (1); */
}

void fake_senddacs()
{
    fake_logicaltime = logicaltime;
}

main(int argc, char **argv)
{
    extern int cpmess_debug;
    extern int max_debug;
    extern int u_debug;

    int advances[MAXCP];

#ifdef DEBUG
    max_debug = 1;
#endif

    /* Max (the parent process) has duplicated stdin and stdout for a connection.
     * Alias the names since much code uses the names `infile' and `outfile'.
     */
    infile = STDIN_FILENO;
    outfile = STDOUT_FILENO;

    /* Trap Unix signals */
    signal(SIGINT, SIG_IGN);
    signal(SIGPIPE, SIG_IGN);

    /* Command line */
    argc--;
    argv++;
    /* if not numeric, it's a "flag" */
    while (argc && (**argv < '0' || **argv > '9'))
    {
        if (**argv == '-')
            max_debug = cpmess_debug = 1;
        else
        {
            infile = open(argv[0], 0);
            if (infile < 0)
                hate("fts: %s: can't open", argv[0]);
        }
        argc--;
        argv++;
    }
    /* parse argument for list of sched advances */
#if 0
    if (argc)
    {
        char *s = *argv;
        while (sscanf(s, "%d,", &advances[cp_nproc]) >= 1)
        {
            cp_nproc++;
            if (cp_nproc == MAXCP)
                break;
            while (*s && *s != ',')     /* separated by commas */
                s++;
            if (!*s)
                break;
            s++;
        }
    }
#endif

    /* bash priority to a high value.  The scheduler tries not to
       monopolize the CPU by sleeping at least once every 50 ticks.  */
#ifdef __sgi
    if (plock(PROCLOCK) < 0)
        fprintf(stderr, "fts: warning: couldn't lock into memory\n");
    if (schedctl(NDPRI, 0, NDPNORMMAX) < 0)
        fprintf(stderr, "fts: warning: couldn't set priority\n");
#else
    if (setpriority(PRIO_PROCESS, 0, -17) < 0)
        fprintf(stderr, "fts: warning: couldn't set priority\n");
#endif
    seteuid(getuid());


#ifdef AUDIOFILE
    if (!open_audiofile_connection())
    {
        cp_audio_open = 1;
        alpha_setchans(nchannels);
        alpha_setsamplerate(sample_rate);
    }
    else
    {
        fake_openconnection();
        alpha_setchans(1);
        alpha_setsamplerate(8000);
    }
#else
#ifdef SGI_NATIVE_AUDIO
    if (!sgi_open_audio())
    {
        cp_audio_open = 1;
    }
    else
    {
        fake_openconnection();
        alpha_setchans(1);
        alpha_setsamplerate(8000);
    }
#else
    fake_openconnection();
    /* hard-wired dafault values ... 8k (mono) audio */
    alpha_setchans(1);
    alpha_setsamplerate(44100);
#endif
#endif

    h_init(0);                  /* 0 == not real time */
    h_canpost();

    post("fts: running in soft realtime");
    cp_print(1);                /* start profiling */

    while (!cp_quit)
    {
        int foo = 0;
        cp_spinphase = (cp_spinphase + 1) & (NSPINCOUNT - 1);
        cp_spincount[cp_spinphase] = cp_nextspin;
        cp_nextspin = 0;
        sched_poll();           /* increment logicaltime */
#ifdef MIDI
        midi_poll();            /* keep up with MIDI in */
#endif
        dac_poll();
        host_poll();
        if (!foo--)
        {
            static int nexttime;
            hq_poll();
            if (logicaltime >= nexttime)
            {
                int foo = nexttime & 4;
                if (!foo)
                    max_sendtimeup();
                nexttime += 500;
            }
            foo = 7;
        }
    }

    h_done();
#ifdef AUDIOFILE
    AFFreeAC(audio_context);
#endif
#ifdef SGI_NATIVE_AUDIO
    sgi_close_audio();
#endif
    exit(0);
}

long realtime()
{
    return dactime;
}

host_poll()
{
    char cmd[BUFSIZ];
    int ret, i;
    fd_set check;
    struct timeval timeout;
    timeout.tv_sec = 0;
    timeout.tv_usec = 0;

    FD_ZERO(&check);
    FD_SET(infile, &check);
    select(64, &check, (fd_set *) 0, (fd_set *) 0, &timeout);
    if (FD_ISSET(infile, &check))
    {
        if ((ret = read(infile, cmd, BUFSIZ)) < 0)
        {
            perror("read");
            hate("host connection broken");
        }
        else if (ret == 0)
        {
            cp_quit = 1;
            return;             /* EOF */
        }
        /* read ok */
        for (i = 0; i < ret; i++)
            cp_dochar(0, cmd[i]);
    }
}

    /* tell DSP network etc about new sample rate */
alpha_setsamplerate(int n)
{

    if (n <= 0)
        n = 1;
    dsp_sr = cp_sr = n;
}

    /* tell everyone what channel count we configured */
alpha_setchans(int n)
{
    if (n <= 0)
    {
        n = 0;
        cp_usedacs = 0;
    }
    else
    {
        if (n > NCHAN)
            n = NCHAN;
        cp_usedacs = 1;
    }
    cp_xferframes = XFERSIZE / n;
    cp_nchans = n;
    cu_zero(soundout, cp_nchans * MAXVS);
    cu_zero(soundin, cp_nchans * MAXVS);
}

#define COERCE (32768)          /* 2^15 */

  /* NB: the use of `short' here is based on their being 16 bits */
io_prepadcbuf(short *sp, float *fp, int n, int skip)
{
    while (n--)
    {
        *fp++ = *sp * (1. / COERCE);
        sp += skip;
    }
}

  /* NB: the use of `short' here is based on their being 16 bits */
io_prepdacbuf(short *sp, float *fp, int n, int skip)
{
    while (n--)
    {
        short xx = *fp++ * COERCE;
        if (xx > (COERCE - 256))
            xx = COERCE - 256;
        else if (xx < -COERCE)
            xx = -COERCE;
        *sp = xx;
        sp += skip;
    }
}

  /* NB: the use of `short' here is based on their being 16 bits */
io_senddacs(short *buffer)
{
#ifdef SGI_NATIVE_AUDIO
    if (sgi_opened)
        sgi_senddacs(buffer);
    else
    {
        fake_senddacs(buffer);
        bzero(buffer, cp_xferframes * cp_nchans * sizeof(short));
    }
#else
#ifdef AUDIOFILE
    if (cp_use_audiofile)
        audiofile_play(buffer, cp_xferframes);
    else
#endif                          /* AUDIOFILE */
        fake_senddacs(buffer);
    bzero(buffer, cp_xferframes * cp_nchans * sizeof(short));
#endif                          /* SGI */
}

int io_dacshungry()
{
#ifdef SGI_NATIVE_AUDIO
    if (sgi_opened)
        return (1);             /* the blocking takes place in io_senddacs */
    else
#else
#ifdef AUDIOFILE
    if (cp_use_audiofile)
        return AFGetTime(audio_context) + (toffset * sample_rate) >=
            playtime;
    else
#endif
#endif
        return (fake_dacshungry());
}

dac_timefwd()
{
    static int dactime_frac;

    dactime_frac += 64000;
    while (dactime_frac >= cp_sr)
    {
        dactime++;
        dactime_frac -= cp_sr;
    }
}


static int cp_insomnia;         /* number of ticks since last sleep */

  /* NB: the use of `short' here is based on their being 16 bits */
dac_poll()
{
    float *in = soundin, *out = soundout;
    int i, ch;
    char tempspace[XFERSIZE * sizeof(int) + DACALIGN];
    short *tempbuf =
        (short *) (tempspace + ((-(long) tempspace) & (DACALIGN - 1)));
    if (dactime > logicaltime)
        bug("dac_tick");

    /* The following loop was introduced for Unix */
    while (!io_dacshungry())
    {
        microsleep(1000);
        cp_insomnia = 0;
    }
    if (cp_insomnia > 100)      /* guard against hogging the entire CPU */
    {
        microsleep(3000);
        cp_insomnia = 0;
    }
    cp_insomnia++;
    if (cp_usedacs)
    {
        while (in < soundin + DACVS)
        {
            int i = 0;
            short *tb2 = tempbuf;
            float *fp;
            ch = cp_nchans;
            for (i = ch, fp = out; i--; fp += DACVS)
                io_prepdacbuf(tb2++, fp, cp_xferframes, ch);
            io_senddacs(tempbuf);
            tb2 = tempbuf;
            for (i = ch, fp = in; i--; fp += DACVS)
                io_prepadcbuf(tb2++, fp, cp_xferframes, ch);
            in += cp_xferframes;
            out += cp_xferframes;
        }
    }
  nodacs:
    cu_zero(soundout, cp_nchans * MAXVS);
    dac_timefwd();
}

/* routine to stop performance, which sched_poll calls if rtfifo_tickin fails */
cp_canit()
{
    cp_quit = 1;
}


#ifdef __alpha
int open_midi_port()
{
    int fd;
    struct devget got;
    struct termios termio, termio1;
    int speed = 31250;

    if ((fd = open("/dev/tty00", O_RDWR | O_NONBLOCK)) == -1)
    {
        return -1;
    }

    ioctl(fd, DEVIOCGET, &got);
    if (tcgetattr(fd, &termio) < 0)
    {
        perror("tcgetattr");
        exit(-1);
    }

    /* set new */
    cfsetispeed(&termio, speed);
    cfsetospeed(&termio, speed);

    if (tcsetattr(fd, TCSANOW, &termio) < 0)
    {
        perror("tcsetattr");
        exit(-1);
    }

    if (tcgetattr(fd, &termio1) < 0)
    {
        perror("tcgetattr");
        exit(-1);
    }
    system("stty -f /dev/tty00 raw cs8 -cstopb -echo ignbrk");
    return fd;
}
#endif

static int midi_fd = 0;

int io_peekmidi()
{
#ifdef __alpha
    static fd_set midiport;
    struct timeval timeout = { 0, 1 };
    unsigned char midibuf;      /* read one at a time */

    if (!midi_fd)
    {
        if ((midi_fd = open_midi_port()) == -1)
            post("Cannot open MIDI port");
    }

    FD_ZERO(&midiport);
    FD_SET(midi_fd, &midiport);
    select(64, &midiport, (fd_set *) 0, (fd_set *) 0, &timeout);
    if (FD_ISSET(midi_fd, &midiport))
    {
        if (read(midi_fd, &midibuf, 1) <= 0)
        {
            /* read error */
            return -1;
        }
        else
        {
            return (int) midibuf;
        }
    }
    else
    {
        return -1;              /* nothing there */
    }
#else
    return (-1);
#endif
}

void io_putmidi(int val)
{
#ifdef __alpha
    unsigned char midibyte = (unsigned char) val;
    if (midi_fd <= 0)
        return;
    write(midi_fd, &midibyte, 1);
#endif
}

midi_poll()
{
    int midibyte;
    while ((midibyte = io_peekmidi()) >= 0)
    {
#if 0
        fprintf(stderr, "gotbyte %x\n", midibyte);
#endif
        sched_domidi(midibyte);
    }
}

Xmit(long port, long val)
{
    io_putmidi((int) val);
}

#ifdef unix
long memlefttosbrk()
{
    /* The approximate amount of data-space, in bytes.
     * How? Allocate store until no more available.
     * Different implementations have a different argument type
     * to malloc. Here we assume that it's the same type as
     * that which sizeof() returns.
     * WARNING: Some systems crash when you try to malloc all store.
     * -- lifted from enquire.c
     */
    unsigned int size;
    long total = 0;

    /* If I malloc all store than subsequent calls will return 0 available bytes
     * Solution: save pointers to malloc'ed store and free them after.
     * How many chunks will be allocated.  Imperically 1024 suggested itself
     */
    int index = 0;
    char *mem[1024];

    /* calculate bits per byte */
    char c = 1;
    int bits_per_byte = 0;
    do
    {
        c = c << 1;
        bits_per_byte++;
    }
    while (c != 0);

    /* allocate all memory */
    size = 1 << ((bits_per_byte * sizeof(int)) - 2);
    while (size != 0)
    {
        while ((mem[index] = malloc(size)) != (char *) NULL)
        {
            total += (size / 2);
            index++;
        }
        size /= 2;
    }
    /* free all malloc'ed memory */
    while (index)
        free(mem[--index]);

    return (total + 511) * 2;   /* approximate value only */
}
#endif

void cp_doprint(long louder)
{
    int i, sum;
    long memlefttosbrk();

    for (i = sum = 0; i < NSPINCOUNT; i++)
        sum += cp_spincount[i];
    sum -= cp_spincount[cp_spinphase];
    sum = sum * .99;
    post((u_chain ? "idle %d.%d%%; mem %dK, %d signals used" :
          "idle %d.%d%%, mem %dK"),
         sum / 10, sum % 10, memlefttosbrk() / 1024, sig_getcount());
    if (louder)
    {
        post("ticks:");
        for (i = 0; i < NSPINCOUNT; i++)
            postlong(cp_spincount[(cp_spinphase - i) & (NSPINCOUNT - 1)]);
    }
}

#if MEMLEFTTOSBRK_WORKS
cp_print(void *x, long louder)
{
    post(u_chain ? "------ DSP ON ------" : "------ DSP OFF ------");
    rtfifo_broadcast(cp_doprint, louder);
}
#endif

int sys_asyncwrite(struct messbuf *m, int len)
{
    /* temp */
    write(outfile, &m, len);
}

int sys_roomtowrite()
{
    return 0x7fffffff;
}

int sys_roomtowrite_animal()
{
    return 0x7fffffff;
}

cp_tick()
{
}

extern void *u_chain;

cp_print(x, start)
void *x;
long start;
{
    static struct timeval startrealtime;
    static long startlogicaltime;
    static struct tms startcputime;
    struct timezone tz;
    if (start)
    {
        gettimeofday(&startrealtime, &tz);
        times(&startcputime);
        startlogicaltime = logicaltime;
    }
    else
    {
        struct timeval newrealtime;
        long newlogicaltime;
        struct tms newcputime;
        gettimeofday(&newrealtime, &tz);
        times(&newcputime);

        post(u_chain ? "------ DSP ON ------" : "------ DSP OFF ------");
        post("elapsed logical time = %ld", logicaltime - startlogicaltime);
        post("elapsed CPU time =     %ld",
             1000 * (newcputime.tms_utime + newcputime.tms_stime -
                     startcputime.tms_utime -
                     startcputime.tms_stime) / HZ);
        post("elapsed real time =    %ld",
             1000 * (newrealtime.tv_sec - startrealtime.tv_sec) +
             (newrealtime.tv_usec - startrealtime.tv_usec) / 1000);
    }
}
