#ifndef lint
static char rcsid[] =
    "$Revision: 2.11 $ IRCAM $Date: 1994/05/10 10:49:43 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.11 $ IRCAM $Date: 1994/05/10 10:49:43 $
 *
 * FTS by Miller Puckette
 *
 */

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#include "m_mess.h"
#include "cp_mess.h"


extern int max_debug;
extern int outfile;
extern t_symbol s_tick;
extern t_symbol s_max, s_load, s_load_obj, s_setfts;
extern int cp_this, cp_nproc;

int cpmess_debug;
int cp_isrealtime;              /* flag indicating we're running in real time */
struct alist *h_objlist;

static int cp_fd;
static int cpmess_running = 1;
static int h_postable = 0;

/* the state of an input channel from a host program (MAX or Animal) */
#ifndef CPOS
static t_inmess cp_inmax, cp_inanimal;
#endif

h_init(int real)
{
    cp_isrealtime = real;

    mess_init();

    if (!(h_objlist = alist_new(10)))
        hate("can't allocate object list");

    alist_put(h_objlist, (long) cp_this, (void *) (s_max.s_thing));
    if (!cp_this)
    {
        int i;
        for (i = 1; i < cp_nproc; i++)
            alist_put(h_objlist, (long) i, (void *) i);
    }
#ifndef CPOS
    cp_inmax.i_pt = (char *) (&cp_inmax.i_msg);
    cp_inmax.i_gothdr = 0;
    cp_inanimal.i_pt = (char *) (&cp_inanimal.i_msg);
    cp_inanimal.i_gothdr = 0;
#endif

    hq_init();
}

h_done()
{
    alist_free(h_objlist);
}

h_canpost()
{
    h_postable = 1;
}

long xtol(char *s)
{
    long n = 0;
    int diff;
    char c;
    while (c = *s++)
    {
        if ((diff = c - '0') >= 0 && diff <= 9)
            n = (n << 4) + diff;
        else if ((diff = c - 'a') >= 0 && diff <= 5)
            n = (n << 4) + diff + 10;
        else if ((diff = c - 'A') >= 0 && diff <= 5)
            n = (n << 4) + diff + 10;
        else
            break;
    }
    return (n);
}

int cp_dispatch(int command, int fudge, int ac, struct atom *av);

/* take a character of input from host */
int cp_dochar(int port, char c)
{
#ifdef CPOS
    t_inmess *in = &(port->inmess);
#else
    t_inmess *in = (port ? &cp_inanimal : &cp_inmax);
#endif

#if 0
    if (c)
        post("(%x) %c", (int) c, (int) c);
    else
        post("\\000");
#endif
#if 0
    if (c)
        fprintf(stderr, "(%x) %c\n", (int) c, (int) c);
    else
        fprintf(stderr, "\\000\n");
#endif

    if (in->i_gothdr)
    {
        if (in->i_pt >= in->i_buf + MAX_ARGLEN - 2)
            (in->i_pt)--;
        *((in->i_pt)++) = c;
        if (!c)
        {
            /* if a zero-length string we're done */
            if (in->i_pt == in->i_buf + 1)
            {
#ifdef CPOS
                cp_dispatch(in->i_msg.m_command,
                            ((int) port * 123456789), in->i_ac, in->i_av);
#else
                cp_dispatch(in->i_msg.m_command,
                            port << 29, in->i_ac, in->i_av);
#endif                          /* CPOS */
                in->i_gothdr = 0;
                in->i_pt = (char *) (&in->i_msg);
            }
            else                /* otherwise it's an atom to append to the message */
            {
                long x;
#ifdef __alpha
                double f;
#else
                float f;
#endif
                in->i_pt = in->i_buf;
                if (in->i_ac >= MARG)
                    return;
                switch (in->i_buf[0])
                {
                case 'i':
                    /* sscanf(buf+1, "%lx", &x); */
                    in->i_ap->a_type = A_LONG;
                    in->i_ap->a_w.w_long = xtol(in->i_buf + 1);
                    break;
                case 'f':
#ifdef __alpha
                    sscanf(in->i_buf + 1, "%lf", &f);
#else
                    sscanf(in->i_buf + 1, "%f", &f);
#endif
                    in->i_ap->a_type = A_FLOAT;
                    in->i_ap->a_w.w_float = f;
                    break;
                case 's':
                    in->i_ap->a_type = A_SYM;
                    in->i_ap->a_w.w_sym = gensym(in->i_buf + 1);
                    break;
                case 'o':
                    in->i_ap->a_type = A_OBJ;
                    in->i_ap->a_w.w_long = xtol(in->i_buf + 1);
                    break;
                default:
                    post("bad message arg type");
                    return;
                }
                in->i_ac++;
                in->i_ap++;
            }
        }
    }
    else
    {
        *((in->i_pt)++) = c;
        if (in->i_pt == (char *) (&in->i_msg + 1))
        {
            in->i_gothdr = 1;
            in->i_pt = in->i_buf;
            in->i_ac = 0;
            in->i_ap = in->i_av;
            cvt_long(&in->i_msg.m_command);
        }
    }
}

dbugit(int command, int ac, struct atom *av)
{
    char buf[80 + PR_MAX], *s, b2[30];
    switch (command)
    {
    case CP_FREE:
        s = "free";
        break;
    case CP_MESS:
        s = "mess";
        break;
    case CP_CONNECT:
        s = "connect";
        break;
    case CP_DISCONNECT:
        s = "disconnect";
        break;
    default:
        if (command >= CP_NEW && command < CP_NEW + MAXCP)
            sprintf(b2, "new on %d:", command - CP_NEW);
        else
            sprintf(b2, "%d???:", command);
        s = b2;
        break;
    }
    strcpy(buf, s);
    while (ac--)
    {
        char bufon[512];
        switch (av->a_type)
        {
        case A_SYM:
            sprintf(bufon, " (s)%s", av->a_w.w_sym->s_name);
            break;
        case A_LONG:
            sprintf(bufon, " (i)%ld", av->a_w.w_long);
            break;
#ifdef __alpha
        case A_FLOAT:
            sprintf(bufon, " (f)%lf", (float) av->a_w.w_float);
            break;
#else
        case A_FLOAT:
            sprintf(bufon, " (f)%f", (float) av->a_w.w_float);
            break;
#endif
        case A_OBJ:
            sprintf(bufon, " (o)%ld", av->a_w.w_long);
            break;
        default:
            strcpy(bufon, " (?)");
        }
        if (strlen(buf) + strlen(bufon) < PR_MAX)
            strcat(buf, bufon);
        else
        {
            strcat(buf, "...");
            break;
        }
        av++;
    }
    post(buf);
}

extern t_object qnewobj;
extern void *newest;

/* dispatch a message from host or from another CP.  If from host, we might
   send it on to another CP.  "Command" is from among CP_MESS, CP_CONNECT, etc. */

cp_dispatch(int command, int fudge, int ac, struct atom *av)
{
    void *whoto;

    if (max_debug)
    {
        if (!(command == CP_MESS &&
              ac >= 2 && !av[0].a_w.w_long && av[1].a_w.w_sym == &s_tick))
            dbugit(command, ac, av);
    }
    /* anything except NEW has an object in its first slot. */

    if (command < CP_NEW)
    {
        if (ac < 1 || av[0].a_type != A_LONG)
        {
            bug("cp_dispatch:  no destination");
            dbugit(command, ac, av);
            return;
        }
        else if (!(whoto = alist_get(h_objlist, av[0].a_w.w_long + fudge)))
        {
            bug("message to non-existent object");
            dbugit(command, ac, av);
            return;
        }
    }

    /* If we're the master CP we have to see if this message is
       really for another CP */


    if (!cp_this)
    {
        if (command > CP_NEW && command < CP_NEW + cp_nproc)
        {
            /* create a new object.  Put the cp number in alist. */

            int thatcp = command - CP_NEW;
            alist_put(h_objlist, av[0].a_w.w_long + fudge,
                      (void *) (long) thatcp);
            if (ac >= 2 && av[0].a_type == A_LONG && av[1].a_type == A_SYM)
                rtfifo_sendmess(thatcp, CP_NEW, av[0].a_w.w_long + fudge,
                                av[1].a_w.w_sym, ac - 2, av + 2);
            else
                error("bad remote 'new'");
            return;
        }
        else if (command < CP_NEW)
        {
            /* anything else goes to the CP owning the object referred
               to.  "whoto" is then the CP number and the ID gets
               passed on to be looked up in the other CP. */

            if ((long) whoto <= MAXCP && (long) whoto > 0)
            {
                rtfifo_sendmess((int) whoto, command,
                                av[0].a_w.w_long + fudge, NIL, ac - 1,
                                av + 1);
                /* if freeing a remote object, you need to clear
                   this alist's entry for it too. */
                if (command == CP_FREE)
                    alist_bag(h_objlist, av[0].a_w.w_long + fudge);
                return;
            }
        }
    }

    /* otherwise do the real work. */
    if (cpmess_running)
    {
        t_atom *ap;
        int count;
        /* look up host IDs */
        for (ap = av, count = ac; count--; ap++)
            if (ap->a_type == A_OBJ)
            {
                ap->a_w.w_obj =
                    alist_get(h_objlist, ap->a_w.w_long + fudge);
                if (!ap->a_w.w_obj)
                {
                    if (cpmess_running)
                        error("cp_mess: reference to non-object");
                    ap->a_w.w_obj = alist_get(h_objlist, 0);
                }
            }
        switch (command)
        {
        case CP_NEW:
            if (ac >= 2 && av[0].a_type == A_LONG && av[1].a_type == A_SYM)
            {
                newest = 0;
                typedmess(&qnewobj, av[1].a_w.w_sym, ac - 2, av + 2);
                if (!newest)
                    error("%s: can't instantiate on CP",
                          av[1].a_w.w_sym->s_name);
                /* if (!ob_class(newest))
                   {
                   sa_printf("new: %lx\n", newest);
                   newest = 0;
                   } */
                alist_put(h_objlist, av[0].a_w.w_long + fudge, newest);
                if (max_debug)
                    post("(->%ld)", newest);
            }
            else
                error("bad args for new object creation");
            break;
        case CP_FREE:
            if (ac >= 1 && av[0].a_type == A_LONG)
            {
                void *obj = alist_get(h_objlist, av[0].a_w.w_long + fudge);
                if (obj)
                {
                    /* extra arg suppresses the actual dealloc */
                    if (ac == 1)
                        obj_free(obj);
                    alist_bag(h_objlist, av[0].a_w.w_long + fudge);
                }
                else
                    error("free on nonexistent object");
            }
            else
                error("bad args for free");
            break;
        case CP_CONNECT:
            if (ac == 4 &&
                av[0].a_type == A_LONG &&
                av[1].a_type == A_LONG &&
                av[2].a_type == A_LONG && av[3].a_type == A_LONG)
            {
                void *obj1 =
                    alist_get(h_objlist, av[0].a_w.w_long + fudge);
                void *obj2 =
                    alist_get(h_objlist, av[2].a_w.w_long + fudge);
                if (obj1 && obj2)
                {
                    /* if (!ob_class(obj2))
                       {
                       sa_printf("connect: %s %lx\n", ob_name(obj1), obj2);
                       }
                       else */
                    obj_connect(obj1, av[1].a_w.w_long,
                                obj2, av[3].a_w.w_long);
                }
                else
                    error("connect to nonexistent object");
            }
            else
                error("bad args for connect");
            break;
        case CP_DISCONNECT:
            if (ac == 4 &&
                av[0].a_type == A_LONG &&
                av[1].a_type == A_LONG &&
                av[2].a_type == A_LONG && av[3].a_type == A_LONG)
            {
                void *obj1 =
                    alist_get(h_objlist, av[0].a_w.w_long + fudge);
                void *obj2 =
                    alist_get(h_objlist, av[2].a_w.w_long + fudge);
                if (obj1 && obj2)
                    obj_disconnect(obj1, av[1].a_w.w_long,
                                   obj2, av[3].a_w.w_long);
                else
                    error("disconnect to nonexistent object");
            }
            else
                error("bad args for disconnect");
            break;
        case CP_MESS:
            if (ac >= 2 && av[0].a_type == A_LONG && av[1].a_type == A_SYM)
            {
                void *obj = alist_get(h_objlist, av[0].a_w.w_long + fudge);
                if (obj)
                    typedmess(obj, av[1].a_w.w_sym, ac - 2, av + 2);
                else
                    error("message to nonexistent object");
            }
            else
                error("bad args for message pass");
            break;
        default:
            error("bad message type");
        }
    }
    /* now send up all hqs */

    if (!cp_isrealtime)
        while (hq_poll());
}

/* machine dependent -- assumes you can just copy arguments....
 * If we have varargs we call vsprintf after popping 
 * in a separate variable the format string */

#ifdef HAS_VARARGS
void post(char *fmt, ...)
{
    va_list ap;
    char buf[80 + PR_MAX];
    sprintf(buf, "\n(%d): ", cp_this + 1);
    va_start(ap, fmt);
    vsprintf(buf + strlen(buf), fmt, ap);
    va_end(ap);
    poststring(buf);
}

#else
void post(char *s, int a, int b, int c, int d, int e, int f, int g, int h)
{
    char buf[80 + PR_MAX], buf2[80 + PR_MAX];
    sprintf(buf2, s, a, b, c, d, e, f, g, h);
    sprintf(buf, "\n(%d): ", cp_this + 1);
    strcat(buf, buf2);
    poststring(buf);
}
#endif

#if 0
void poststring(char *s)
{
    struct messbuf m;
    int k = strlen(s), len;
    char *t = m.m_shit, *s2 = s;
    if (k > PR_MAX)
        k = PR_MAX;
    len = k + sizeof(struct messhdr);
    m.m_h.m_command = H_PRINT;
    m.m_h.m_size = k;
    if (!k)
        return;                 /* something is fucked up for zero-length strings */
    while (k--)
        *t++ = *s2++;
    if (!h_postable)
    {
#if defined(I860) && (! defined(CPOS))
        sa_printf("%s", s);
#else
        fprintf(stderr, "%s", s);
#endif
    }
    else if (cp_this)
        rtfifo_sendtohost(&m, len);
    else
    {
        cvt_long(&m.m_h.m_command);
        cvt_long(&m.m_h.m_size);
        if (cp_isrealtime)
#ifdef CPOS
        {
            if (postClient)
                sys_asyncwrite(&m, len, postClient);
            else
                write(1, m.m_shit, len - sizeof(struct messhdr));
        }
#else
            sys_asyncwrite(&m, len);
#endif
        else if (cpmess_debug)
        {
            write(1, m.m_shit, len - sizeof(struct messhdr));
        }
        else
        {
#ifndef I860
            if (write(outfile, &m, len) < len)
                hate("cp->host write failed");
#endif
        }
    }
}
#else
void poststring(char *s)
{
    fprintf(stderr, "%s", s);
}
#endif

cleanexit(int n)
{
    rtfifo_shutdown();
    exit(n);
}

cp_run(void *x, long int n)
{
    cpmess_running = n;
}

#if defined(NEXTSTEP) || defined(I860) || defined(__unix)
cp_load_obj(void *x, t_symbol *filesym, t_symbol *classsym)
{
    load_object(filesym->s_name, classsym->s_name);
    if (!cp_this)
    {
        int i;
        t_atom at[2];
        at[0].a_type = at[1].a_type = A_SYM;
        at[0].a_w.w_sym = filesym;
        at[1].a_w.w_sym = classsym;
        for (i = 1; i < cp_nproc; i++)
            rtfifo_sendmess(i, CP_MESS, (long) i, &s_load_obj, 2, at);
    }
}
#endif

#ifndef GRAPHICS

static t_symbol *cp_dir = &s_;

t_symbol *cp_getdir()
{
    return (cp_dir);
}

cp_setfts(void *x, t_symbol *s)
{
    cp_dir = s;
    if (!cp_this)
    {
        int i;
        t_atom at;
        at.a_type = A_SYM;
        at.a_w.w_sym = s;
        for (i = 1; i < cp_nproc; i++)
            rtfifo_sendmess(i, CP_MESS, (long) i, &s_setfts, 1, &at);
    }
}
#endif
