#ifndef lint
static char rcsid[] =
    "$Revision: 2.6 $ IRCAM $Date: 1994/05/10 10:49:52 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.6 $ IRCAM $Date: 1994/05/10 10:49:52 $
 *
 * FTS by Miller Puckette
 *
 */


/* definitions of +~, -~, *~, /~ . */
#include "m_mess.h"
#include "d_graph.h"
#include "d_ugen.h"

extern t_symbol s_put, s__sigplus, s__sigtimes, s__sigminus, s__sigdiv,
    s_ft1;


#ifdef I860
void su_vadd(), su_vsub(), su_vmul(), su_vdiv();
#endif

typedef struct sigbinop {
    t_head x_h;
    t_sig *x_io[IN2 + OUT1];
} t_sigbinop;

/************** PLUS ***************/

#ifndef I860
long *ugen_vadd(long *arg)
{
    float *in1 = (float *) (arg[1]);
    float *in2 = (float *) (arg[2]);
    float *out = (float *) (arg[3]);
    long n = (long) (arg[4]);
    while (n--)
    {
        float f = *in1++ + *in2++;
        if (!((f >= 1e-20 && f <= 1e20) || (f <= -1e-20 && f >= -1e20)))
            f = 0;
        *out++ = f;
    }
    return (arg + 5);
}
#endif

void sigplus_put(t_sigbinop *x, long int whether)
{
    if (whether)
    {
        u_stdout((t_ugen *) x);
#ifdef I860
        dspchain_put860(u_chain, su_vadd, 4,
                        x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                        x->x_io[2]->s_shit, x->x_io[0]->s_n);
#else
        dspchain_addugen(ugen_vadd, 4,
                         x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                         x->x_io[2]->s_shit, x->x_io[0]->s_n);
#endif
        if (u_debug)
            post("sigplus %lx: (%lx,%lx)->%lx", x,
                 x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                 x->x_io[2]->s_shit);
    }
}

void *sigplus_class;
void sigplus_setup()
{
    c_new(&s__sigplus, u_clean, sizeof(t_sigbinop), 0, 0);
    c_addmess(sigplus_put, &s_put, A_CANT, 0);
    u_inletmethod(0);
    u_inletmethod(1);
}

void *sigplus_new()
{
    t_sigbinop *x =
        (t_sigbinop *) obj_new((t_messlist **) & sigplus_class,
                               sigplus_setup);
    u_setup((t_ugen *) x, IN2, OUT1);
    if (u_debug)
        post("sigplus %lx", x);
    return (x);
}

/************** MINUS ***************/

#ifndef I860
long *ugen_vsub(long *arg)
{
    float *in1 = (float *) (arg[1]);
    float *in2 = (float *) (arg[2]);
    float *out = (float *) (arg[3]);
    long n = (long) (arg[4]);
    while (n--)
        *out++ = *in1++ - *in2++;
    return (arg + 5);
}
#endif

void sigminus_put(t_sigbinop *x, long int whether)
{
    if (whether)
    {
        u_stdout((t_ugen *) x);
#ifdef I860
        dspchain_put860(u_chain, su_vsub, 4,
                        x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                        x->x_io[2]->s_shit, x->x_io[0]->s_n);
#else
        dspchain_addugen(ugen_vsub, 4,
                         x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                         x->x_io[2]->s_shit, x->x_io[0]->s_n);
#endif
        if (u_debug)
            post("sigminus %lx: (%lx,%lx)->%lx",
                 x, x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                 x->x_io[2]->s_shit);
    }
}

void *sigminus_class;
void sigminus_setup()
{
    c_new(&s__sigminus, u_clean, sizeof(t_sigbinop), 0, 0);
    c_addmess(sigminus_put, &s_put, A_CANT, 0);
    u_inletmethod(0);
    u_inletmethod(1);
}

void *sigminus_new()
{
    t_sigbinop *x =
        (t_sigbinop *) obj_new((t_messlist **) & sigminus_class,
                               sigminus_setup);
    u_setup((t_ugen *) x, IN2, OUT1);
    if (u_debug)
        post("sigminus %lx", x);
    return (x);
}

/************** TIMES ***************/

#ifndef I860
long *ugen_vmul(long *arg)
{
    float *in1 = (float *) (arg[1]);
    float *in2 = (float *) (arg[2]);
    float *out = (float *) (arg[3]);
    long n = (long) (arg[4]);
    while (n--)
        *out++ = *in1++ * *in2++;
    return (arg + 5);
}
#endif

void sigtimes_put(t_sigbinop *x, long int whether)
{
    if (whether)
    {
        u_stdout((t_ugen *) x);
#ifdef I860
        dspchain_put860(u_chain, su_vmul, 4,
                        x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                        x->x_io[2]->s_shit, x->x_io[0]->s_n);
#else
        dspchain_addugen(ugen_vmul, 4,
                         x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                         x->x_io[2]->s_shit, x->x_io[0]->s_n);
#endif
        if (u_debug)
            post("sigtimes %lx: (%lx,%lx)->%lx",
                 x, x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                 x->x_io[2]->s_shit);
    }
}

void *sigtimes_class;
void sigtimes_setup()
{
    c_new(&s__sigtimes, u_clean, sizeof(t_sigbinop), 0, 0);
    c_addmess(sigtimes_put, &s_put, A_CANT, 0);
    u_inletmethod(0);
    u_inletmethod(1);
}

void *sigtimes_new()
{
    t_sigbinop *x =
        (t_sigbinop *) obj_new((t_messlist **) & sigtimes_class,
                               sigtimes_setup);
    u_setup((t_ugen *) x, IN2, OUT1);
    if (u_debug)
        post("sigtimes %lx", x);
    return (x);
}

/************** DIVIDE ***************/

#ifndef I860
long *ugen_vdiv(long *arg)
{
    float *in1 = (float *) (arg[1]);
    float *in2 = (float *) (arg[2]);
    float *out = (float *) (arg[3]);
    long n = (long) (arg[4]);
    while (n--)
    {
        float f = *in2++;
        if (f != 0.)
            *out++ = *in1++ / f;
        else
            *out++ = 0., in1++;
    }
    return (arg + 5);
}
#endif

void sigdiv_put(t_sigbinop *x, long int whether)
{
    if (whether)
    {
        u_stdout((t_ugen *) x);
#ifdef I860
        dspchain_put860(u_chain, su_vdiv, 4,
                        x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                        x->x_io[2]->s_shit, x->x_io[0]->s_n);
#else
        dspchain_addugen(ugen_vdiv, 4,
                         x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                         x->x_io[2]->s_shit, x->x_io[0]->s_n);
#endif
        if (u_debug)
            post("sigdiv %lx: (%lx,%lx)->%lx",
                 x, x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                 x->x_io[2]->s_shit);
    }
}

void *sigdiv_class;
void sigdiv_setup()
{
    c_new(&s__sigdiv, u_clean, sizeof(t_sigbinop), 0, 0);
    c_addmess(sigdiv_put, &s_put, A_CANT, 0);
    u_inletmethod(0);
    u_inletmethod(1);
}

void *sigdiv_new()
{
    t_sigbinop *x =
        (t_sigbinop *) obj_new((t_messlist **) & sigdiv_class,
                               sigdiv_setup);
    u_setup((t_ugen *) x, IN2, OUT1);
    if (u_debug)
        post("sigdiv %lx", x);
    return (x);
}

/************ COMPATIBILITY *****************/

#ifndef I860
void cu_vadd(float *in1, float *in2, float *out, long n)
{
    int i;
    for (i = 0; i < n; i++)
    {
        float f = *in1++ + *in2++;
        if (!((f >= 1e-20 && f <= 1e20) || (f <= -1e-20 && f >= -1e20)))
            f = 0;
        *out++ = f;
    }
}

void cu_vsub(float *in1, float *in2, float *out, long n)
{
    int i;
    for (i = 0; i < n; i++)
        *out++ = *in1++ - *in2++;
}

void cu_vmul(float *in1, float *in2, float *out, long n)
{
    int i;
    for (i = 0; i < n; i++)
        *out++ = *in1++ * *in2++;
}

void cu_vdiv(float *in1, float *in2, float *out, long n)
{
    int i;
    for (i = 0; i < n; i++, in1++, in2++)
    {
        float f = *in2++;
        if (f == 0)
            *out++ = *in1++ / f;
        else
            *out++ = 0;
    }
}
#endif
