#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1993/11/19 16:21:59 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1993/11/19 16:21:59 $
 *
 * FTS by Miller Puckette
 *
 */


/* definitions of sig~, line~, snapshot~.  */
#include <stdio.h>
#include "m_mess.h"
#include "d_graph.h"
#include "d_ugen.h"

extern struct symbol s_sig, s_,
    s__sig, s_put, s__sigline, s_print, s__sigsnapshot, s_ft1;

/************** CTLSIG ***************/
typedef struct ctlsig {
    t_head c_h;
    t_sig *c_io[IN1 + OUT1];
    float c_val;
    float *c_ctl;
    int c_down;
} t_ctlsig;

#ifndef I860

/*
void cu_ctlsig(float *sp, float *fp, long int n)
{
    float f = *sp;
    while (n--) *fp++ = f;
}
*/

#ifndef I860
long *ugen_ctlsig(long *where)
{
    float f = *(float *) (where[1]);
    float *fp = (float *) (where[2]);
    long i, n = where[3];
    for (i = 0; i < n; i++)
        *fp++ = f;
    return (where + 4);
}
#endif

cu_zero(float *fp, long int n)
{
    while (n--)
        *fp++ = 0;
}
#endif

void ctlsig_float(t_ctlsig *x, double f)
{
    *x->c_ctl = f;
}

void ctlsig_int(t_ctlsig *x, long int n)
{
    ctlsig_float(x, (double) n);
}

void ctlsig_put(t_ctlsig *x, long int whether)
{
    if (whether)
    {
        u_genout((t_ugen *) x, x->c_io[0]->s_n >> x->c_down);
        x->c_ctl = dspchain_putstate(u_chain, &x->c_val,
                                     sizeof(float), sizeof(float));
#ifdef I860
        dspchain_put860(u_chain, su_ctlsig, 3, x->c_ctl,
                        x->c_io[1]->s_shit, x->c_io[1]->s_n);
#else
        dspchain_addugen(ugen_ctlsig, 3, x->c_ctl,
                         x->c_io[1]->s_shit, x->c_io[1]->s_n);
#endif
        if (u_debug)
            post("ctlsig %lx: ->%lx", x, x->c_io[1]->s_shit);
    }
    else
    {
        x->c_val = *x->c_ctl;
        x->c_ctl = &x->c_val;
    }
}

void ctlsig_setup()
{
    c_new(&s__sig, u_clean, sizeof(t_ctlsig), 0, 0);
    c_addmess(ctlsig_put, &s_put, A_CANT, 0);
    c_addfloat(ctlsig_float);
    c_addint(ctlsig_int);
    u_inletmethod(0);
}

void *ctlsig_class;
void *ctlsig_new(double f, long int down)
/* number of times to downsample */
{
    t_ctlsig *x =
        (t_ctlsig *) obj_new((t_messlist **) & ctlsig_class, ctlsig_setup);
    u_setup((t_ugen *) x, IN1, OUT1);
    u_setforcer(x);
    x->c_val = f;
    x->c_ctl = &x->c_val;
    if (down < 0)
        down = 0;
    x->c_down = down;
    if (u_debug)
        post("ctlsig %lx", x);
    return (x);
}

/************** LINE ***************/
typedef struct linectl {
    float c_val;
    float c_target;
    float c_steps;
    float c_vecsize;
} t_linectl;

typedef struct sigline {
    t_head x_h;
    t_sig *x_io[IN1 + OUT1];
    int x_in1;
    int x_set;
    int x_vs;
    int x_down;
    float x_sr;
    t_linectl *x_ctl;
    t_linectl x_cspace;
} t_sigline;

#ifndef I860
/*
void cu_line(float *fp, t_linectl *x, long int n)
{
    if (x->c_steps > 0)
    {
  float val = x->c_val;
  float diff =
  (x->c_target - val)/x->c_steps;
  while (n--) *fp++ = (val += diff);
  x->c_val = val;
  x->c_steps -= x->c_vecsize;
    }
    else
    {
  float target = x->c_target;
  while (n--) *fp++ = target;
  x->c_val = target;
    }
}
*/
long *ugen_line(long *arg)
{
    float *fp = (float *) (arg[1]);
    t_linectl *x = (t_linectl *) (arg[2]);
    long n = (long) (arg[3]);
    if (x->c_steps > 0)
    {
        float val = x->c_val;
        float diff = (x->c_target - val) / x->c_steps;
        while (n--)
            *fp++ = (val += diff);
        x->c_val = val;
        x->c_steps -= x->c_vecsize;
    }
    else
    {
        float target = x->c_target;
        while (n--)
            *fp++ = target;
        x->c_val = target;
    }
    return (arg + 4);
}

#endif

void sigline_float(t_sigline *x, double f)
{
    x->x_ctl->c_target = f;
    if (!x->x_set ||
        (x->x_ctl->c_steps = x->x_ctl->c_vecsize * x->x_in1) <= 0)
    {
        x->x_ctl->c_val = f;
        x->x_ctl->c_steps = 0;
    }
    x->x_set = 0;
}

void sigline_int(t_sigline *x, long int n)
{
    sigline_float(x, (double) n);
}

void sigline_ft1(t_sigline *x, double f)
{
    x->x_in1 = f * .001 * x->x_sr / x->x_ctl->c_vecsize;
    x->x_set = 1;
}

void sigline_put(t_sigline *x, long int whether)
{
    if (whether)
    {
        u_genout((t_ugen *) x, x->x_io[0]->s_n >> x->x_down);
        x->x_sr = x->x_io[1]->s_sr;
        x->x_cspace.c_vecsize = x->x_io[1]->s_n;
        x->x_ctl = dspchain_putstate(u_chain, &x->x_cspace,
                                     sizeof(t_linectl), sizeof(float));
#ifdef I860
        dspchain_put860(u_chain, su_line, 3,
                        x->x_io[1]->s_shit, x->x_ctl, x->x_io[1]->s_n);
#else
        dspchain_addugen(ugen_line, 3,
                         x->x_io[1]->s_shit, x->x_ctl, x->x_io[1]->s_n);
#endif
        if (u_debug)
            post("sigline %lx: ->%lx", x, x->x_io[1]->s_shit);
    }
    else
    {
        bcopy(x->x_ctl, &x->x_cspace, sizeof(x->x_cspace));
        x->x_ctl = &x->x_cspace;
    }
}

void sigline_setup()
{
    c_new(&s__sigline, u_clean, sizeof(t_sigline), 0, 0);
    c_addfloat(sigline_float);
    c_addint(sigline_int);
    c_addftx(sigline_ft1, 1);
    c_addmess(sigline_put, &s_put, A_CANT, 0);
    u_inletmethod(0);
}

void *sigline_class;
void *sigline_new(long int down)
/* number of times to downsample */
{
    t_sigline *x;
    x = (t_sigline *) obj_new((t_messlist **) & sigline_class,
                              sigline_setup);
    u_setup((t_ugen *) x, IN1, OUT1);
    u_setforcer(x);
    inlet(x, x, &s_float, &s_ft1);
    x->x_in1 = 0;
    x->x_ctl = &x->x_cspace;
    x->x_cspace.c_val = 0;
    x->x_cspace.c_target = 0;
    x->x_cspace.c_steps = 0;
    x->x_cspace.c_vecsize = DEFAULTVS;
    x->x_set = 0;
    x->x_sr = dsp_sr;
    if (down < 0)
        down = 0;
    x->x_down = down;
    if (u_debug)
        post("sigline %lx", x);
    return (x);
}

/************** SNAP ***************/

typedef struct sigsnap {
    t_head x_h;
    t_sig *x_io[IN1 + OUT0];
    float x_val;
} t_sigsnap;

#ifdef I860                     /* this one is not in i860 assembler */
void cu_snap(float *in, t_sigsnap *x)
{
    x->x_val = *in;
}
#else
long *ugen_snap(long *arg)
{
    float *in = (float *) (arg[1]);
    t_sigsnap *x = (t_sigsnap *) (arg[2]);
    x->x_val = *in;
    return (arg + 3);
}
#endif

void sigsnap_bang(t_sigsnap *x)
{
    outlet_float(x->x_h.h_ob.o_outlet, x->x_val);
}

void sigsnap_float(t_sigsnap *x, double f)
{
    x->x_val = f;
}

void sigsnap_int(t_sigsnap *x, long int n)
{
    x->x_val = n;
}

void sigsnap_put(t_sigsnap *x, long int whether)
{
    if (whether)
    {
        u_stdout((t_ugen *) x);
#ifdef I860
        dspchain_putc(u_chain, cu_snap, 2,
                      x->x_io[0]->s_shit + (x->x_io[0]->s_n - 1), x);
#else
        dspchain_addugen(ugen_snap, 2,
                         x->x_io[0]->s_shit + (x->x_io[0]->s_n - 1), x);
#endif
        if (u_debug)
            post("sigsnap %lx: (%lx)", x, x->x_io[0]->s_shit);
    }
}

void *sigsnap_class;
void sigsnap_setup()
{
    c_new(&s__sigsnapshot, u_clean, sizeof(t_sigsnap), 0, 0);
    c_addbang(sigsnap_bang);
    c_addint(sigsnap_int);
    c_addfloat(sigsnap_float);
    c_addmess(sigsnap_put, &s_put, A_CANT, 0);
    u_inletmethod(0);
}

void *sigsnap_new()
{
    t_sigsnap *x =
        (t_sigsnap *) obj_new((t_messlist **) & sigsnap_class,
                              sigsnap_setup);
    u_setup((t_ugen *) x, IN1, OUT0);
    x->x_val = 0;
    outlet(x, &s_float);
    if (u_debug)
        post("sigsnap %lx", x);
    return (x);
}
