
/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.4 $ IRCAM $Date: 1993/11/19 10:50:55 $
 *
 * FTS by Miller Puckette
 *
 */


#define MAXIN 8

typedef struct head {
    t_object h_ob;
    short h_nin;
    short h_nout;
    short h_count;
    unsigned int h_bazzed:1;    /* true if ugen is already on a call list */
    unsigned int h_recall:1;    /* "put" me again after dependents */
    unsigned int h_forcer:1;    /* inlet is "order forcer" */
    struct ugen *h_next;
} t_head;

typedef struct ugen {
    t_head u_h;
    struct sig *u_io[1];
} t_ugen;

typedef void *(*t_retptr)();    /* function returning pointer */

void u_set(long int vecsize);

#define U_IN(x) (x)             /* preferred */
#define U_OUT(x) (x)
#define IN0 0                   /* historical */
#define IN1 1
#define IN2 2
#define IN3 3
#define OUT0 0
#define OUT1 1
#define OUT2 2
#define OUT3 3

extern int u_debug;

#ifdef I860
#define UCALL_PAGE_SIZE 0x1000  /* this can be exended later for 4meg ram */
#else
#define UCALL_PAGE_SIZE 0x1000
#endif

/* values for argument to "put" message -- probably temporary */
#define U_TAKEOFF 0L
#define U_PUTON 1L
#define U_DONEPUTTINGON 2L
