#ifndef lint
static char rcsid[] =
    "$Revision: 2.1 $ IRCAM $Date: 1993/11/22 12:24:15 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.1 $ IRCAM $Date: 1993/11/22 12:24:15 $
 *
 *  definitions of samplerate~ and vectorsize~.  Provides access to sample
 *  rates and vector sizes of signals -- msp 11/93.
 *
 */


#include "m_mess.h"
#include "d_graph.h"
#include "d_ugen.h"

extern struct symbol s_sig, s_, s_put, s__sigsamplerate, s__sigvectorsize;

typedef struct sigparam {
    t_head c_h;
    t_sig *c_io[IN1];
    float c_rate;
    int c_vecsize;
    int c_isvecsize;
} t_sigparam;

void sigparam_bang(t_sigparam *x)
{
    if (x->c_vecsize <= 0)
        error("samplerate/vecsize: not available until DSP started");
    else if (x->c_isvecsize)
        outlet_int(x->c_h.h_ob.o_outlet, x->c_vecsize);
    else
        outlet_float(x->c_h.h_ob.o_outlet, (double) x->c_rate);
}

void sigparam_put(t_sigparam *x, long int whether)
{
    if (whether)
    {
        u_stdout((t_ugen *) x);
        x->c_rate = x->c_io[0]->s_sr;
        x->c_vecsize = x->c_io[0]->s_n;
    }
}

void sigparam_setup()
{
    c_new(&s__sigsamplerate, u_clean, sizeof(t_sigparam), 0, 0);
    c_addmess(sigparam_put, &s_put, A_CANT, 0);
    c_addbang(sigparam_bang);
    u_inletmethod(0);
}

void *sigparam_class;
void *sigsamplerate_new()
{
    t_sigparam *x =
        (t_sigparam *) obj_new((t_messlist **) & sigparam_class,
                               sigparam_setup);
    u_setup((t_ugen *) x, IN1, OUT0);
    x->c_vecsize = -1;
    x->c_isvecsize = 0;
    outlet_new(x, &s_float);
    return (x);
}

void *sigvectorsize_new()
{
    t_sigparam *x =
        (t_sigparam *) obj_new((t_messlist **) & sigparam_class,
                               sigparam_setup);
    u_setup((t_ugen *) x, IN1, OUT0);
    x->c_vecsize = -1;
    x->c_isvecsize = 1;
    outlet_new(x, &s_int);
    return (x);
}
