#ifndef lint
static char rcsid[] =
    "$Revision: 2.4 $ IRCAM $Date: 1993/11/19 16:22:09 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.4 $ IRCAM $Date: 1993/11/19 16:22:09 $
 *
 * FTS by Miller Puckette
 *
 */


/* definitions of up~, down~.  */
#include "m_extern.h"
#include "d_graph.h"
#include "d_ugen.h"

extern struct symbol s_, s__sig, s_put, s__sigup, s__sigdown;

#ifdef I860
void su_up(), su_down();
#endif

/************** up ***************/
typedef struct upctl {
    float c_last[3];
} t_upctl;

typedef struct up {
    t_head x_h;
    t_sig *x_io[IN1 + OUT1];
    t_upctl *x_ctl;
    t_upctl x_cspace;
} t_up;

#ifndef I860

void cu_up(float *in, float *out, t_upctl *x, long int n)       /* untested */
{
    float x0;
    float x1 = x->c_last[0];
    float x2 = x->c_last[1];
    float x3 = x->c_last[2];
    while (n--)
    {
        x0 = x1;
        x1 = x2;
        x2 = x3;
        x3 = *in++;
        *out++ = .5625 * (x1 + x2) - .0625 * (x0 + x3);
        *out++ = x2;
    }
    x->c_last[0] = x1;
    x->c_last[1] = x2;
    x->c_last[2] = x3;
}
#endif

void up_put(t_up *x, long int whether)
{
    if (whether)
    {
        u_genout((t_ugen *) x, x->x_io[0]->s_n << 1);
        x->x_ctl = dspchain_putstate(u_chain, &x->x_cspace,
                                     sizeof(t_upctl), sizeof(float));
#ifdef I860
        dspchain_put860(u_chain, su_up, 4,
                        x->x_io[0]->s_shit, x->x_io[1]->s_shit, x->x_ctl,
                        x->x_io[0]->s_n);
#else
        dspchain_putc(u_chain, cu_up, 4,
                      x->x_io[0]->s_shit, x->x_io[1]->s_shit, x->x_ctl,
                      x->x_io[0]->s_n);
#endif
        if (u_debug)
            post("up %lx: %lx->%lx", x->x_ctl,
                 x->x_io[0]->s_shit, x->x_io[1]->s_shit);
    }
    else
    {
        bcopy(x->x_ctl, &x->x_cspace, sizeof(t_upctl));
        x->x_ctl = &x->x_cspace;
    }
}

void *up_class;
void up_setup()
{
    c_new(&s__sigup, u_clean, sizeof(t_up), 0, 0);
    c_addmess(up_put, &s_put, A_CANT, 0);
    u_inletmethod(0);
}

void *sigup_new()
{
    t_up *x = (t_up *) obj_new((t_messlist **) & up_class, up_setup);
    u_setup((t_ugen *) x, IN1, OUT1);
    x->x_ctl = &x->x_cspace;
    x->x_cspace.c_last[0] = x->x_cspace.c_last[1] = x->x_cspace.c_last[2] =
        0;
    if (u_debug)
        post("up %lx", x);
    return (x);
}

/************** down ***************/
typedef struct down {
    t_head x_h;
    t_sig *x_io[IN1 + OUT1];
} t_down;

#ifndef I860
void cu_down(float *in, float *out, long int n) /* untested */
{
    out += n;
    in += 2 * n - 1;
    while (n--)
    {
        *--out = *in;
        in -= 2;
    }
}
#endif

void down_put(t_down *x, long int whether)
{
    if (whether)
    {
        u_genout((t_ugen *) x, x->x_io[0]->s_n >> 1);
#ifdef I860
        dspchain_put860(u_chain, su_down, 3,
                        x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                        x->x_io[1]->s_n);
#else
        dspchain_putc(u_chain, cu_down, 3,
                      x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                      x->x_io[1]->s_n);
#endif
        if (u_debug)
            post("down %lx: %lx->%lx", x,
                 x->x_io[0]->s_shit, x->x_io[1]->s_shit);
    }
}

void *down_class;
void down_setup()
{
    c_new(&s__sigdown, u_clean, sizeof(t_down), 0, 0);
    c_addmess(down_put, &s_put, A_CANT, 0);
    u_inletmethod(0);
}

void *sigdown_new()
{
    t_down *x =
        (t_down *) obj_new((t_messlist **) & down_class, down_setup);
    u_setup((t_ugen *) x, IN1, OUT1);
    if (u_debug)
        post("down %lx", x);
    return (x);
}
