#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1993/11/19 10:51:05 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1993/11/19 10:51:05 $
 *
 * FTS by Miller Puckette
 *
 */


/* sigthrow and sigcatch */

#include "m_mess.h"
#include "d_graph.h"
#include "d_ugen.h"

extern struct symbol s_put, s_set, s_, s_print, s_rats, s__sigthrow,
    s__sigcatch, s__sigswitch;

#ifdef NONONONO
static float *foobar;
static int counter;
#endif

/******************** sigcatch ***********************/
typedef struct sigcatch {
    t_head x_h;
    t_sig *x_io[IN1 + OUT1];
    t_symbol *x_sym;
    struct sigcatch *x_next;    /* list of sigcatchs hanging from symbol */
    char x_buf[SIGALIGN + MAXVS * sizeof(float)];
    float *x_samps;             /* aligned pointer into above */
} t_sigcatch;

extern void *sigcatch_class;

void copy_in(char *in, char *out, int bytes), cu_zero(float *fp,
                                                      long int n);

#ifdef NONONONO
void cu_sigcatch(samps, sig, n)
float *samps, *sig;
{
    long *fp;
    int i;
    copy_in(samps, sig, n << 2);
    if (foobar == samps)
    {
        for (i = 0, fp = (long *) sig; i < n; i++, fp++)
        {
            if (*fp)
            {
                if (counter < 5)
                    post("cu_sigcatch");
                counter++;
                break;
            }
        }
    }
    cu_zero(samps, n);
}
#endif

void sigcatch_put(t_sigcatch *x, long int whether)
{
    if (whether)
    {
        u_stdout((t_ugen *) x);
        if (x->x_sym->s_thing != (t_object *) x)
            warn("%s: duplicate", x->x_sym->s_name);
        cu_zero(x->x_samps, MAXVS);
        dspchain_putc(u_chain, copy_in, 3,
                      x->x_samps, x->x_io[1]->s_shit,
                      (x->x_io[1]->s_n << 2));
        dspchain_putc(u_chain, cu_zero, 2, x->x_samps, x->x_io[1]->s_n);
        /*
           dspchain_putc(u_chain, cu_sigcatch, 3, 
           x->x_samps, x->x_io[1]->s_shit, (x->x_io[1]->s_n));
         */
        if (u_debug)
            post("catch %lx: ->%lx", x, x->x_io[1]->s_shit);
    }
}

#ifdef NONONONO
void sigcatch_rats(x, whether)
t_sigcatch *x;
long whether;
{
    if (whether)
        foobar = x->x_samps;
    else
        foobar = 0;
}
#endif

void sigcatch_clean(t_sigcatch *x)
{
    u_clean((t_ugen *) x);
    if (x->x_sym->s_thing
        && ob_messlist(x->x_sym->s_thing) == sigcatch_class)
    {
        t_sigcatch stub, *y, *z;
        stub.x_next = (t_sigcatch *) (x->x_sym->s_thing);
        for (y = &stub; z = y->x_next; y = z)
        {
            if (z == x)
            {
                y->x_next = z->x_next;
                break;
            }
        }
        x->x_sym->s_thing = (t_object *) (stub.x_next);
    }
}

void *sigcatch_class;
void sigcatch_setup()
{
    c_new(&s__sigcatch, sigcatch_clean, sizeof(t_sigcatch), 0, 0);
    c_addmess(sigcatch_put, &s_put, A_CANT, 0);
    /* c_addmess(sigcatch_rats, &s_rats, A_LONG, 0); */
    u_inletmethod(0);
}

void *sigcatch_new(t_symbol *s)
{
    t_sigcatch *x =
        (t_sigcatch *) obj_new((t_messlist **) & sigcatch_class,
                               sigcatch_setup);
    float *fp;
    int i;
    if (!(*s->s_name))
        s = &s__sigcatch;
    x->x_samps =
        (float *) (x->x_buf + ((-(long) (x->x_buf)) & (SIGALIGN - 1)));
    for (i = MAXVS, fp = x->x_samps; i--;)
        *(fp++) = 0;
    u_setup((t_ugen *) x, IN1, OUT1);
    u_setforcer(x);
    if (u_debug)
        post("catch %lx", x);
    x->x_sym = s;
    if (s->s_thing)
    {
        if (ob_messlist(s->s_thing) != sigcatch_class)
        {
            error("%s: already exists and is not a catch", s->s_name);
        }
        else
        {
            x->x_next = ((t_sigcatch *) (s->s_thing));
            s->s_thing = (t_object *) x;
        }
    }
    else
    {
        s->s_thing = (t_object *) x;
        x->x_next = 0;
    }
    return (x);
}

/******************** sigthrow ***********************/

typedef struct sigthrow {
    t_head x_h;
    t_sig *x_io[IN1 + OUT1];
    t_symbol *x_sym;
    float *x_cspace;
    float **x_ctl;
} t_sigthrow;

void cu_throw(float *in, float **outp, long int n, t_sigthrow *x)
{
    float *out = *outp;
    if (out)
        cu_vadd(in, out, out, n);
#ifdef NONONONO
    if (out && out == foobar)
    {
        post("%x wrote to it", x);
        foobar = 0;
    }
#endif
}

void sigthrow_set(t_sigthrow *x, t_symbol *s)
{
    t_sigcatch *c;
    x->x_sym = s;
    if ((c = (t_sigcatch *) (x->x_sym->s_thing)) &&
        ob_messlist(c) == sigcatch_class)
        *(x->x_ctl) = c->x_samps;
    else
    {
        error("throw: %s: no such catch", s->s_name);
        *(x->x_ctl) = 0;
    }
}

void sigthrow_int(t_sigthrow *x, long int n)
{
    char buf[30];
    gensampname(buf, "catch", n);
    sigthrow_set(x, gensym(buf));
}

void sigthrow_print(t_sigthrow *x, t_symbol *s)
{
    if (s == &s_)
        s = &s__sigthrow;
    post("%s: %s", s->s_name, x->x_sym->s_name);
}

void sigthrow_put(t_sigthrow *x, long int whether)
{
    if (whether)
    {
        t_sigcatch *c;
        u_stdout((t_ugen *) x);
        x->x_ctl = dspchain_putstate(u_chain, &x->x_cspace,
                                     sizeof(x->x_cspace), sizeof(float));
        if ((c = (t_sigcatch *) (x->x_sym->s_thing)) &&
            ob_messlist(c) == sigcatch_class)
        {
            *(x->x_ctl) = c->x_samps;
            dspchain_putc(u_chain, cu_throw, 4,
                          x->x_io[0]->s_shit, x->x_ctl, x->x_io[0]->s_n,
                          x);
        }
        else
            error("throw~: can't find catch named '%s", x->x_sym->s_name);
        if (u_debug)
            post("throw %lx: %lx->", x, x->x_io[0]->s_shit);
    }
    else
    {
        x->x_cspace = *x->x_ctl;
        x->x_ctl = &x->x_cspace;
    }
}

void sigthrow_setup()
{
    c_new(&s__sigthrow, u_clean, sizeof(t_sigthrow), 0, 0);
    c_addmess(sigthrow_put, &s_put, A_CANT, 0);
    c_addmess(sigthrow_set, &s_set, A_SYM, 0);
    c_addmess(sigthrow_print, &s_print, A_DEFSYM, 0);
    c_addint(sigthrow_int);
    u_inletmethod(0);
}

void *sigthrow_class;
void *sigthrow_new(t_symbol *s)
{
    t_sigthrow *x =
        (t_sigthrow *) obj_new((t_messlist **) & sigthrow_class,
                               sigthrow_setup);
    u_setup((t_ugen *) x, IN1, OUT1);
    x->x_sym = s;
    x->x_ctl = &x->x_cspace;
    x->x_cspace = 0;
    if (u_debug)
        post("throw %lx", x);
    return (x);
}

/******************** sigswitch ***********************/

typedef struct switchctl {
    long x_on;
    long x_next;
} t_switchctl;

typedef struct sigswitch {
    t_head x_h;
    t_sig *x_io[IN1 + OUT1];
    t_switchctl x_cspace;
    t_switchctl *x_ctl;
} t_sigswitch;

#ifdef I860
void su_switch();
#else
long *ugen_switch(long *where)
{
    t_switchctl *ctl = (t_switchctl *) (where[1]);
    if (ctl->x_on)
        return (where + 2);
    else
        return ((long *) (ctl->x_next));
}
#endif


void sigswitch_int(t_sigswitch *x, long int n)
{
    x->x_ctl->x_on = n;
}

long dspchain_next(t_dspchain * x);

void sigswitch_put(t_sigswitch *x, long int whether)
{
    if (whether == U_PUTON)
    {
        t_sigcatch *c;
        u_stdout((t_ugen *) x);
        x->x_ctl = dspchain_putstate(u_chain, &x->x_cspace,
                                     sizeof(x->x_cspace), sizeof(float));
        if (x->x_io[0]->s_shit != x->x_io[1]->s_shit)
            dspchain_putc(u_chain, copy_in, 3,
                          x->x_io[0]->s_shit, x->x_io[1]->s_shit,
                          x->x_io[0]->s_n * sizeof(float));
#ifdef I860
        dspchain_put860(u_chain, su_switch, 1, x->x_ctl);
#else
        dspchain_addugen(ugen_switch, 1, x->x_ctl);
#endif
        if (u_debug)
            post("switch %lx", x);
    }
    else if (whether == U_DONEPUTTINGON)
    {
        x->x_ctl->x_next = dspchain_next(u_chain);
    }
    else
    {
        bcopy(x->x_ctl, &x->x_cspace, sizeof(x->x_cspace));
        x->x_ctl = &x->x_cspace;
    }
}

void sigswitch_setup()
{
    c_new(&s__sigswitch, u_clean, sizeof(t_sigswitch), 0, 0);
    c_addmess(sigswitch_put, &s_put, A_CANT, 0);
    c_addint(sigswitch_int);
    u_inletmethod(0);
}

void *sigswitch_class;
void *sigswitch_new(t_symbol *s)
{
    t_sigswitch *x =
        (t_sigswitch *) obj_new((t_messlist **) & sigswitch_class,
                                sigswitch_setup);
    u_setup((t_ugen *) x, IN1, OUT1);
    x->x_ctl = &x->x_cspace;
    x->x_cspace.x_on = 0;
    x->x_cspace.x_next = 0;
    x->x_h.h_recall = 1;
    if (u_debug)
        post("switch %lx", x);
    return (x);
}
