#ifndef lint
static char rcsid[] =
    "$Revision: 2.11 $ IRCAM $Date: 1994/02/07 10:39:32 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.11 $ IRCAM $Date: 1994/02/07 10:39:32 $
 *
 * FTS by Miller Puckette
 *
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include "m_mess.h"
#include "cp_mess.h"
#include "h_cp.h"
#include <stdarg.h>

int h_nproc = 1;                /* number of CPs used */
struct messbuf messbuf;

char *ebuf = messbuf.m_shit + MSIZE, *bptr;
int initted1;

int logfd;
static t_method pollfn = 0;
static int h_logfd;             /* fd for writing logfile */
static ftsType currentFts = (ftsType) 0;
int h_dead = 1;
static int h_initted = 0;
int h_machversion = 3;
int h_verbose;
static void h_sendit(long command);

void h_poll(int secs), doqueue(char *s, int size);


h_died()
{
    h_dead = 1;
    post("FTS died -- save your work and restart");
}

#ifdef __alpha
void nop_because_of_incredible_compiler_bug()
{
    /* null function */
}
#endif

static void doneit(struct messhdr *msg, char *s)
{
#ifdef __alpha
    /* If the first line of a function is a switch statement
       then the alpha compiler skips it.  Hence this kludge */
    nop_because_of_incredible_compiler_bug();
#endif
    switch (msg->m_command)
    {
    case H_PRINT:
        pdisplay(s);
        break;
    case H_QUEUE:
        doqueue(s, msg->m_size);
        break;
    default:
        error("bad return message");
    }
}

void doit(int c)
{
    static struct messhdr msg;
    static char buf[MSIZE + 1], *pt = (char *) (&msg), *emess;
    static int gothdr = 0;
    if (gothdr)
    {
        *(pt++) = c;
        if (pt == emess)
        {
            *pt = 0;
            doneit(&msg, buf);
            gothdr = 0;
            pt = (char *) (&msg);
        }
    }
    else
    {
#ifdef __linux                  /* MACHDEP -- really should be ifdef little-endian */
        if (pt == (char *) &msg && (c != H_PRINT && c != H_QUEUE))
#else
        if (pt >= (char *) &msg && pt <= ((char *) &msg) + 2 && c)
#endif
        {                       /* bad message */
            putc(c, stderr);
            pt = (char *) &msg;
        }
        else
        {
            *(pt++) = c;
            if (pt == (char *) (&msg + 1))
            {
                /* should really reallocate buffer here */
                if (msg.m_size > MSIZE || msg.m_size < 0)
                {
                    error("return message too long");
                    pt = (char *) &msg;
                }
                else
                {
                    pt = buf;
                    emess = pt + msg.m_size;
                    gothdr = 1;
                }
            }
        }
    }
}

void (*h_timeackfunction)();

h_installack(void (*f)( /* ??? */ ))
{
    h_timeackfunction = f;
}

void doqueue(char *s, int size)
{
    struct qmess *qm = (struct qmess *) s;
    s += sizeof(struct qmess);
    size -= sizeof(struct qmess);
    if (size < 0)
    {
        post("bad q return message");
        return;
    }
    if (qm->qm_fn)
        (*qm->qm_fn) (qm->qm_ptr, s, size);
    else if (h_timeackfunction)
        (*h_timeackfunction) (qm->qm_ptr, s, size);
}

void fromsock(char *s, int n)
{
    while (n--)
        doit(*s++ & 0xff);
}

void h_dopoll()
{
    if (pollfn)
        (*pollfn) ();
    h_poll(0);
}

/* @@@ Questi erano static e sono comunque locali a h_mess,
   andrebbero riorganizzati tutti assieme ai default */

t_symbol *h_ftsdir = 0, *h_bootdir = 0;
int h_usedacs = 3;
int h_animal = 1;               /* new default: start as animal */
int h_killer = 0;
int h_srate = 0;
int h_usingoldcpos = 0;

void h_setftsdir(const char *s)
{
    utils_init();               /* so gensym will work */
    h_ftsdir = gensym(s);
}

char *h_getftsdir()
{
    if (!h_ftsdir)
        h_setftsdir(".");
    return (h_ftsdir->s_name);
}

void h_setbootdir(const char *s)
{
    utils_init();
    h_bootdir = gensym(s);
}

char *h_getbootdir()
{
    if (!h_bootdir)
        return ("");
    else
        return (h_bootdir->s_name);
}

h_setkiller(int n)
{
    h_killer = n;
}

/* set or get the sample rate */
void h_setrate(float rate)
{
    utils_init();
    if (rate < 1 || rate > 1000000000)
    {
        error("sample rate out of range -- defaulting to 44100");
        rate = 44100;
    }
    h_srate = rate;
    if (h_initted)
        h_vmess(0, gensym("#_setsr_"), "l", (long) h_srate);
}

float h_getrate()
{
    return h_srate;
}

static int h_channels[MAXCP / 2] = { 2, 2, 2 };

/* set or get the current throttle settings for host/CP xfers */
int h_throttlehasbeenset;
static int h_th1, h_th2, h_th3;

void h_setthrottle(int th1, int th2, int th3)
{
    if (th1 < 1)
        error("throttle1 set to 1"), th1 = 1;
    if (th2 < 0)
        error("throttle2 set to 0"), th2 = 0;
    if (th3 < 0)
        error("throttle3 set to 0"), th3 = 0;
    h_th1 = th1;
    h_th2 = th2;
    h_th3 = th3;
    (*currentFts->h_dosetthrottle) (th1, th2, th3);
    h_throttlehasbeenset = 1;
}

void h_getthrottle(int *th1, int *th2, int *th3)
{
    *th1 = h_th1;
    *th2 = h_th2;
    *th3 = h_th3;
}

int h_advances[MAXCP];

/* set or get the current list of scheduler advances */
void h_setadvances(int *vec, int n)
{
    int i;
    t_atom at[MAXCP];
    utils_init();
    for (i = 0; i < n; i++)
    {
        if (vec[i] < MINADVANCE)
            vec[i] = MINADVANCE;
        else if (vec[i] > MAXADVANCE)
            vec[i] = MAXADVANCE;
        h_advances[i] = vec[i];
    }
    if (h_initted)
    {
#if 0
        for (i = 0; i < h_nproc; i++)
            SETLONG(at + i, h_advances[i]);
        for (i = 0; i < h_nproc; i++)
            h_mess((void *) i, gensym("#_setadv_"), h_nproc, at);
#else
        for (i = 0; i < h_nproc; i++)
            h_vmess((void *) i, gensym("#_setadv_"), "l", h_advances[i]);
#endif
    }
}

void h_getadvances(int *vec)
{
    int i;
    for (i = 0; i < h_nproc; i++)
        vec[i] = h_advances[i];
}

/* utilities for parsing colon-separated strings into ints or strings */
int h_getstr(char **in, char *str, int maxlen)
{
    char *in2 = *in, *in3;
    int length, i;
    while (*in2 == ':' || *in2 == ',')
        in2++;
    if (!*in2)
        return (-1);
    for (in3 = in2; *in3 && *in3 != ':' && *in3 != ','; in3++);
    if (in3 - in2 >= maxlen - 2)
    {
        error("%s: string too long", in2);
        return (-1);
    }
    if (in3 != in2)
    {
        strncpy(str, in2, in3 - in2);
        str[in3 - in2] = 0;
        *in = in3;
        return (0);
    }
    else
        return (-1);
}

int h_getint(char *str, int *vec, int *count)
{
    char s2[81];
    int i;
    for (i = 0; i < *count; i++)
    {
        if (h_getstr(&str, s2, 80))
            break;
        if (sscanf(s2, "%d", vec + i) < 1)
            return (-1);
    }
    *count = i;
    return (0);
}

void h_setthrottlestring(const char *str)
{
    int throttle[3], narg = 3;
    if (h_getint((char *) str, throttle, &narg) || narg < 3)
        error("throttle: %s: 3 values required", str);
    else
        h_setthrottle(throttle[0], throttle[1], throttle[2]);
}

/* set the scheduler advances, given a colon-separated string */
void h_setadvancesstring(const char *str)
{
    int advance[MAXCP], narg = MAXCP;
    if (h_getint((char *) str, advance, &narg) || narg < 1)
        error("advance: %s: integer values required", str);
    else
        h_setadvances(advance, narg);
}

int h_faketime = 0, h_makinglogfile = 0;
h_setnonrealtime()
{
    h_faketime = 1;
}

h_setlogfile(int n)
{
    h_makinglogfile = n;
}

void h_setpollfunction(t_method fun)
{
    pollfn = fun;
}

void h_setverbose(int n)
{
    h_verbose = n;
}

int h_getverbose()
{
    return (h_verbose);
}

/****************** set the hardware *****************/

static int hardware;

int h_gethardware()
{
    return (hardware);
}

/* set hardware platform.  The "none" case is treated by the
   "unix" functions. */

void h_sethardware(int x)
{
    switch (x)
    {
    case H_UNIX:
        currentFts = soxFts;
        break;
    case H_NONE:
        currentFts = soxFts;
        break;
#ifdef NEXTSTEP
    case H_ISPW:
        currentFts = standaloneFts;
        break;
#endif
    default:
        bug("h_sethardware");
        break;
    }
    hardware = x;
}

void h_setfts(ftsType fts)      /* old version */
{
    if (currentFts)
        return;
    currentFts = fts;
}

ftsType whichFts()
{
    return (currentFts);
}

int h_iscpos()
{
    return 0;
}

/****************** sending messages to CP ********************/
h_newmess()
{
    bptr = messbuf.m_shit;
}

void h_putint(x)
#ifdef __alpha
long x;
#else
void *x;
#endif
{
    char buf[80];
    int len;
    sprintf(buf, "%lx", x);
    len = strlen(buf) + 1;
    if (bptr + len + 2 >= ebuf)
        error("message overflow");
    else
    {
        *(bptr++) = 'i';
        strcpy(bptr, buf);
        bptr += len;
    }
}

void h_putfloat(double f)
{
    char buf[80];
    int len;
    sprintf(buf, "%lf", f);
    len = strlen(buf) + 1;
    if (bptr + len + 2 >= ebuf)
        error("message overflow");
    else
    {
        *(bptr++) = 'f';
        strcpy(bptr, buf);
        bptr += len;
    }
}

void h_putsym(struct symbol *s)
{
    int len = strlen(s->s_name) + 1;
    if (bptr + len + 2 >= ebuf)
        error("message overflow");
    else
    {
        *(bptr++) = 's';
        strcpy(bptr, s->s_name);
        bptr += len;
    }
}

void h_putobj(x)
#ifdef __alpha
long x;
#else
int x;
#endif
{
    char buf[80];
    int len;
    sprintf(buf, "%lx", x);     /* unsure if should always be %lx */
    /* foley@iannis Tuesday August 3, 1993 */
    len = strlen(buf) + 1;
    if (bptr + len + 2 >= ebuf)
        error("message overflow");
    else
    {
        *(bptr++) = 'o';
        strcpy(bptr, buf);
        bptr += len;
    }
}

void h_new(void *id, int proc, struct symbol *s, int ac, struct atom *av)
{
    h_newmess();
    h_putint(id);
    h_putsym(s);
    while (ac--)
    {
        switch (av->a_type)
        {
        case A_SYM:
            h_putsym(av->a_w.w_sym);
            break;
        case A_LONG:
            h_putint(av->a_w.w_long);
            break;
        case A_FLOAT:
            h_putfloat((double) av->a_w.w_float);
            break;
        case A_OBJ:
            h_putobj(av->a_w.w_long);
            break;
        }
        av++;
    }
    h_sendit((long) CP_NEW + proc);
}

void *h_makeid()
{
    static int i = 99;
    return ((void *) (i += 2));
}


void *h_newunique(int proc, struct symbol *s, int ac, struct atom *av)
{
    void *id = h_makeid();
    h_new(id, proc, s, ac, av);
    return (id);
}

void h_mess(void *id, struct symbol *s, int ac, struct atom *av)
{
    h_newmess();
    h_putint(id);
    h_putsym(s);
    while (ac--)
    {
        switch (av->a_type)
        {
        case A_SYM:
            h_putsym(av->a_w.w_sym);
            break;
        case A_LONG:
            h_putint(av->a_w.w_long);
            break;
        case A_FLOAT:
            h_putfloat((double) av->a_w.w_float);
            break;
        case A_OBJ:
            h_putobj(av->a_w.w_long);
            break;
        default:
            error("unknown message type");
        }
        av++;
    }
    h_sendit((long) CP_MESS);
}


#ifdef THESE_MACHINE_DEPENDENT_VERSIONS_ARE_REPLACED_BY_THE_ONES_BELOW
void h_vnew(void *id, int proc, struct symbol *s, char *fmt, ...)
{
    t_atom av[100];
    int ac;
    mkacv(&ac, av, fmt, (char *) (&fmt + 1));
    h_new(id, proc, s, ac, av);
}

void *h_vnewunique(int proc, struct symbol *s, char *fmt, ...)
{
    t_atom av[100];
    int ac;
    void *id = h_makeid();
    mkacv(&ac, av, fmt, (char *) (&fmt + 1));
    h_new(id, proc, s, ac, av);
    return (id);
}

void h_vmess(void *id, struct symbol *s, char *fmt, ...)
{
    t_atom av[100];
    int ac;
    mkacv(&ac, av, fmt, (char *) (&fmt + 1));
    h_mess(id, s, ac, av);
}
#endif

void h_vnew(void *id, int proc, t_symbol *s, char *fmt, ...)
{
    va_list ap;
    t_atom atoms[100], *nextatom = atoms;
    int atomcount = 0;

    va_start(ap, fmt);
    while (1)
    {
        switch (*fmt++)
        {
        case 'l':
            SETLONG(nextatom, va_arg(ap, long));
            break;
        case 'f':
            SETFLOAT(nextatom, va_arg(ap, double));
            break;
        case 's':
            SETSYM(nextatom, va_arg(ap, t_symbol *));
            break;
        case 'o':
            SETOBJ(nextatom, va_arg(ap, void *));
            break;
        case 0:
            goto nomore;
        default:
            bug("h_vnew: bad character in format string");
        }
        atomcount++;
        nextatom++;
    }
  nomore:
    h_new(id, proc, s, atomcount, atoms);
    va_end(ap);
}

void *h_vnewunique(int proc, t_symbol *s, char *fmt, ...)
{
    va_list ap;
    t_atom atoms[100], *nextatom = atoms;
    int atomcount = 0;
    void *id = h_makeid();

    va_start(ap, fmt);
    while (1)
    {
        switch (*fmt++)
        {
        case 'l':
            SETLONG(nextatom, va_arg(ap, long));
            break;
        case 'f':
            SETFLOAT(nextatom, va_arg(ap, double));
            break;
        case 's':
            SETSYM(nextatom, va_arg(ap, t_symbol *));
            break;
        case 'o':
            SETOBJ(nextatom, va_arg(ap, void *));
            break;
        case 0:
            goto nomore;
        default:
            bug("h_vnew: bad character in format string");
        }
        atomcount++;
        nextatom++;
    }
  nomore:
    va_end(ap);
    h_new(id, proc, s, atomcount, atoms);
    return (id);
}

void h_vmess(void *id, t_symbol *s, char *fmt, ...)
{
    va_list ap;
    t_atom atoms[100], *nextatom = atoms;
    int atomcount = 0;

    va_start(ap, fmt);
    while (1)
    {
        switch (*fmt++)
        {
        case 'l':
            SETLONG(nextatom, va_arg(ap, long));
            break;
        case 'f':
            SETFLOAT(nextatom, va_arg(ap, double));
            break;
        case 's':
            SETSYM(nextatom, va_arg(ap, t_symbol *));
            break;
        case 'o':
            SETOBJ(nextatom, va_arg(ap, void *));
            break;
        case 0:
            goto nomore;
        default:
            bug("h_vnew: bad character in format string");
        }
        atomcount++;
        nextatom++;
    }
  nomore:
    va_end(ap);
    h_mess(id, s, atomcount, atoms);
}

void h_free(void *id)
{
    h_newmess();
    h_putint(id);
    h_sendit((long) CP_FREE);
}

/* version of free which only disconnects from host */
void h_cutoff(void *id)
{
    h_newmess();
    h_putint(id);
    h_putint(NIL);
    h_sendit((long) CP_FREE);
}

void h_connect(void *id1, int n1, void *id2, int n2)
{
    h_newmess();
    h_putint(id1);
    h_putint((long) n1);
    h_putint(id2);
    h_putint((long) n2);
    h_sendit((long) CP_CONNECT);
}

void h_disconnect(void *id1, int n1, void *id2, int n2)
{
    h_newmess();
    h_putint(id1);
    h_putint((long) n1);
    h_putint(id2);
    h_putint((long) n2);
    h_sendit((long) CP_DISCONNECT);
}

int pongwait;

void h_pong()
{
    pongwait = 0;
}

void h_init()
{

    if (h_initted)
        return;
    h_initted = 1;
#ifdef XMAX                     /* why different */
    (*currentFts->h_init) ();
#else
    utils_init();
#endif
}

int h_cpuslot[MAXCP];           /* this should be symbols naming processors */

/* Queste due dovrebbero essere sostituite da qualcosa di generico
   contenuto in h_mess_gen; al piu' possono chiamare quelle,
   o possiamo mettere quelle nella struttura visto che sono uguali per
   sock ee gli altri.  (but they're now considered generic, if not
   perfectly machine dependent -- msp)
   */

/* set slots and scheduler advances.  List should be separated by commas,
   no spaces.  Stupid flags like "S" should disappear and others like
   DAC config should be redone machine-independently. */

extern int h_stdnproc, h_unixnproc;

#ifdef ISPW
#include "../6a/6a.h"           /* these are here for t_setconfig()  */
#include "../6a/proto56.h"
#include "../56k/converterType.h"

void h_setconfig(char *s)
{
    int i = 0;
    int hit[MAXSLOTNO];
    int dactype = CONV_ARIEL;
    int non = 0;
    while (*s && *s <= '0' || *s >= '9')
    {
        if (*s == 'q')
        {
            h_usedacs = 0;
        }
        else if (*s == 'n')
        {

            if (h_verbose)
                post("running in simulation\n");
            h_setnonrealtime();
            non = 1;
            /* hack added to facilitate debugging "unix version" from NeXT */
            if (s[1] && s[1] != ',')
                h_setunix(s + 1, 1), i = 1;
        }
        else if (*s == 'S')
        {
            if (h_verbose)
                post("limit to 2 channels\n");
            h_usedacs = 1;
        }
        else if (*s == 'Q')
        {
            if (h_verbose)
                post("limit to 4 channels\n");
            h_usedacs = 2;
        }
        else if (*s == 'H')
        {
            if (h_verbose)
                post("limit to 6 channels\n");
            h_usedacs = 3;
        }
        else if (*s == 'a')
        {
            dactype = CONV_ARIEL;
        }
        else if (*s == 'k')
        {
            if (h_verbose)
                post("setting killer flag\n");
            h_setkiller(1);
        }
        else if (*s == 'r')
        {
            int sr = 44100;
            sscanf(s + 1, "%d", &sr);
            if (sr < 0)
                sr = 0;
            else if (sr > 96000)
                sr = 96000;
            h_srate = sr;
        }
        else if (*s == 'b')
        {
            dactype = CONV_IRCAM;
            if (!h_srate)
                h_srate = 44100;
        }
        else if (*s == 'c')
        {
            dactype = CONV_CD;
        }
        else if (*s == 'o')
        {
            if (h_verbose)
                post("using NeXT system 2.0 driver\n");
            h_machversion = 2;
        }
        else if (*s == 'e' || *s == 'E')
        {
            int sync = atoi(s + 1);
            if (sync <= 0 || sync > 12)
                sync = 1;
            if (*s == 'E')
                h_initsyncfrom(sync);
            else
                h_inituseebu(sync);
        }
        while (*s && *s != ',')
            s++;
        if (*s == ',')
            s++;
    }
    while (sscanf(s, "%d", &h_cpuslot[i]) >= 1)
    {
        while (*s && *s != '/')
            s++;
        if (!*s)
            break;
        s++;
        if (sscanf(s, "%d", &h_advances[i]) < 1 || h_advances[i] < 2)
            h_advances[i] = 2;
        i++;
        if (i == MAXCP)
            break;
        while (*s && *s != ',')
            s++;
        if (!*s)
            break;
        s++;
    }
    h_nproc = h_stdnproc = h_unixnproc = i;
    if (non)
        h_sethardware(i > 0 ? H_UNIX : H_NONE);
    else
    {
        h_sethardware(H_ISPW);
        if (i < 1)
            hate("can't parse CPU list");
        for (i = 0; i < MAXSLOTNO; i++)
            hit[i] = 0;
        for (i = 0; i < h_nproc; i++)
        {
            if (h_cpuslot[i] < 0 || h_cpuslot[i] >= MAXSLOTNO)
                h_cpuslot[i] = DEFAULTSLOT;
            if (hit[h_cpuslot[i]])
                hate("duplicate slot in CPU list");
            hit[h_cpuslot[i]] = 1;
        }
    }
    h_initdactype(dactype);
}
#endif                          /* ISPW */

void h_getpost()
{
    (*currentFts->h_getpost) ();
}

void h_eof()                    /* disconnect from FTS. */
{
    if (!h_dead)
    {
        (*currentFts->h_eof) ();
        h_dead = 1;
    }
}

int h_start()
{
    if (!h_dead)
    {
        bug("h_start");
        return (0);
    }
    else
        return (*currentFts->h_start) ();
}

void h_poll(int secs)
{
    (*currentFts->h_poll) (secs);
}

#define H_CACHESIZE 102400
char h_cachebuf[H_CACHESIZE];
int h_cachefill;
int h_cacheing;

static void h_flushcache()
{
    if (!h_dead)
        (*currentFts->h_dosend) (h_cachebuf, h_cachefill);
    h_cachefill = 0;
}

static void h_sendit(long command)
{
    int len;
    *(bptr++) = 0;
    messbuf.m_h.m_command = command;
    len = bptr - (char *) (&messbuf);
    if (logfd >= 0 && write(logfd, (char *) (&messbuf), len) < len)
        perror("logfile");
    if (h_dead)
        return;
    if (h_cacheing)
    {
        if (h_cachefill + len > H_CACHESIZE)
        {
            h_flushcache();
        }
        if (len > H_CACHESIZE)
            (*currentFts->h_dosend) ((char *) (&messbuf), len);
        else
        {
            bcopy((char *) (&messbuf), h_cachebuf + h_cachefill, len);
            h_cachefill += len;
        }
    }
    else
        (*currentFts->h_dosend) ((char *) (&messbuf), len);
}

int h_setcacheing(int n)
{
#if 1
    int was = h_cacheing;
    if (was != n)
    {
        if (n)
            h_cachefill = 0;
        else
            h_flushcache();
        h_cacheing = n;
    }
    return (was);
#endif
}

void h_ping()
{
    (*currentFts->h_ping) ();
}

/* Temporary; should be reorganized a little bit */

void h_setmax()
{
    h_animal = 0;
}
