#ifndef lint
static char rcsid[] =
    "$Revision: 2.7 $ IRCAM $Date: 1994/01/29 07:47:59 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.7 $ IRCAM $Date: 1994/01/29 07:47:59 $
 *
 * FTS by Miller Puckette
 *
 */


/* $$$ FASE DEL LAVORO :Cancellate le funzioni uguali per tutti e obsolete,
   assunto h_pipe sempre e comunque. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sgtty.h>
#include <fcntl.h>
#include <signal.h>
#include <errno.h>
#include <stdarg.h>

#include "m_mess.h"
#include "cp_mess.h"
#include "h_cp.h"

#ifdef I860
#include "../6a/6a.h"           /* this is just to know the max slot number... */
#include "../6a/proto56.h"
#endif


extern int h_nproc;
extern struct messbuf messbuf;

/* External declaration for variables included int h_mess_gen.c */

extern char *ebuf;
extern char *bptr;
extern int h_faketime, h_makinglogfile;
extern int h_usedacs;
extern int h_useariel;
extern int h_srate;
extern int h_animal;
extern int h_killer;
extern t_symbol *h_ftsdir;
extern int logfd;
extern int h_dead;

#define UNIXCMDSIZE 1024
int h_unixnproc;
static char h_unixcmd[UNIXCMDSIZE];

void doqueue(char *s, int size);

static fd_set readset, writeset, exceptset;
static int cofd, sendfd;
static char *readahead;
static int readbytes, readalloc;
static void h_poll(int secs);
static int h_start_sox();

#define INITREADSIZE 8192
#define READSIZE 4096

extern int h_advances[];

void h_getunix(char **s1, int *n)
{
    *s1 = h_unixcmd;
    *n = h_unixnproc;
}

void h_setunix(const char *command, int ncp)
{
    strncpy(h_unixcmd, command, UNIXCMDSIZE);
    h_unixcmd[UNIXCMDSIZE - 1] = 0;
    h_unixnproc = ncp;
}

static int h_sox_initted;

static void h_init_sox()
{
    if (h_sox_initted)
        return;
    h_sox_initted = 1;
    if (h_makinglogfile)
    {
        if ((logfd = creat("/tmp/logfile", 0666)) < 0)
            fprintf(stderr, "warning: can't create log file\n");
    }
    else
        logfd = -1;
    if (!(readahead = (char *) malloc(INITREADSIZE)))
        hate("no space for readahead buffer\n");
    readalloc = INITREADSIZE;
    readbytes = 0;

    h_unixnproc = h_nproc;
}

static int h_start_sox()
{
    int pipe1[2], pipe2[2], goo, flags;
    char cmd[256];
    struct timeval timout;
    h_init_sox();
    h_dead = 0;

    if (h_gethardware() == H_NONE)
    {
        post("- running without FTS -");
        h_nproc = 0;
        h_dead = 1;
    }
    else
    {
        post("- running in simulation -");
        h_nproc = h_unixnproc;
        if (pipe(pipe1) < 0)
        {
            syserror("can't create pipe 1\n");
            return (1);
        }
        if (pipe(pipe2) < 0)
        {
            syserror("can't create pipe 2\n");
            return (1);
        }
        if ((goo = fork()) < 0)
        {
            syserror("can't fork\n");
            return (1);
        }
        else if (!goo)
        {
            int foo;
            char procno[80];
            int pn;
            if (dup2(pipe1[0], 0) < 0)
                perror("dup 1");
            if (dup2(pipe2[1], 1) < 0)
                perror("dup 2");
            close(pipe1[0]);
            close(pipe1[1]);
            close(pipe2[0]);
            close(pipe2[1]);
            sprintf(procno, "%d", h_advances[0]);
            for (pn = 1; pn < h_nproc; pn++)
                sprintf(procno + strlen(procno), ",%d", h_advances[pn]);
            if (*h_unixcmd)
                strcpy(cmd, h_unixcmd);
            else
            {
                strcpy(cmd, h_ftsdir->s_name);
                strcat(cmd, "/sock");
            }
            fprintf(stderr, "%s %s\n", cmd, procno);
            foo = execl(cmd, cmd, procno, 0);
            perror("exec");
            _exit(0);
        }
        close(pipe1[0]);
        close(pipe2[1]);
        sendfd = pipe1[1];
        cofd = pipe2[0];
        FD_ZERO(&readset);
        FD_ZERO(&writeset);
        FD_ZERO(&exceptset);
        signal(SIGPIPE, SIG_IGN);
        h_nproc = h_unixnproc;
    }
}

static void h_getpost()
{
    h_animal = 0;
}

static void h_eof_sox()
{
    struct timeval timstart, timstop;
    int elapsedtime;
    gettimeofday(&timstart, 0);
    close(sendfd);
    sendfd = -1;
    while (!h_dead)
    {
        h_poll(1);
        gettimeofday(&timstop, 0);
        elapsedtime =
            (1000 * (timstop.tv_sec - timstart.tv_sec) +
             (timstop.tv_usec - timstart.tv_usec) / 1000);
        if (elapsedtime > 10)
        {
            error("h_eof_sox: child process won't exit");
            break;
        }
    }
    close(cofd);
    cofd = -1;
}

/* Forward declaration */
static int h_getfromcp(char *buf, int size, int secs);

static void h_poll(int secs)
{
    char buf[4096];
    int x;
    if (h_dead)
        return;

    if (readbytes)
    {
        fromsock(readahead, readbytes);
        readbytes = 0;
    }
    while (x = h_getfromcp(buf, 4096, secs))
        fromsock(buf, x);
}

static int h_getfromcp(char *buf, int size, int secs)
{
    int x;
    int gotbytes;
    struct timeval timout;
    timout.tv_sec = secs;
    timout.tv_usec = 0;

    if (h_dead)
        return (0);

    FD_SET(cofd, &readset);
    FD_SET(cofd, &exceptset);
    x = select(cofd + 1, &readset, &writeset, &exceptset, &timout);
    if (x < 0)
    {
        syserror("select failed\n");
        h_eof();
        return (0);
    }
    if (secs && !x)
    {
        post("timout");
        return (0);
    }
    if (FD_ISSET(0, &exceptset))
    {
        post("stdin exception!");
    }
    if (FD_ISSET(cofd, &exceptset))
    {
        post("socket exception!");
    }
    if (FD_ISSET(cofd, &readset))
    {
        gotbytes = read(cofd, buf, size);
        if (gotbytes <= 0)
        {
            h_died();
            return (0);
        }
        else
            return (gotbytes);
    }
    else
        return (0);
}

/* this routine attempts to use asynchronous writing to a pipe,
   which doesn't work yet.  The current solution is not guaranteed not
   to deadlock.  The output pipe should be made F_ASYNC to fix this; I
   didn't know that at the time. */

static sendtopipe(int fd, char *buf, int len)
{
    fd_set readset, writeset, exceptset;
    int sent = 0;
    struct timeval tv;
    FD_ZERO(&readset);
    FD_ZERO(&writeset);
    FD_ZERO(&exceptset);
    tv.tv_sec = 0;
    tv.tv_usec = 0;
    while (1)
    {
        FD_SET(sendfd, &writeset);
        FD_SET(cofd, &readset);
        if (select((sendfd > cofd ? sendfd : cofd) + 1,
                   &readset, &writeset, &exceptset, &tv) < 0)
            perror("select");
        if (sent >= len)
            break;
        if (FD_ISSET(cofd, &readset))
        {
            int nbytes;
            /* post("reading input pipe...\n"); */
            if (readbytes + READSIZE > readalloc)
            {
                readalloc += INITREADSIZE;
                if (!(readahead = (char *) realloc(readahead, readalloc)))
                    hate("no space for readahead buffer");
            }
            nbytes = read(cofd, readahead + readbytes, READSIZE);
#ifdef __unix
            if (nbytes <= 0 && errno != EAGAIN)
#else
            if (nbytes <= 0)
#endif
                return (-1);
            else
                readbytes += nbytes;
        }
        if (FD_ISSET(sendfd, &writeset))
        {
            int newsent = write(sendfd, buf + sent, len - sent);
            if (newsent < 0)
                return (-1);
            sent += newsent;
        }
        tv.tv_sec = 1;
    }
    return (0);
}

static void h_dosend(char *buf, int bytes)
{
    if (sendtopipe(sendfd, buf, bytes) < 0)
        perror("cp write"), h_died();
}

extern int pongwait;
extern void h_pong();
static void h_ping()
{
    pongwait = 1;
    h_vmess((void *) 0, gensym("ping"), "l", h_pong);
    fromsock(readahead, readbytes);
    readbytes = 0;
    while (pongwait)
    {
        char buf[1];
        int ch = h_getfromcp(buf, 1, 0);
        if (h_dead)
            break;
        else if (ch > 0)
            doit(buf[0] & 0xff);
    }
}

void syserror(char *fmt, ...)
{
    char buf[BIGSTRING];
    va_list ap;
    va_start(ap, fmt);
    vsnprintf(buf, BIGSTRING-1, fmt, ap);
    va_end(ap);
    post("%s", buf);
}

static void sox_setthrottle(int t1, int t2, int t3)
{
}

struct ftsTypeTable soxFtsTable = {
    h_init_sox,
    h_getpost,
    h_eof_sox,
    h_start_sox,
    h_poll,
    h_dosend,
    h_ping,
    sox_setthrottle
};

ftsType soxFts = &soxFtsTable;
