#ifndef lint
static char rcsid[] =
    "$Revision: 2.6 $ IRCAM $Date: 1994/05/10 10:50:44 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.6 $ IRCAM $Date: 1994/05/10 10:50:44 $
 *
 * FTS by Miller Puckette
 *
 */


#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sgtty.h>
#include <fcntl.h>
#include <signal.h>
#include "m_mess.h"
#include "cp_mess.h"
#include "h_cp.h"
#import "getNameValue.h"

#include "../6a/6a.h"           /* this is just to know the max slot number... */
#include "../6a/proto56.h"
#include "../56k/converterType.h"


extern int h_nproc;
extern struct messbuf messbuf;
extern int h_cpuslot[];
extern int h_advances[];
static int bootcp();
extern int h_throttlehasbeenset;
int h_start_std();

/* External declaration for variables included in h_mess_gen.c */

extern char *ebuf, *bptr;
extern int h_faketime, h_makinglogfile;
extern int h_usedacs;
extern int h_srate;
extern int h_animal;
extern int h_killer;
extern char *h_runflags;
extern int h_usingoldcpos;
extern int logfd;
extern int h_dead;
void h_poll(), doqueue();
extern int h_machversion;
extern int h_verbose;

#define HSYSBUFSIZE 512
static char h_syscmd[HSYSBUFSIZE + 1];
static char h_sysbuf[HSYSBUFSIZE + 1];
static int h_sysreturn;
static int h_dactype;
int h_stdnproc;
static void h_senddac(int index);
static int h_didsync;

static h_system(s)
char *s;
{
    FILE *fp;
    int ret;
    strncpy(h_syscmd, s, HSYSBUFSIZE);
    if (h_verbose)
        post("%s", s);
    h_sysreturn = 0;
    if (!(fp = popen(s, "r")))
        return (1);
    h_sysreturn = fread(h_sysbuf, 1, HSYSBUFSIZE, fp);
    if (ferror(fp))
    {
        pclose(fp);
        return (1);
    }
    h_sysbuf[h_sysreturn] = '\0';
    if (h_verbose)
        pdisplay(h_sysbuf);
    if (pclose(fp))
        return (2);
    else
        return (0);
}

static h_substring(s)
char *s;
{
    int i = strlen(s);
    char *foo = h_sysbuf, *efoo = h_sysbuf + h_sysreturn;
    for (; foo < efoo; foo++)
        if (!strncmp(foo, s, i))
            return (1);
    return (0);
}

static h_dumpcmd()
{
    post("%s", h_syscmd);
    pdisplay(h_sysbuf);
}

static int slottocpunum(int slotno)
{
    int i;
    for (i = 0; i < h_nproc; i++)
        if (h_cpuslot[i] == slotno)
            return (i);
    return (-1);
}

h_setanimal(n)
{
    h_animal = n;
}

void h_setstd(int slot2, int slot4, int slot6, int version2)
{
    int i;
    h_stdnproc = 0;
    if (slot2)
    {
        h_cpuslot[h_stdnproc++] = 3;
        h_cpuslot[h_stdnproc++] = 2;
    }
    if (slot4)
    {
        h_cpuslot[h_stdnproc++] = 5;
        h_cpuslot[h_stdnproc++] = 4;
    }
    if (slot6)
    {
        h_cpuslot[h_stdnproc++] = 7;
        h_cpuslot[h_stdnproc++] = 6;
    }
    for (i = 0; i < h_stdnproc; i++)
        if (h_advances[i] < MINADVANCE)
            h_advances[i] = ((i & 1) ? 5 : 3);
    h_machversion = (version2 ? 2 : 3);
}

void h_getstd(int *slot2, int *slot4, int *slot6, int *version2)
{
    int i;
    *slot2 = *slot4 = *slot6 = 0;
    for (i = 0; i < h_stdnproc; i++)
    {
        if (h_cpuslot[i] == 3)
            *slot2 = 1;
        else if (h_cpuslot[i] == 5)
            *slot4 = 1;
        else if (h_cpuslot[i] == 7)
            *slot6 = 1;
    }
    *version2 = (h_machversion == 2);
}

typedef struct ispw {
    char i_clocksource[12];
    int i_dactype;
    int i_chans;
    int i_in;
    int i_out;
    int i_ebu1;
    int i_ebu2;
    int i_backplane;
} t_ispw;

#define NCARDS ((MAXSLOTNO-2)/2)

static t_ispw ispw[NCARDS] = {
    { "internal", CONV_ARIEL, 2, 1, 1 },
    { "internal", CONV_ARIEL, 2, 1, 1 },
    { "internal", CONV_ARIEL, 2, 1, 1 }
};

void h_getispw(int nslot, int *dacType, int *in, int *out, int *nChans,
               int *EBU1, int *EBU2, const char **clockSource,
               int *backplane)
{
    int index = (nslot / 2) - 1;
    t_ispw *ip = &ispw[index];
    *clockSource = ip->i_clocksource;
    *dacType = ip->i_dactype;
    *nChans = ip->i_chans;
    *in = ip->i_in;
    *out = ip->i_out;
    *EBU1 = ip->i_ebu1;
    *EBU2 = ip->i_ebu2;
    *backplane = ip->i_backplane;
}

void h_setispw(int nslot, int dacType, int in, int out, int nChans,
               int EBU1, int EBU2, const char *clockSource, int backplane)
{
    int index = (nslot / 2) - 1;
    t_ispw *ip = &ispw[index];
    strncpy(ip->i_clocksource, clockSource, 12);
    ip->i_dactype = dacType;
    ip->i_chans = nChans;
    ip->i_in = in;
    ip->i_out = out;
    ip->i_ebu1 = EBU1;
    ip->i_ebu2 = EBU2;
    ip->i_clocksource[11] = 0;
    ip->i_backplane = backplane;
    h_senddac(index);
}

void h_senddac(int index)
{
    int cpuno;
    t_ispw *ip = &ispw[index];
    if (h_gethardware() == H_ISPW
        && (cpuno = slottocpunum(3 + 2 * index)) >= 0)
    {
        t_atom av[10], *ap = av + 4;
        int ac = 4;
        SETLONG(av, (ip->i_in ? ip->i_dactype : 0));
        SETLONG(av + 1, (ip->i_out ? ip->i_dactype : 0));
        SETLONG(av + 2, ip->i_chans);
        SETSYM(av + 3, gensym(ip->i_clocksource));
        if (ip->i_ebu1)
        {
            SETSYM(ap, gensym("ebu1"));
            ap++;
            ac++;
        }
        if (ip->i_ebu2)
        {
            SETSYM(ap, gensym("ebu2"));
            ap++;
            ac++;
        }
        if (ip->i_backplane)
        {
            SETSYM(ap, gensym("synctobackplane"));
            ap++;
            ac++;
        }
        h_mess((void *) cpuno, gensym("#_setdacs_"), ac, av);
    }
}

void h_restartdacs(int on)
{
    h_vmess(0, gensym("#_restartdacs_"), "l", (long) on);
}

/* sanitized version of above for "declare" object  */
void h_setchans(const int *vec)
{
    int i;
    for (i = 0; i < NCARDS; i++)
    {
        int dacType, nChans, EBU1, EBU2, backplane, in, out;
        char *clockSource;
        h_getispw(2 * i + 3, &dacType, &in, &out, &nChans, &EBU1,
                  &EBU2, &clockSource, &backplane);
        h_setispw(2 * i + 3, dacType, in, out, vec[i], EBU1,
                  EBU2, clockSource, backplane);
    }
}

void h_getchans(int *vec)
{
    int i;
    for (i = 0; i < NCARDS; i++)
        vec[i] = ispw[i].i_chans;
}

h_initsyncfrom(syncno)          /* call only on init */
{
    int index = ((syncno - 1) >> 1), which = ((syncno - 1) & 3) + 1, i;
    if (which == 1)
        ispw[index].i_ebu1 = 1;
    else if (which == 2)
        ispw[index].i_ebu2 = 1;
    for (i = 0; i < NCARDS; i++)
    {
        if (i == index)
        {
            sprintf(ispw[i].i_clocksource, "ebu%d", which);
            ispw[i].i_backplane = 1;
        }
        else
            sprintf(ispw[i].i_clocksource, "backplane");
    }
}

h_inituseebu(syncno)            /* call only on init */
{
    int index = ((syncno - 1) >> 1), which = ((syncno - 1) & 3) + 1, i;
    if (which == 1)
        ispw[index].i_ebu1 = 1;
    else if (which == 2)
        ispw[index].i_ebu2 = 1;
    else
        error("ebu line %d is always used anyway", syncno);
}

h_initdactype(n)                /* on init only, set dac type */
{
    int i;
    h_dactype = n;
    for (i = 0; i < NCARDS; i++)
    {
        ispw[i].i_dactype = n;
        ispw[i].i_chans = 2;
        if (h_dactype == CONV_IRCAM && (!h_didsync))
        {
            if (!slottocpunum(3 + 2 * i))
                ispw[i].i_backplane = 1;
            else
                sprintf(ispw[i].i_clocksource, "backplane");
        }
    }
}

static int h_std_initted;

static void h_init_std()
{
    if (h_std_initted)
        return;
    h_std_initted = 1;
    if (h_verbose)
    {
        if (!h_usedacs)
            post("dacs disabled");
        else if (h_dactype == CONV_CD)
            post("using hacked CD dacs");
        else if (h_dactype == CONV_ARIEL)
            post("using Ariel dacs");
        else if (h_dactype == CONV_IRCAM)
            post("using SoundSmith dacs");
    }
    /* this should choose a good value (which depends on config) */
    if (!h_throttlehasbeenset)
    {
        int th1 = getIntOption("Throttle1", -1);
        int th2 = getIntOption("Throttle2", 0);
        int th3 = getIntOption("Throttle3", 0);
        if (th1 > 0)
            h_setthrottle(th1, th2, th3);
        else
        {
            const char *thrstring = getStringOption("Throttle", "");
            if (*thrstring)
                h_setthrottlestring(thrstring);
            else
                h_setthrottle(8, 8, 1);
        }
    }
}

int h_start_std()
{
    int i, j;

    h_dead = 0;
    h_init_std();
    if (h_makinglogfile)
    {
        if ((logfd = creat("/tmp/logfile", 0666)) < 0)
            fprintf(stderr, "warning: can't create log file\n");
    }
    else
        logfd = -1;

    io_clear();
    h_nproc = h_stdnproc;
    if (!h_animal)
    {
        post("- booting FTS on ISPW -\n");
        if (bootcp())
        {
            h_dead = 1;
            return (1);
        }
    }
    mmap_open(h_cpuslot[0] & (~1));

    if (h_animal)
    {
        if (io_useanimal())
            hate("animal: must start MAX first");
    }
    else
    {
        for (i = 0; i < h_nproc; i++)
        {
            mmap_slotno(h_cpuslot[i]);
            io_setlock();
        }
        io_setslotno(h_cpuslot[0]);
        for (i = 0; i < h_nproc; i += 2)
            h_senddac((h_cpuslot[i] - 3) / 2);
        h_vmess(0, gensym("#_setsr_"), "l", (long) h_getrate());
        h_restartdacs(1);
        for (i = 0; i < h_nproc; i++)
        {
            mmap_slotno(h_cpuslot[i]);
            for (j = 0; j < h_nproc; j++)
                io_param(h_cpuslot[j], h_advances[j]);
            io_start(h_cpuslot[i],
                     !((h_cpuslot[i] & 1) && (i / 2 < h_usedacs)),
                     h_dactype, h_killer, h_srate);
        }
    }
    io_setslotno(h_cpuslot[0]);
    return (0);
}

static h_addslot(x, n)
char *x;
{
    sprintf(x + strlen(x), ",%d", n - 1);
}

static int commandfailed(s)
char *s;
{
    int ret = h_system(s);
    if (ret == 1)
        syserror("%s", s);
    else if (ret)
    {
        if (!h_verbose)
            h_dumpcmd();
        post("FTS startup failed");
    }
    return (ret);
}

static int unloadcposfailed(bootdir)
char *bootdir;
{
    char command[1024];
    if (h_usingoldcpos)
        sprintf(command, "%s/autoboot -unload\n", bootdir);
    else
        sprintf(command, "%s/autoboot -shutdown 2>&1\n", bootdir);
    return (commandfailed(command));
}

static int bootfailed(bootdir, machversion)
char *bootdir;
{
    char command[1024];
    int i;
    sprintf(command, "%s/userboot -hkernel %s/hkernel-%d.0 -exec",
            bootdir, h_getftsdir(), machversion);
    for (i = 0; i < h_nproc; i++)
        h_addslot(command, h_cpuslot[i]);
    sprintf(command + strlen(command), " %s/fts -stack-addr",
            h_getftsdir());
    for (i = 0; i < h_nproc; i++)
        h_addslot(command, h_cpuslot[i]);
    sprintf(command + strlen(command), " 0x%x 2>&1\n",
            0xa07c0000 - 0x10000 * (h_nproc - 1));
    return (h_system(command));
}

char defaultboot[] = "/LocalApps/Max/Max.app";

static const char *h_whereboot;

const char *h_getwherebooted()
{
    return (*h_whereboot ? h_whereboot : "/");
}

static int bootcp()
{
    char command[1024];
    int i, onset, fd, machversion = h_machversion, retried = 0, whyfailed;
    h_whereboot = h_getbootdir();
    if (!*h_whereboot)
        h_whereboot = h_getftsdir();

    while (whyfailed = bootfailed(h_whereboot, machversion))
    {
        if (h_substring("relocate") && machversion == h_machversion)
        {
            machversion = 5 - machversion;
            post("NextStep version mismatch -- retrying for NS %d.0...",
                 machversion);
            post("(note: you can specify this in advance using the ");
            post("'o' switch in configuration string)");
            retried = 1;
        }
        else if (h_substring("root") && strcmp(h_whereboot, defaultboot))
        {
            post("%s/userboot: setuid apparently failed", h_whereboot);
            post("retrying using %s...", defaultboot);
            post("(note: you can redirect this in advance using the MAX");
            post("\"BOOTDIR\" default)");
            h_whereboot = defaultboot;
            retried = 1;
        }
        else if (h_substring("autoboot"))
        {
            post("shutting down CPOS...");
            if (unloadcposfailed(h_whereboot))
            {
                post("shutdown failed -- giving up");
                return (1);
            }
            retried = 1;
        }
        else
        {
            if (whyfailed == 1)
                syserror("%s", command);
            else
            {
                if (!h_verbose)
                    h_dumpcmd();
                post("startup failed");
            }
            return (1);
        }
    }

    if (retried)
        post("boot retry succeeded.");

    sprintf(command, "%s/initdma ", h_getftsdir());
    for (i = 0; i < MAXSLOTNO; i++)
    {
        int k;
        for (k = 0; k < h_nproc; k++)
        {
            if (h_cpuslot[k] == i)
            {
                if (i & 1)
                    sprintf(command + strlen(command), "-cpu %d -go ",
                            i - 1);
                else
                    sprintf(command + strlen(command),
                            "-cpu %d -boot56k %s/dma -go ", i - 1,
                            h_getftsdir());
            }
        }
    }
    sprintf(command + strlen(command), " 2>&1\n");
    return (commandfailed(command));
}

static void h_getpost()
{
    h_animal = 0;
}

static void h_eof_std()
{
}

static int h_getfromcp(char *buf, int size, int secs);

int elapsedsince(tv)
struct timeval *tv;
{
    struct timeval tv2;
    struct timezone tz;

    gettimeofday(&tv2, &tz);
    return (1000 * (tv2.tv_sec - tv->tv_sec) +
            (tv2.tv_usec - tv->tv_usec) / 1000);
}

static void h_poll(int secs)
{
    char buf[4096];
    int x, didit = 0;
    static struct timeval timeoflastresponse;
    struct timezone tz;

    if (h_dead)
        return;


    while (x = h_getfromcp(buf, 4096, secs))
    {
        didit = 1;
        fromsock(buf, x);
    }
    if (didit)
        gettimeofday(&timeoflastresponse, &tz);
    else
    {
        if (elapsedsince(&timeoflastresponse) > 3000)
        {
            int slot;
            if ((slot = io_isdead()) >= 0)
            {
                post("fatal problem in CP %d (diagnostics on stderr)",
                     slottocpunum(slot) + 1);
                io_setslotno(slot);
                fflush(stderr);
                while (x = h_getfromcp(buf, 4096, 0))
                    write(fileno(stderr), buf, x);
                h_dead = 1;
            }
            gettimeofday(&timeoflastresponse, &tz);
        }
    }
}

static int h_getfromcp(char *buf, int size, int secs)
{
    int x;
    int gotbytes;
    struct timeval timout;
    timout.tv_sec = secs;
    timout.tv_usec = 0;

    if (h_dead)
        return (0);

    if (!h_animal)
        while (io_pollrequest());
    gotbytes = io_readout(buf, size);
    if (gotbytes < 0)
    {
        h_died();
        return (0);
    }
    else if (gotbytes > 0)
        return (gotbytes);
    else if (!secs--)
        return (0);
    sleep(1);
}

#define SENDBETWEENPOLL 500
static int sendbeforenextpoll;

static void h_dosend(char *buf, int bytes)
{
    sendbeforenextpoll -= bytes;
    if (sendbeforenextpoll < 0)
    {
        if (!io_pollrequest())
            sendbeforenextpoll = SENDBETWEENPOLL;
    }
    if (io_sendit(buf, bytes))
    {
        char buf2[4096];
        int gotbytes;
        gotbytes = io_readout(buf2, 4096);
        if (gotbytes > 0)
            fromsock(buf2, gotbytes);
        h_died();
    }
}

extern int pongwait;
extern void h_pong();

static void h_ping()
{
    pongwait = 1;
    h_vmess((void *) 0, gensym("ping"), "l", h_pong);
    while (pongwait)
    {
        char buf[1];
        int ch = h_getfromcp(buf, 1, 0);
        if (h_dead)
            break;
        else if (ch > 0)
            doit(buf[0] & 0xff);
    }
}

static void std_setthrottle(int t1, int t2, int t3)
{
    mmap_setthrottle(t1, t2, t3);
}

struct ftsTypeTable standaloneFtsTable = {
    h_init_std,
    h_getpost,
    h_eof_std,
    h_start_std,
    h_poll,
    h_dosend,
    h_ping,
    std_setthrottle
};

ftsType standaloneFts = &standaloneFtsTable;
