#ifndef lint
static char rcsid[] =
    "$Revision: 2.2 $ IRCAM $Date: 1993/11/17 14:38:00 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.2 $ IRCAM $Date: 1993/11/17 14:38:00 $
 *
 * FTS by Miller Puckette
 *
 */


#include <stdio.h>
#include "m_mess.h"
#include "h_cp.h"

extern t_symbol s_debug;

dogf1(ptr, buf, size)
void *ptr, **buf;
{
    post("dogf1 %x %x %d\n", ptr, buf, size);
    if (size)
        post("-> %ld", ((long *) buf)[0]);
}

dogf2(ptr, buf, size)
char *ptr, *buf;
{
    post("dogf2 %x %x %d\n", ptr, buf, size);
}

/* test of animal methods.  The ids will be:
  1. the class "foo"
  2. the class "bar"
  10. a "bar" instance 
  11. its "sub" "foo"
  12. a dynamic "foo"
  20. a re-creation of the archive
*/

#ifdef NOPE
sickinit2()
{
    /* set up class "foo" with an int and a float */
    h_vnew((void *) 1, 0, gensym("class"), "sss", gensym("foo"),
           gensym("int"), gensym("float"));
    h_vmess((void *) 1, gensym("add"), "s", gensym("int"));
    h_vmess((void *) 1, gensym("add"), "s", gensym("float"));
    h_vmess((void *) 1, gensym("add_method"), "ssl",
            gensym("print"), gensym("../foo_print.o"), 0L);
    h_vmess((void *) 1, gensym("add_method"), "ssll",
            gensym("set"), gensym("../foo_set.o"), A_LONG, 0L);

    h_vnew((void *) 2, 0, gensym("class"), "s", gensym("bar"));
    h_vmess((void *) 2, gensym("add"), "s", gensym("foo"));
    h_vmess((void *) 2, gensym("add_method"), "ssl",
            gensym("print"), gensym("../bar_print.o"), 0L);

    /* make an object of class "bar" */
    h_vnew((void *) 10, 0, gensym("animal"), "o", (void *) 2);

    /* connect to it */
    h_vmess((void *) 10, gensym("graphic"), "llll",
            10L, dogf1, dogf2, 123L);

    /* connect to its subanimal */
    h_vmess((void *) 10, gensym("subgraphic"), "lllll",
            0L, 11L, dogf1, dogf2, 234L);

    /* add a foo dynamically and connect to that. */
    h_vmess((void *) 10, gensym("add"), "o", (void *) 1);
    h_vmess((void *) 10, gensym("listgraphic"), "lllll",
            0L, 12L, dogf1, dogf2, 345L);

    /* send sub-foo a "set 23" */
    h_vmess((void *) 11, gensym("set"), "l", 23L);

    /* send contained foo a "set 56" */
    h_vmess((void *) 12, gensym("set"), "l", 56L);

    /* print out everything */
    h_vmess((void *) 10, gensym("print"), "");

    /* archive it */
    h_vmess((void *) 10, gensym("archive_instance"), "s",
            gensym("../bar.archive"));

    /* free it */
    h_free((void *) 10);

    /* read back archive */
    h_vnew((void *) 20, 0, gensym("animal_dearchive"), "s",
           gensym("../bar.archive"));

    /* print out everything */
    h_vmess((void *) 20, gensym("print"), "");

    /* clone it */
    h_vnew((void *) 21, 0, gensym("animal_copy"), "o", (void *) 20);

    /* print out everything */
    h_vmess((void *) 21, gensym("print"), "");

    p                           /* free it */
        h_free((void *) 20);
    h_free((void *) 21);
}

sickinit()
{
    h_vmess((void *) 0, &s_debug, "l", 1L);
    h_vmess((void *) 0, &s_debug, "l", 1L);
    h_ping();
    h_vmess((void *) 0, &s_debug, "l", 1L);
}
#endif

sickinit()
{
    h_vmess((void *) 0, &s_debug, "l", 1L);
    h_vmess((void *) 0, &s_debug, "l", 1L);
    h_vnew((void *) 100, 1, gensym("print"), "s", gensym("foo"));
    h_vmess((void *) 100, gensym("foobar"), "l", 1L);
    h_vnew((void *) 101, 1, gensym("vslider"), "lll", 123, dogf1, dogf2);
    h_vmess((void *) 101, gensym("int"), "l", 2345L);
    h_vmess((void *) 0, gensym("tick"), "l", 100L);
    h_vmess((void *) 0, &s_debug, "l", 1L);
}

sigfun()
{
    post("interrupt");
    cleanexit();
}

cleanexit()
{
    exit(1);
}

  /* printout from CP */
pdisplay(s, a, b, c, d, e, f, g, h)
char *s;
{
    fprintf(stderr, s, a, b, c, d, e, f, g, h);
}

  /* printout from host */
post(s, a, b, c, d, e, f, g, h)
{
    fprintf(stderr, s, a, b, c, d, e, f, g, h);
    fprintf(stderr, "\n");
}

poststring(s)
char *s;
{
    fprintf(stderr, s);
}

void fromsock();
extern int h_dead;

main(argc, argv)
char **argv;
{
    h_setdirs(".", (char *) 0);
    h_setadv("a,b,3/10");
    h_init(0, (char *) 0);
    signal(2, sigfun);
    sickinit();
    h_eof();
    while (!h_dead)
        h_poll(10, fromsock);
}
