#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1994/05/10 10:50:53 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/05/10 10:50:53 $
 *
 * FTS by Miller Puckette
 *
 */


/*
  the "method" and "class" classes, and support routines for bashing FTS
  classes.
  */

#include "m_mess.h"
#include "l_animal.h"
#include "l_animal2.h"

extern t_symbol s_graphic, s_subgraphic, s_listgraphic,
    s_rm, s_animal, s_, s_tick, s_midi,
    s_push, s_pop, s_write, s__A, s__C, s__New,
    s_add, s_symbol, s_,
    s_add_method, s_rm_method, s_a_class, s_set, s_rename;
extern void *h_objlist;

void *animal_new();
extern char *progname;
extern void *animal_messlist;
int animal_serial;

/************************ METHOD **************************/

#ifdef I860
void a_method_free(x)
t_a_method *x;
{
    free(x->m_space);
    freebytes(x, sizeof(t_a_method));
}

t_a_method *a_method_new(file, s)
t_symbol *s, *file;
{
    t_a_method *x;
    void *space, (*fn) ();
    /* if (loadmacho(&space, &fn, progname, file->s_name))
       return (0); */
    x = (t_a_method *) getbytes(sizeof(t_a_method));
    x->m_space = space;
    x->m_fn = fn;
    x->m_sym = s;
    x->m_file = file;
    return (x);
}
#endif

/************************ CLASS **************************/

t_maxclass *a_class_messlist;
t_a_class *a_class_list = 0;
int animal_dotick(t_animal * x, t_method fun), animal_domidi(t_animal * x,
                                                             t_method fun,
                                                             int byte_in);

#ifdef I860
void a_class_add_method(cl, s, ac, av)
t_a_class *cl;
t_symbol *s;
t_atom *av;
{
    int m[100];
    t_a_method *cm, *cm2, cmstub;
    t_symbol *sel, *file;
    t_animal *a;
    int i;
    if (ac < 2 || av[0].a_type != A_SYM || av[1].a_type != A_SYM)
    {
        error("addmethod: bad arg type for selector or filename");
        return;
    }
    sel = av[0].a_w.w_sym;
    file = av[1].a_w.w_sym;
    ac -= 2;
    av += 2;
    if (ac > 11)
        ac = 11;
    for (i = 0; i < ac; i++)
        m[i] = av[i].a_w.w_long;
    m[ac] = 0;
    cmstub.m_next = cl->c_methods;
    for (cm = &cmstub; cm2 = cm->m_next; cm = cm2)
        if (cm2->m_sym == sel)
        {
            if (sel == &s_midi)
                for (a = cl->c_animal; a; a = a->a_next)
                    sched_uninstallmidi(a);
            c_rmmessfrom(&cl->c_messlist, sel);
            a_method_free(cm2, file, sel);
            cm->m_next = cm2->m_next;
            cm2 = cm;
        }
    cl->c_methods = cmstub.m_next;
    if (cm = a_method_new(file, sel))
    {
        cm->m_next = cl->c_methods;
        cl->c_methods = cm;
        c_addmessto(&cl->c_messlist, cm->m_fn, sel, &m);
        for (a = cl->c_animal; a; a = a->a_next)
            c_setclass(a->a_bag, cl->c_messlist);
        if (sel == &s_midi)
            for (a = cl->c_animal; a; a = a->a_next)
                sched_installmidi(animal_domidi, a, cm->m_fn);
    }
}

void a_class_rm_method(cl, s)
t_a_class *cl;
t_symbol *s;
{
    t_a_method stub, *cm, *cm2;
    t_animal *a;
    stub.m_next = cl->c_methods;
    for (cm = &stub; cm2 = cm->m_next; cm = cm2)
        if (cm2->m_sym == s)
        {
            cm->m_next = cm2->m_next;
            a_method_free(cm2);
        }
    cl->c_methods = stub.m_next;
    c_rmmessfrom(&cl->c_messlist, s);
    for (a = cl->c_animal; a; a = a->a_next)
        c_setclass(a->a_bag, cl->c_messlist);
    if (s == &s_midi)
        for (a = cl->c_animal; a; a = a->a_next)
            sched_uninstallmidi(a);

}
#endif

void a_class_add(t_a_class *cl, t_symbol *type, t_symbol *name)
{
    int nitems = cl->c_nitems;
    t_animal *a;

    animal_serial++;
    /* this sanity check had to be removed because Animal can add
       items to a class which are not yet defined */
    /*
       if (type != &s_int && type != &s_float && (!type->s_thing ||
       ob_messlist(type->s_thing) != a_class_messlist))
       {
       error("%s: no such class", type->s_name);
       type = &s_int;
       }
     */

    cl->c_fields = (t_field *) resizebytes((void *) cl->c_fields,
                                           (nitems + 1) * sizeof(t_field),
                                           (nitems + 2) * sizeof(t_field));
    cl->c_fields[nitems].f_type = type;
    cl->c_fields[nitems].f_name = name;
    for (a = cl->c_animal; a; a = a->a_next)
    {
        a->a_bag = (t_ax *) resizebytes((void *) a->a_bag,
                                        sizeof(t_animal_header) +
                                        nitems * sizeof(void *),
                                        sizeof(t_animal_header) + (nitems +
                                                                   1) *
                                        sizeof(void *));
        if (type == &s_int)
            ((long *) (a->a_bag->x_x))[nitems] = 0;
        else if (type == &s_float)
            ((float *) (a->a_bag->x_x))[nitems] = 0.;
        else if (type == &s_symbol)
            ((t_symbol **) (a->a_bag->x_x))[nitems] = &s_;
        else
            ((t_animal **) (a->a_bag->x_x))[nitems] = 0;
        hq_resize(a->a_hqgfx, sizeof(void *) * (nitems + 1));
    }
    cl->c_nitems = nitems + 1;
}

void a_class_rm(t_a_class *cl, long int index)
{
    int nitems = cl->c_nitems, i;
    t_animal *a;
    t_field *tp;
    int wasanimal;
    animal_serial++;
    if (index >= nitems)
    {
        bug("remove offset");
        return;
    }

    /* get it out of c_fields */
    for (tp = cl->c_fields + index, i = nitems - index - 1; i--; tp++)
        tp[0] = tp[1];
    cl->c_fields = (t_field *) resizebytes((void *) cl->c_fields,
                                           (nitems + 1) * sizeof(t_field),
                                           (nitems) * sizeof(t_field));

    for (a = cl->c_animal; a; a = a->a_next)
    {
        void **w;
        for (w = a->a_bag->x_x + index, i = nitems - index - 1; i--; w++)
            w[0] = w[1];
        a->a_bag = (t_ax *) resizebytes((void *) a->a_bag,
                                        sizeof(t_animal_header) +
                                        nitems * sizeof(void *),
                                        sizeof(t_animal_header) + (nitems -
                                                                   1) *
                                        sizeof(void *));
        hq_resize(a->a_hqgfx, sizeof(void *) * (nitems - 1));
    }
    cl->c_nitems = nitems - 1;
}

void a_class_rename(t_a_class *cl, t_symbol *s, int ac, t_atom *av)
{
    animal_serial++;
    if (ac == 1 && av[0].a_type == A_SYM)
        ((t_class *) (cl->c_messlist[0].t_symbol))->c_sym = cl->c_name =
            av[0].a_w.w_sym;
    else if (ac == 2 && av[0].a_type == A_LONG && av[1].a_type == A_SYM)
    {
        int onset = av[0].a_w.w_long;
        if (onset < 0 || onset >= cl->c_nitems)
            error("class_rename: bad onset");
        else
            cl->c_fields[onset].f_name = av[1].a_w.w_sym;
    }
    else
        error("class_rename: bad or missing  arguments");
}

void a_class_ff(t_a_class *cl)
{
    animal_serial++;
    if (cl->c_animal)
        error("%s: still has instances", cl->c_name);
    if (cl->c_name->s_thing == (t_object *) cl)
        cl->c_name->s_thing = 0;
    if (cl->c_next)
        cl->c_next->c_prev = cl->c_prev;
    if (cl->c_prev)
        cl->c_prev->c_next = cl->c_next;
    if (cl == a_class_list)
        a_class_list = cl->c_next;
    /* oops -- forgot to free type list !? */
}

void c_a_class()
{
    c_new(&s_a_class, a_class_ff, sizeof(t_a_class), 1, 0);
    c_addmess(a_class_add, &s_add, A_SYM, A_SYM, 0);
    c_addmess(a_class_rm, &s_rm, A_LONG, 0);
    c_addmess(a_class_rename, &s_rename, A_GIMME, 0);
#ifdef I860
    c_addmess(a_class_add_method, &s_add_method, A_GIMME, 0);
    c_addmess(a_class_rm_method, &s_rm_method, A_SYM, 0);
#endif
}

void *a_class_new(t_symbol *name)
{
    t_a_class *cl;
    int i;
    animal_serial++;
    if (name->s_thing)
    {
        error("%s: already exists", name->s_name);
        return (0);
    }
    cl = (t_a_class *) obj_new((t_messlist **) & a_class_messlist,
                               c_a_class);
    cl->c_methods = 0;
    cl->c_animal = 0;
    cl->c_name = name;
    cl->c_name->s_thing = (t_object *) cl;
    c_setup();
    c_new(cl->c_name, NIL, sizeof(t_object), 1, 0);
    c_install(&cl->c_messlist);
    cl->c_fields = (t_field *) getbytes(sizeof(t_field));
    cl->c_nitems = 0;
    cl->c_next = a_class_list;
    cl->c_prev = 0;
    if (a_class_list)
        a_class_list->c_prev = cl;
    a_class_list = cl;
    return (cl);
}
