#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1994/01/04 17:56:40 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/01/04 17:56:40 $
 *
 * FTS by Miller Puckette
 *
 */


#include "m_mess.h"
#include "cp_mess.h"
#include "l_animal.h"
#include "l_animal2.h"
#include "l_list.h"

extern t_symbol s_add, s_rm, s_a_set, s_graphic, s_bind, s_unbind;

typedef struct a_set {
    t_object x_ob;
    t_sll *x_sll;
    void *x_hq;
    t_symbol *x_instancename;
} t_a_set;


void a_set_graphic(t_a_set *x, long int fn, long int freefn, long int ptr)
{
    hq_connect(x->x_hq, fn, freefn, ptr);
}

void a_set_add(t_a_set *x, void *y)
{
    x->x_sll = sll_insert(x->x_sll, y);
}

void a_set_rm(t_a_set *x, void *y)
{
    x->x_sll = sll_delete(x->x_sll, y);
}

void a_set_bang(t_a_set *x)
{
    t_sll *z;
    for (z = x->x_sll; z; z = z->l_next)
        mess0(z->l_item, &s_bang);
}

void a_set_int(t_a_set *x, long int n)
{
    t_sll *z;
    for (z = x->x_sll; z; z = z->l_next)
        mess1(z->l_item, &s_int, n);
}

void a_set_float(t_a_set *x, double f)
{
    t_sll *z;
    for (z = x->x_sll; z; z = z->l_next)
        mess1(z->l_item, &s_float, f);
}

void a_set_bind(t_a_set *x, t_symbol *s)        /* set an animal's name (bind it to a symbol). */
{
    s->s_thing = (t_object *) x;
    x->x_instancename = s;
}

void a_set_unbind(t_a_set *x, t_symbol *s)      /* unbind it */
{
    if (s->s_thing == (t_object *) x)
        s->s_thing = 0;
    x->x_instancename = 0;
}

void a_set_anything(t_a_set *x, t_symbol *s, int ac, t_atom *av)
{
    t_sll *z;
    for (z = x->x_sll; z; z = z->l_next)
        typedmess(z->l_item, s, ac, av);
}

/* bang an outlet with animal_self ranging through contents (experimental)*/
void a_set_uzi(t_a_set *x, void *w)
{
    t_sll *z;
    for (z = x->x_sll; z; z = z->l_next)
    {
        animal_self = z->l_item;
        outlet_bang(w);
    }
}

void a_set_hqfn(t_a_set *x, void *hq)
{
}

void a_set_ff(t_a_set *x)
{
    while (x->x_sll)
    {
        sll_free(x->x_sll);
        x->x_sll = x->x_sll->l_next;
    }
    if (x->x_instancename && x->x_instancename->s_thing == (t_object *) x)
        x->x_instancename->s_thing = 0;
    hq_free(x->x_hq);
}

t_maxclass *a_set_class;
void a_set_setup()
{
    c_new(&s_a_set, a_set_ff, sizeof(t_a_set), 0, 0);
    c_addbang(a_set_bang);
    c_addint(a_set_int);
    c_addfloat(a_set_float);
    c_addmess(a_set_add, &s_add, A_OBJ, 0);
    c_addmess(a_set_rm, &s_rm, A_OBJ, 0);
    c_addmess(a_set_anything, &s_anything, A_GIMME, 0);
    c_addmess(a_set_graphic, &s_graphic, A_LONG, A_LONG, A_LONG, 0);
    c_addmess(a_set_bind, &s_bind, A_SYM, 0);
    c_addmess(a_set_unbind, &s_unbind, A_SYM, 0);
}

void *a_set_new()
{
    t_a_set *x =
        (t_a_set *) obj_new((t_messlist **) & a_set_class, a_set_setup);
    x->x_sll = 0;

    x->x_hq = hq_new(0L, 0L, 0L, x, a_set_hqfn, 0, currentPort);
    x->x_instancename = 0;
    return (x);
}
