
/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.2 $ IRCAM $Date: 1993/11/17 14:39:05 $
 *
 * FTS by Miller Puckette
 *
 */

/* header file for "animals".  An animal consists of a fixed-size,
nonrelocatable structure, "t_animal", and a variable-sized relocatable
"instance",  both pointing to each other.  The relocatable part has
a fixed header of type t_animal_header.  */

typedef struct animal_header    /* header for animal instances */
{
    t_tinyobject h_obj;         /* used by message system */
    struct _animal *h_backptr;  /* pointer to fixed part */
} t_animal_header;

/* in the following def, fields marked by <> should later be removed. */
typedef struct _animal          /* fixed part of the animal. */
{
    t_tinyobject a_obj;         /* used by message system */
    void *a_hqgfx;              /* host graohics queue */
    long a_keygfx;              /* key when accessed from host <> */
    struct a_class *a_class;    /* dynamic class */
    struct _animal *a_next;     /* next animal belonging to class */
    struct _animal *a_prev;     /* prev animal belonging to class */
    struct _animal *a_parent;   /* animal's parent (points to fixed part) */
    struct _ax *a_bag;          /* pointer to relocatable part */
    t_symbol *a_instancename;   /* instance name, set via "bind" message */
} t_animal;

#define PARENT(me) ((me)->header.h_backptr->a_parent->a_bag)
#define UPDATE(me) (animal_update((me)->header.h_backptr))
typedef float GFLOAT;
typedef struct _animal *ANIMAL;
