#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1994/01/04 17:56:56 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/01/04 17:56:56 $
 *
 * FTS by Miller Puckette
 *
 */

#include "m_mess.h"
#include "t_mac.h"
typedef void *ClientConnection;
#define currentPort ((ClientConnection)0)

#include "t_wind.h"
#include "x_explode.h"
#include "p_pic.h"

extern t_symbol s_explode, s_in1, s_in2, s_in3, s_in4, s_connect;

void *explode_new(), explode_int(t_explode * x, long int n),
explode_float(t_explode * x, double f), explode_in1(t_explode * x,
                                                    long int n),
explode_in2(t_explode * x, long int n), explode_in3(t_explode * x,
                                                    long int n),
explode_in4(t_explode * x, long int n), explode_nth(t_explode * x,
                                                    long int n),
explode_startat(t_explode * x, long int n1, long int n2, long int n3),
explode_followat(t_explode * x, long int n1, long int n2, long int n3),
explode_list(t_explode * x, struct symbol *s, int ac, struct atom *av),
explode_params(t_explode * x, long int n1, long int n2, long int n3),
explode_clear(t_explode * x), explode_start(t_explode * x),
explode_follow(t_explode * x, long int n), explode_next(t_explode * x),
explode_record(t_explode * x), explode_stop(t_explode * x),
explode_update(t_explode * x, int n), explode_append(t_explode * x,
                                                     struct symbol *s,
                                                     int ac,
                                                     struct atom *av),
explode_connect(t_explode * x, long int ptr, long int fun,
                long int freefun), explode_dispose(t_explode * x);

t_maxclass *explode_class;

void explode_init()
{
    /* set up the class creator's arguments and the inst size */
    c_new(&s_explode, explode_dispose, sizeof(t_explode), 0, 0);
    c_addmess(explode_next, gensym("next"), 0);
    c_addint(explode_int);      /* "int" method */
    c_addfloat(explode_float);  /* "float" method */
    c_addinx(explode_in1, 1);   /* "int" in 4 inlets */
    c_addinx(explode_in2, 2);
    c_addinx(explode_in3, 3);
    c_addinx(explode_in4, 4);

    c_addmess(explode_nth, gensym("nth"), A_DEFLONG, 0);
    c_addmess(explode_list, gensym("list"), A_GIMME, 0);
    c_addmess(explode_append, gensym("append"), A_GIMME, 0);
    c_addmess(explode_clear, gensym("clear"), 0);
    c_addmess(explode_start, gensym("start"), 0);
    c_addmess(explode_record, gensym("record"), 0);

    c_addmess(explode_stop, gensym("stop"), 0);
    c_addmess(explode_follow, gensym("follow"), A_DEFLONG, 0);
    c_addmess(explode_startat, gensym("startat"), A_LONG, A_LONG, A_LONG,
              0);
    c_addmess(explode_followat, gensym("followat"), A_LONG, A_LONG, A_LONG,
              0);
    c_addmess(explode_update, gensym("update"), A_LONG, 0);

    c_addmess(explode_params, gensym("params"), A_LONG, A_LONG, A_LONG, 0);
    c_addmess(explode_connect, &s_connect, A_LONG, A_LONG, A_LONG, 0);

    post("explode version 0.04/NeXT");
    RestoreA4();
}

void explode_append(t_explode *x, struct symbol *s, int ac,
                    struct atom *av)
{
    if (ac < 5
        || av[0].a_type != A_LONG
        || av[1].a_type != A_LONG
        || av[2].a_type != A_LONG
        || av[3].a_type != A_LONG || av[4].a_type != A_LONG)
        error("append: bad arguments");
    else
        explode_doappend(x, av[0].a_w.w_long, av[1].a_w.w_long,
                         av[2].a_w.w_long, av[3].a_w.w_long,
                         av[4].a_w.w_long);
}

/* @@@ HOW DO THIS UPDATE FIND THE RIGHT PORT, when the CPOS multiple connecion
   will be in place ?? */

void explode_update(t_explode *x, int n)
{
    if (!x->x_hq)
        bug("explode_update");
    if (n == HC_REQEVT)
    {
        if (x->x_mode != MUPDATE)
        {
            explode_stop(x);
            x->x_mode = MUPDATE;
            x->x_current = x->x_evt;
            x->x_rectime = 0;
        }
        x->x_hqcount = 10;
        hq_set(x->x_hq);
    }
    else if (n == HC_STARTUPD)
    {
        x->x_mode = MDRAW;
        explode_clear(x);
        x->x_mode = MUPDATE;
        x->x_rectime = 0;
        x->x_serial = 0;
    }
    else if (n == HC_DONEUPD)
    {
        x->x_mode = MDRAW;
        explode_stop(x);
    }
}

explode_hqfn(t_explode *x, void *hq)
{
    t_evt *e;
    long ebuf;
    if (x->x_dirtytohost)
    {
        ebuf = CH_DIRTY;
        cvt_long(&ebuf);
        hq_doit(hq, &ebuf, sizeof(ebuf));
        if (x->x_mode == MUPDATE)
            hq_set(x->x_hq);
        x->x_dirtytohost = 0;
    }
    else if ((e = x->x_current) && x->x_hqcount)
    {
        long buf[NPARAM + 1];
        int i;
        if (x->x_mode != MUPDATE)
            bug("explode_qfn");
        buf[0] = CH_EVENT;
        buf[1] = e->e_time - x->x_rectime;
        buf[2] = e->e_pit;
        buf[3] = e->e_vel;
        buf[4] = e->e_dur;
        buf[5] = e->e_chan;
        x->x_rectime = e->e_time;
        for (i = 0; i < NPARAM + 1; i++)
            cvt_long(buf + i);
        hq_doit(hq, buf, sizeof(buf));
        hq_set(x->x_hq);
        x->x_current = e->e_next;
        x->x_hqcount--;
    }
    else
    {
        if (x->x_mode != MUPDATE)
            bug("explode_qfn");
        if (x->x_current)
            ebuf = CH_NOTDONEUPD;
        else
        {
            x->x_mode = x->x_savemode;
            explode_stop(x);
            ebuf = CH_DONEUPD;
        }
        cvt_long(&ebuf);
        hq_doit(hq, &ebuf, sizeof(ebuf));
    }
}

void explode_markdirty(t_explode *x)
{
    if (x->x_hq)
    {
        x->x_dirtytohost = 1;
        hq_set(x->x_hq);
    }
}

void explode_dispose(t_explode *x)
{
    struct symbol *s;
    explode_clear(x);
    if (x->x_sym->s_thing
        && ob_messlist(x->x_sym->s_thing) == explode_class)
    {
        t_explode stub, *y, *z;
        stub.x_next = (t_explode *) (x->x_sym->s_thing);
        for (y = &stub; z = y->x_next; y = z)
        {
            if (z == x)
            {
                y->x_next = z->x_next;
                break;
            }
        }
        x->x_sym->s_thing = (t_object *) (stub.x_next);
    }
    if (x->x_hq)
        hq_free(x->x_hq);
}

explode_setdiff(t_explode *x)
{
}

void explode_connect(t_explode *x, long int ptr, long int fun,
                     long int freefun)
{
    if (ptr)
    {
        if (x->x_hq)
            bug("explode_connect 1");
        x->x_hq = hq_new(fun, freefun, ptr, x, explode_hqfn,
                         (NPARAM + 1) * sizeof(long), currentPort);
    }
    else
    {
        if (!x->x_hq)
            bug("explode_connect 2");
        else
            hq_free(x->x_hq);
        x->x_hq = 0;
    }
}

void *gexplode_new(t_symbol *s)
{
    t_explode *x =
        (t_explode *) obj_new((t_messlist **) & explode_class,
                              explode_init);
    explode_init1(x, s);
    /* x->x_wind = 0; */
    x->x_hq = 0;
    x->x_dirtytohost = 0;
    return (x);
}
