#ifndef lint
static char rcsid[] =
    "$Revision: 2.2 $ IRCAM $Date: 1993/11/18 15:37:39 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.2 $ IRCAM $Date: 1993/11/18 15:37:39 $
 *
 * FTS by Miller Puckette
 *
 */

#include "l_list.h"
void *getbytes(int n);
void freebytes(void *x, int n);

t_sll *sll_insert(t_sll *x, void *item)
{
    t_sll *y = sll_new(item);
    y->l_next = x;
    y->l_item = item;
    return (y);
}

t_sll *sll_delete(t_sll *x, void *item)
{
    t_sll *y, *z;
    if (!x)
        bug("sll_delete: not in list");
    else if (x->l_item == item)
    {
        freebytes(x, sizeof(t_sll));
        return (x->l_next);
    }
    else
    {
        for (z = x; y = z->l_next; z = y)
        {
            if (y->l_item == item)
            {
                z->l_next = y->l_next;
                freebytes(y, sizeof(t_sll));
                return (x);
            }
        }
    }
}

void sll_free(t_sll *x)
{
    freebytes(x, sizeof(t_sll));
}

t_sll *sll_new(void *item)
{
    t_sll *x = (t_sll *) getbytes(sizeof(t_sll));
    x->l_item = item;
    return (x);
}
