#ifndef lint
static char rcsid[] =
    "$Revision: 2.12 $ IRCAM $Date: 1994/01/29 07:48:13 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.12 $ IRCAM $Date: 1994/01/29 07:48:13 $
 *
 * FTS by Miller Puckette
 *
 */


#include "m_mess.h"
#include "cp_mess.h"
#include "m_inout.h"

extern t_symbol s_gint, s_gfloat, s_set, s_symbol, s_vmessage, s_patcher,
    s_inlet, s_inchild, s_outlet, s_outchild, s_connect, s_disconnect,
    s_vtoggle, s_vbutton, s_sig, s__Pat, s_, s_append, s__set;
extern t_maxclass *rreceive_class;
void *rsend_new(int cpno, long int id_o, long int sig);
extern void *h_objlist;

/* the "gint" object -- maintains a connection to an int on host. */

typedef struct gint {
    t_object g_ob;
    long g_n;
    void *g_hq;
} t_gint;

void gint_bang(t_gint *x)
{
    outlet_int(x->g_ob.o_outlet, x->g_n);
}

void gint_int(t_gint *x, long int n)
{
    outlet_int(x->g_ob.o_outlet, n);
    x->g_n = n;
    if (x->g_hq)
        hq_set(x->g_hq);
}

void gint_float(t_gint *x, double f)
{
    gint_int(x, (long) f);
}

void gint_set(t_gint *x, long int n)
{
    x->g_n = n;
    if (x->g_hq)
        hq_set(x->g_hq);
}

void gint_gint(t_gint *x, long int n)
{
    outlet_int(x->g_ob.o_outlet, n);
    x->g_n = n;
}

void gint_hqfn(t_gint *x, void *hq)
{
    long buf = x->g_n;
    cvt_long(&buf);
    hq_doit(hq, &buf, sizeof(long));
}

void gint_connect(t_gint *x, long ptr, long fun, long freefun)
{
    if (ptr)
    {
        if (x->g_hq)
            bug("gint_connect 1");
        x->g_hq = hq_new(fun, freefun, ptr, x, gint_hqfn,
                         sizeof(long), currentPort);
        hq_set(x->g_hq);
    }
    else
    {
        if (!x->g_hq)
            bug("gint_connect 2");
        else
            hq_free(x->g_hq);
        x->g_hq = 0;
    }
}

void gint_ff(t_gint *x)
{
    if (x->g_hq)
        hq_free(x->g_hq);
}

t_maxclass *gint_class;
void gint_setup()
{
    c_new(&s_gint, gint_ff, sizeof(t_gint), 0, 0);
    c_addbang(gint_bang);
    c_addint(gint_int);
    c_addfloat(gint_float);
    c_addmess(gint_set, &s_set, A_LONG, 0);
    c_addmess(gint_gint, &s_gint, A_LONG, 0);
    c_addmess(gint_connect, &s_connect, A_LONG, A_LONG, A_LONG, 0);
}

void *gint_new()
{
    t_gint *x =
        (t_gint *) obj_new((t_messlist **) & gint_class, gint_setup);
    outlet(x, &s_int);
    x->g_n = 0;
    x->g_hq = 0;
    return (x);
}

/********************** change bang method to do toggle *************/

void gint_vtoggle(t_gint *x)
{
    gint_int(x, !(x->g_n));
}

t_maxclass *vtoggle_class;
void vtoggle_setup()
{
    c_new(&s_vtoggle, gint_ff, sizeof(t_gint), 0, 0);
    c_addbang(gint_vtoggle);
    c_addint(gint_int);
    c_addfloat(gint_float);
    c_addmess(gint_set, &s_set, A_LONG, 0);
    c_addmess(gint_gint, &s_gint, A_LONG, 0);
    c_addmess(gint_vtoggle, &s_vtoggle, 0);
    c_addmess(gint_connect, &s_connect, A_LONG, A_LONG, A_LONG, 0);
}

void *gtoggle_new()
{
    t_gint *x =
        (t_gint *) obj_new((t_messlist **) & vtoggle_class, vtoggle_setup);
    outlet(x, &s_int);
    x->g_n = 0;
    x->g_hq = 0;
    return (x);
}

/******* gfloat - floating-point counterpart to "gint". ***************/

typedef struct gfloat {
    t_object g_ob;
    float g_f;
    void *g_hq;
} t_gfloat;

void gfloat_bang(t_gfloat *x)
{
    outlet_float(x->g_ob.o_outlet, x->g_f);
}

void gfloat_float(t_gfloat *x, double f)
{
    outlet_float(x->g_ob.o_outlet, f);
    x->g_f = f;
    if (x->g_hq)
        hq_set(x->g_hq);
}

void gfloat_int(t_gfloat *x, long int n)
{
    gfloat_float(x, (double) n);
}

void gfloat_set(t_gfloat *x, double f)
{
    x->g_f = f;
    if (x->g_hq)
        hq_set(x->g_hq);
}

void gfloat_gfloat(t_gfloat *x, double f)
{
    outlet_float(x->g_ob.o_outlet, f);
    x->g_f = f;
}

void gfloat_hqfn(t_gfloat *x, void *hq)
{
    float buf = x->g_f;
    cvt_float(&buf);
    hq_doit(hq, &buf, sizeof(float));
}

void gfloat_connect(t_gfloat *x, long ptr, long fun, long freefun)
{
    if (ptr)
    {
        if (x->g_hq)
            bug("gfloat_connect 1");
        x->g_hq = hq_new(fun, freefun, ptr, x, gint_hqfn,
                         sizeof(long), currentPort);
        hq_set(x->g_hq);
    }
    else
    {
        if (!x->g_hq)
            bug("gfloat_connect 2");
        else
            hq_free(x->g_hq);
        x->g_hq = 0;
    }
}

void gfloat_ff(t_gfloat *x)
{
    if (x->g_hq)
        hq_free(x->g_hq);
}

t_maxclass *gfloat_class;
void gfloat_setup()
{
    c_new(&s_gfloat, gfloat_ff, sizeof(t_gfloat), 0, 0);
    c_addbang(gfloat_bang);
    c_addint(gfloat_int);
    c_addfloat(gfloat_float);
    c_addmess(gfloat_set, &s_set, A_FLOAT, 0);
    c_addmess(gfloat_gfloat, &s_gfloat, A_FLOAT, 0);
    c_addmess(gfloat_connect, &s_connect, A_LONG, A_LONG, A_LONG, 0);
}

void *gfloat_new()
{
    t_gfloat *x = (t_gfloat *) obj_new((t_messlist **) & gfloat_class,
                                       gfloat_setup);
    outlet(x, &s_float);
    x->g_f = 0;
    x->g_hq = 0;
    return (x);
}

/******** "vbutton" - blacken button on NeXT when you get a message ****/

typedef struct vbutton {
    t_object g_ob;
    long g_black;
    void *g_clock;
    void *g_hq;
} t_vbutton;

/* call this when the mouse goes down or up */
void vbutton_vbutton(t_vbutton *x, long int n)
{
    if (n)
        outlet_bang(x->g_ob.o_outlet);
    x->g_black = n;
    if (x->g_hq)
        hq_set(x->g_hq);
    clock_unset(x->g_clock);
}

/* if you receive a message, blacken the button for 150 msec. */
void vbutton_bang(t_vbutton *x)
{
    x->g_black = 1;
    outlet_bang(x->g_ob.o_outlet);
    if (x->g_hq)
        hq_set(x->g_hq);
    clock_set(x->g_clock, logicaltime + 150);
}

void vbutton_tick(t_vbutton *x)
{
    x->g_black = 0;
    if (x->g_hq)
        hq_set(x->g_hq);
}

void vbutton_hqfn(t_vbutton *x, void *hq)
{
    long buf = x->g_black;
    cvt_long(&buf);
    hq_doit(hq, &buf, sizeof(long));
}

void vbutton_connect(t_vbutton *x, long ptr, long fun, long freefun)
{
    if (ptr)
    {
        if (x->g_hq)
            bug("vbutton_connect 1");
        x->g_hq = hq_new(fun, freefun, ptr, x, gint_hqfn,
                         sizeof(long), currentPort);
    }
    else
    {
        if (!x->g_hq)
            bug("vbutton_connect 2");
        else
            hq_free(x->g_hq);
        x->g_hq = 0;
    }
}

void vbutton_ff(t_vbutton *x)
{
    if (x->g_hq)
        hq_free(x->g_hq);
    clock_free(x->g_clock);
}

t_maxclass *vbutton_class;
void vbutton_setup()
{
    c_new(&s_vbutton, vbutton_ff, sizeof(t_vbutton), 0, 0);
    c_addbang(vbutton_bang);
    c_addint(vbutton_bang);
    c_addfloat(vbutton_bang);
    c_addmess(vbutton_vbutton, &s_vbutton, A_LONG, 0);
    c_addmess(vbutton_bang, &s_anything, A_GIMME, 0);
    c_addmess(vbutton_bang, &s_list, A_GIMME, 0);
    c_addmess(vbutton_connect, &s_connect, A_LONG, A_LONG, A_LONG, 0);
}

void *gbutton_new()
{
    t_vbutton *x =
        (t_vbutton *) obj_new((t_messlist **) & vbutton_class,
                              vbutton_setup);
    outlet(x, &s_bang);
    x->g_clock = clock_new(x, vbutton_tick);
    x->g_black = 0;
    x->g_hq = 0;
    return (x);
}

/***************** text updating for messages ***************/

#define SP_FIRST 1              /* first update in sequence */
#define SP_LAST 2               /* last update in sequence */

#define UPDATESIZE HQ_MAX

typedef struct textupd {
    struct hq *u_hq;
    char **u_sendtext;
    long u_textonset;
    long u_textsize;
    struct binbuf *u_buf;
    int u_dirty;                /* true if need update but u_hq is not specified */
} t_textupd;

void textupd_flush(t_textupd *x)
{
    if (x->u_sendtext)
        t_disposehandle((void **) x->u_sendtext);
    x->u_sendtext = (char **) t_newhandle(0L);
    x->u_textonset = 0;
    if (binbuf_totext(x->u_buf, x->u_sendtext, &x->u_textsize))
    {
        error("textupd_flush: not enough memory");
        t_disposehandle((void **) x->u_sendtext);
        x->u_sendtext = 0;
    }
    else
        hq_set(x->u_hq);
}

void textupd_hqfn(t_textupd *x, struct hq *hq)
{
    int bytestosend = x->u_textsize - x->u_textonset, count;
    char *s1, *s2, buf[UPDATESIZE], flag = (x->u_textonset ? 0 : SP_FIRST);
    if (bytestosend > UPDATESIZE - 2)
        bytestosend = UPDATESIZE - 2;
    if (bytestosend < 0)
    {
        bug("textupd_hq 1");
        return;
    }
    for (count = bytestosend, s1 = buf + 1, s2 =
         *x->u_sendtext + x->u_textonset; count--;)
        *s1++ = *s2++;
    *s1++ = 0;
    x->u_textonset += bytestosend;

    if (x->u_textonset >= x->u_textsize)
    {
        t_disposehandle((void **) x->u_sendtext);
        x->u_sendtext = 0;
        flag |= SP_LAST;
        x->u_dirty = 0;
    }
    else
        hq_set(x->u_hq);
    buf[0] = flag;
    hq_doit(hq, buf, bytestosend + 2);
}

void textupd_connect(t_textupd *x, long fun, long freefun, long ptr)
{
    x->u_hq = hq_new(fun, freefun, ptr, x, textupd_hqfn,
                     UPDATESIZE, currentPort);
    if (x->u_dirty)
        textupd_flush(x);
}

void textupd_disconnect(t_textupd *x)
{
    hq_free(x->u_hq);
    x->u_hq = 0;
}

void textupd_dirty(t_textupd *x)
{
    x->u_dirty = 1;
    if (x->u_hq)
        textupd_flush(x);
}

int textupd_isdirty(t_textupd *x)
{
    return (x->u_dirty);
}

void textupd_free(t_textupd *x)
{
    if (x->u_hq)
        hq_free(x->u_hq);
    if (x->u_sendtext)
        t_disposehandle((void **) x->u_sendtext);
    freebytes(x, sizeof(t_textupd));
}

t_textupd *textupd_new(struct binbuf *b)
{
    t_textupd *x = getbytes(sizeof(t_textupd));
    x->u_hq = 0;
    x->u_sendtext = 0;
    x->u_dirty = 0;
    x->u_buf = b;
    return (x);
}

/********************* vmessage ************************/
typedef struct vmessage {
    t_object t_ob;
    void *t_buf;
    t_textupd *t_up;            /* structure which is allocated when connected to host */
} t_vmessage;

void vmessage_bang(t_vmessage *x)
{
    binbuf_eval(x->t_buf, 0, NIL, x->t_ob.o_outlet);
}

void vmessage_int(t_vmessage *x, long int n)
{
    t_atom at;
    at.a_type = A_LONG;
    at.a_w.w_long = n;
    binbuf_eval(x->t_buf, 1, &at, x->t_ob.o_outlet);
}

void vmessage_float(t_vmessage *x, double f)
{
    t_atom at;
    at.a_type = A_FLOAT;
    at.a_w.w_float = f;
    binbuf_eval(x->t_buf, 1, &at, x->t_ob.o_outlet);
}

void vmessage_symbol(t_vmessage *x, t_symbol *s)
{
    t_atom at;
    at.a_type = A_SYM;
    at.a_w.w_sym = s;
    binbuf_eval(x->t_buf, 1, &at, x->t_ob.o_outlet);
}

void vmessage_list(t_vmessage *x, t_symbol *s, int argc, t_atom *argv)
{
    binbuf_eval(x->t_buf, argc, argv, x->t_ob.o_outlet);
}

void vmessage__set(t_vmessage *x, t_symbol *s, int argc, t_atom *argv)
{
    binbuf_set(x->t_buf, NIL, argc, argv);
}

void vmessage_set(t_vmessage *x, t_symbol *s, int argc, t_atom *argv)
{
    binbuf_set(x->t_buf, NIL, argc, argv);
    if (!x->t_up)
        x->t_up = textupd_new(x->t_buf);
    textupd_dirty(x->t_up);
}

void vmessage_append(t_vmessage *x, t_symbol *s, int argc, t_atom *argv)
{
    binbuf_append(x->t_buf, NIL, argc, argv);
    if (!x->t_up)
        x->t_up = textupd_new(x->t_buf);
    textupd_dirty(x->t_up);
}

void vmessage_connect(t_vmessage *x, long ptr, long fun, long freefun)
{
    if (ptr)
    {
        if (!x->t_up)
            x->t_up = textupd_new(x->t_buf);
        textupd_connect(x->t_up, fun, freefun, ptr);
    }
    else
    {
        textupd_disconnect(x->t_up);
        if (!textupd_isdirty(x->t_up))
        {
            textupd_free(x->t_up);
            x->t_up = 0;
        }
    }
}

void vmessage_ff(t_vmessage *x)
{
    binbuf_free(x->t_buf);
    if (x->t_up)
        textupd_free(x->t_up);
}

t_maxclass *vmessage_class;
void vmessage_setup()
{
    c_new(&s_vmessage, vmessage_ff, sizeof(t_vmessage), 0, 0);
    c_addbang(vmessage_bang);
    c_addint(vmessage_int);
    c_addfloat(vmessage_float);
    c_addmess(vmessage_list, &s_list, A_GIMME, 0);
    c_addmess(vmessage_symbol, &s_symbol, A_GIMME, 0);
    c_addmess(vmessage_set, &s_set, A_GIMME, 0);
    c_addmess(vmessage__set, &s__set, A_GIMME, 0);
    c_addmess(vmessage_append, &s_append, A_GIMME, 0);
    c_addmess(vmessage_connect, &s_connect, A_LONG, A_LONG, A_LONG, 0);
}

void *gmessage_new(t_symbol *s, int argc, t_atom *argv)
{
    t_vmessage *x =
        (t_vmessage *) obj_new((t_messlist **) & vmessage_class,
                               vmessage_setup);
    x->t_buf = binbuf_new();
    outlet(x, NIL);
    x->t_up = 0;
    if (argc)
        binbuf_set(x->t_buf, NIL, argc, argv);
    return (x);
}

/********************* vinlet ************************/
void vinlet_bag(), vinlet_put();

typedef struct vinlet {
    t_object i_ob;
    t_object *i_patcher;
    struct inlet *i_inlet;
    void *i_rsend;
    int i_sig;
} t_vinlet;

typedef struct inchild {
    t_object i_ob;
    void *i_rreceive;
} t_inchild;

void vinlet_int(t_vinlet *x, long int n)
{
    x->i_inlet->i_xloc = n;
    vinlet_bag(x);
    vinlet_put(x);
}

void vinlet_bag(t_vinlet *x)
{
    struct inlet *pi2, *pi3;
    struct inlet stub;
    stub.i_next = x->i_patcher->o_inlet;
    for (pi2 = &stub; pi3 = pi2->i_next; pi2 = pi3)
    {
        if (pi3 == x->i_inlet)
        {
            pi2->i_next = pi3->i_next;
            break;
        }
    }
    x->i_patcher->o_inlet = stub.i_next;
}

void vinlet_put(t_vinlet *x)
{
    struct inlet *pi2, *pi3;
    struct inlet stub;
    int didit = 0;
    stub.i_next = x->i_patcher->o_inlet;
    for (pi2 = &stub; pi2; pi2 = pi3)
    {
        pi3 = pi2->i_next;
        if (!pi3 || pi3->i_xloc > x->i_inlet->i_xloc)
        {
            x->i_inlet->i_next = pi3;
            pi2->i_next = x->i_inlet;
            didit = 1;
            break;
        }
    }
    if (!didit)
        bug("lost CP inlet");
    x->i_patcher->o_inlet = stub.i_next;
}

void vinlet_connect(t_vinlet *x, long int who, long int cpno)
/* inchild to connect to (or rreceive if remote) */
{
    if (x->i_rsend)
        bug("ginchild_connect");
    if (cpno != cp_this)
    {
        x->i_rsend = rsend_new(cpno, who, x->i_sig);
        inlet_to(x->i_inlet, x->i_rsend);
    }
    else
    {
        void *ptr = alist_get(h_objlist, who);
        if (!CP_LOCAL(ptr))
            bug("ginchild_connect 2");
        else
            inlet_to(x->i_inlet, ((t_inchild *) ptr)->i_ob.o_outlet);
        x->i_rsend = 0;
    }
}

void vinlet_disconnect(t_vinlet *x)
{
    if (x->i_rsend)
    {
        rsend_free(x->i_rsend);
        x->i_rsend = 0;
    }
    inlet_to(x->i_inlet, NIL);
}

void vinlet_ff(t_vinlet *x)
{
    freeobject((t_object *) x->i_inlet);
}

t_maxclass *vinlet_class;
void vinlet_setup()
{
    c_new(&s_inlet, vinlet_ff, sizeof(t_vinlet), 0, 0);
    c_addint(vinlet_int);
    c_addmess(vinlet_connect, &s_connect, A_LONG, A_LONG, 0);
    c_addmess(vinlet_disconnect, &s_disconnect, 0);
}

void *ginlet_new(t_object *p, long int n, long int sig)
/* owning patcher */
/* x-location */
/* true if this is a signal inlet */
{
    t_vinlet *x =
        (t_vinlet *) obj_new((t_messlist **) & vinlet_class, vinlet_setup);
    x->i_patcher = p;
    x->i_inlet = inlet_new(p, NIL, NIL, NIL);
    x->i_rsend = 0;
    x->i_sig = sig;
    vinlet_int(x, n);
    return (x);
}

/* if remote, the child gets passed a pointer to an rreceive created on
   the host. */

void inchild_connect(t_inchild *x, void *who)
{
    if (x->i_rreceive)
        bug("inchild_connect");
    x->i_rreceive = who;
    rreceive_to(who, x->i_ob.o_outlet);
}

/* called when breaking a connection; only does something if the
   connection was remote. */

void inchild_disconnect(t_inchild *x)
{
    if (x->i_rreceive)
    {
        rreceive_bag(x->i_rreceive);
        x->i_rreceive = 0;
    }
}

void inchild_ff(t_inchild *x)
{
    if (x->i_rreceive)
        rreceive_bag(x->i_rreceive);
}

t_maxclass *inchild_class;
void inchild_setup()
{
    c_new(&s_inchild, inchild_ff, sizeof(t_inchild), 0, 0);
    c_addmess(inchild_connect, &s_connect, A_OBJ, 0);
    c_addmess(inchild_disconnect, &s_disconnect, 0);
}

void *inchild_new(long int sig)
{
    t_inchild *x =
        (t_inchild *) obj_new((t_messlist **) & inchild_class,
                              inchild_setup);
    outlet(x, NIL);             /* LATER set to s_sig if you can -- see u_setup */
    x->i_rreceive = 0;
    return (x);
}

/********************* voutlet ************************/
void voutlet_bag(), voutlet_put();

typedef struct voutlet {
    t_object o_ob;
    t_object *o_patcher;
    struct outlet *o_outlet;
    void *o_rreceive;
} t_voutlet;

typedef struct outchild {
    t_object o_ob;
    void *o_rsend;
    int o_sig;
} t_outchild;

void voutlet_int(t_voutlet *x, long int n)
{
    x->o_outlet->o_xloc = n;
    voutlet_bag(x);
    voutlet_put(x);
}

void voutlet_bag(t_voutlet *x)
{
    struct outlet *pi2, *pi3;
    struct outlet stub;
    stub.o_next = x->o_patcher->o_outlet;
    for (pi2 = &stub; pi3 = pi2->o_next; pi2 = pi3)
    {
        if (pi3 == x->o_outlet)
        {
            pi2->o_next = pi3->o_next;
            break;
        }
    }
    x->o_patcher->o_outlet = stub.o_next;
}

void voutlet_put(t_voutlet *x)
{
    struct outlet *pi2, *pi3;
    struct outlet stub;
    int didit = 0;
    stub.o_next = x->o_patcher->o_outlet;
    for (pi2 = &stub; pi2; pi2 = pi3)
    {
        pi3 = pi2->o_next;
        if (!pi3 || pi3->o_xloc > x->o_outlet->o_xloc)
        {
            x->o_outlet->o_next = pi3;
            pi2->o_next = x->o_outlet;
            didit = 1;
            break;
        }
    }
    if (!didit)
        bug("lost CP outlet");
    x->o_patcher->o_outlet = stub.o_next;
}

/* if remote, the voutlet gets passed a pointer to an rreceive created by
   the host. */

void voutlet_connect(t_voutlet *x, void *who)
{
    if (x->o_rreceive)
        bug("voutlet_connect");
    x->o_rreceive = who;
    rreceive_to(who, x->o_outlet);
}

/* called when breaking a connection; only does something if the
   connection was remote. */

void voutlet_disconnect(t_voutlet *x)
{
    if (x->o_rreceive)
    {
        rreceive_bag(x->o_rreceive);
        x->o_rreceive = 0;
    }
}

void voutlet_ff(t_voutlet *x)
{
    if (x->o_rreceive)
        rreceive_bag(x->o_rreceive);
    freeobject((t_object *) x->o_outlet);
}

t_maxclass *voutlet_class;
void voutlet_setup()
{
    c_new(&s_outlet, voutlet_ff, sizeof(t_voutlet), 0, 0);
    c_addint(voutlet_int);
    c_addmess(voutlet_connect, &s_connect, A_OBJ, 0);
    c_addmess(voutlet_disconnect, &s_disconnect, 0);
}

void *goutlet_new(t_object *p, long int n, long int sig)
/* owning patcher */
{
    t_voutlet *x =
        (t_voutlet *) obj_new((t_messlist **) & voutlet_class,
                              voutlet_setup);
    x->o_patcher = p;
    x->o_outlet = outlet_new(p, NIL);
    x->o_rreceive = 0;
    voutlet_int(x, n);
    return (x);
}

void outchild_connect(t_outchild *x, long int who, long int cpno)
/* voutlet to connect to (or rreceive if remote) */
{
    if (x->o_rsend)
        bug("outchild_connect");
    if (cpno != cp_this)
    {
        x->o_rsend = rsend_new(cpno, who, x->o_sig);
        inlet_to(x->o_ob.o_inlet, x->o_rsend);
    }
    else
    {
        void *ptr = alist_get(h_objlist, who);
        if (!CP_LOCAL(ptr))
            bug("outchild_connect 2");
        else
            inlet_to(x->o_ob.o_inlet, ((t_voutlet *) ptr)->o_outlet);
        x->o_rsend = 0;
    }
}

void outchild_disconnect(t_outchild *x)
{
    if (x->o_rsend)
    {
        rsend_free(x->o_rsend);
        x->o_rsend = 0;
    }
    inlet_to(x->o_ob.o_inlet, NIL);
}

t_maxclass *outchild_class;
void outchild_setup()
{
    c_new(&s_outchild, NIL, sizeof(t_outchild), 0, 1);
    c_addmess(outchild_connect, &s_connect, A_LONG, A_LONG, 0);
    c_addmess(outchild_disconnect, &s_disconnect, 0);
}

void *outchild_new(long int sig)
{
    t_outchild *x =
        (t_outchild *) obj_new((t_messlist **) & outchild_class,
                               outchild_setup);
    inlet(x, NIL, NIL, NIL);
    x->o_rsend = 0;
    x->o_sig = sig;
    return (x);
}

/************* "patcher" -- in parent CP; holds inlets and outlets *****/
t_maxclass *vpatcher_class;
void vpatcher_setup()
{
    c_new(&s_patcher, NIL, sizeof(t_object), 0, 1);
}

void *gpatcher_new(t_symbol *s, int argc, t_atom *argv)
{
    t_object *x =
        (t_object *) obj_new((t_messlist **) & vpatcher_class,
                             vpatcher_setup);
    return (x);
}

/************* "pchild" -- in child CP; defines current "volume" ******/
typedef struct pchild {
    t_object o_ob;
    t_symbol *p_volume;
    t_symbol *p_searchpath;
} t_pchild;

void pchild_int(t_pchild *x, long int n)
{
    if (n)
    {
        defvolume = x->p_volume;
        t_setpath(x->p_searchpath);
        s__Pat.s_thing = (t_object *) x;
    }
    else
    {
        s__Pat.s_thing = 0;
    }
}

void pchild_ff(t_pchild *x)
{
    if (s__Pat.s_thing == (t_object *) x)
        s__Pat.s_thing = 0;
}

t_maxclass *pchild_class;
void pchild_setup()
{
    c_new(&s_patcher, pchild_ff, sizeof(t_pchild), 0, 1);
    c_addint(pchild_int);
}

void *pchild_new(t_symbol *s, t_symbol *t)
{
    t_pchild *x =
        (t_pchild *) obj_new((t_messlist **) & pchild_class, pchild_setup);
    x->p_volume = s;
    x->p_searchpath = t;
    return (x);
}
