#ifndef lint
static char rcsid[] =
    "$Revision: 2.6 $ IRCAM $Date: 1994/01/29 07:48:33 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.6 $ IRCAM $Date: 1994/01/29 07:48:33 $
 *
 * dynamic loader object
 *
 * Eric Viara <@Ircam May 1992>
 * Heavily diddled by msp, Sept. 1992
 */


#include "m_mess.h"
#include <stdio.h>

#define __STRICT_BSD__
#include <math.h>
#undef __STRICT_BSD__

#ifdef __unix
#include <dlfcn.h>
#endif

#ifdef I860
extern t_symbol *cp_getdir();

char *progname_get()
{
    char ftsname[1024];
    strcpy(ftsname, cp_getdir()->s_name);
    strcat(ftsname, "/cp_null.o");
    return (gensym(ftsname)->s_name);
}

#define hobjdir_get()   "/oops/"
#define cpobjdir_get()  "/oops/"
#define hobj_ext()      ".o"
#define cpobj_ext()     ".o860"
/* #define EXTERN_OBJECT   (t_messlist *)1 */
#endif

#ifdef NEXTSTEP
#include <rld.h>
#endif

extern t_object qnewobj;
#define MAXLOADSTACK 16
static int load_sp;

void load_free();

#define MAXOBJFILES 24


void *get_symbol(char *name, void *handle)
{
#ifdef NEXTSTEP
    unsigned long *vaddr = 0;
    rld_lookup(0, name, (unsigned long *) &vaddr);
    return (void *) vaddr;
#elif defined(I860)
    return ((void *) dld_get_symbol(name));
#elif defined(__unix)
    return ((void *) dlsym(handle, name));
#endif
}


#if (0)
printaddr(c, s)
char *c, *s;
{
    char buf[1000];
#ifdef I860
    sprintf(buf, "%s_%s", c, s);
#else
    sprintf(buf, "_%s_%s", c, s);
#endif
    post("printaddr: %s: %lx", buf, get_symbol(buf));
}
#endif

int load_object(filename, classname)
char *filename, *classname;
{
    char setupname[256], slotname[256], realfilename[1024],
        symbolname[1024];
    t_method obj_setup;
    long *obj_class;
    void *dlhandle;
#ifdef I860
    int status;
    char **undefsyms;
    extern char **dld_list_undefined_sym();
#elif defined(NEXTSTEP)
    char *objf[2];
    int status;
    NXStream *dldstream;
#elif defined(__unix)
#endif                          /* I860 */

    /* special handling for classes whose names end in tilde:
       prepend "sig" and take off the tilde so that it can be
       a symbol in c. */
    if (classname[strlen(classname) - 1] == '~')
    {
        strcpy(symbolname, "sig");
        strcat(symbolname, classname);
        symbolname[strlen(symbolname) - 1] = '\0';
    }
    else
        strcpy(symbolname, classname);
#ifdef NEXTSTEP
    sprintf(setupname, "_%s_setup", symbolname);
    sprintf(slotname, "%_s_class", symbolname);
#else                           /* I860 */
    sprintf(setupname, "%s_setup", symbolname);
    sprintf(slotname, "%s_class", symbolname);
#endif                          /* I860 */


#ifdef I860
    strcpy(realfilename, filename);
    strcat(realfilename, ".fts_i860");
    post("load %s...", realfilename);

#ifdef TRACE
    load_trace("init_load... \n");
#endif
    init_load();

#ifdef TRACE
    load_trace("dld_link -> %s\n", realfilename);
#endif
    status = dld_link(realfilename);
#ifdef TRACE
    load_trace("dld_link returns %d\n", status);
#endif
    sys_flush();

    if (undefsyms = dld_list_undefined_sym())
    {
        load_error(0, "*error* in dynamic loading");
        while (*undefsyms)
            post("Symbol %s is undefined", *undefsyms++);
        dld_unlink_by_file(realfilename);
        return 0;
    }

#elif defined(NEXTSTEP)

    strcpy(realfilename, filename);
#ifndef GRAPHICS
    strcat(realfilename, ".fts_ns68k");
#endif
    post("load %s...", realfilename);
    /* post("load_object 1: %s", filename); */
    /* load_error(0, "#-> %s\n", filename); */
    objf[0] = realfilename;
    objf[1] = 0;

    dldstream = NXOpenMemory(NULL, 0, NX_WRITEONLY);
    status = rld_load(dldstream, 0, objf, 0);

    /* check */
    if (!status)
    {
        char *contents;
        int length, maxlength;
        load_error(0, "");
        NXGetMemoryBuffer(dldstream, &contents, &length, &maxlength);
        while (length > 0)
        {
            char buf[1025];
            int size = (length > 1024 ? 1024 : length);
            bcopy(contents, buf, size);
            buf[size] = 0;
#ifdef GRAPHICS
            pdisplay(buf);
#else
            post(buf);
#endif
            contents += size;
            length -= size;
        }
        rld_unload(0);
        NXCloseMemory(dldstream, NX_FREEBUFFER);
        return 0;
    }
    NXCloseMemory(dldstream, NX_FREEBUFFER);

#elif defined(__sgi)

    strcpy(realfilename, filename);
#ifndef GRAPHICS
#ifdef N32
    strcat(realfilename, ".fts_n32");
#else
    strcat(realfilename, ".fts_sgi");
#endif
#endif                          /* GRAPHICS */
    post("load %s...", realfilename);
    dlhandle = dlopen(realfilename, RTLD_NOW);
    if (!dlhandle)
    {
        post("%s: %s", realfilename, dlerror());
        return 0;
    }

#elif defined(__linux)

    strcpy(realfilename, filename);
#ifndef GRAPHICS
    strcat(realfilename, ".fts_lnx");
#endif
    post("load %s...", realfilename);
    dlhandle = dlopen(realfilename, RTLD_NOW);
    if (!dlhandle)
    {
        post("%s: %s", realfilename, dlerror());
        return 0;
    }
#endif

    /* printaddr(classname, "setup");
       printaddr(classname, "new");
       printaddr(classname, "free"); */

    if (!(obj_setup = (t_method) get_symbol(setupname, dlhandle)))
    {
        load_error(0, "load_object: Symbol \"%s\" not found", setupname);
        return 0;
    }
    else
    {
        /* post("setup routine %lx", obj_setup); */
#ifdef TRACE
        load_trace("c_setup\n");
#endif
        c_clearextern();
        c_setup();
        /* *obj_class = (long)EXTERN_OBJECT; */
#ifdef TRACE
        /* post("obj_setup 0x%x\n", obj_setup);
           {
           long *xxx = (long *)obj_setup;
           int i;
           for (i = 0; i < 25; i++) post("0x%x  0x%x", xxx+i, xxx[i]);
           } */
#endif
        obj_setup(gensym(classname));
        /* *obj_class = 0; */
#ifdef TRACE
        load_trace("c_install\n");
#endif
        c_installextern();
#ifdef TRACE
        load_trace("c_install done\n");
#endif
    }
    return 1;
}

#define MAX(A,B) ((A) > (B) ? (A) : (B))

#ifdef I860
int init_load()
{
    static int init, __aa;


    if (!init)
    {
        int error = dld_init(progname_get());
        if (error)
            dld_perror("init");
        m_ext_init();
        init = 1;
    }
}
#endif

#define fillname(b, plist) \
{ \
  struct load_list_name *l; \
  l = *plist = (struct load_list_name *)malloc(sizeof(struct load_list_name)); \
  bzero(l, sizeof(struct load_list_name)); \
  l->name = (char *)malloc(strlen(b)+1); \
  strcpy(l->name, b); \
  l->next = 0; \
}



load_error(x, fmt, a0, a1, a2)
char *fmt;
{
    post(fmt, a0, a1, a2);
}

int getword(tok, fd)
char *tok;
FILE *fd;
{
    char c;
    int empty = 1;

    while ((c = getc(fd)) != EOF)
    {
        if (c == ' ' || c == '\t' || c == '\n' || c == '#')
        {
            if (empty)
            {
                if (c == '#')
                    while (getc(fd) != '\n');
                continue;
            }
            else
            {
                *tok++ = 0;
                if (c == '#')
                    while (getc(fd) != '\n');
                return 1;
            }
        }
        else
        {
            empty = 0;
            *tok++ = c;
        }
    }
    return EOF;
}

void load_trace(fmt, a0, a1, a2, a3, a4, a5, a6)
char *fmt;
{
#ifdef TRACE
    static int cpu = -1;

    post(fmt, a0, a1, a2, a3, a4, a5, a6);
#endif
}
