#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1994/01/04 17:58:25 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/01/04 17:58:25 $
 *
 * Functions that FTS makes available to externs
 * To get names of supplied functions:
 * $ awk /\{\"'/ {print "_" $3}' m_extfun.c
 */

#include <stdio.h>
#include "m_mess.h"
#include "m_extern.h"
#include "d_graph.h"
#include "d_ugen.h"
#include <strings.h>
#include <math.h>
  /* unix stuff */
int open(), creat(), read(), write(), lseek(), close(), sprintf(),
sscanf();
  /* number crunchers */

#ifdef I860
int __divsi3();
int __modsi3();
void bcopy();
void bzero();
#define foobar1 bcopy
#define foobar2 bzero
#else
foobar1(a, b, n)
char *a, *b;
int n;
{
    bcopy(a, b, n);
}

foobar2(a, n)
char *a;
int n;
{
    bzero(a, n);
}
#endif

typedef struct dld_predef {
    char *p_name;
    t_method p_value;
} t_dld_predef;

  /* functions which are specifically for externs to use */
extern t_symbol *defvolume;
t_symbol *getdefvolume()
{
    return (defvolume);
}

/* debugging...
slobber(s) char *s; {post ("addr %lx", s); post ("slobber %s", s);}
dprint(n,x) {post ("xp(%d) = %lx", n, x);}
{ "slobber", (t_method)slobber},
{ "dprint", (t_method)dprint},
*/

t_dld_predef dld_deflist[] = {
    { "gensym", (t_method) gensym },
    { "typedmess", (t_method) typedmess },
    { "post", (t_method) post },
    { "poststring", (t_method) poststring },
    { "postlong", (t_method) postlong },
    { "postfloat", (t_method) postfloat },
    { "error", (t_method) error },
    { "warn", (t_method) warn },
    { "ouch", (t_method) ouch },
    { "gettime", (t_method) gettime },
    { "getdefvolume", (t_method) getdefvolume },
    { "getbytes", (t_method) getbytes },
    { "freebytes", (t_method) freebytes },
    { "t_newhandle", (t_method) t_newhandle },
    { "t_growhandle", (t_method) t_growhandle },
    { "t_disposehandle", (t_method) t_disposehandle },
    { "c_extern", (t_method) c_extern },
    { "c_addbang", (t_method) c_addbang },
    { "c_addint", (t_method) c_addint },
    { "c_addfloat", (t_method) c_addfloat },
    { "c_addmess", (t_method) c_addmess },
    { "obj_new", (t_method) obj_new },
    { "obj_free", (t_method) obj_free },
    { "obj_getclassname", (t_method) obj_getclassname },
    { "outlet_new", (t_method) outlet_new },
    { "outlet_bang", (t_method) outlet_bang },
    { "outlet_int", (t_method) outlet_int },
    { "outlet_float", (t_method) outlet_float },
    { "outlet_symbol", (t_method) outlet_symbol },
    { "outlet_list", (t_method) outlet_list },
    { "outlet_anything", (t_method) outlet_anything },
    { "binbuf_new", (t_method) binbuf_new },
    { "binbuf_free", (t_method) binbuf_free },
    { "binbuf_eval", (t_method) binbuf_eval },
    { "binbuf_clear", (t_method) binbuf_clear },
    { "binbuf_read", (t_method) binbuf_read },
    { "binbuf_write", (t_method) binbuf_write },
    { "binbuf_set", (t_method) binbuf_set },
    { "binbuf_append", (t_method) binbuf_append },
    { "binbuf_getatom", (t_method) binbuf_getatom },
    { "inlet_new", (t_method) inlet_new },
    { "clock_new", (t_method) clock_new },
    { "clock_set", (t_method) clock_set },
    { "clock_delay", (t_method) clock_delay },
    { "clock_unset", (t_method) clock_unset },
    { "clock_free", (t_method) clock_free },
    { "u_inletmethod", (t_method) u_inletmethod },
    { "u_setup", (t_method) u_setup },
    { "u_stdout", (t_method) u_stdout },
    { "u_clean", (t_method) u_clean },
    { "dspchain_addc", (t_method) dspchain_addc },
#ifdef I860
    { "dspchain_add860", (t_method) dspchain_add860 },
#endif
    { "dspchain_addstate", (t_method) dspchain_addstate },
    /* strings */
    { "strcat", (t_method) strcat },
    { "strncat", (t_method) strncat },
    { "strcmp", (t_method) strcmp },
    { "strncmp", (t_method) strncmp },
    { "strcpy", (t_method) strcpy },
    { "strncpy", (t_method) strncpy },
    { "strlen", (t_method) strlen },
    { "index", (t_method) index },
    { "rindex", (t_method) rindex },
    { "sprintf", (t_method) sprintf },
    { "sscanf", (t_method) sscanf },
    /* math */
    { "acos", (t_method) acos },
    { "asin", (t_method) asin },
    { "atan", (t_method) atan },
    { "atan2", (t_method) atan2 },
    { "cos", (t_method) cos },
    { "exp", (t_method) exp },
    { "fabs", (t_method) fabs },
    { "hypot", (t_method) hypot },
    { "log", (t_method) log },
    { "log10", (t_method) log10 },
    { "pow", (t_method) pow },
    { "sin", (t_method) sin },
    { "sqrt", (t_method) sqrt },
    { "tan", (t_method) tan },
    /* bcopy */
    { "bcopy", (t_method) foobar1 },
    { "bzero", (t_method) foobar2 },
    /* other builtin functions */
#ifdef I860
    { "__divsi3", (t_method) __divsi3 },
    { "__modsi3", (t_method) __modsi3 },
#endif
    /* unix V7 filesys */
    { "open", (t_method) open },
    { "creat", (t_method) creat },
    { "read", (t_method) read },
    { "write", (t_method) write },
    { "lseek", (t_method) lseek },
    { "close", (t_method) close },
    /* vector functions */
    { "cu_vadd", (t_method) cu_vadd },
    { "cu_vsub", (t_method) cu_vsub },
    { "cu_vmul", (t_method) cu_vmul },
    { "cu_vdiv", (t_method) cu_vdiv },
    { "cu_ctlsig", (t_method) cu_ctlsig },
    { "cu_zero", (t_method) cu_zero },
    { "fft_init", (t_method) fft_init },
    { "fft", (t_method) fft },
    { "cu_f2p2z", (t_method) cu_f2p2z },
};

m_ext_init()
{
#ifdef I860
    int i;
    for (i = 0; i < sizeof(dld_deflist) / sizeof(dld_deflist[0]); i++)
        dld_set_sym(dld_deflist[i].p_name, dld_deflist[i].p_value);
    /* {
       sa_printf("%d %s %lx ", i, dld_deflist[i].p_name,
       dld_deflist[i].p_value);
       } */
#endif
}
