#ifndef lint
static char rcsid[] =
    "$Revision: 2.7 $ IRCAM $Date: 1994/01/04 17:58:32 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.7 $ IRCAM $Date: 1994/01/04 17:58:32 $
 *
 * FTS by Miller Puckette
 *
 */


#include <stdio.h>
#include "m_mess.h"
#include "m_inout.h"

char *StackOverflow = "stack overflow";
typedef int (*intfun)();
static char *stacklimit;

extern struct symbol s_outlet, s_, s_inlet, s_checkin, s_symbol;

/* int inlet_notify(), inlet_print(); */

io_init()
{
    char c;
    /* stacklimit = &c - 20000; /* how do you really get this? */
    /* stacklimit = GetApplLimit();
       stacklimit += 5000; */
    stacklimit = 0;             /* <a> until we can fix this */
}

/* doubly linked list: */
dll_relink(struct dll *x, struct dll *next)
{
    if (x->d_next)
        x->d_next->d_prev = x->d_prev;  /* get out of old list */
    if (x->d_prev)
        x->d_prev->d_next = x->d_next;

    x->d_prev = 0;              /* get into new one */
    x->d_next = next;
    next->d_prev = x;
}

void dll_free(struct dll *x)
{
    if (x->d_next)
        x->d_next->d_prev = x->d_prev;
    if (x->d_prev)
        x->d_prev->d_next = x->d_next;
    freebytes(x, sizeof(*x));
}

void *dll_new(struct dll *next)
{
    struct dll *x = (struct dll *) getbytes(sizeof(struct dll));
    x->d_prev = 0;              /* get into new one */
    x->d_next = next;
    if (next)
        next->d_prev = x;
    return (x);
}



/* the outlet object.  outlet_add, outlet_rm to edit list;
   An outlet may be chained to an inlet.
   Later we should unionize o_s2, o_chain and o_sig fields.
   */

outlet_doadd(struct outlet *x, struct object *op)
{
    struct dll *d;
    x->o_dll = d = dll_new(x->o_dll);
    d->d_x1 = op;
    if (x->o_s2)
        d->d_x2.fn = egetfn(op, x->o_s2);
    else
        d->d_x2.fn = 0;
    /* if (ISINLET(op)) inlet_notify(op, x, d); */
    return (0);
}

outlet_docheck(struct outlet *x, struct object *op)
{
    struct dll *d;
    int (*fn)() = 0;
    /* post("add %lx, %lx", x, op); */
    for (d = x->o_dll; d; d = d->d_next)
        if (op == d->d_x1)
        {
            warn("outlet_add: already in table");
            break;
        }
    if (x->o_s2)
    {
        if ((fn = (intfun) zgetfn(op, &s_checkin)) && (*fn) (op, x->o_s2))
        {
            /* sa_printf("%x -> %x\n", x, op);
               sa_printf("source %x is %s\n", x->o_owner, ob_name(x->o_owner));
               sa_printf("sink %x is %s\n", op, ob_name(op));
               if (ISINLET(op)) sa_printf("(inlet of %x (%s)\n",
               ((t_inlet *)op)->i_who , ob_name(((t_inlet *)op)->i_who)); */
            error("%s: can't connect", ob_name(op));
            post("(doesn't match '%s)", x->o_s2->s_name);
            return (1);
        }
        fn = (intfun) zgetfn(op, x->o_s2);
        if (!fn)
        {
            error("%s: doesn't understand \"%s\"", ob_name(op),
                  x->o_s2->s_name);
            return (1);
        }
    }
    return (0);
}

/* can actually be any object with a header */
outlet_add(struct outlet *x, struct object *ip)
{
    /* added !x to condition --- foley@iannis Wednesday July 21, 1993 */
    if (!x || outlet_docheck(x, ip))
        return (1);
    else
    {
        outlet_doadd(x, ip);
        return (0);
    }
}

outlet_rm(struct outlet *x, struct object *op)
{
    struct dll *d;
    void (*fn)();
    /* added if (!x) ... --- foley@iannis Wednesday July 21, 1993 */
    if (!x)
        return 0;
    /* post("rm %lx, %lx", x, op); */
    for (d = x->o_dll; d; d = d->d_next)
        if (op == d->d_x1)
        {
            /* if (ISINLET(op)) inlet_notify(op, x, NIL); */
            if (x->o_dll == d)
                x->o_dll = d->d_next;
            dll_free(d);
            return (0);
        }
    bug("outlet_rm: wasn't in table");
    return (0);
}

void *outlet_get(struct outlet *x)      /* return something in outlet */
{
    struct dll *d = x->o_dll;
    return (d ? d->d_x1 : NIL);
}

t_symbol *outlet_getsym(struct outlet *x)       /* get outlet's symbol */
{
    return (x->o_s2);
}

void *outlet_printout(struct outlet *x)
{
    struct dll *d;
    post("outlet:");
    for (d = x->o_dll; d; d = d->d_next)
        poststring(" "), poststring(ob_name(d->d_x1));
}

/* change outlet to a float (it should be a fix beforehand.)
   void *outlet_setfloat(x)
   struct outlet *x;
   {
   struct dll *d;
   for (d = x->o_dll; d; d = d->d_next)
   d->d_x2.fn = egetfn(d->d_x1, &s_float);
   x->o_s2 = &s_float;
   } */

nomess(struct object *op, struct symbol *sym)
{
    error("%s: doesn't understand \"%s\"", ob_name(op), sym->s_name);
}

void outlet_bang(void *xx)
{
    t_outlet *x = xx;
    struct dll *d;
    for (d = x->o_dll; d; d = d->d_next)
    {
        void *y = d->d_x1;
        (*(ob_class(y))->c_bangfun) (y);
    }
}

void outlet_int(void *xx, long int n)
{
    t_outlet *x = xx;
    struct dll *d;
    for (d = x->o_dll; d; d = d->d_next)
    {
        void *y = d->d_x1;
        (*(ob_class(y))->c_intfun) (y, n);
    }
}

void outlet_float(void *xx, double f)
{
    t_outlet *x = xx;
    struct dll *d;
    for (d = x->o_dll; d; d = d->d_next)
    {
        void *y = d->d_x1;
        (*(ob_class(y))->c_floatfun) (y, f);
    }
}

void outlet_symbol(void *xx, t_symbol *s)
{
    t_outlet *x = xx;
    struct dll *d;
    for (d = x->o_dll; d; d = d->d_next)
    {
        void *y = d->d_x1;
        (*(ob_class(y))->c_symfun) (y, s);
    }
}

void outlet_list(void *xx, struct symbol *s, int ac, struct atom *av)
{
    t_outlet *x = xx;
    struct dll *d;
    char c;
    if (d = x->o_dll)
    {
        if (&c < stacklimit)
            ouch(StackOverflow);
        else
            do
                stdlist(d->d_x1, NIL, ac, av);
            while (d = d->d_next);
    }
}

void outlet_anything(void *xx, struct symbol *s, int ac, struct atom *av)
{
    t_outlet *x = xx;
    struct dll *d;
    char c;
    if (d = x->o_dll)
    {
        if (&c < stacklimit)
            ouch(StackOverflow);
        else
            do
                typedmess(d->d_x1, s, ac, av);
            while (d = d->d_next);
    }
}

void outlet_ff(struct outlet *x)
{
    struct outlet *op, *op2;
    struct dll *d;
    while (d = x->o_dll)
        outlet_rm(x, d->d_x1);
    if (x->o_owner)
    {
        if (x == (op = (struct outlet *) x->o_owner->o_outlet))
        {
            x->o_owner->o_outlet = (void *) x->o_next;
            return;
        }
        else if (op)
        {
            for (; op2 = op->o_next; op = op2)
                if (op2 == x)
                {
                    op->o_next = op2->o_next;
                    return;
                }
        }
        bug("outlet: %s: didn't find it", ob_name(x->o_owner));
    }
}

t_maxclass *outlet_class;
void outlet_setup()
{
    c_new(&s_outlet, outlet_ff, sizeof(t_outlet), 1, 0);
    c_addbang(outlet_bang);
    c_addint(outlet_int);
    c_addfloat(outlet_float);
    c_addsymbol(outlet_symbol);
    c_addmess(outlet_list, &s_list, A_GIMME, 0);
    c_addmess(outlet_anything, &s_anything, A_GIMME, 0);
}

/* outlet.  Sends messages with selector s2 */
void *outlet_new(void *op, struct symbol *s2)
/* owning object, NIL if none */
/* message type */
{
    t_outlet *x =
        (t_outlet *) obj_new((t_messlist **) & outlet_class, outlet_setup);

    x->o_dll = 0;
    x->o_s2 = s2;
    x->o_flags = 0;
#ifdef SIGNALS
    x->o_sig = 0;
#endif
    if (x->o_owner = op)
    {
        x->o_next = (struct outlet *) ((t_object *) op)->o_outlet;
        ((t_object *) op)->o_outlet = (void *) x;
    }
    else
        x->o_next = 0;
    return (x);
}

void *outlet(void *op, struct symbol *s2)       /* obsolete form */
{
    return (outlet_new(op, s2));
}

void inlet_bang(struct inlet *x)
{
    if (x->i_s1 == &s_bang)
        (*x->i_fn) (x->i_who);
    else if (!x->i_s1)
    {
        if (x->i_who)
            mess0(x->i_who, &s_bang);
    }
    else
        error("inlet: wrong symbol");
}

void inlet_int(struct inlet *x, long int n)
{
    if (x->i_fast == INLET_FASTINT)
        *(long *) (x->i_who) = n;
    else if (x->i_fast == INLET_FASTFLOAT)
        *(float *) (x->i_who) = n;
    else if (x->i_s1 == &s_int)
        (*x->i_fn) (x->i_who, n);
    else if (x->i_s1 == &s_float)
        (*x->i_fn) (x->i_who, (double) n);
    else if (!x->i_s1)
    {
        if (x->i_who)
            mess1(x->i_who, &s_int, n);
    }
    else
        error("inlet: wrong symbol");
}

void inlet_float(struct inlet *x, double f)
{
    if (x->i_fast == INLET_FASTFLOAT)
        *(float *) (x->i_who) = f;
    else if (x->i_fast == INLET_FASTINT)
        *(long *) (x->i_who) = f;
    else if (x->i_s1 == &s_float)
        (*x->i_fn) (x->i_who, f);
    else if (x->i_s1 == &s_int)
        (*x->i_fn) (x->i_who, (long) f);
    else if (!x->i_s1)
    {
        if (x->i_who)
            mess1(x->i_who, &s_float, f);
    }
    else
        error("inlet: wrong symbol");
}

void inlet_symbol(struct inlet *x, t_symbol *s)
{
    if (x->i_s1 == &s_symbol)
        (*x->i_fn) (x->i_who, s);
    else
        error("inlet: wrong symbol");
}

void inlet_anything(struct inlet *x, struct symbol *s, int ac,
                    struct atom *av)
{
    if (!x->i_s1)
    {
        if (x->i_who)
            typedmess(x->i_who, s, ac, av);
    }
    else if (x->i_s1 == s)
        (*x->i_fn) (x->i_who, s, ac, av);
    else
        error("inlet: wrong symbol");
}

void inlet_list(struct inlet *x, struct symbol *s, int ac, struct atom *av)
{
    if (x->i_s1 == &s_list)
        (*x->i_fn) (x->i_who, &s_list, ac, av);
    else if (!x->i_s1)
    {
        if (x->i_who)
            typedmess(x->i_who, &s_list, ac, av);
    }
    else
        error("inlet: wrong symbol");
}

inlet_to(struct inlet *x, void *w)
{
    x->i_who = w;
}

int inlet_checkin(struct inlet *x, struct symbol *s)
{
    if (!x->i_s1 || s == x->i_s1 ||
        (s == &s_int && x->i_s1 == &s_float) ||
        (s == &s_float && x->i_s1 == &s_int))
        return (0);
    else
        return (1);
}

/* Give the inlet's "who" (which must be an outlet) a pointer back to the
   inlet. */
inlet_chain(struct inlet *x)
{
    struct outlet *to = (struct outlet *) (x->i_who);
    to->o_inlet = x;
}

/* should free up the dlls (or at least check it.) */
void inlet_ff(struct inlet *x)
{
    struct inlet *ip, *ip2;
    if (x->i_owner)
    {
        if (x == (ip = (struct inlet *) x->i_owner->o_inlet))
        {
            x->i_owner->o_inlet = (void *) x->i_next;
            return;
        }
        else if (ip)
        {
            for (; ip2 = ip->i_next; ip = ip2)
                if (ip2 == x)
                {
                    ip->i_next = ip2->i_next;
                    return;
                }
        }
        bug("inlet: %s: didn't find it", ob_name(x->i_owner));
    }
}

t_maxclass *inlet_class;
void inlet_setup()
{
    c_new(&s_inlet, inlet_ff, sizeof(t_inlet), 1, 0);
    c_addbang(inlet_bang);
    c_addint(inlet_int);
    c_addfloat(inlet_float);
    c_addmess(inlet_list, &s_list, A_GIMME, 0);
    c_addmess(inlet_anything, &s_anything, A_GIMME, 0);
    c_addmess(inlet_symbol, &s_symbol, A_SYM, 0);
    c_addmess((t_method) inlet_checkin, &s_checkin, 0);
}

/* create an inlet.  op = owner; who = assoc object; s1 = message
   /* the inlet receives; s2 = message it sends on to "who". */

void *inlet_new(void *op, void *who, struct symbol *s1, struct symbol *s2)
{
    t_inlet *x =
        (t_inlet *) obj_new((t_messlist **) & inlet_class, inlet_setup);
    x->i_who = who;
    x->i_s1 = s1;
    if (s2)
        x->i_fn = getfn(who, s2);
    else
        x->i_fn = nullfn;
    if (x->i_owner = op)
    {
        x->i_next = (struct inlet *) ((t_object *) op)->o_inlet;
        ((t_object *) op)->o_inlet = (void *) x;
    }
    else
        x->i_next = 0;
    x->i_dll = 0;
    x->i_fast = 0;
    return (x);
}

void *inlet(void *op, void *who, struct symbol *s1, struct symbol *s2)  /* obsolete form */
{
    return (inlet_new(op, who, s1, s2));
}

void *inlet_new_fast(void *owner, void *slot, t_symbol *s1)
{
    t_inlet *x =
        (t_inlet *) obj_new((t_messlist **) & inlet_class, inlet_setup);
    if (x->i_owner = owner)
    {
        x->i_next = (struct inlet *) ((t_object *) owner)->o_inlet;
        ((t_object *) owner)->o_inlet = (void *) x;
    }
    else
        x->i_next = 0;
    x->i_who = slot;
    x->i_s1 = s1;
    x->i_fast = (s1 == &s_float ? INLET_FASTFLOAT : INLET_FASTINT);
}

void stdlist(struct object *x, struct symbol *s, int ac, struct atom *av)
{
    void (*fn)();
    if (fn = (ob_class(x))->c_listfun)
        (*fn) (x, s, ac, av);
    else
    {
        struct inlet *inp = x->o_inlet;
        struct atom *ap = av + 1;
        char c;
        /* "list" should never go to a tiny object without a method (?) */
        if (!ac || (ob_class(x))->c_tiny)
            return;
        while (--ac && inp)
        {
            if ((c = ap->a_type) == A_LONG)
                inlet_int(inp, ap->a_w.w_long);
            else if (c == A_FLOAT)
                inlet_float(inp, ap->a_w.w_float);
            inp = inp->i_next;
            ap++;
        }
        if ((c = av->a_type) == A_LONG)
            mess1(x, &s_int, av->a_w.w_long);
        else if (c == A_FLOAT)
            mess1(x, &s_float, av->a_w.w_float);
    }
}

void stdfloat(struct object *x, double f)
{
    (*egetfn(x, &s_int)) (x, (long) f);
}

/* utility to print out general stats of an object */

printobject(struct object *x)
{
    struct outlet *op;
    struct inlet *ip;
#ifdef CAREFUL
    if (NOGOOD(x))
    {
        post("corrupt object -- bad magic number");
        return;
    }
#endif
    for (op = (struct outlet *) x->o_outlet; op; op = op->o_next)
        post("outlet %s", (op->o_s2 ? op->o_s2->s_name : "(nil)"));
    for (ip = (struct inlet *) x->o_inlet; ip; ip = ip->i_next)
        post("inlet %s", (ip->i_s1 ? ip->i_s1->s_name : "(nil)"));
}

void *obj_connect(t_object *x1, long int n1, t_object *x2, long int n2)
{
    struct outlet *po;
    struct inlet *pi;
    for (po = x1->o_outlet; n1-- && po; po = po->o_next);
    if (!ob_class(x2)->c_noinlet && !(n2--))
        pi = (struct inlet *) x2;
    else
        for (pi = x2->o_inlet; n2-- && pi; pi = pi->i_next);
    if (!po || !pi)
    {
        error("obj_connect: inlet or outlet out of range");
        return;
    }
    if (outlet_add(po, (t_object *) pi))
        error("connect: inlet and outlet don't match");
}

void *obj_disconnect(t_object *x1, long int n1, t_object *x2, long int n2)
{
    struct outlet *po;
    struct inlet *pi;
    for (po = x1->o_outlet; n1-- && po; po = po->o_next);
    if (!ob_class(x2)->c_noinlet && !(n2--))
        pi = (struct inlet *) x2;
    else
        for (pi = x2->o_inlet; n2-- && pi; pi = pi->i_next);
    if (!po || !pi)
    {
        error("obj_connect: inlet or outlet out of range");
        return;
    }
    outlet_rm(po, (t_object *) pi);
}
