
/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.2 $ IRCAM $Date: 1993/11/17 14:42:07 $
 *
 * FTS by Miller Puckette
 *
 */

typedef struct dll              /* doubly linked list */
{
    struct dll *d_next;
    struct dll *d_prev;
    void *d_x1;                 /* storage space -- 2 slots to be liberal */
    union {
        void (*fn)();
        void *x;
    } d_x2;
} t_dll;
/* in outlets the dll has (x1) an inlet and (x2.fn) the function to call on it;
  in inlets x1 is the outlet's dll which points to you and x2.x is the outlet. */

typedef struct outlet {
    struct tinyobject o_ob;     /* object header */
    short o_xloc;               /* x-location in box, if any */
    char o_flags;               /* flags */
    struct dll *o_dll;          /* double linked list of active entries */
    struct object *o_owner;     /* owner */
    struct symbol *o_s2;        /* primary message selector -- 0 if none */
    struct inlet *o_inlet;      /* inlet if chained */
    struct outlet *o_next;      /* next outlet for same object */
} t_outlet;

typedef struct inlet {
    struct tinyobject i_ob;
    short i_xloc;               /* x-location in box, if any */
    char i_fast;                /* flag -- inlet has pointer to float or int */
    void *i_who;                /* associated object */
    struct object *i_owner;     /* owning object (for freeing) */
    struct symbol *i_s1;        /* associated symbol */
    void (*i_fn)();             /* method, if any, for i_s2 */
    struct inlet *i_next;
    struct dll *i_dll;          /* list of outlets connected */
} t_inlet;

#define INLET_FASTINT 1
#define INLET_FASTFLOAT 2

extern t_maxclass *inlet_class, *outlet_class;
#define ISINLET(x) (ob_messlist(x) == inlet_class)
#define ISOUTLET(x) (ob_messlist(x) == outlet_class)
