#ifndef lint
static char rcsid[] =
    "$Revision: 1.16 $ IRCAM $Date: 1994/02/07 10:39:49 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.16 $ IRCAM $Date: 1994/02/07 10:39:49 $
 *
 * Maintain a symbol table and define a message-passing system
 */


#include <stdio.h>
#include "m_mess.h"
#include "m_ctype.h"

union argunion {
#ifdef __alpha
    double a_float;
#endif
    long a_long;
    void *a_pointer;
};

static union argunion max_arglist[MAXARG];
#if (defined(I860) || defined(__alpha) || defined(__unix))
#define SEPARATE_FLOAT_REGS
#endif

extern struct object qnewobj;

typedef void *(*t_foo)();
extern void max_dbug(void *x, long int n);

#define PTRSIZE (sizeof(char *))        /* the sizes of the msg arg types */
#define FIXSIZE (sizeof(long))
#define FLOATSIZE (sizeof(double))
#define MAXARGLEN (FLOATSIZE * MAXARG)
#define MSTKSIZE 1000           /* 1000-word-deep */
static struct atom *mstk, *emstk;       /* message-arg stack */
void *newest;                   /* most recent value returned from qnewobj */
char *t_newptr(int n);
static int didinit;
int max_debug;
extern t_symbol s_;

int atom_string(char *buf, struct atom *a);

mess_init()
{
    int i, nbash = 0;
    if (didinit)
        return;
    didinit = 1;
    if (!(mstk = (struct atom *)
          t_newptr((long) (MSTKSIZE * sizeof(union word)))))
        hate("no space for message stack");
    emstk = mstk + MSTKSIZE;
    utils_init();
    conf_init();
    m_obj_init();
#ifdef __unix
    if (((long) max_arglist) & (sizeof(double) - 1))
        post("max_arglist????");
#endif
}

long atol(char *s)
{
    long n = 0;
    int diff, minus = 0;
    char c;
    if (*s == '-')
        minus = 1, s++;
    while ((diff = *(s++) - '0') >= 0 && diff <= 9)
        n = 10 * n + diff;
    return (minus ? -n : n);
}

/*  do this if you want to wrap messaging around a consistency check ...
  void *domess();
  void *typedmess(op, msg, argc, argp)
  struct object *op;
  struct symbol *msg;
  struct atom *argp;
  {
  void *v;
  zcheck(3);
  v = domess(op, msg, argc, argp);
  zcheck(4);
  return (v);
  } */

#if (defined(I860) || defined (N32))
#define PARALLELREGS
#else
#ifdef __sgi
#define OLDSGI
#endif
#endif

#ifdef PARALLELREGS
double max_floatargs[MAXARG];
#endif


void typedmess(void *xx, struct symbol *msg, int argc, struct atom *argp)
{
    t_object *op = xx;
    struct messlist *mp = op->o_messlist;
#ifdef CAREFUL
    if (NOGOOD(op))
    {
        bug("typedmess: %s: corrupt object", msg->s_name);
        /* post("address %lx, contents %x %x %x %x", op,
           ((long *)op)[0],((long *)op)[1],((long *)op)[2],((long *)op)[3]); */
        return;
    }
#endif
#if 0
    {
        struct atom *arg3;
        int cnt;
        post("%s_%s: ", ob_name(op), msg->s_name);
        for (cnt = argc, arg3 = argp; cnt--; arg3++)
            postatom(arg3);
    }
#endif
    /* 1. find a t_method */
    {
        struct symbol *sp;
        for (mp = op->o_messlist; sp = mp->t_symbol; mp++)
            if (sp == msg)
                goto gotit;
        for (mp = op->o_messlist; sp = mp->t_symbol; mp++)
            if (sp == &s_anything)
                goto gotit;
        error("%s: doesn't understand \"%s\"", ob_name(op), msg->s_name);
        return;
    }
  gotit:;
    /* 2. copy args, checking type */
    {
        char *wanttype = mp->m_type;
        union argunion *wp = max_arglist;
        int count = argc;
#ifdef PARALLELREGS
        double *dp = max_floatargs;
#endif
#ifdef OLDSGI
        if (op != &qnewobj)
            (wp++)->a_long = (long) op;
#endif
#ifdef N32
        if (op != &qnewobj)
            *dp++ = 0;
#endif
        while (count--)         /* while there are args to send */
        {
            char type = argp->a_type;
            switch (*(wanttype++))      /* did it want any? */
            {
            case A_GIMME:
                /* cheat out of loop and call with
                   typed args */
                if (op == &qnewobj)
                    newest = (*(t_foo) (mp->m_fun)) (msg, argc, argp);
                else
                    ((*(t_foo) (mp->m_fun)) (op, msg, argc, argp));
                return;
            case A_DEFLONG:
            case A_LONG:
                /* if it wants a long,
                   and given a long, OK. */
                if (type == A_LONG)
                    (wp++)->a_long = (argp++)->a_w.w_long;
                else if (type == A_FLOAT)
                    (wp++)->a_long = (argp++)->a_w.w_float;
                else if (type == A_SYM && *argp->a_w.w_sym->s_name == '#')
                {
                    (wp++)->a_long = 0;
                    argp++;
                }
                else
                {
                    error("%s: bad arguments for message \"%s\"",
                          ob_name(op), msg->s_name);
                    return;
                }
#ifdef N32
                *dp++ = 0;
#endif
                break;
            case A_DEFFLOAT:
            case A_FLOAT:
#ifdef PARALLELREGS
#ifdef N32
                (wp++)->a_long = 0;
#endif
                if (type == A_FLOAT)
                    *dp++ = (argp++)->a_w.w_float;
                else if (type == A_LONG)
                    *dp++ = (argp++)->a_w.w_long;
                else if (type == A_SYM && *argp->a_w.w_sym->s_name == '#')
                    *dp++ = 0;
#else
#ifdef OLDSGI
                if (((long) wp) & (sizeof(double) - 1))
                    wp++;
#endif
                if (type == A_FLOAT)
                    *(double *) wp = (argp++)->a_w.w_float,
                        wp += (sizeof(double) / sizeof(long));
                else if (type == A_LONG)
                    *(double *) wp = (argp++)->a_w.w_long,
                        wp += (sizeof(double) / sizeof(long));
                else if (type == A_SYM && *argp->a_w.w_sym->s_name == '#')
                    *(double *) wp = 0, wp +=
                        (sizeof(double) / sizeof(long));
#endif
                else
                {
                    post("%s: bad arguments for message \"%s\"",
                         ob_name(op), msg->s_name);
                    return;
                }
                break;
            case A_DEFSYM:
            case A_SYM:
                if (type != A_SYM)
                {
                    post("%s: bad arguments for message \"%s\"",
                         ob_name(op), msg->s_name);
                    return;
                }
                (wp++)->a_pointer = (void *) ((argp++)->a_w.w_sym);
#ifdef N32
                *dp++ = 0;
#endif
                break;
            case A_OBJ:
                if (type == A_OBJ)
                    (wp++)->a_pointer = (void *) ((argp++)->a_w.w_obj);
                else if (!(type == A_SYM &&
                           ((wp++)->a_pointer =
                            (void *) ((argp++)->a_w.w_sym->s_thing))))
                {
                    post("%s: bad arguments for message \"%s\"",
                         ob_name(op), msg->s_name);
                    return;
                }
#ifdef N32
                *dp++ = 0;
#endif
                break;
            case A_NOTHING:
                warn("%s: extra arguments for message \"%s\"",
                     ob_name(op), msg->s_name);
                goto done;
            default:
                bug("unknown message argument type");
                return;
            }
        }
        while (1)               /* supply default args to function if needed */
        {
            switch (*(wanttype++))
            {
            case A_GIMME:       /* cheat out of loop and
                                   call with typed args */
                if (op == &qnewobj)
                    newest = (*(t_foo) (mp->m_fun)) (msg, argc, argp);
                else
                    ((*(t_foo) (mp->m_fun)) (op, msg, argc, argp));
                return;
            case A_NOTHING:
                goto done;
            case A_DEFLONG:
                /* defaulting long */
                (wp++)->a_long = 0;
#ifdef N32
                *dp++ = 0;
#endif
                break;
            case A_DEFFLOAT:
                /* defaulting float */
#ifdef PARALLELREGS
                *dp++ = 0.;
#ifdef N32
                (wp++)->a_long = 0;
#endif
#else
#ifdef OLDSGI
                if (((long) wp) & (sizeof(double) - 1))
                    wp++;
#endif
                *(double *) wp = 0, wp += (sizeof(double) / sizeof(long));
#endif
                break;
            case A_DEFSYM:
                /* defaulting symbol */
                (wp++)->a_pointer = (void *) &s_;
                break;
            default:
                error("%s: missing arguments for message \"%s\"",
                      ob_name(op), msg->s_name);
                return;
            }
        }
      done:
#ifdef PARALLELREGS
        if (dp != max_floatargs)
        {
            if (dp <= max_floatargs + 5)
                mess_dummy(max_floatargs[0],
                           max_floatargs[1],
                           max_floatargs[2],
                           max_floatargs[3], max_floatargs[4]);
            else if (dp <= max_floatargs + 10)
                mess_dummy(max_floatargs[0],
                           max_floatargs[1],
                           max_floatargs[2],
                           max_floatargs[3],
                           max_floatargs[4],
                           max_floatargs[5],
                           max_floatargs[6],
                           max_floatargs[7],
                           max_floatargs[8], max_floatargs[9]);
            else
            {
                error("%s: message too long (\"%s\")",
                      ob_name(op), msg->s_name);
                return;
            }
        }
#endif
#ifdef __alpha
        {
            /* fprintf(stderr, "addr %lx data %lf\n", max_arglist, max_arglist[0].a_float); */
            if (op == &qnewobj)
                mess_dummy(max_arglist[0].a_float,
                           max_arglist[1].a_float,
                           max_arglist[2].a_float,
                           max_arglist[3].a_float, max_arglist[4].a_float);
            else
                mess_dummy(max_arglist[0].a_float,      /* magic */
                           max_arglist[0].a_float,
                           max_arglist[1].a_float,
                           max_arglist[2].a_float,
                           max_arglist[3].a_float, max_arglist[4].a_float);
        }
#endif
#ifdef OLDSGI
        mess_dummy(*(double *) (max_arglist),
                   *(double *) (max_arglist + 2));
#endif
        if (wp < max_arglist + 5)
        {
#ifdef OLDSGI
            if (1)
#else
            if (op == &qnewobj)
#endif
            {
                newest = (*(t_foo) (mp->m_fun))
                    (max_arglist[0].a_long,
                     max_arglist[1].a_long,
                     max_arglist[2].a_long,
                     max_arglist[3].a_long, max_arglist[4].a_long);
            }
            else
            {
                (*(t_foo) (mp->m_fun))
                    (op,
                     max_arglist[0].a_long,
                     max_arglist[1].a_long,
                     max_arglist[2].a_long,
                     max_arglist[3].a_long, max_arglist[4].a_long);
            }
            return;
        }
        else if (wp < max_arglist + MAXARG)
        {
#ifdef OLDSGI
            if (1)
#else
            if (op == &qnewobj)
#endif
            {
                newest = (*(t_foo) (mp->m_fun))
                    (max_arglist[0].a_long,
                     max_arglist[1].a_long,
                     max_arglist[2].a_long,
                     max_arglist[3].a_long,
                     max_arglist[4].a_long,
                     max_arglist[5].a_long,
                     max_arglist[6].a_long,
                     max_arglist[7].a_long,
                     max_arglist[8].a_long,
                     max_arglist[9].a_long, max_arglist[10].a_long);
            }
            else
            {
                (*(t_foo) (mp->m_fun))
                    (op,
                     max_arglist[0].a_long,
                     max_arglist[1].a_long,
                     max_arglist[2].a_long,
                     max_arglist[3].a_long,
                     max_arglist[4].a_long,
                     max_arglist[5].a_long,
                     max_arglist[6].a_long,
                     max_arglist[7].a_long,
                     max_arglist[8].a_long,
                     max_arglist[9].a_long, max_arglist[10].a_long);
            }
            return;
        }
        else
        {
            error("%s: message too long (\"%s\")",
                  ob_name(op), msg->s_name);
            return;
        }
    }
}

void nullfn()
{
}

#ifdef SEPARATE_FLOAT_REGS
mess_dummy(double a, double b, double c, double d, double e)
{
    /*fprintf(stderr, "%lf\n", a); */
}
#endif

t_method getfn(void *xx, struct symbol *msg)
{
    t_object *op = xx;
    struct messlist *mp;
    struct symbol *sp;
#ifdef CAREFUL
    if (NOGOOD(op))
    {
        bug("getfn (%s): corrupt object", msg->s_name);
        return (nullfn);
    }
#endif
    for (mp = op->o_messlist; sp = mp->t_symbol; mp++)
        if (sp == msg)
            return (mp->m_fun);
    error("%s: doesn't understand \"%s\"", ob_name(op), msg->s_name);
    return (nullfn);
}

t_method egetfn(void *xx, struct symbol *msg)
{
    t_object *op = xx;
    struct messlist *mp;
    struct symbol *sp;
#ifdef CAREFUL
    if (NOGOOD(op))
    {
        bug("egetfn (%s): corrupt object", msg->s_name);
        return (nullfn);
    }
#endif
    for (mp = op->o_messlist; sp = mp->t_symbol; mp++)
        if (sp == msg)
            return (mp->m_fun);
    return (nullfn);
}

t_method zgetfn(void *xx, struct symbol *msg)
{
    t_object *op = xx;
    struct messlist *mp;
    struct symbol *sp;
#ifdef CAREFUL
    if (NOGOOD(op))
    {
        bug("zgetfn (%s): corrupt object", msg->s_name);
        return ((t_method) 0);
    }
#endif
    for (mp = op->o_messlist; sp = mp->t_symbol; mp++)
        if (sp == msg)
            return (mp->m_fun);
    return ((t_method) 0);
}

#ifdef GRAPHICS
extern int loadnumber;
#endif

struct symbol *getdollsym(struct symbol *s, int ac, struct atom *av)
{
    long onset = s->s_name[0] - '0';
    char xx[80];
    if (onset < 0 || onset > ac)
        return (0);
    else if (onset == 0)
    {
#ifdef GRAPHICS
        if (loadnumber > 0)
            sprintf(xx, "%d%s", loadnumber, s->s_name + 1);
        else
            sprintf(xx, "#0%s", s->s_name + 1);
#else
        sprintf(xx, "#0%s", s->s_name + 1);
#endif
    }
    else
    {
        atom_string(xx, av + onset);
        strcat(xx, s->s_name + 1);
    }
    return (gensym(xx));
}

union ptr {
    char *p_charstar;
    long *p_longstar;
#ifdef __alpha
    double *p_floatstar;
#else
    float *p_floatstar;
#endif
    struct symbol **p_sym;
    struct object **p_obj;
};

    /* for some reason the i860 compiler barfed when I did this prototype
       the modern way! - msp */
char *attostr(c, p)
char c;
union ptr p;
{
    static char buf[80];
    if (c == A_SEMI)
        return (";");
    else if (c == A_COMMA)
        return (",");
    else if (c == A_SYM)
        sprintf(buf, "'%s", (*p.p_sym)->s_name);
    else if (c == A_OBJ)
        sprintf(buf, "'%s", ob_name(*p.p_obj));
    else if (c == A_LONG)
        sprintf(buf, "%ld", *(p.p_longstar));
    else if (c == A_FLOAT)
        sprintf(buf, "%f", *(p.p_floatstar));
    else if (c == A_DOLLAR)
        sprintf(buf, "$%ld", *(p.p_longstar));
    else if (c == A_DOLLSYM)
        sprintf(buf, "$%s", (*p.p_sym)->s_name);
    else if (!c)
        return ("(end)");
    else
        return ("?");
    return (buf);
}

void evalbuf(char **buf, long int onset, int ac, struct atom *av,
             struct object *messto)
/* handle for message buffer */
/* onset into buf of first arg */
/* arg count */
/* arg values */
/* outlet (sort of) */
{
    long nargs = 0;             /* number of args eaten */
    struct object *ret = 0;
    int didone = 0;
    struct atom *mstkwas = mstk;
    av--;                       /* fix arglist to start from 1, not 0 */
    while (1)                   /* go through messages */
    {
        char *tp = *buf + nargs, c;     /* ptr to next type */
        union ptr p;
        struct atom *ap;
        long count = 0;
        int argc;
        struct symbol *mess;
        int n;
        p.p_charstar = *buf + onset;    /* ptr to next arg */
        while (1)               /* find out whom it's to */
        {
            if (!(c = *tp))
                return;         /* if nothing quit */
            else if (c == A_SEMI)
            {
                messto = 0;
                tp++;           /* eat leading semis */
                continue;
            }
            else if (c == A_COMMA)
            {
                tp++;           /* eat leading commas */
                continue;
            }
            /* done: messto!=0 and next arg ok */
            else if (messto)
                break;
            else
            {
                if (c == A_SYM)
                {
                    if (!(messto = (*p.p_sym)->s_thing))
                    {
                        error("%s: no such object", (*p.p_sym)->s_name);
                        goto eat;
                    }
                    else
                    {
                        tp++;
                        p.p_sym++;
                        continue;
                    }
                }
                /* <> code inserted to make $1 etc work as a destination */
                else if (c == A_DOLLAR)
                {
                    long argno = *p.p_longstar;
                    struct atom *at;
                    if (argno < 1 || argno >= ac + 1)
                    {
                        error("%s: argument out of range", attostr(c, p));
                        goto eat;
                    }
                    at = av + argno;
                    if (at->a_type != A_SYM)
                    {
                        error("%s: not a symbol",
                              attostr(at->a_type, &at->a_w));
                        goto eat;
                    }
                    else if (!(messto = at->a_w.w_sym->s_thing))
                    {
                        error("%s: no such object", at->a_w.w_sym->s_name);
                        goto eat;
                    }
                    else
                    {
                        tp++;
                        p.p_longstar++;
                        continue;
                    }
                }
                else if (c == A_DOLLSYM)
                {
                    struct symbol *waka = getdollsym(*p.p_sym, ac, av);
                    struct atom *at;
                    if (!waka)
                    {
                        error("%s: argument out of range", attostr(c, p));
                        goto eat;
                    }
                    else if (!(messto = waka->s_thing))
                    {
                        error("%s: no such object", waka->s_name);
                        goto eat;
                    }
                    else
                    {
                        tp++;
                        p.p_sym++;
                        continue;
                    }
                }
                else
                {
                    error("%s: not a symbol", attostr(c, p));
                    goto eat;
                }
            }
        }
        /* count arguments */
        for (count = 0; (c = *tp) && c != A_SEMI && c != A_COMMA;
             count++, mstk++, tp++)
        {
            int dollar;
            struct symbol *waka;
            if (mstk >= emstk)
            {
                ouch("message stack overflow");
                goto eat;
            }
            switch (c)
            {
            case A_LONG:
                mstk->a_type = A_LONG;
                mstk->a_w.w_long = *((p.p_longstar)++);
                break;
            case A_SYM:
                mstk->a_type = A_SYM;
                mstk->a_w.w_sym = *((p.p_sym)++);
                break;
            case A_FLOAT:
                mstk->a_type = A_FLOAT;
                mstk->a_w.w_float = *((p.p_floatstar)++);
                break;
            case A_DOLLAR:
                /* dollar sign means nth element in the arg list */
                dollar = *((p.p_longstar)++);
                if (dollar < 1 || dollar > ac)
                {
                    error("\"$\" variable out of range");
                    p.p_longstar--;
                    goto eat;
                }
                else
                    *mstk = av[dollar];
                break;
            case A_DOLLSYM:
                waka = getdollsym(*((p.p_sym)++), ac, av);
                if (!waka)
                {
                    error("\"$\" variable out of range");
                    p.p_sym--;
                    goto eat;
                }
                else
                    SETSYM(mstk, waka);
                break;
            default:
                error("%s: bad argument", attostr(c, p));
                goto eat;
            }
        }
        argc = count;
        ap = mstkwas;           /* get beginning of message */
        /* get message selector: */
        /* it might be supplied as the first arg of the msg */
        if (ap->a_type == A_SYM)
            mess = (ap++)->a_w.w_sym, argc--;
        else                    /* otherwise it might be a standard message
                                   without the selector */
        {
            int t1;
            if ((t1 = mstkwas->a_type) == A_LONG)
            {
                if (argc == 1)
                    mess = &s_int;
                else
                    mess = &s_list;
            }
            else if (t1 == A_FLOAT)
            {
                if (argc == 1)
                    mess = &s_float;
                else
                    mess = &s_list;
            }
            else
            {
                error("badly formed message");
                goto eat;
            }
        }
#if 0
        post("cmd: ");
        poststring(ob_name(messto));
        poststring(" ");
        poststring(mess->s_name);
        for (n = 0; n < argc; n++)
            postatom(ap + n);
#endif
        nargs = tp - *buf;
        onset = p.p_charstar - *buf;
        typedmess(messto, mess, argc, ap);
        if (*tp == A_SEMI)
            messto = 0;
        mstk = mstkwas;
        continue;

      eat:                      /* tail to eat through to end of message */
        for (; (c = *tp) && c != A_SEMI && c != A_COMMA; tp++)
        {
            if (c == A_LONG)
                (p.p_longstar)++;
            else if (c == A_FLOAT)
                (p.p_floatstar)++;
            else if (c == A_SYM || c == A_DOLLSYM)
                (p.p_sym)++;
            else if (c == A_DOLLAR)
                (p.p_longstar)++;
        }
        nargs = tp - *buf;
        onset = p.p_charstar - *buf;
        if (*tp == A_SEMI)
            messto = 0;
        mstk = mstkwas;
    }
}

atom_string(char *buf, struct atom *a)
{
    int c = a->a_type;

    if (c == A_SEMI)
        strcpy(buf, ";");
    else if (c == A_COMMA)
        strcpy(buf, ",");
    else if (c == A_SYM)
        sprintf(buf, "%s", a->a_w.w_sym->s_name);
    else if (c == A_OBJ)
        sprintf(buf, "%s", ob_name(a->a_w.w_obj));
    else if (c == A_LONG)
        sprintf(buf, "%ld", a->a_w.w_long);
    else if (c == A_DOLLAR)
        sprintf(buf, "$%ld", a->a_w.w_long);
    else if (c == A_DOLLSYM)
        sprintf(buf, "$%s", a->a_w.w_sym->s_name);
    else if (!c)
        strcpy(buf, "(end)");
    else
        strcpy(buf, "(???)");
}

extern t_symbol
    s_in1, s_in2, s_in3, s_in4, s_in5, s_in6, s_in7, s_in8, s_in9,
    s_ft1, s_ft2, s_ft3, s_ft4, s_ft5, s_ft6, s_ft7, s_ft8, s_ft9,
    s_sm1, s_sm2, s_sm3, s_sm4, s_sm5, s_sm6, s_sm7, s_sm8, s_sm9;
static t_symbol *itab[] = {
    &s_in1, &s_in2, &s_in3, &s_in4, &s_in5, &s_in6, &s_in7, &s_in8, &s_in9
};

static t_symbol *ftab[] = {
    &s_ft1, &s_ft2, &s_ft3, &s_ft4, &s_ft5, &s_ft6, &s_ft7, &s_ft8, &s_ft9
};

static t_symbol *stab[] = {
    &s_sm1, &s_sm2, &s_sm3, &s_sm4, &s_sm5, &s_sm6, &s_sm7, &s_sm8, &s_sm9
};

static t_messlist **newmhandle;
static t_class newclass;
static int nmess;
static int maxmess;
static char *classmem = "out of memory while creating a class";

c_setup()
{
    if (newmhandle)
        DisposHandle(newmhandle);
    newmhandle = (t_messlist **)
        t_newhandle((long) (10 * sizeof(t_messlist)));
    if (!newmhandle)
        hate("coudn't create newmhandle");
    maxmess = 10;
    nmess = 0;
}

c_install(t_messlist **mlp)
{
    t_messlist *ml, *ml2;
    t_class *c2;
    if (!(c2 = (t_class *) t_newptr((long) sizeof(t_class))))
        hate(classmem);
    *c2 = newclass;
    if (!(ml = *mlp = (t_messlist *) t_newptr((long)
                                              ((nmess +
                                                2) * sizeof(t_messlist)))))
        hate(classmem);
    (ml++)->t_symbol = (t_symbol *) c2;
    for (ml2 = *newmhandle; nmess--; ml++, ml2++)
        *ml = *ml2;
    ml->t_symbol = 0;
    DisposHandle(newmhandle);
    newmhandle = 0;
}

void obj_nobang(t_object * x), obj_noint(t_object * x),
obj_nofloat(t_object * x), obj_nosym(t_object * x);

void c_new(t_symbol *s, t_method freefun, int size, int tiny, int noinlet)      /* set up class */
{
    newclass.c_sym = s;
    newclass.c_freefun = freefun;
    newclass.c_bangfun = obj_nobang;
    newclass.c_intfun = obj_noint;
    newclass.c_floatfun = obj_nofloat;
    newclass.c_symfun = obj_nosym;
    newclass.c_listfun = 0;
    newclass.c_anyfun = 0;
    newclass.c_size = size;
    newclass.c_tiny = tiny;
    newclass.c_noinlet = noinlet;
}

/* extern t_symbol s_print; */

/* c_addmess is "temporarily" in m_varargs.c */

void c_doaddmess(t_method f, t_symbol *s, int *typelist, int ntype)     /* add an incoming message */
{
    t_messlist *messp;
    int i;
    if (ntype > MAXARG)
        ntype = MAXARG;
    if (nmess == maxmess)
    {
        if (t_growhandle((void **) newmhandle,
                         (long) ((maxmess += 10) * sizeof(t_messlist))))
            hate(classmem);
    }
    messp = *newmhandle + (nmess++);
    for (i = 0; i < ntype; i++)
        messp->m_type[i] = typelist[i];
    messp->m_type[ntype] = 0;
    messp->m_fun = f;
    messp->t_symbol = s;
    /* post("%lx (%s) / %lx", s->s_name, &s_print, s_print.s_name); */
    if (s == &s_bang)
        newclass.c_bangfun = f;
    else if (s == &s_int)
        newclass.c_intfun = f;
    else if (s == &s_float)
        newclass.c_floatfun = f;
    else if (s == &s_symbol)
        newclass.c_symfun = f;
    else if (s == &s_list)
        newclass.c_listfun = f;
}

void c_addbang(t_method f)      /* add a "bang" message ... */
{
    t_messlist *messp;
    if (nmess == maxmess)
    {
        if (t_growhandle((void **) newmhandle,
                         (long) ((maxmess += 10) * sizeof(t_messlist))))
            hate(classmem);
    }
    messp = *newmhandle + (nmess++);
    messp->t_symbol = &s_bang;
    messp->m_fun = f;
    messp->m_type[0] = 0;
    newclass.c_bangfun = f;
}

void c_addint(t_method f)       /* "int" */
{
    t_messlist *messp;
    if (nmess == maxmess)
    {
        if (t_growhandle((void **) newmhandle,
                         (long) ((maxmess += 10) * sizeof(t_messlist))))
            hate(classmem);
    }
    messp = *newmhandle + (nmess++);
    messp->t_symbol = &s_int;
    messp->m_fun = f;
    messp->m_type[0] = A_LONG;
    messp->m_type[1] = 0;
    newclass.c_intfun = f;
}

void c_addfloat(t_method f)     /* "float" */
{
    t_messlist *messp;
    if (nmess == maxmess)
    {
        if (t_growhandle((void **) newmhandle,
                         (long) ((maxmess += 10) * sizeof(t_messlist))))
            hate(classmem);
    }
    messp = *newmhandle + (nmess++);
    messp->t_symbol = &s_float;
    messp->m_fun = f;
    messp->m_type[0] = A_FLOAT;
    messp->m_type[1] = 0;
    newclass.c_floatfun = f;
}

void c_addsymbol(t_method f)    /* "symbol" */
{
    t_messlist *messp;
    if (nmess == maxmess)
    {
        if (t_growhandle((void **) newmhandle,
                         (long) ((maxmess += 10) * sizeof(t_messlist))))
            hate(classmem);
    }
    messp = *newmhandle + (nmess++);
    messp->t_symbol = &s_symbol;
    messp->m_fun = f;
    messp->m_type[0] = A_SYM;
    messp->m_type[1] = 0;
    newclass.c_symfun = f;
}

void c_addlist(t_method f)
{
    c_addmess(f, &s_list, A_GIMME, 0);
}

void c_addanything(t_method f)
{
    c_addmess(f, &s_anything, A_GIMME, 0);
}

void c_addinx(t_method f, int n)
{
    t_messlist *messp;
    if (nmess == maxmess)
    {
        if (t_growhandle((void **) newmhandle,
                         (long) ((maxmess += 10) * sizeof(t_messlist))))
            hate(classmem);
    }
    messp = *newmhandle + (nmess++);
    if (n < 1 || n > 9)
        error("inlet method out of range"), n = 1;
    messp->t_symbol = itab[n - 1];
    messp->m_fun = f;
    messp->m_type[0] = A_LONG;
    messp->m_type[1] = 0;
}

void c_addftx(t_method f, int n)
{
    t_messlist *messp;
    if (nmess == maxmess)
    {
        if (t_growhandle((void **) newmhandle,
                         (long) ((maxmess += 10) * sizeof(t_messlist))))
            hate(classmem);
    }
    messp = *newmhandle + (nmess++);
    if (n < 1 || n > 9)
        error("inlet method out of range"), n = 1;
    messp->t_symbol = ftab[n - 1];
    messp->m_fun = f;
    messp->m_type[0] = A_FLOAT;
    messp->m_type[1] = 0;
}

void c_addsmx(t_method f, int n)
{
    t_messlist *messp;
    if (nmess == maxmess)
    {
        if (t_growhandle((void **) newmhandle,
                         (long) ((maxmess += 10) * sizeof(t_messlist))))
            hate(classmem);
    }
    messp = *newmhandle + (nmess++);
    if (n < 1 || n > 9)
        error("inlet method out of range"), n = 1;
    messp->t_symbol = stab[n - 1];
    messp->m_fun = f;
    messp->m_type[0] = A_SYM;
    messp->m_type[1] = 0;
}

char *c_what(void *x)
{
    post("%s\n", ob_name(x));
    return (ob_name(x));
}

/* allocate space for an object */
void *newobject(struct messlist *ml)
{
    struct class *cp = (struct class *) ((ml++)->t_symbol);
    struct object *op = (struct object *) getbytes((long) (cp->c_size));
    if (!op)
        hate("out of memory");
    op->o_messlist = ml;
#ifdef CAREFUL
    op->o_magic = MAGIC;
#endif
    if (!cp->c_tiny)
        op->o_inlet = 0, op->o_outlet = 0;
    /* post("new %s at %lx", cp->c_sym->s_name, op); */
    return (op);
}

void freeobject(t_object *xx)
{
    t_object *op = xx;
    void (*fn)();
    struct class *cp = ob_class(op);
    /* post("freeobject %lx", op); */
#ifdef CAREFUL
    if (NOGOOD(op))
        post("freeobject: %lx: bad object", op);
    else
    {
#endif
        /* post("freeing %s at %lx", ob_name(op), op); */
        /* post("1 class %lx", cp); */
        if (fn = cp->c_freefun)
            (*fn) (op);
        /* post("2 class %lx", cp); */
        if (!cp->c_tiny)
        {
            void *tp;
            while (op->o_outlet)
                freeobject((t_object *) op->o_outlet);
            while (op->o_inlet)
                freeobject((t_object *) op->o_inlet);
        }
#ifdef CAREFUL
        op->o_magic = 0;
#endif
        freebytes(op, cp->c_size);
        /* post("   freed %lx", op); */
#ifdef CAREFUL
    }
#endif
}

/* allocate space for an object, new version */
void *obj_new(t_maxclass **mlp, t_method fn)
{
    t_messlist *ml;
    if (!(ml = *mlp))
    {
        if (fn)
        {
            c_setup();
            (*fn) ();
            c_install(mlp);
            ml = *mlp;
        }
        else
        {
            error("obj_new: no setup function");
            return (0);
        }
    }
    return (newobject(ml));
}

void obj_free(void *op)
{
    freeobject((t_object *) op);
}

t_symbol *obj_getclassname(void *op)
{
    return (ob_class(op)->c_sym);
}

t_messlist **extern_messlistp;

c_clearextern()
{
    extern_messlistp = 0;
}

c_installextern()
{
    if (!extern_messlistp)
        error("external object didn't call c_extern() from setup routine");
    else
        c_install(extern_messlistp);
}

/* moved...
   int
   c_extern(mlp, m_new, m_free, sym, size, tiny, noinlet, type0, type1, type2,
   type3)
   t_messlist **mlp;
   t_method m_new, m_free;
   t_symbol *sym;
   {
   int typelist[4] = {0, 0, 0, 0};
   if ( typelist[0] = type0 )
   if ( typelist[1] = type1 )
   if ( typelist[2] = type2 )
   typelist[3] = type3;
   
   c_addmessto(&qnewobj.o_messlist, m_new, sym, typelist);
   
   c_new(sym, m_free, size, tiny, noinlet);
   extern_messlistp = mlp;
   }
   */
/******************** support routines for dynamic classes **********/

/* the c_ routines here might find their way into m_mess.c later. */

int c_addmessto(t_messlist **mlp, t_method f, t_symbol *s, int *type)
{
    t_messlist *ml;
    int *tp, narg = 0, is, nmeth, oldsize;
    char *mp;

    /* bug: must start at *mlp and not *mlp+1 */
    for (ml = *mlp, nmeth = 0; ml->t_symbol; ml++, nmeth++);
    oldsize = (nmeth + 2) * sizeof(t_messlist);

    /* bug: the allocation has been done for *mlp-1 and not for *mlp 
       so the reallocation must be done for the same <#viara> */
    *mlp = ((t_messlist *)
            resizebytes(*mlp - 1, oldsize,
                        oldsize + sizeof(t_messlist))) + 1;
    if (!*mlp)
        hate("out of space");

    /* bug: must be '+ nmeth' and not '+ nmeth + 1' */
    ml = *mlp + nmeth;
    tp = type;
    mp = ml->m_type;
    do
        is = *mp++ = *tp++;
    while (is && ++narg <= MAXARG);

    ml->m_fun = f;
    ml->t_symbol = s;

    /* bug: must zeroes the t_symbol field of last messlist <#viara> */
    (*mlp + nmeth + 1)->t_symbol = 0;

    return 1;
}

int c_rmmessfrom(t_messlist **mlp, t_symbol *s)
{
    t_messlist *ml, *ml2 = 0, *ml3;
    int *tp, narg = 0, is, nmeth, oldsize;
    char *mp;

    /* bug: must start at *mlp and not *mlp+1 */
    for (ml = *mlp, nmeth = 0; ml->t_symbol; ml++, nmeth++)
        if (ml->t_symbol == s)
            ml2 = ml;

    if (ml2)
    {
        for (ml3 = ml2; ml3 < ml; ml3++)
            ml3[0] = ml3[1];
        oldsize = (nmeth + 2) * sizeof(t_messlist);

        /* bug: the allocation has been done for *mlp-1 and not for *mlp 
           so the reallocation must be done for the same <#viara> */
        *mlp = ((t_messlist *)
                resizebytes(*mlp - 1, oldsize,
                            oldsize - sizeof(t_messlist))) + 1;

        if (!*mlp)
            hate("out of space");

        return 1;
    }
    else
        return 0;
}

c_setclass(t_object *op, t_messlist *ml)
{
    op->o_messlist = ml + 1;
#ifdef CAREFUL
    op->o_magic = MAGIC;
#endif
}
