#ifndef lint
static char rcsid[] =
    "$Revision: 1.14 $ IRCAM $Date: 1994/05/10 10:51:10 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.14 $ IRCAM $Date: 1994/05/10 10:51:10 $
 *
 * FTS by Miller Puckette
 *
 */


#include <stdio.h>
#include "m_mess.h"
#include "cp_mess.h"
#ifdef I860
#include "../56k/converterType.h"
#endif

extern struct symbol s_max, s_new, s_n, s_m, s_, s_addtopath, s__New,
    s_print, s_debug, s_set, s_v2, s_tick, s_run, s_ping, s_led, s_rats,
    s_load, s_load_obj, s_setfts;

void c_qnew();
t_maxclass *qnew_class;

extern int max_debug;

void max_dbug(void *x, long int n)
{
    post("--- debug %d ---", n);
    max_debug = n;
#ifdef I860
    if (n < 0)
        sys_spin(n);
#endif                          /* I860 */
}

void max_rats(void *x, long int n)
{
    post("max: rats");
}

void max_set(void *x, long int n)
{
    SetCurrentTime(n);
}

extern int binbuf_compat;
t_symbol *atom_getsym(t_atom * at);

#ifdef GRAPHICS
void declare__doit();
#endif

void cp_led(void *x, long int n1, long int n2)
{
#ifdef I860
    sys_led((int) n1, (int) n2);
#else
    post("leds: %ld %ld", n1, n2);
#endif
}

static int cp_wantedrate;
extern int cp_sr;

#if !defined(GRAPHICS) && defined(__sgi)
void cp_sgichannels(void *x, long in, long out)
{
    sgi_set_chans((int) in, (int) out);
}

void cp_sgisrate(void *x, long srate)
{
    sgi_setlogicalsamplerate((int) srate);
}

extern void sgi_setup2(void *x, long n);
#endif                          /* __sgi and !graphics */

#ifdef I860
extern t_symbol s_internal;
extern int cp_slotno;
static t_symbol *clk = &s_internal;
static int nchans = 2, ebu1, ebu2, synctobackplane;
static int foobar;

extern void cp_findrate();
extern int cp_this;
void io_setrunning();



/* set dac config.  args: nchans, clocksource, flag...
   as a hack, if "x" is zero, stop dac_poll from doing any work  */
void cp_setdacs(x, s, ac, av)
void *x;
t_symbol *s;
t_atom *av;
{
    nchans = 2;
    ebu1 = ebu2 = synctobackplane = 0;
    clk = gensym("internal");
    if (!(cp_slotno & 1))
    {
        error("cp_setdacs: cp 0, 2, or 4 only");
        return;
    }
    if (!ac)
        goto usage;
    else
    {
        if (av[0].a_type != A_LONG)
            goto usage;
        nchans = av[0].a_w.w_long;
        if (nchans && nchans != 2 && nchans != 4 && nchans != 8)
            goto usage;
        ac--;
        av++;
    }
    if (ac)
    {
        if (av[0].a_type != A_SYM)
            goto usage;
        clk = av[0].a_w.w_sym;
        ac--;
        av++;
    }
    while (ac)
    {
        char *name;
        if (av[0].a_type != A_SYM)
            goto usage;
        name = av[0].a_w.w_sym->s_name;
        if (!strcmp(name, "ebu1"))
            ebu1 = 1;
        else if (!strcmp(name, "ebu2"))
            ebu2 = 1;
        else if (!strcmp(name, "synctobackplane"))
            synctobackplane = 1;
        else
            goto usage;
        ac--;
        av++;
    }
    io_setdacs(cp_sr, (nchans ? nchans : 2), clk->s_name,
               ebu1, ebu2, synctobackplane);
    nchans = (x ? nchans : 0);
    /* set dacs running unless called from _setdacs_ below */
    if (!foobar)
    {
        /* post("setchans %d", nchans); */
        cp_setchans(nchans);
        io_setrunning(1);
    }
    return;
  usage:
    error("usage: max setdacs [chans] [clocksource] [flags...]");
    post("chans may be 2 (the default), 4, or 8");
    post("clocksource may be \"internal\" (default), \"external,\" \"ebu[1234]\", ");
    post("\"cbit,\" \"cword,\" \"int32000,\" \"int44100,\" or \"int48000\"");
    post("flags may be \"ebu1,\" \"ebu2,\" \"synctobackplane.\"");
}

static int cp_bksdacs;

/* set dac type and setup.  Called from host, only when dacs are stopped */
void cp__setdacs(x, s, ac, av)
void *x;
t_symbol *s;
t_atom *av;
{
    if (ac < 2)
        error("setdacs: bad arg");
    else
    {
        int intype = av[0].a_w.w_long, outtype = av[1].a_w.w_long;
        foobar = 1;
        io_setdactype(intype, outtype);
        cp_setdacs((void *) (intype || outtype), s, ac - 2, av + 2);
        cp_bksdacs = ((intype | outtype) == CONV_IRCAM);
        foobar = 0;
    }
}

void cp_setrunning(n)
{
    if (cp_slotno & 1)
    {
        cp_setchans(n ? nchans : 0);
        io_setrunning(n);
    }
}


void cp_maxsetch(x, n)          /* take effect on setrunning(1) */
void *x;
long n;
{
#ifdef I860
    nchans = n;
    io_setdacs(cp_sr, nchans, clk->s_name, ebu1, ebu2, synctobackplane);
#endif                          /* I860 */
}


#if 0
long atom_getlong();

void cp_maxsetadv(x, s, ac, av)
void *x;
t_symbol *s;
t_atom *av;
{
    int i;
    for (i = 0; i < ac; i++)
        rtfifo_setadvancefor(i, (int) atom_getlong(av + i));
}
#else
void cp_maxsetadv(x, n)
void *x;
long n;
{
    rtfifo_setadvance((int) n);
}
#endif
#endif

void cp_dsp(void *x, long int n)
{
    if (n)
        u_setall(x, 0);
    else
        u_unsetall(x);
}

#ifndef GRAPHICS
void cp_maxsetsr(x, sr)
void *x;
long sr;
{
    if (cp_this)
        bug("domaxsr");
#ifdef I860
    if (cp_bksdacs)
    {
        if (!sr)
            sr = 44100;
        cp_sr = sr;
        io_setdacs(cp_sr, nchans, clk->s_name, ebu1, ebu2,
                   synctobackplane);
    }
#endif                          /* I860 */
#ifdef __sgi
    sgi_setlogicalsamplerate(sr);
#endif
    cp_wantedrate = sr;
}

void cp__restartdacs(x, n)
void *x;
long n;
{
#ifdef I860
    rtfifo_broadcast(cp_setrunning, n);
#endif
    if ((!cp_this) && n)
    {
#ifdef I860
        cp_findrate(cp_wantedrate);
#else
#endif
        post("sample rate = %d", cp_sr);
    }
}

static long max_timef;
static void *max_timehq;

void max_hqfn(void *x, void *hq)
{
    long buf = logicaltime / 1000;
    cvt_long(&buf);
    hq_doit(hq, &buf, sizeof(long));
}

void cp_settimef(void *x, long int n)
{
    if (!max_timehq)
        max_timehq = hq_new(n, 0L, 1L, (void *) 1L, max_hqfn,
                            sizeof(long), NIL);
    else
        bug("cp_settimef");
}

void max_sendtimeup()
{
    if (max_timehq)
        hq_set(max_timehq);
}

void max_test1(void *x, long n1, double f1)
{
    fprintf(stderr, "test 1: int %d float %lf\n", n1, f1);
}

void max_test2(void *x, double f1, long n1)
{
    fprintf(stderr, "test 2: float %lf, int %d\n", f1, n1);
}

void max_test3(void *x)
{
    fprintf(stderr, "test 3:\n");
}


void cp_tick(void *x, long int n);
void cp_run(void *x, long int n);
void cp_ping(void *x, long int n);
void cp_led(void *x, long int n1, long int n2);
void cp_load();
void cp_load_obj();
void cp_setfts();
void cp_dsp(void *x, long int n);
void cp_print();                /* Exp: */

#ifndef GRAPHICS
#ifdef I860
void io_print();
#endif                          /* I860 */
#endif                          /* not GRAPHICS */
#endif

t_maxclass *max_class;
void max_setup()
{
    c_new(&s_max, NIL, sizeof(t_object), 0, 0);
    c_addmess(max_dbug, &s_debug, A_DEFLONG, 0);
    c_addmess(max_rats, &s_rats, A_DEFLONG, 0);
    c_addmess(max_set, &s_set, A_LONG, 0);
#ifdef GRAPHICS
    c_addmess(declare__doit, &s_v2, A_GIMME, 0);
#else
#if defined(NEXTSTEP) || defined(I860) || defined(__unix)
    c_addmess(cp_load_obj, &s_load_obj, A_SYM, A_SYM, 0);
#endif
#ifndef GRAPHICS
    c_addmess(cp_setfts, &s_setfts, A_SYM, 0);
    c_addmess(cp_print, &s_print, A_DEFLONG, 0);
    c_addmess(cp_maxsetsr, gensym("#_setsr_"), A_LONG, 0);
    c_addmess(cp__restartdacs, gensym("#_restartdacs_"), A_LONG, 0);
#endif
    c_addmess(cp_tick, &s_tick, A_LONG, 0);
    c_addmess(cp_run, &s_run, A_LONG, 0);
    c_addmess(cp_ping, &s_ping, A_LONG, 0);
    c_addmess(cp_dsp, gensym("dsp"), A_LONG, 0);
    c_addmess(cp_led, &s_led, A_LONG, A_LONG, 0);
    c_addmess(cp_settimef, gensym("#_settimefn_"), A_LONG, 0);
#ifdef I860
    c_addmess(cp_maxsetch, gensym("#_setch_"), A_LONG, 0);
    c_addmess(cp_maxsetadv, gensym("#_setadv_"), A_LONG, 0);
    c_addmess(cp_setdacs, gensym("setdacs"), A_GIMME, 0);
    c_addmess(cp__setdacs, gensym("#_setdacs_"), A_GIMME, 0);
    c_addmess(io_print, gensym("printdacs"), 0);
#endif
#ifdef __sgi
    c_addmess(cp_sgichannels, gensym("channels"), A_LONG, A_LONG, 0);
    c_addmess(cp_sgisrate, gensym("srate"), A_LONG, 0);
    c_addmess(sgi_setup2, gensym("up2"), A_LONG, 0);

#endif                          /* __sgi */
    c_addmess(cp_print, &s_print, A_DEFLONG, 0);        /* Exp: */
    c_addmess(max_test1, gensym("test1"), A_LONG, A_FLOAT, 0);
    c_addmess(max_test2, gensym("test2"), A_FLOAT, A_LONG, 0);
    c_addmess(max_test3, gensym("test3"), 0);
#endif                          /* GRAPHICS */
}

/* the "new" object is copied into a known place to speed up checking if
   some object is that one or not. */

t_object qnewobj;

m_obj_init()
{
    t_object *x =
        (t_object *) obj_new((t_messlist **) & qnew_class, c_qnew);
    qnewobj = *x;
    freebytes(x, sizeof(t_object));
    s__New.s_thing = &qnewobj;
    s_max.s_thing =
        (t_object *) obj_new((t_messlist **) & max_class, max_setup);
}

/*********** default methods for any object **********/

obj_nobang(t_object *x)
{
    error("%s: no method for bang", ob_name(x));
}

obj_noint(t_object *x)
{
    error("%s: no method for int", ob_name(x));
}

obj_nofloat(t_object *x)
{
    error("%s: no method for float", ob_name(x));
}

obj_nosym(t_object *x)
{
    error("%s: no method for symbol", ob_name(x));
}

obj_bang(t_object *x)
{
    (*(ob_class(x))->c_bangfun) (x);
}

obj_int(t_object *x, long int n)
{
    (*(ob_class(x))->c_intfun) (x, n);
}

obj_float(t_object *x, double f)
{
    (*(ob_class(x))->c_floatfun) (x, f);
}
