#ifndef lint
static char rcsid[] =
    "$Revision: 1.16 $ IRCAM $Date: 1994/05/10 10:51:27 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.16 $ IRCAM $Date: 1994/05/10 10:51:27 $
 *
 * FTS by Miller Puckette
 *
 */

#include <errno.h>

#ifndef I860
#include <sys/types.h>
#include <sys/stat.h>
#endif

#ifndef I860
#include <stdio.h>
typedef struct toolfile {
    FILE *t_f;
} t_toolfile;
#endif
extern int errno;

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "m_mess.h"
#include "cp_mess.h"            /* to set max pathname length */
#ifdef I860
#include "../6a/6a.h"
#include "../6a/proto56.h"
#endif
#ifdef GRAPHICS
#include "h_cp.h"
#endif

extern t_symbol s_, s__Pat;
void *lowload(char *name, t_symbol * volume, int ac, struct atom *av,
              int couldedit);
int t_composename(char *buf, int length, char *dir, char *basename);

t_symbol *defvolume = &s_;

extern char lockout, memislow;
extern int h_ishost;

#ifndef I860
toolfile_fwrite(struct toolfile *x, void *what, int size)
{
    return (fwrite(what, 1, size, x->t_f) < size);
}

toolfile_error(struct toolfile *x)
{
    return (ferror(x->t_f));
}

toolfile_free(struct toolfile *x)
{
    fclose(x->t_f);
    freebytes(x, sizeof(*x));
}

void *toolfile_new(char *name, t_symbol *vol, long int type)
{
    FILE *fopen(const char *, const char *), *fd;
    char buf[512];
    t_composename(buf, 512, vol->s_name, name);
    fd = fopen(buf, (type ? "w" : "r"));
    if (fd)
    {
        struct toolfile *x =
            (struct toolfile *) getbytes(sizeof(t_toolfile));
        x->t_f = fd;
        return (x);
    }
    else
        return (0);
}
#endif                          /* I860 */


FSWrite(int fd, int *size, char *buf)
{
    int foo = *size;
    *size = write(fd, buf, foo);
    return (*size != foo);
}

FSRead(int fd, int *size, char *buf)
{
    int foo = *size;
    *size = read(fd, buf, foo);
    return (*size < 0);
}

FSClose(int fd)
{
    close(fd);
}

getfilelength(int fd, long int *sizep)
{
    long was = lseek(fd, 0L, 1);
    *sizep = lseek(fd, 0L, 2);
    lseek(fd, was, 0);
}

static char create_error[80];
char *strerror();

char *getcreateerror()
{
    return (create_error);
}

createfile(char *name, t_symbol *vol, int shit, int *fd)
{
    char buf[512];
    t_composename(buf, 512, vol->s_name, name);
    *fd = creat(buf, 0666);
    sprintf(create_error, "%.40s: %s", name,
            (*fd >= 0 ? "couldn't save" : strerror(errno)));
    return (*fd >= 0);
}

opentoread(char *name, t_symbol *vol, int *fd)
{
    char buf[512];
    t_composename(buf, 512, vol->s_name, name);
    return ((*fd = open(buf, 0)) < 0);
}

FlushVol()
{
}

SetEOF()
{
}

void postlong(long int l)
{
    char s[80];
    sprintf(s, " %ld", l);
    poststring(s);
}

t_ftoa(double f, char *xx)
{
    double baz;
    char *s;
    if (f >= 0)
    {
        baz = f;
        strcpy(xx, "");
        s = xx;
    }
    else
    {
        baz = -f;
        strcpy(xx, "-");
        s = xx + 1;
    }
    if (baz >= 1000000.)
        sprintf(s, "%lf", baz);
    else
    {
        long lo, decimal, digits = 8, popo;
        char *cp, *cp2;
        if (baz >= 100000.)
            decimal = 1, popo = 10;
        else if (baz >= 10000.)
            decimal = 2, popo = 100;
        else if (baz >= 1000.)
            decimal = 3, popo = 1000;
        else if (baz >= 100.)
            decimal = 4, popo = 10000;
        else if (baz >= 10.)
            decimal = 5, popo = 100000;
        else
            decimal = 6, popo = 1000000;
        lo = (long) (popo * baz + .5) % popo;
        while (decimal > 1 && !(lo % 10))
            lo /= 10, decimal--;
        sprintf(s, "%ld.", (long) baz);
        cp2 = s + strlen(s);
        cp = cp2 + decimal;
        *cp = 0;
        while (cp > cp2)
        {
            *--cp = '0' + lo % 10;
            lo /= 10;
        }
    }
}

void postfloat(double f)
{
    char xx[80];
    t_ftoa(f, xx);
    poststring(xx);
}

memouch()
{
    ouch("out of memory");
}

#if defined(__unix)
void ouch(char *fmt, ...)
{
    va_list args;

    va_start(args, fmt);
#ifdef GRAPHICS
    panel_ouch(fmt, args);            /* not fmt, args */
#else
    error(fmt, args);                 /* not fmt, args */
#endif
    va_end(args);
}

void sysouch(s)
char *s;
{
    char buf[1024];
    strcpy(buf, s);
    strcat(buf, ": ");
    strcat(buf, strerror(errno));
    ouch("%s", buf);
}

#else
void ouch(s, a, b, c, d, e, f, g, h)
char *s;
void *a;
void *b;
void *c;
int d;
int e;
int f;
int g;
int h;
{
#ifdef GRAPHICS
    panel_ouch(s, a, b, c, d, e, f, g, h);
#else
    error(s, a, b, c, d, e, f, g, h);
#endif
}
#endif

readerror(char *s)
{
    error("%s: read failed", s);
}

SetCurrentTime()
{
}

#ifdef GRAPHICS
static t_symbol *defsearchpath = &s_, *defsearchpathfromui = &s_;
static int t_uselibs;
char *h_getftsdir();

static t_symbol *makepath(char *path, int uselibs)
{
    if (uselibs)
    {
        char boo[4096];
        char *ftsdir = h_getftsdir();
        if (strlen(path) + 2 * strlen(ftsdir) > 3996)
            return (gensym("(name too long)"));
        strcpy(boo, path);
        strcat(boo, ":");
        strcat(boo, ftsdir);
#ifdef NEXTSTEP
        strcat(boo, "/../lib:");
#else
        strcat(boo, "/lib:");
#endif
        strcat(boo, ftsdir);
#ifdef NEXTSTEP
        strcat(boo, "/../jimmies:");
#else
        strcat(boo, "/jimmies");
#endif
        return (gensym(boo));
    }
    else
        return (gensym(path));
}

static void t_setrealdefpath(void)
{
    defsearchpath = makepath(defsearchpathfromui->s_name, t_uselibs);
    if (h_getverbose())
        post("setting real search path to:"),
            post("%s", defsearchpath->s_name);
}

void t_setdefpath(t_symbol *s)
{
    defsearchpathfromui = s;
    t_setrealdefpath();
}

t_symbol *t_getdefpath()
{
    return (defsearchpath);
}

void t_setdefpathandflag(char *s, int n)
{
    defsearchpathfromui = gensym(s);
    t_uselibs = n;
    t_setrealdefpath();
}

char *t_getdefpathstring()
{
    return (defsearchpathfromui->s_name);
}

int t_getusestandardibs()
{
    return (t_uselibs);
}

#endif
static t_symbol *searchpath = &s_, *helppath = &s_;

void t_setpath(t_symbol *s)
{
    searchpath = s;
}

#ifdef GRAPHICS
void t_setpathandlib(char *s, int n)
{
    searchpath = makepath(s, n);
}
#endif

t_symbol *t_getpath()
{
    return (searchpath);
}


void t_sethelppath(t_symbol *s)
{
    helppath = s;
}

t_symbol *t_gethelppath()
{
    return (helppath);
}

t_composename(char *buf, int length, char *dir, char *basename)
{
    if (*basename == '/')
        strncpy(buf, basename, length);
    else
    {
        int l1 = strlen(dir);
        if (*dir)
        {
            strncpy(buf, dir, length);
            if (l1 < length - 1)
            {
                strcat(buf, "/");
                l1++;
            }
        }
        else
            *buf = 0;
        if (l1 < length - 1)
            strncat(buf, basename, length - l1);
    }
    buf[length - 1] = 0;
}

t_decomposename(char *name, int length, char *dir, char *basename)
{
    char *s1, *s2, *lastslash;
    for (s2 = lastslash = name; *s2; s2++)
        if (*s2 == '/')
            lastslash = s2 + 1;
    if (lastslash == name)
        *dir = 0;
    else
    {
        if (lastslash - name > length - 1)
            lastslash = name + length - 1;
        for (s1 = dir, s2 = name; s2 != lastslash - 1;)
            *s1++ = *s2++;
        *s1 = 0;
    }
    strncpy(basename, lastslash, length);
    basename[length - 1] = 0;
}

t_symbol *t_openedvolume = &s_;
t_symbol *t_getlastopenvolume()
{
    return (t_openedvolume);
}

#define OPENPATHBUF 512

    /* open a file; if reading, verify it's not a directory */
static int open_to_read(char *s)
{
    int fd = open(s, 0);
#ifndef I860
    if (fd >= 0)
    {
        struct stat statbuf;
        if ((fstat(fd, &statbuf) < 0) || (S_ISDIR(statbuf.st_mode)))
        {
            close(fd);
            fd = -1;
        }
    }
#endif
    return (fd);
}

open_via_path(char *s, t_symbol *vol, int perm)
{
    char namebuf[OPENPATHBUF], *pathnext;
    int index, fd;
    if (perm)
        return (-1);            /* read only -- perm shouldn't have been an arg */
    if (*s == '/')
    {
        char foundvol[OPENPATHBUF];
        t_decomposename(s, OPENPATHBUF, foundvol, namebuf);
        t_openedvolume = gensym(foundvol);
#ifdef GRAPHICS
        if (h_getverbose())
            post("open: %s", namebuf);
#endif
        return (open_to_read(s));
    }
    if (*(vol->s_name))
    {
        t_composename(namebuf, OPENPATHBUF, vol->s_name, s);
#ifdef GRAPHICS
        if (h_getverbose())
            post("open: %s", namebuf);
#endif
        fd = open_to_read(namebuf);
        if (fd >= 0)
        {
            t_openedvolume = vol;
            return (fd);
        }
    }
    for (pathnext = searchpath->s_name; *pathnext;)
    {
        char buf2[OPENPATHBUF], *p2;
        int left;
        if (*pathnext != '/')
        {
            strcpy(buf2, vol->s_name);
            p2 = buf2 + strlen(buf2);
            *p2++ = '/';
        }
        else
            p2 = buf2;
        left = buf2 - p2 + (OPENPATHBUF - 2);
        while (left && *pathnext && *pathnext != ':' && *pathnext != ',')
        {
            *p2++ = *pathnext++;
            left--;
        }
        *p2 = 0;
        if (*pathnext)
            pathnext++;
        t_composename(namebuf, OPENPATHBUF, buf2, s);
#ifdef GRAPHICS
        if (h_getverbose())
            post("open: %s", namebuf);
#endif
        fd = open_to_read(namebuf);
        if (fd >= 0)
        {
            t_openedvolume = gensym(buf2);
            return (fd);
        }
    }

    t_openedvolume = &s_;
    return (-1);
}

extern void *newest;

#ifdef GRAPHICS
typedef struct _cachebuf {
    struct binbuf *c_buf;       /* contents */
    t_symbol *c_name;           /* file basename */
    t_symbol *c_vol;            /* directory or volume */
    struct _cachebuf *c_next;   /* next in list */
    int c_recurlock;            /* lock to prevent recursive file load */
} t_cachebuf;

t_cachebuf lowload_cachebuf;

t_cachebuf *lowload_getcache(t_symbol *s, t_symbol **svolp)
{
    t_cachebuf *cb = &lowload_cachebuf, *cb2;
    for (; cb2 = cb->c_next; cb = cb2)
    {
        if (cb2->c_name == s)
        {
            /* put it in front of the queue for next time */
            cb->c_next = cb2->c_next;
            cb2->c_next = lowload_cachebuf.c_next;
            lowload_cachebuf.c_next = cb2;
            *svolp = cb2->c_vol;
            return (cb2);
        }
    }
    return (0);
}

t_cachebuf *lowload_putcache(struct binbuf *b, t_symbol *s, t_symbol *vol)
{
    t_cachebuf *cb = (t_cachebuf *) getbytes(sizeof(*cb));
    cb->c_next = lowload_cachebuf.c_next;
    lowload_cachebuf.c_next = cb;
    cb->c_name = s;
    cb->c_buf = b;
    cb->c_vol = vol;
    return (cb);
}

void lowload_freecache()
{
    t_cachebuf *cb;
    while (cb = lowload_cachebuf.c_next)
    {
        lowload_cachebuf.c_next = cb->c_next;
        binbuf_free(cb->c_buf);
        freebytes(cb, sizeof(*cb));
    }
}

void *lowload(char *name, t_symbol *volume, int ac, struct atom *av,
              int couldedit)
{
    char savelock, savecacheing;
    short fd, io;
    long size;
    char **space;
    int bin;
    void *ret = 0;
    t_cachebuf *cachebuf = 0;
    int recurlockwas = 0;
    struct binbuf *bbuf;
    t_symbol *volwas = defvolume, *thisvolume;
    t_symbol *sname = gensym(name);
    savecacheing = h_setcacheing(1);
    defvolume = volume;
    savelock = lockout;
    lockout = 1;
    if (!(cachebuf = lowload_getcache(sname, &thisvolume)))
    {
        bbuf = binbuf_new();
        if (binbuf_read(bbuf, name, volume, 0))
        {
            binbuf_free(bbuf);
            goto cleanup;
        }
        if (couldedit && !binbuf_chkload(bbuf))
        {
            binbuf_setouch("bad MAX file");
            binbuf_free(bbuf);
            goto cleanup;
        }
        cachebuf = lowload_putcache(bbuf, sname,
                                    thisvolume = t_getlastopenvolume());
    }
    else if (cachebuf->c_recurlock)
    {
        error("%s: patch tried to load itself recursively", name);
        recurlockwas = 1;
        goto cleanup;
    }
    else
        bbuf = cachebuf->c_buf;
    cachebuf->c_recurlock = 1;  /* prevent recursive loading of file */
    memislow = 0;
    newest = 0;
    binbuf_loadeval(bbuf, ac, av, NIL);
    ret = newest;
    if (memislow && ret)
    {
        /* <a> memouch made conditional on memislow being one (other
           values now used for other errors I'm signaling on site.) */
        if (memislow == 1)
            binbuf_setouch("out of memory");
        freeobject((t_object *) ret);
        ret = 0;
    }
    if (ret)
        (*(egetfn(ret, gensym("filename")))) (ret, name, thisvolume, bin);

  cleanup:
    if (cachebuf)
        cachebuf->c_recurlock = recurlockwas;
    if (!savecacheing)
        lowload_freecache();
    lockout = savelock;
    h_setcacheing(savecacheing);
    defvolume = volwas;
    return (ret);
}

/* open to a text editor */
void *lowopen(char *name, int volume)
{
    return (0);
}

#endif                          /* GRAPHICS */

#ifndef I860
char *getpage(int size, int cacheable)
{
    return (malloc(size));
}

void ungetpage(char *x, int size)
{
    free(x);
}
#endif                          /* not I860 */

char *uncachedMalloc(unsigned int n)
{
#ifdef I860
    /* allocate at least a cache line on either end because malloc()
       stores its own information between buffers and someday it
       might get that into cacheable memory, change it, and flush
       it at a bad time. */
    char *ret = (char *) (((int) malloc(n + 64)) & (~CACHEBIT));
    if (!ret)
        return (0);
    else
        return (ret + 32);
#else
    return (malloc(n));
#endif                          /* I860 */
}

void uncachedFree(char *buf)
{
#ifdef I860
    /* Since we upped the address 32 bytes we must now subtract
       them before handing it to free() ... */
    free((char *) (CACHEBIT | (((int) buf) - 32)));
#else
    free(buf);
#endif
}

#ifdef I860
/* for dld package */
char *getwd()
{
    return "/";
}
#endif

#ifdef I860
void hate(s, a, b, c, d, e, f, g, h)
char *s;
{
    post("fatal error:");
    post(s, a, b, c, d, e, f, g, h);
    sys_spin(14);
}

#else
#ifdef GRAPHICS
void hate(char *fmt, ...)
{
    va_list args;
    va_start(args, fmt);
    ouch(fmt, args);
    va_end(args);
    cleanexit(1);
}

#else
#include <stdio.h>
void hate(char *fmt, ...)
{
    va_list args;
    fprintf(stderr, "\nfatal error:\n");
    va_start(args, fmt);
    vfprintf(stderr, fmt, args);
    va_end(args);
    fprintf(stderr, "\n");
#ifdef __unix
    cp_exit(1);
#endif
    exit(1);
}
#endif  /* GRAPHICS */
#endif  /* I860 */

#ifdef GRAPHICS
static void *msgtomax;

toolbox__restart()
{
    msgtomax = 0;
}

#define MTOMAX 50
toolbox_sendtocp(char *data, int length)
{
    t_atom at[260];
    int ac;
    struct binbuf *b = binbuf_new();
    int first = 1;

    if (!msgtomax)
    {
        msgtomax = getbytes(sizeof(long));
        h_vnew(msgtomax, 0, gensym("vmessage"), "");
    }

    binbuf_text(b, &data, length);
#if 0                           /* I tried to automatically prepend a semicolon when needed... */
    ac = binbuf_toatoms(b, at + 1);
    if (ac && at[1].a_type == A_SEMI)
        h_mess(msgtomax, gensym("_set"), ac, at + 1);
    else
    {
        SETSEMI(at);
        h_mess(msgtomax, gensym("_set"), ac + 1, at);
    }
#endif
    ac = binbuf_toatoms(b, at);
    h_mess(msgtomax, gensym("_set"), ac, at);
    h_vmess(msgtomax, gensym("bang"), "");
    binbuf_free(b);
}
#endif                          /* GRAPHICS */
