#ifndef lint
static char rcsid[] =
    "$Revision: 2.8 $ IRCAM $Date: 1994/02/07 06:45:38 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.8 $ IRCAM $Date: 1994/02/07 06:45:38 $
 *
 * FTS by Miller Puckette
 *
 */


#include <stdio.h>
#include "m_mess.h"

#ifdef I860
#define UNUSABLE_STDARG
#endif

#ifndef UNUSABLE_STDARG
#include <stdarg.h>
#endif


typedef void *(*t_foo)();

/* function caller which formats up an (ac, av) list from a printf-
   style call, e.g.
   vfun(binbuf, binbuf_insert, NIL, "sl", &s_int, 5L)
   */

#ifdef UNUSABLE_STDARG
void *vfun(x, f, s, fmt, x0, x1, x2, x3, x4, x5, x6, x7, x8, x9)
void *x;
t_foo f;
t_symbol *s;
char *fmt;
long x0, x1, x2, x3, x4, x5, x6, x7, x8, x9;
{
    long args[11], *argp = args;
    t_atom atoms[11], *atomp = atoms;
    char c;
    int count = 0;
    int narg = strlen(fmt);
    if (narg > 0)
        args[0] = x0;
    if (narg > 1)
        args[1] = x1;
    if (narg > 2)
        args[2] = x2;
    if (narg > 3)
        args[3] = x3;
    if (narg > 4)
        args[4] = x4;
    while (c = *(fmt++))
    {
        switch (c)
        {
        case 'l':
            SETLONG(atomp, *argp);
            break;
        case 's':
            SETSYM(atomp, (t_symbol *) (*argp));
            break;
        default:
            bug("vfun");
        }
        argp++;
        atomp++;
        count++;
    }
    return ((*f) (x, s, count, atoms));
}

#else                           /* UNUSABLE_STDARG */

void *vfun(void *x, t_foo f, t_symbol *s, char *fmt, ...)
{
    struct atom atoms[2 * MAXARG];
    struct atom *atomp = atoms;
    char c;
    int count = 0;
    va_list ap;
    va_start(ap, fmt);
    while (c = *(fmt++))
    {
        switch (c)
        {
        case 'l':
            atomp->a_type = A_LONG;
            atomp->a_w.w_long = va_arg(ap, long);
            atomp++;
            count++;
            break;
        case 'f':
            atomp->a_type = A_FLOAT;
            atomp->a_w.w_float = va_arg(ap, double);
            atomp++;
            count++;
            break;
        case 's':
            atomp->a_type = A_SYM;
            atomp->a_w.w_sym = va_arg(ap, t_symbol *);
            atomp++;
            count++;
            break;
        case 'o':
            atomp->a_type = A_OBJ;
            atomp->a_w.w_obj = va_arg(ap, t_object *);
            atomp++;
            count++;
            break;
        }
    }
    va_end(ap);
    return ((*f) (x, s, count, atoms));
}

#endif                          /* UNUSABLE_STDARG */

#ifdef UNUSABLE_STDARG
void c_addmess(f, s, x0, x1, x2, x3, x4, x5, x6, x7, x8, x9)
t_foo f;
t_symbol *s;
int x0, x1, x2, x3, x4, x5, x6, x7, x8, x9;
{
    int args[11], *tp = args, narg = 0;
    if ((args[0] = x0) && (args[1] = x1) && (args[2] = x2)
        && (args[3] = x3) && (args[4] = x4) && (args[5] = x5)
        && (args[6] = x6) && (args[7] = x7) && (args[8] = x8)
        && (args[9] = x9))
        args[10] = 0;
    while (*tp++)
        narg++;
    c_doaddmess(f, s, args, narg);
}

#else                           /* UNUSABLE_STDARG */

/* VARARGS -- function, symbol, arg types terminated by zero */
void c_addmess(t_method f, t_symbol *s, ...)
    /* add an incoming message to "current" class */
{
    va_list ap;
    int args[MAXARG + 1], newarg;
    int *tp = args, narg = 0;
    va_start(ap, s);
    do
        newarg = *tp++ = va_arg(ap, int);
    while (newarg && ++narg <= MAXARG);
    c_doaddmess(f, s, args, narg);
    va_end(ap);
}
#endif                          /* UNUSABLE_STDARG */

/* VARARGS -- message list pointer, new function, free function, symbol,
  instance size, inlet-suppression, (zero or more creation types) */

extern struct object qnewobj;
extern t_messlist **extern_messlistp;

#ifdef UNUSABLE_STDARG
void c_extern(mlp, m_new, m_free, sym, size, noinlet,
              x0, x1, x2, x3, x4, x5, x6, x7, x8, x9)
t_messlist **mlp;
t_method m_new, m_free;
t_symbol *sym;
int size, noinlet, x0, x1, x2, x3, x4, x5, x6, x7, x8, x9;
{
    int args[11], newarg;
    int *tp = args, narg = 0;
    t_object *xxx = &qnewobj;
    if ((args[0] = x0) && (args[1] = x1) && (args[2] = x2)
        && (args[3] = x3) && (args[4] = x4) && (args[5] = x5)
        && (args[6] = x6) && (args[7] = x7) && (args[8] = x8)
        && (args[9] = x9))
        args[10] = 0;
    c_addmessto(&xxx->o_messlist, m_new, sym, args);
    c_new(sym, m_free, size, 0, noinlet);
    extern_messlistp = mlp;
}

#else                           /* UNUSABLE_STDARG */
void c_extern(t_maxclass **mlp, t_creator m_new, t_method m_free,
    t_symbol *sym, int size, int noinlet, ...)
{
    va_list ap;
    int args[MAXARG + 1], newarg;
    int *tp = args, narg = 0;
    t_object *xxx = &qnewobj;
    va_start(ap, noinlet);
    do
        newarg = *tp++ = va_arg(ap, int);
    while (newarg && ++narg <= MAXARG);
    c_addmessto(&xxx->o_messlist, m_new, sym, args);
    c_new(sym, m_free, size, 0, noinlet);
    extern_messlistp = mlp;
    va_end(ap);
}
#endif                          /* UNUSABLE_STDARG */
