#ifndef lint
static char rcsid[]= "$Revision: 2.7 $ IRCAM $Date: 1994/01/29 07:49:14 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.7 $ IRCAM $Date: 1994/01/29 07:49:14 $
 *
 * FTS by Miller Puckette
 *
 */

#import "nx_charlie.h"
#import <appkit/OpenPanel.h>
#import <appkit/Text.h>
#import <appkit/Application.h>
#include "m_mess.h"
#include "h_cp.h"
@implementation nx_charlie

void *lowload();
extern t_symbol s_;
static t_symbol *openpaneldir = &s_;
t_symbol *t_getpath(), *t_getdefpath();

setopenpaneldir(s)
 char *s;
{
	char dir[512], basename[512];
	t_decomposename(s, 512, dir, basename);
	openpaneldir = gensym(dir);
}

+ new
{
	id me = [super new];
	return (me);
}

void patcher__help();
- help: (id)who
{
	patcher__help();
}

- new_patch: (id)who
{
	t_setpath(t_getdefpath());
	patcher();
}

openfrompath(name, setit)
 char *name;
 int setit;		/* sets file dialog window directory */
{
	void *x;
	struct atom at[10];
	char dir[512], basename[512];
	t_symbol *t_getpath(), *pathwas = t_getpath();
	t_setpath(t_getdefpath());
	t_decomposename(name, 512, dir, basename);
	crosshatch(at);
	defvolume = gensym(dir);
	if (setit) setopenpaneldir(name);
	loadbang__doit(0);
	x = lowload(basename, gensym(dir), 9, at, 1);
	if (x)
	{
		(*(egetfn(x, gensym("front"))))(x);
	}
	else binbuf_ouch("%s: can't open", name);
	loadbang__doit(1);
	t_setpath(pathwas);
}

- open: (id)who
{
	id panel;
	panel = [OpenPanel new];
	if (*(openpaneldir->s_name))
	{
		if ([panel runModalForDirectory: openpaneldir->s_name file: ""])
			openfrompath([panel filename], 1);
	}
	else
	{
		if ([panel runModal])
			openfrompath([panel filename], 1);
	}
}

- (int)appAcceptsAnotherFile: (id)who
{
	return (1);
}

- appOpenFile: (char *) name type: (char *) atype
{
	openfrompath(name, 1);
}


- appWillTerminate: sender
{
  return self;
}  

static id infopanel;
extern char max_version[];

- info: sender		/* put up "info" Panel */
{
	if (!infopanel)
	{
		char paneltext[1024];
		NXRect	rect;
		NXRect  inside;
		id panelt_text;
		NXSetRect(&rect, 150.0, 700.0, 420.0, 120.0);
		infopanel = [Panel newContent:&rect
				style:NX_TITLEDSTYLE
				backing:NX_BUFFERED
				buttonMask:NX_CLOSEBUTTONMASK
				defer:YES];
		[infopanel setTitle:"About Max"];
		[infopanel removeFromEventMask:(NX_KEYDOWNMASK | NX_KEYUPMASK)];
	
		NXSetRect(&rect, 0.0, 0.0, 420.0, 120.0);
		sprintf(paneltext, "%s%s%s%s%s%s",
			"Max version ",
			max_version,
			"\nBy Miller Puckette\n"
 "with contributions from Maurizio de Cecco, Joseph Francis, Cort Lippe,\n",
 "Zack Settel, Eric Viara, David Yadegari, and David Zicarelli.\n", 
 "\240 IRCAM 1990,1993\n");
	
		panelt_text = [Text newFrame:&rect text:paneltext alignment:NX_CENTERED];
		[panelt_text setSelectable:NO];
		[[infopanel contentView] addSubview:panelt_text];
		[infopanel display];
	}
	[infopanel orderFront: nil];
}

- preferences: sender
{
	preferences_activate();
}

- settings: sender
{
	settings_activate();
}

- restart: sender
{
	restart_activate();
}

- find: sender
{
	find_activate();
}

- findagain: sender
{
	find_again();
}

@end

char *charlie_getdir()
{
	return (openpaneldir->s_name);
}

/*********** panel_ routines --  *************/

panel_ouch(s, a, b, c, d, e, f, g, h)	/* simple warning panel */
 char *s;
{
	NXRunAlertPanel(NIL, s, NIL, NIL, NIL, a, b, c, d, e, f, g, h);
}

#if (0)		/* I gave up on this.... */
	/* offer to save a window which is closing.  Returns nonzero if
	"cancel" is selected; otherwise, a nonnull pathname means to save it. */

int panel_offertosave(s, t)
 char *s;		/* name of object to save */
 char **t;		/* pathname to save to */
{
	while (1)
	{
		int choice = NXRunAlertPanel(NIL, "Save changes to %s?",
					"Save", "Discard", "Cancel", s);
		if (choice == NX_ALERTDEFAULT)
		{
			id panel = [SavePanel new];
			if (*(savedir = charlie_getdir()))
				doit = [panel runModalForDirectory: savedir file: ""];
			else doit = [panel runModal];
			if (doit)
			{
				name = [panel filename];
				setopenpaneldir(name);
				*t = name;
				return (0);
			}
		}
		else if (choice == NX_ALERTALTERNATE) return (1);
		else
		{
			*t = 0;
			return (0);
		}
	}
}

#endif /* 0 */

t_symbol *t_openpanel()
{
	id panel, fd;
	panel = [OpenPanel new];
	if (*(openpaneldir->s_name))
	{
		if (![panel runModalForDirectory: openpaneldir->s_name file: ""])
			return (0);
	}
	else
	{
		if (![panel runModal]) return (0);
	}
	setopenpaneldir([panel filename]);
	return (gensym([panel filename]));
}

t_symbol *t_savepanel()
{
	id panel, fd;
	panel = [SavePanel new];
	if (*(openpaneldir->s_name))
	{
		if (![panel runModalForDirectory: openpaneldir->s_name file: ""])
			return (0);
	}
	else
	{
		if (![panel runModal]) return (0);
	}
	setopenpaneldir([panel filename]);
	return (gensym([panel filename]));
}

