#ifndef lint
static char rcsid[]= "$Revision: 2.5 $ IRCAM $Date: 1994/05/10 10:51:36 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/05/10 10:51:36 $
 *
 * FTS by Miller Puckette
 *
 */

/* This is the main routine for MAX. */

#import <appkit/Application.h>
#import <appkit/View.h>
#import <appkit/Menu.h>
#import <appkit/MenuCell.h>
#import <appkit/Window.h>
#import <appkit/Pasteboard.h>
#import <appkit/Listener.h>
#import <defaults.h>
#import <objc/List.h>
#import "m_mess.h"
#import "cp_mess.h"
typedef void t_wind;

#import "nx_view.h"
#import "nx_charlie.h"
#import <sys/param.h>
#import "h_cp.h"
#import "getNameValue.h"
void *sock_new();
const char *appname();
extern char max_version[];

@interface Maxapp : Application		// override the terminate message
{
}
- maxService: (id)pasteboard 
    userData:(const char *)userData 
    error:(char **)msg;
@end

@implementation Maxapp
- terminate:sender
/*
 * Overridden to be sure all documents get an opportunity to be saved
 * before exiting the program.
 */
{
    int count, choice;
    id window, document;

    count = [windowList count];
    while (count--)
	{
		window = [windowList objectAt:count];
		document = [window delegate];
		if ([document respondsTo:@selector(needsSaving)] &&
			[document needsSaving])
		{
			choice = NXRunAlertPanel("Quit", "You have unsaved documents.",
				"Review Unsaved", "Quit Anyway", "Cancel");
			if (choice == NX_ALERTOTHER)
			{
				return self;
			}
			else if (choice == NX_ALERTDEFAULT)
			{
				count = [windowList count];
				while (count--)
				{
					window = [windowList objectAt:count];
					document = [window delegate];
					if ([document
						respondsTo:@selector(windowWillClose:)])
					{
						if ([document windowWillClose:window])
						{
							[window close];
						}
						else
						{
							return self;
						}
					}
				}
			}
			break;
		}
    }

    [super terminate:sender];

    return nil;
}

extern void *key_keyout, *keyup_keyout;

- sendEvent:(NXEvent *)ev
{
	static int didit;
	if (!didit) [[NXApp appListener] setServicesDelegate:NXApp];
	didit = 1;

	if (ev->type == NX_KEYDOWN)
	{
		if (key_keyout) outlet_int(key_keyout, (long)(ev->data.key.charCode));
		/* if (key_codeout)
			outlet_int(key_keyout, (long)(ev->data.key.keyCode)); */
	}
	else if (ev->type == NX_KEYUP)
	{
		if (keyup_keyout)
			outlet_int(keyup_keyout, (long)(ev->data.key.charCode));
	}
	[super sendEvent:ev];
}

- maxService: (id)pasteboard 
    userData:(const char *)userData 
    error:(char **)msg
{
	const char *types[1];
	char *buffer, *revBuffer, *data;
	int length, i=0, j;

	[pasteboard types];

	if ([pasteboard readType:NXAsciiPboardType data:&data
			length:&length])
	{
		toolbox_sendtocp(data, length);
	}
	else *msg = "Error: Max takes text only";
	return self;
}
@end

static argDesc max_argdesc[] = {
{"Help", "help", 0, HELP, BOOL_VALUE, "print a usage message and exit"},
{"Version", "v", "version", OPTIONAL, BOOL_VALUE,
									"print version number and exit"},
{"NextAteThisOne", 0, 0, INTERNAL, STRING_VALUE, ""},
{"NXOpen", 0, 0, INTERNAL, STRING_VALUE, ""},
{"NXHost", 0, 0, INTERNAL, STRING_VALUE, ""},
{"MachLaunch", 0, 0, INTERNAL, STRING_VALUE, ""},
{"Simulate", "n", 0, OPTIONAL, BOOL_VALUE, "simulate FTS under UNIX"},
{"Config", "c", "configuration", OPTIONAL, STRING_VALUE, "FTS configuration"},
{"SampleRate", "r", "SampleRate", OPTIONAL, INTEGER_VALUE,
	"override DAC sample rate"},
{"MAXPATH", "p", "patchPath", OPTIONAL, STRING_VALUE,
	"search path for patches and externs"},
{"HELPDIR", "h", "helpDir", OPTIONAL, PATH_VALUE, "help file directory"},
{"NXFont", "f", "fontName", OPTIONAL, STRING_VALUE, "text font name"},
{"NXFontSize", "s", "FontSize", OPTIONAL, INTEGER_VALUE, "text font size"},
{"Advance", "a", "Advance", OPTIONAL, STRING_VALUE,
	"comma-separated list of scheduler advances"},
{"BOOTDIR", "b", "bootDir", OPTIONAL, PATH_VALUE,
	"boot command directory (for standalone only)"},
{"Logfile", "l", 0, OPTIONAL, BOOL_VALUE, "make a logfile"},
{"FTSDIR", "d", "ftsDir", OPTIONAL, PATH_VALUE,
	"directory to find FTS and whatnot"},
{"Killer", "k", 0, OPTIONAL, BOOL_VALUE,
	"debugging; its effect changes"},
{"Stderr", 0, 0, OPTIONAL, BOOL_VALUE, "copy Max window to stderr"},
{"Throttle1", 0, 0, INTERNAL, INTEGER_VALUE,
	"transfers before releasing NeXTBus"},
{"Throttle2", 0, 0, INTERNAL, INTEGER_VALUE,
	"count before regaining NeXTBus"},
{"Throttle", "throttle", "<string>", OPTIONAL, STRING_VALUE,
	"3 colon or comma separated host/CP transfer throttle values"},
{"Verbose", "verbose", 0, OPTIONAL, BOOL_VALUE, "verbose startup"},
{"NoStandardLibs", 0, 0, OPTIONAL, BOOL_VALUE, "suppress standard lib search"},
0};

static void registerthem(void )
{
	struct _NXDefault def[sizeof(max_argdesc)/sizeof(argDesc) + 1], *dp;
	argDesc *ap;
	int i;
	for (i = sizeof(max_argdesc)/sizeof(argDesc), dp = def, ap = max_argdesc;
		i--; dp++, ap++)
	{
		dp->name = (char *)ap->name;
		dp->value = 0;
	}
	dp->name = dp->value = 0;
    NXRegisterDefaults("Max", def);
}

#define POLLINTERVAL .1
static DPSTimedEntry timerno;
static float pollinterval = POLLINTERVAL;

	/* this is messed up -- it can send back so much graphics the
		NeXT never hands you another event */
	
void h_domaxpoll()
{
	int wascached = post_setcache(1);
	h_dopoll();
	post_setcache(wascached);
}

void max_timefn(void *x, char *buf, int size)
{
	long foo = *(long *)buf;
	restart_settime(foo);
}

void max_startfts()
{
	h_start();
	h_vmess(NIL, gensym("setfts"), "s", gensym(h_getftsdir()));
	h_vmess(NIL, gensym("#_settimefn_"), "l", max_timefn);
	/* h_vmess(NIL, gensym("debug"), "l", 1L); */
}

void max_startpolling()
{
  timerno = DPSAddTimedEntry(pollinterval, h_domaxpoll, (void *)0, 1);
}

void max_stoppolling()
{
	if (timerno) DPSRemoveTimedEntry(timerno);
	h_setpollfunction(0);
}

h_setpollinterval(f)
 float f;
{
	pollinterval = .05;
}

void newmaxpath()
{
	const char *searchpath;
	char *NXGetDefaultValue();
	int uselibs;
	const char *uselibstring = getStringOption("NoStandardLibs", 0);
	uselibs = !(uselibstring && !strcmp(uselibstring, "TRUE"));
	searchpath = getStringOption("MAXPATH", 0);
	if (!searchpath) searchpath = NXGetDefaultValue(appname(), "PATH");
	if (!searchpath) searchpath = NXGetDefaultValue(appname(), "PATCHDIR");
	if (!searchpath) searchpath = "";
	{
		t_setdefpathandflag(searchpath, uselibs);
		t_setpath(t_getdefpath());
	}
}


main(argc, argv)
 char **argv;
{
	int cposboot = 0, i, setrate = 0;
	const char *ftsdir = 0, *advances = 0, *font = 0, *fontsize = 0,
		*helpdir = 0,  *bootdir = 0;
	const char *config, *t_config();
	char *NXGetDefaultValue(), mofo[100];
	int rate, killer, logfile, deffontsize;
	/* fprintf(stderr, "MAX starting...\n"); */
	
	/* Initialize the super  default/env/site configuration system.
	   Soon all of the code should be converted to use this call,
	   (superset and compatible with the Next Defaults) */

	for (i = 0; i < argc; i++) if (!argv[i]) argv[i] = "-NextAteThisOne";
	if (!initNameValue("Max",max_argdesc,argc-1,argv+1)) exit(1);
    if (getBoolOption("Version", 0))
	{
		printf("Max version %s\ncopyright 1992 IRCAM\n", max_version);
		exit(0);
	}
	[Maxapp new];
	setupmenus();
	registerthem();
    if (getBoolOption("Stderr", 0)) post_copytostd();
    if (getBoolOption("Verbose", 0)) h_setverbose(1);
	sprintf(mofo, "Max version %s\n\240 1992 IRCAM\n", max_version);
	pdisplay(mofo);
	/* for (i = 0; i < argc; i++) fprintf(stderr, "%s ", argv[i]);
	fprintf(stderr, "\n"); */

	config = getStringOption("Config", 0);
	if (!config) config = t_config();
	if (!config) config = "n,3/5";

	h_setmax(); /* The contrary of the old setanimal */

	if (getBoolOption("Simulate",0) || *config == 'n')
	{
		h_setfts(soxFts);
		h_setnonrealtime();
	}
	else
	  h_setfts(standaloneFts);

	ftsdir = getStringOption("FTSDIR", 0);
	if (!ftsdir)
	{
		char *appname = *argv;
		if (appname)
		{
			char *slashp = 0, *sp, *ftsspace, *malloc();
			if (!(ftsspace = malloc(strlen(appname) + 1)))
				hate("out of space");
			strcpy(ftsspace, appname);
			for (sp = ftsspace; *sp; sp++) if (*sp == '/') slashp = sp;
			if (slashp)
			{
				*slashp = 0;
				ftsdir = ftsspace;
			}
			else ftsdir = ".";
		}
		else ftsdir = ".";
	}
	helpdir = getStringOption("HELPDIR", 0);
	h_setconfig((char *)config);
	if (advances = getStringOption("Advance", 0))
		h_setadvancesstring(advances);
	if (rate = getIntOption("SampleRate", 0)) h_setrate((float)rate);
	if (font = getStringOption("Font", 0)) t_setfont(font);
	if (getBoolOption("Killer", 0)) h_setkiller(1);
	if (getBoolOption("Logfile", 0)) h_setlogfile(1);
	if (deffontsize = getIntOption("FontSize", 0))
	{
		char idiot[80];
		sprintf(idiot, "%d", deffontsize);
		t_setfontsize(idiot);
	}
	if (ftsdir) h_setftsdir(ftsdir);
	if (bootdir = getStringOption("BOOTDIR", 0))
		h_setbootdir(bootdir);

	h_init();
	mess_init();
	{
		char dir[MAXPATHLEN+1];
		if (getwd(dir)) defvolume = gensym(dir);
	}
	h_getpost();		/* declare MAX as the post client */
	if (helpdir) t_sethelppath(gensym(helpdir));
	else
	{
		char helphelp[512];
		strcpy(helphelp, ftsdir);
		strcat(helphelp, "/help");
		t_sethelppath(gensym(helphelp));
	}
	max_startfts();
	max_startpolling();
	newmaxpath();
	[NXApp run];
	max_stoppolling();
	h_eof();
	[NXApp free];
}

const char *appname()
{
	return("Max");
}

id charlie;

setupmenus()
{
	id		myMenu,
		infomenu, filemenu, windmenu, editmenu, miscmenu, classmenu;

	charlie = [nx_charlie new];
	[NXApp setDelegate: charlie];

	/* menus */
	myMenu = [Menu newTitle:appname()];

	infomenu = [Menu newTitle:"Info"];
	[[infomenu addItem:"Info Panel..."
			action:@selector(info:)
			keyEquivalent:0]
				setTarget:charlie];
	[[infomenu addItem:"Preferences..."
			action:@selector(preferences:)
			keyEquivalent:'1']
				setTarget:charlie];
	[[infomenu addItem:"Help..."
			action:@selector(help:)
			keyEquivalent:'?']
				setTarget:charlie];
	[infomenu sizeToFit];
	[myMenu setSubmenu: infomenu
		forItem: [myMenu addItem:"Info"
			action:0
			keyEquivalent:0]];

	filemenu = [Menu newTitle:"File"];
	[[filemenu addItem:"Open..."
			action:@selector(open:)
			keyEquivalent:'o']
				setTarget:charlie];
	[[filemenu addItem:"New Patcher"
			action:@selector(new_patch:)
			keyEquivalent:'n']
				setTarget:charlie];
	[filemenu addItem:"Save"
			action:@selector(save:)
			keyEquivalent:'s'];
	[filemenu addItem:"Save as..."
			action:@selector(saveAs:)
			keyEquivalent:'S'];
	[filemenu sizeToFit];
	[myMenu setSubmenu: filemenu
		forItem: [myMenu addItem:"File"
			action:0
			keyEquivalent:0]];

	editmenu = [Menu newTitle:"Edit"];
	[editmenu addItem:"Cut"
			action:@selector(cut:)
			keyEquivalent:'x'];
	[editmenu addItem:"Copy"
			action:@selector(copy:)
			keyEquivalent:'c'];
	[editmenu addItem:"Paste"
			action:@selector(paste:)
			keyEquivalent:'v'];
	[editmenu addItem:"Duplicate"
			action:@selector(dup:)
			keyEquivalent:'d'];
	[editmenu addItem:"Select All"
			action:@selector(selectall:)
			keyEquivalent:'a'];
	[editmenu sizeToFit];
	[myMenu setSubmenu: editmenu
		forItem: [myMenu addItem:"Edit"
			action:0
			keyEquivalent:0]];

	/*
	classmenu = [Menu newTitle:"Class"];
	[[classmenu addItem:"Load"
			action:@selector(load:)
			keyEquivalent:'l']
				setTarget:charlie];
	[[classmenu addItem:"Unload"
			action:@selector(unload:)
			keyEquivalent:'u']
				setTarget:charlie];
	[classmenu sizeToFit];
	[myMenu setSubmenu: classmenu
		forItem: [myMenu addItem:"Class"
			action:0
			keyEquivalent:0]];
	*/

	windmenu = [Menu newTitle:"Windows"];
	[windmenu addItem:"Close"
			action:@selector(close:)
			keyEquivalent:'w'];
	[windmenu addItem:"Miniaturize"
			action:@selector(miniaturize:)
			keyEquivalent:'M'];
	[NXApp setWindowsMenu: windmenu];
	[myMenu setSubmenu: windmenu
		forItem: [myMenu addItem:"Windows"
			action:0
			keyEquivalent:0]];


	[myMenu addItem:"Print ..."
			action:@selector(print:)
			keyEquivalent:'p'];

	miscmenu = [Menu newTitle:"Font"];
	[miscmenu addItem:"9" action:@selector(s9:) keyEquivalent:0];
	[miscmenu addItem:"10" action:@selector(s10:) keyEquivalent:0];
	[miscmenu addItem:"12" action:@selector(s12:) keyEquivalent:0];
	[miscmenu addItem:"14" action:@selector(s14:) keyEquivalent:0];
	[miscmenu addItem:"16" action:@selector(s16:) keyEquivalent:0];
	[miscmenu addItem:"18" action:@selector(s18:) keyEquivalent:0];
	[miscmenu addItem:"20" action:@selector(s20:) keyEquivalent:0];
	[miscmenu addItem:"24" action:@selector(s24:) keyEquivalent:0];
	[miscmenu addItem:"FONT BOMB" action:@selector(fontbomb:) keyEquivalent:0];
	[miscmenu sizeToFit];
	[myMenu setSubmenu: miscmenu forItem: [myMenu addItem:"Font"
		action:0 keyEquivalent:0]];

	miscmenu = [Menu newTitle:"Misc"];
	[miscmenu addItem:"Edit" action:@selector(edit:) keyEquivalent:'e'];
	[miscmenu addItem:"Stretch" action:@selector(stretch:) keyEquivalent:0];
	[miscmenu addItem:"Contract" action:@selector(contract:) keyEquivalent:0];
	[[miscmenu addItem:"Settings..."
		action:@selector(settings:) keyEquivalent:'2'] setTarget:charlie];
	[[miscmenu addItem:"Restart..."
		action:@selector(restart:) keyEquivalent:'3'] setTarget:charlie];
	[miscmenu addItem:"Inspect..."
		action:@selector(inspect:) keyEquivalent:'4'];
	[miscmenu addItem:"Find..."
		action:@selector(find:) keyEquivalent:'f'];
	[miscmenu addItem:"Find again"
		action:@selector(findagain:) keyEquivalent:'g'];
	[miscmenu sizeToFit];
	[myMenu setSubmenu: miscmenu forItem: [myMenu addItem:"Misc"
		action:0 keyEquivalent:0]];

	[myMenu addItem:"Hide"
			action:@selector(hide:)
			keyEquivalent:'h'];
	[myMenu addItem:"Quit"
			action:@selector(terminate:)
			keyEquivalent:'q'];
	[myMenu sizeToFit];
	[NXApp setMainMenu:myMenu];
	[myMenu display];

}

cleanexit(n)
{
	[NXApp free];
	exit(n);
}

id focusview()
{
	return([NXApp focusView]);
}

void max_restart()
{
	int count = [[NXApp windowList] count], i;
	rsf__restart();
	toolbox__restart();
	max_startfts();
  	for (i=0; i<count; i++) 
	{
		id window = [[NXApp windowList] objectAt:i];
		if ([window respondsTo:@selector(restart_fts)])
			[window restart_fts];
	}
}

void max_find(s, again)
 char *s;
{
	int nwind, *windows, i;
	[NXApp getWindowNumbers: &windows count:&nwind];
  	for (i=0; i < nwind; i++) 
	{
		id window = [NXApp findWindow: windows[i]];
		if (window && [window respondsTo:@selector(find::)])
		{
			[window find: s :again];
			return;
		}
	}
}

id max_front()
{
	int nwind, *windows, i;
	[NXApp getWindowNumbers: &windows count:&nwind];
  	for (i=0; i < nwind; i++) 
	{
		id window = [NXApp findWindow: windows[i]];
		if (window && [window respondsTo:@selector(wind)])
			return (window);
	}
	return (0);
}

int max_canrestart()
{
	int count = [[NXApp windowList] count], i;
  	for (i=0; i<count; i++) 
	{
		id window = [[NXApp windowList] objectAt:i];
		if ([window respondsTo:@selector(setinspector:)]) return (0);
	}
	return (1);
}

