#ifndef lint
static char rcsid[]= "$Revision: 2.1 $ IRCAM $Date: 1993/08/26 16:05:25 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.1 $ IRCAM $Date: 1993/08/26 16:05:25 $
 *
 * FTS by Miller Puckette
 *
 */

#import <appkit/View.h>
#import <appkit/Text.h>
#import <appkit/ScrollView.h>
#import <appkit/Window.h>
static id pwind, ptext, pscroll;
static int initted;
#define DEFWIDTH 400.
#define DEFHEIGHT 500.
#define DEFX 0.
#define DEFY 120.

#define POSTBUFSIZE 1024
char *post_buf;
int post_nchars = 0, post_cache = 0;

void post_flush()
{
	if (post_nchars)
	{
		pdodisplay(post_buf);
		post_nchars = 0;
		post_buf[0] = 0;
	}
}

int post_setcache(n)
 int n;
{
	int was = post_cache;
	post_cache = n;
	if (!n) post_flush();
	return (was);
}

pwind_init(s)
 char *s;
{
	NXRect	rect;
	NXRect  inside;
	NXSize sigh;

	NXSetRect(&rect, DEFX, DEFY, DEFWIDTH, DEFHEIGHT);
	pwind = [Window newContent:&rect
			style:NX_RESIZEBARSTYLE
			backing:NX_BUFFERED
			buttonMask:(NX_MINIATURIZEBUTTONMASK)
			defer:NO];
	[pwind setTitle:"MAX"];
	[[pwind contentView] setAutoresizeSubviews:YES];
	[pwind setBackgroundGray: 1.];

	NXSetRect(&rect, 0.0, 0.0, DEFWIDTH, DEFHEIGHT);
	/* new*/ 
	pscroll = [ScrollView newFrame:&rect];
	[pscroll setVertScrollerRequired: YES];
	[pscroll getDocVisibleRect: &rect];
	[pscroll setAutosizing: NX_WIDTHSIZABLE | NX_HEIGHTSIZABLE];
	[pscroll setAutoresizeSubviews:YES];

	ptext = [Text newFrame:&rect
			text:s
			alignment:NX_LEFTALIGNED];
	
	[ptext setOpaque:YES];
	/**/ [pscroll setDocView: ptext];
	[[pwind contentView] addSubview:pscroll]; /* was ptext */

	[pwind display];
	[pwind orderFront:nil];
	[pwind makeKeyWindow];

	sigh.width = sigh.height = 10000000;
	[ptext setMaxSize: &sigh];
	[ptext setVertResizable:YES];
	[ptext setHorizResizable:NO];
	[ptext setAutosizing: NX_HEIGHTSIZABLE];
	
	if (!(post_buf = (char *)malloc(POSTBUFSIZE))) hate("post buffer alloc failed");
	post_buf[0] = 0;
}

pdodisplay(s)
 char *s;
{
	NXSelPt sst, se;
	int n = [ptext textLength];
	[ptext getSel: &sst :&se];
	if (sst.cp != n) [ptext setSel: n :n];
	[ptext replaceSel: s];
	n = [ptext textLength];
	[ptext setSel: n :n];
	[ptext scrollSelToVisible];
}

static int post_amcopyingtostd = 0;

pdisplay(s)
 char *s;
{
	int n;
	if (post_amcopyingtostd) fprintf(stderr, "%s", s);
	if (!initted)
	{
		pwind_init(s);
		initted = 1;
	}
	else if (!post_cache) pdodisplay(s);
	else
	{
		int n = strlen(s);
		if (n > POSTBUFSIZE - 2) post_flush(), pdodisplay(s);
		else
		{
			if (n + post_nchars > POSTBUFSIZE-2) post_flush();
			strcat(post_buf + post_nchars, s);
			post_nchars += n;
		}
	}
}

post(s, a, b, c, d, e, f, g, h)
 char *s;
{
	char boo[1000];
	sprintf(boo, "\n(h): ");
	sprintf(boo+strlen(boo), s, a, b, c, d, e, f, g, h);
	poststring(boo);
}

poststring(s)
 char *s;
{
	pdisplay(s);
}

post_copytostd()
{
	post_amcopyingtostd = 1;
}
