#ifndef lint
static char rcsid[]= "$Revision: 2.5 $ IRCAM $Date: 1994/05/10 10:51:45 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/05/10 10:51:45 $
 *
 * FTS by Miller Puckette
 *
 */

#define _OBJC_
#import <appkit/View.h>
#import <appkit/ScrollView.h>
#import <appkit/Window.h>
#import "m_mess.h"
#import "t_mac.h"
#import "t_wind.h"
#import "nx_view.h"
#import <appkit/SavePanel.h>
#import <appkit/Application.h>
#import <appkit/Pasteboard.h>
extern t_symbol s_update, s_click, s_key, s_;
typedef void *(*t_foo)();
#define hit0(x, y) (*((t_foo)egetfn(x, y)))(x)
#define hit1(x, y, z1) (*((t_foo)egetfn(x, y)))(x, z1)
#define hit2(x, y, z1,z2) (*((t_foo)egetfn(x, y)))(x, z1,z2)
#define hit3(x, y, z1,z2,z3) (*((t_foo)egetfn(x, y)))(x, z1,z2,z3)
#define hit4(x, y, z1,z2,z3,z4) (*((t_foo)egetfn(x, y)))(x, z1,z2,z3,z4)
#define hit5(x, y, z1,z2,z3,z4,z5) (*((t_foo)egetfn(x, y)))(x, z1,z2,z3,z4,z5)
@implementation nx_view
NXEvent *thisev;
long max_serialno;
void wind_update();
void wind_reframe();

#define NOVIEW ((id)1)
id thisview = NOVIEW;

/* this should be taken from the real include file -- but where is it? */
#define nx_shiftKey (1<<16)
#define nx_cmdKey (1<<20)
#define nx_optionKey (1<<19)

static void dragfnpt();

+ newFrame: (NXRect const *)rect 
{
	id me = [super newFrame: rect];
	[me setFlipped:YES];
	[me allocateGState];
	[me setOpaque:YES];
	[me setAutoresizeSubviews:YES];

	return (me);
}

- setWind: (void *)w 
{
	wind = w;
}

- (void *)getAssoc
{
	return (wind->w_assoc);
}

- mouseDown:(NXEvent *)ev
{
	NXPoint pt;
	Point p2;
	GrafPort *gunk;
	int isscroll = (self != wind->w_contentview);
	max_serialno++;
	thisev = ev;
	pt = ev->location;
	[self convertPoint: &pt fromView: (id)0];
	p2.h = pt.x;
	p2.v = pt.y;
	gunk = wind_setport(wind);
	hit3(wind->w_assoc, &s_click, p2, (ev->data.mouse.click == 2),
		((ev->flags & nx_shiftKey) ? shiftKey : 0) |
		((ev->flags & nx_cmdKey) ? cmdKey : 0) |
		((ev->flags & nx_optionKey) ? optionKey : 0) |
		(isscroll ? 0 : inMargin));
	t_resetport(gunk);
	chknoport();
    return self;
}

- mouseUp:(NXEvent *)ev
{
	GrafPort *gunk;
	NXPoint pt;
	Point p2;
	max_serialno++;
	pt = ev->location;
	[self convertPoint: &pt fromView: (id)0];
	p2.h = pt.x;
	p2.v = pt.y;
	gunk = wind_setport(wind);
	dragfnpt(p2, 0);
	t_resetport(gunk);
	chknoport();
    return self;
}

- keyDown:(NXEvent *)ev
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	thisev = ev;
	hit2(wind->w_assoc, &s_key, (int)(ev->data.key.charCode),
		(int)(ev->flags));
	t_resetport(gunk);
	chknoport();
    return self;
}

- keyUp:(NXEvent *)ev
{
	max_serialno++;
    return self;
}

static void view_eraserect(NXRect *rp)
{
	t_eraserect((int)(rp->origin.x), (int)(rp->origin.y),
		(int)(rp->size.width + rp->origin.x),
			(int)(rp->size.height + rp->origin.y));
}

static NXRect *whatrect;

wind_getupdaterect(x, a, b, c, d)
 t_wind *x;
 int *a, *b, *c, *d;
{
	NXRect xxx, *baz;
	if (whatrect) baz = whatrect;
	else
	{
		[x->w_view getBounds: &xxx];
		baz = &xxx;
	}
	*c = (*a = baz->origin.x) + baz->size.width;
	*d = (*b = baz->origin.y) + baz->size.height;
}

- drawSelf: (NXRect *)rp :(int)nr
{
	id viewwas = thisview;
	NXRect *lastrect = whatrect;
	thisview = self;
	whatrect = rp;
	if (nr == 3)
	{
		view_eraserect(rp+1);
		view_eraserect(rp+2);
	}
	else view_eraserect(rp);
	hit1(wind->w_assoc, &s_update, self != wind->w_view);
	/* foofoo(wind, "display"); */
	thisview = viewwas;
	whatrect = lastrect;
}

- (BOOL)acceptsFirstResponder
{
	return (YES);
}

- cut: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	hit0(wind->w_assoc, &s_cut);
	t_resetport(gunk);
	chknoport();
}

- copy: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	hit0(wind->w_assoc, &s_copy);
	t_resetport(gunk);
	chknoport();
}

- paste: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	hit0(wind->w_assoc, &s_paste);
	t_resetport(gunk);
	chknoport();
}

- selectall: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	hit0(wind->w_assoc, gensym("selectall"));
	t_resetport(gunk);
	chknoport();
}

- dup: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	hit0(wind->w_assoc, &s_dup);
	t_resetport(gunk);
	chknoport();
}

- edit: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	hit0(wind->w_assoc, gensym("edit"));
	t_resetport(gunk);
	chknoport();
}

- close: (id) who
{
	[wind->w_nxwind performClose: who];
}

- miniaturize: (id) who
{
	[wind->w_nxwind performMiniaturize: who];
}

- inspect: (id) who
{
	tabinspect_activate();
}

wind_generic(x, s, n)
 t_wind *x;
 char *s;
{
	GrafPort *gunk = wind_setport(x);
	max_serialno++;
	hit1(x->w_assoc, gensym(s), n);
	t_resetport(gunk);
	chknoport();
}

- stretch: (id)who { wind_generic(wind, "stretch", 0); }
- contract: (id)who { wind_generic(wind, "stretch", 1); }
- s9: (id)who { wind_generic(wind, "font", 0); }
- s10: (id)who { wind_generic(wind, "font", 1); }
- s12: (id)who { wind_generic(wind, "font", 2); }
- s14: (id)who { wind_generic(wind, "font", 3); }
- s16: (id)who { wind_generic(wind, "font", 4); }
- s18: (id)who { wind_generic(wind, "font", 5); }
- s20: (id)who { wind_generic(wind, "font", 6); }
- s24: (id)who { wind_generic(wind, "font", 7); }
- fontbomb: (id)who { wind_generic(wind, "font", -1); }

- fixwidth: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	hit0(wind->w_assoc, gensym("fixwidth"));
	t_resetport(gunk);
	chknoport();
}

- lineup: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	hit0(wind->w_assoc, gensym("lineup"));
	t_resetport(gunk);
	chknoport();
}

- save: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	wind_save(wind);
	t_resetport(gunk);
	chknoport();
}

- saveAs: (id)who
{
	GrafPort *gunk = wind_setport(wind);
	max_serialno++;
	wind_saveas(wind);
	t_resetport(gunk);
	chknoport();
}

static int bashit = 0;
- beginSetup
/*
 * Spit out the custom PostScript defs.
 */
{
    [super beginSetup];
    MPSInit();
    return self;
}

static id lastwindowup;

@end
@implementation nx_window
- setWind: (void *)w 
{
	wind = w;
}

- (void *)wind 
{
	return ((void *)wind);
}

- close
{
	[super close];
	lastwindowup = 0;
}

- windowWillClose: (id)sender
{
	id ret;
	if (wind_willclose(wind)) ret = NIL;
	else ret = self;
	return (ret);
}

	/* setinspector: if "1", respond to "set" hit on inspector
	window.  Client should get new values from inspector.
	If "0", client should put its own settings into inspector. 
	At the moment, only tables use this.  See table_setinspect()
	and ../nib/tabinspect.m 
	calls to tabinspect_set() here should be replaced by generic
	no-inspector-available routine. */

- setinspector: (int)put
{
	t_method fn = zgetfn(wind->w_assoc, gensym("setinspector"));
	if (fn) (*fn)(wind->w_assoc, put);
	else tabinspect_set(0, 0, 0, 0, 0, 0);
}

- windowDidClose: (id)sender
{
	id who = [NXApp mainWindow];
	lastwindowup = who;
	if ([who respondsTo: @selector(wind)])
		[who setinspector: 0];
	else tabinspect_set(0, 0, 0, 0, 0, 0);
	return self;
}

- windowDidResize: (id)sender
{
	wind_getcoords(wind);
	wind_reframe(wind);
}

- windowDidMove: (id)sender
{
	wind_getcoords(wind);
}

- print: (id)sender
{
	wind->w_printing = 1;
	[wind->w_view printPSCode: sender];
	wind->w_printing = 0;
}

- (int)needsSaving
{
	return (wind->w_dirty);
}

- windowDidBecomeMain: who
{
	[self setinspector: 0];
	lastwindowup = self;
}

- windowDidResignKey: who
{
	wind_nodrag();
}

- restart_fts
{
	max_serialno++;
	hit0(wind->w_assoc, gensym("restart_fts"));
}

- find: (char *)s :(int)again
{
	if (again) patcher_findagain(1);
	else patcher__findstringouch(s);
}

@end

	/* called when "set" button is hit on inspector window */
max_banginspector()
{
	if (lastwindowup && [lastwindowup respondsTo:@selector(setinspector:)])
		[lastwindowup setinspector: 1];
}

/* void *wind_front()
{
	if (lastwindowup && [lastwindowup respondsTo:@selector(wind)])
		 return (((t_wind *)[lastwindowup wind])->w_assoc);
	else return (0);
} */

id max_front();
void *wind_front()
{
	id foo = max_front();
	if (foo) return (((t_wind *)[foo wind])->w_assoc);
	else return (0);
}

static t_method drag_fun;
static void *drag_arg;
static Point drag_pt;
static t_wind *drag_wind;

printframe(s, f)
 char *s;
 NXRect *f;
{
	fprintf(stderr, "%s: (%f, %f) (%f, %f)\n",
		s, f->origin.x, f->origin.y,  f->size.width, f->size.height);
}

foofoo(x, s)
 t_wind *x;
 char *s;
{
	NXRect frame;
	fprintf(stderr, "------ %s ------\n", s);
	[x->w_view getFrame: &frame]; printframe("doc frame", &frame);
	[x->w_view getBounds: &frame]; printframe("doc bounds", &frame);
	[[x->w_view superview] getFrame: &frame]; printframe("cont frame", &frame);
	[[x->w_view superview] getBounds: &frame];
		printframe("cont bounds", &frame);
}

void wind_reframe(x)
 t_wind *x;
{
	int xmin, xmax, ymin, ymax;
	NXRect frame, vf, vb;
	int scrollx, scrolly, translate;
	float xwas, ywas;
	if (!(x->w_vis && x->w_scroll)) return;
	[[x->w_view superview] getBounds: &frame];
	[x->w_view getFrame: &vf];
	[x->w_view getBounds: &vb];
	xwas = vf.origin.x;
	ywas = vf.origin.y;
	
	/* frame.origin.x += vf.origin.x - vb.origin.x;
	frame.origin.y += vf.origin.y - vb.origin.y; */
		/* the frame is offset by the scroll amount to give the
		rectangle, _in the view's coordinates_, which is actually
		showing. */
	/* frame.origin.x += vb.origin.x;
	frame.origin.y += vb.origin.y; */
		/* take the span of "currently showing" and "span of boxes" */
	if (frame.origin.x > x->w_xmin)
	{
		frame.size.width += frame.origin.x - x->w_xmin;
		frame.origin.x = x->w_xmin;
	}
	if (frame.origin.y > x->w_ymin)
	{
		frame.size.height += frame.origin.y - x->w_ymin;
		frame.origin.y = x->w_ymin;
	}
	if (frame.size.width < x->w_xmax - frame.origin.x)
		frame.size.width = x->w_xmax - frame.origin.x;
	if (frame.size.height < x->w_ymax - frame.origin.y)
		frame.size.height = x->w_ymax - frame.origin.y;

	translate = (xwas != frame.origin.x || ywas != frame.origin.y);
	if (translate)
	{
		view_eraserect(&vb);
		[x->w_view setFrame: &frame];
		[x->w_view setDrawOrigin: frame.origin.x : frame.origin.y];
	}
	else [x->w_view setFrame: &frame];
	/* foofoo(x, "reframe"); */
	[[[x->w_view superview] superview] reflectScroll: [x->w_view superview]];
	if (translate) [x->w_view display];
}

void wind_getscroll(x, h, v)
 t_wind *x;
 int *h, *v;
{
	NXRect frame;
	if (x->w_nxwind)
	{
		[[x->w_view superview] getBounds: &frame];
		*h = frame.origin.x;
		*v = frame.origin.y;
	}
	else
	{
		*h = x->w_xoffset;
		*v = x->w_yoffset;
	}
}

void wind_setsval(x, a, b)	/* obsolete -- replaced below */
 t_wind *x;
{
}

void wind_setsmax(x, a, b)
 t_wind *x;
{
}

void wind_setscrollrect(x, left, top, right, bottom)
 t_wind *x;
{
	x->w_xmin = left;
	x->w_xmax = right;
	x->w_ymin = top;
	x->w_ymax = bottom;
	wind_reframe(x);
}

void wind_dirty(x, d)
 t_wind *x;
{
	x->w_dirty = d;
	if (x->w_vis) [x->w_nxwind setDocEdited: d];
}

void setwindowtitle(x, s, t)
 t_wind *x;
 char *s, *t;
{
	char namebuf[256];
	if (*t)
	{
		if (x->w_titled || !strcmp(s, "Untitled"))
			sprintf(namebuf, "%.50s - %.70s", s, t);
		else sprintf(namebuf, "[%.50s - %.70s]", s, t);
		[x->w_nxwind setTitle: namebuf];
	}
	else [x->w_nxwind setTitle: s];
}

void wind_setuntitled(x)	/* set to "Untitled," default volume*/
 t_wind *x;
{
	wind_filename(x, "Untitled", defvolume, 0);
	x->w_titled = 0;
}

/* set the filename and volume number. */
void wind_filename(x, fn, vol, bin)
 t_wind *x;
 char *fn;
 t_symbol *vol;
{
	strcpy(x->w_name, fn);
	x->w_vol = vol;
	x->w_bin = bin;
	x->w_titled = 1;
	if (x->w_vis) setwindowtitle(x, x->w_name, x->w_vol->s_name);
}

void wind_unfilename(x)
 t_wind *x;
{
	x->w_titled = 0;
	if (x->w_vis) setwindowtitle(x, x->w_name, x->w_vol->s_name);
}

/* just set the title to a "c" string; do not take it as a filename. */
void wind_settitle(x, s)
 t_wind *x;
 char *s;
{
	char buf[80];
	sprintf(buf, "[%s]", s);
	strcpy(x->w_name, buf);
	x->w_vol = &s_;
	x->w_bin = 0;
	x->w_titled = 0;
	if (x->w_vis) setwindowtitle(x, buf, "");
}

wind_close(x)	/* call the NextStep window close method  */
 t_wind *x;
{
	x->w_vis = 0;
	if (x == drag_wind) wind_nodrag();
	if (x->w_nxwind)
	{
		wind_getscroll(x, &x->w_xoffset, &x->w_yoffset);
		[x->w_nxwind close];
		x->w_nxwind = 0;
	}
}

wind_willclose(x)	/* return nonzero on error (which aborts closing) */
 t_wind *x;
{
	noundo(x);
/* <a> second condition added in case user-written window has no close method
(in which case we just make it invisible and go on.) Otherwise, when you
quit from MAX there's no way to close this window. */
	if (x->w_refcount || !zgetfn(x->w_assoc, &s_close))
	{
		hit0(x->w_assoc, &s_invis);
		x->w_nxwind = 0;
		x->w_vis = 0;
	}
	else
	{
		if (x->w_dirty)
		{
			int save = NXRunAlertPanel("Close", "%s has changes. Save them?",
				"Save", "Don't Save", "Cancel", x->w_name);
			if (save != NX_ALERTDEFAULT && save != NX_ALERTALTERNATE)
				return (-1);
			if (save == NX_ALERTDEFAULT)
			{
				if (wind_save(x)) return (-1);
			}
		}
		x->w_nxwind = 0;
		hit0(x->w_assoc, &s_close);
	}
	return (0);
}

wind_save(x)	/* returns 0 if saved it */
 t_wind *x;
{
	noundo(x);
	if (x->w_titled)
	{
		if (!hit2(x->w_assoc, gensym("saveto"), x->w_name, x->w_vol))
		{
			wind_dirty(x, 0);
			return (0);
		}
		else return (1);
	}
	else return (wind_saveas(x));
}

char *charlie_getdir();

wind_saveas(x)	/* returns 0 if saved it */
 t_wind *x;
{
	const char *name;
	char basename[512], dir[512], wtitle[100], *savedir;
	id panel;
	int doit;
	noundo(x);

	panel = [SavePanel new];
	if (*(savedir = charlie_getdir()))
		doit = [panel runModalForDirectory: savedir file: ""];
	else doit = [panel runModal];
	if (doit)
	{
		name = [panel filename];
		t_decomposename(name, 512, dir, basename);
		setopenpaneldir(name);
		if (!x->w_keeptitle)
		{
			strcpy(x->w_name, basename);
			x->w_vol = gensym(dir);
			x->w_titled = 1;
			setwindowtitle(x, x->w_name, dir);
		}
		if (!hit2(x->w_assoc, gensym("saveto"), basename, gensym(dir)))
		{
			wind_dirty(x, 0);
			return (0);
		}
		else return (1);
	}
	else return (1);
}

void wind_setscrollparams(x, left, top, right, bottom)
 t_wind *x;
{
	x->w_scroll = 1;
	x->w_topmargin = top;
	x->w_leftmargin = left;
	x->w_bottommargin = bottom;
	x->w_rightmargin = right;
}

void wind_vis(x)
 t_wind *x;
{
	if (!x->w_vis)
	{
		wind_dovis(x);
		wind_update(x);
	}
	[x->w_nxwind makeKeyAndOrderFront: nil];
	[x->w_nxwind makeFirstResponder: x->w_view];
}

void wind_visnoupdate(x)
 t_wind *x;
{
	if (!x->w_vis) wind_dovis(x);
	[x->w_nxwind makeKeyAndOrderFront: nil];
	[x->w_nxwind makeFirstResponder: x->w_view];
}

wind_dovis(x)
 t_wind *x;
{
	float width = x->w_x2 - x->w_x1, height = x->w_y2 - x->w_y1,
		totwidth, totheight;
	GrafPort *gp;
	NXRect	rect;
	NXSize outsize, insize;
	if (x->w_scroll)
	{
		insize.width = width;
		insize.height = height;
		[ScrollView getFrameSize: &outsize forContentSize: &insize
			horizScroller: x->w_scrollx vertScroller: x->w_scrolly
				borderType: NX_LINE];
		totwidth = outsize.width + x->w_leftmargin + x->w_rightmargin;
		totheight = outsize.height + x->w_topmargin + x->w_bottommargin;
	}
	else
	{
		totwidth = width;
		totheight = height;
	}
	x->w_vis = 1;
	NXSetRect(&rect, (float)x->w_x1, (float)x->w_y1, totwidth, totheight);
	x->w_nxwind = [nx_window newContent:&rect
			style:NX_RESIZEBARSTYLE
			backing:NX_RETAINED  /* was NX_NONRETAINED */
			buttonMask: (NX_MINIATURIZEBUTTONMASK |
				NX_CLOSEBUTTONMASK)
			defer:NO];
	[x->w_nxwind setWind: x];
	[x->w_nxwind setBackgroundGray: 1.];
	[x->w_nxwind setDelegate: x->w_nxwind];
	[x->w_nxwind useOptimizedDrawing: YES];

	NXSetRect(&rect, 0.0, 0.0, totwidth, totheight);
	x->w_contentview = [nx_view newFrame: &rect];
	[x->w_contentview setWind: x];
	[x->w_contentview setAutosizing: NX_WIDTHSIZABLE | NX_HEIGHTSIZABLE];

	[[x->w_nxwind setContentView: x->w_contentview] free];

	if (x->w_scroll)
	{
		id pscroll;
		NXSetRect(&rect, x->w_leftmargin, x->w_topmargin,
			outsize.width, outsize.height);
		pscroll = [ScrollView newFrame:&rect];
		[pscroll setBorderType: NX_LINE];
		if (x->w_scrollx) [pscroll setHorizScrollerRequired: YES];
		if (x->w_scrolly) [pscroll setVertScrollerRequired: YES];
		[pscroll setAutosizing: NX_WIDTHSIZABLE | NX_HEIGHTSIZABLE];
		[pscroll setAutoresizeSubviews:YES];
		[pscroll setFlipped:YES];
		[x->w_contentview addSubview:pscroll];
		NXSetRect(&rect, 0.0, 0.0, insize.width, insize.height);
		/* NXSetRect(&rect, 0.0, 0.0, 1500., 1500.); */
		x->w_view = [nx_view newFrame: &rect];
		[x->w_view setWind: x];
		[pscroll setDocView: x->w_view];
	}
	else x->w_view = x->w_contentview;
	x->w_willclose = 0;
	gp = wind_setport(x);
	MPSEraserect(0, 0, x->w_x2 - x->w_x1, x->w_y2 - x->w_y1);
	t_resetport(gp);
	setwindowtitle(x, x->w_name, x->w_vol->s_name);
	[x->w_nxwind setinspector: 0];
}

void wind_invis(x)
 t_wind *x;
{
	wind_close(x);
}

int wind_defaultscroll(x, pt)
t_wind *x;
Point pt;
{
	return (0);
}

void wind_issubpatch(x)
 t_wind *x;
{
	x->w_keeptitle = 1;
}

wind_getcoords(x)
 t_wind *x;
{
	NXRect r;
	[x->w_contentview getFrame: &r];
	if (x->w_scroll)
	{
			/* fix size to represent scrollview's size; don't bother with
				offset, fuck it. */
		NXSize insize;
		[ScrollView getContentSize: &insize forFrameSize: &r.size
			horizScroller: x->w_scrollx vertScroller: x->w_scrolly
				borderType: NX_LINE];
		r.size.width = insize.width - x->w_leftmargin - x->w_rightmargin;
		r.size.height = insize.height - x->w_topmargin - x->w_bottommargin;
	}
	[x->w_nxwind convertBaseToScreen: &(r.origin)];
	x->w_x1 = r.origin.x;
	x->w_y1 = r.origin.y;
	x->w_x2 = x->w_x1 + r.size.width;
	x->w_y2 = x->w_y1 + r.size.height;
}

GrafPort *wind_setportto(x, whichview)
 t_wind *x;
 id whichview;
{
	if (x->w_vis)
	{
		id port = thisview;
		if (port != whichview)
		{
			if (port != NOVIEW) [port unlockFocus];
			thisview = whichview;
			[thisview lockFocus];
		}
		return ((GrafPort *)port);
	}
	else return (0);
}

	/* set current drawing view to the window's view; return old one */
GrafPort *wind_setport(x)
 t_wind *x;
{
	return (wind_setportto(x, x->w_view));
}

	/* set current drawing view to the window's margin; return old one */
GrafPort *wind_marginport(x)
 t_wind *x;
{
	return (wind_setportto(x, x->w_contentview));
}

void t_resetport(gp)
 GrafPort *gp;
{
	if (thisview != (id)gp)
	{
		if (thisview == NOVIEW)
			fprintf(stderr, "ouch: t_resetport without setport\n");
		else
		{
			/* [[(id)thisview window] flushWindow]; .... */
			[(id)thisview unlockFocus];
			if ((id)gp != NOVIEW) [(id)gp lockFocus];
			thisview = (id)gp;
		}
	}
}

void *t_getview()
{
	return (thisview);
}

t_send_fake_key(view)
 id view;
{
	hit2([view getAssoc], &s_key, 'a' & 0xff, 0);
}

chknoport()
{
	if (thisview != NOVIEW) post("port not reset");
	thisview = NOVIEW;
}

static void dragfnpt(pt, x)
 Point pt;
{
	GrafPort *gunk;
	if (!drag_wind) return;
	gunk = wind_setport(drag_wind);
	if (!gunk) bug("gunk");
	if (pt.h != drag_pt.h || pt.v != drag_pt.v || !x)
	{
		drag_pt = pt;
		(*drag_fun)(drag_arg, pt, x);
	}
	if (!x) drag_wind = 0;
	t_resetport(gunk);
}

void view_poll()
{
	NXPoint pt;
	Point p2;
	if (!drag_wind) return;
	[drag_wind->w_nxwind getMouseLocation: &pt];
	[drag_wind->w_view convertPoint: &pt fromView: (id)0];
	p2.h = pt.x;
	p2.v = pt.y;
	dragfnpt(p2, 1);
}

void wind_nodrag()
{
	if (drag_wind)
	{
		dragfnpt(drag_pt, 0);
		drag_wind = 0;
	}
}

void wind_drag(x, fun, arg)
 t_wind *x;
 t_method fun;
 void *arg;
{
	if (!fun) wind_nodrag();	/* shouldn't be necessary */
	else
	{
		drag_fun = fun;
		drag_arg = arg;
		drag_wind = x;
	}
}

void wind_update(x)
 t_wind *x;
{
	id viewwas = thisview;
	thisview = x->w_view;
	[x->w_nxwind display];
	thisview = viewwas;
}

void wind_copytorect(x, left, top, bottom, right)
 t_wind *x;
{
    char *data;
    NXStream *stream;   
    const char *types[1];
    int i = 0, length, maxlen;
	NXRect rect;
	bashit = 1;
	NXSetRect(&rect, (float)left, (float)top, (float)(right-left),
		(float)(bottom-top));
	types[0] = NXPostScriptPboardType;
	stream = NXOpenMemory(NULL, 0, NX_WRITEONLY);
	[x->w_view copyPSCodeInside:&rect to:stream];
	/* [x->w_view copyPSCodeInside:NULL to:stream]; */
	NXGetMemoryBuffer(stream, &data, &length, &maxlen);
	[[Pasteboard new] declareTypes:types num:1 owner:[x->w_view class]];
	[[Pasteboard new] writeType:NXPostScriptPboardType data:data
		length:length];
	NXCloseMemory(stream, NX_FREEBUFFER);
}

void wind_ff(x)
 t_wind *x;
{
	wind_close(x);
	/* qelem_free(x->w_qelem); */
	 /* if (x->w_vis) [x->w_nxwind free]; */
}

void c_wind()
{
	c_new(&s_int, wind_ff, sizeof(t_wind), 0, 0);
}

extern t_symbol *defvolume;
t_maxclass *wind_messlist;
void *qelem_new();
int phase = 0;
t_wind *wind_new(assoc, a, b, c, d, flags)
 void *assoc;
{
	t_wind *x = (t_wind *)obj_new(&wind_messlist, c_wind);
	phase = (phase + 1) % 6;
	if (a >= c || b >= d)
	{
		a = 100 + 50*phase;
		b = 400 - 50 * phase;
		c = a + 400;
		d = b + 400;
	}
	x->w_x1 = a;
	x->w_y1 = b;
	x->w_x2 = c;
	x->w_y2 = d;
	x->w_xoffset = x->w_yoffset = 0;
	x->w_topmargin = x->w_bottommargin =
		x->w_leftmargin = x->w_rightmargin = 0;
	x->w_scrollgrain = 1;
	x->w_scroll = 0;
	x->w_scrollx = ((flags & WSCROLLX) != 0);
	x->w_scrolly = ((flags & WSCROLLY) != 0);
	x->w_refcount = x->w_titled = 0;
	x->w_assoc = assoc;
	x->w_vis = 0;
	x->w_nxwind = 0;
	x->w_dirty = 0;
	/* x->w_qelem = qelem_new(x, wind_qfn); */
	x->w_keeptitle = 0;
	strcpy(x->w_name, "Untitled");
	x->w_vol = defvolume;
	x->w_dirty = 0;
	x->w_printing = 0;
	if (flags & WVIS) wind_vis(x);
	return (x);
}

box_correctwidth() {}
