#ifndef lint
static char rcsid[] =
    "$Revision: 2.4 $ IRCAM $Date: 1994/01/04 18:00:34 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.4 $ IRCAM $Date: 1994/01/04 18:00:34 $
 *
 * FTS by Miller Puckette
 *
 */


/* the "CP receiver" (cpr) class.  Forwards update messages to the
   client but stays after the client disconnects it to field late
   messages from CP.  Finally the CP acknowledges the closure of
   the connection by calling cpr_zap() which does the real free.
   The CP object must have a pointer to the client as a host ID. */

#include "m_mess.h"
extern t_symbol s_connect;

typedef struct cpr {
    void *b_who;
    void *b_cpid;
    void (*b_fn)();
} t_cpr;


cpr_zap(t_cpr *x)
{
    freebytes(x, sizeof(t_cpr));
}

cpr_upd(t_cpr *x, void *buf, int n)
{
    if (x->b_who)
        (*x->b_fn) (x->b_who, buf, n);
}

cpr_free(t_cpr *x)
{
    h_vmess(x->b_cpid, &s_connect, "lll", 0L, 0L, 0L);
    x->b_who = 0;
}

void *cpr_new(void *w, void (*fn)())
{
    t_cpr *x =(t_cpr *)(getbytes(sizeof(t_cpr)));
    x->b_cpid = x->b_who = w;
    x->b_fn = fn;
    h_vmess(w, &s_connect, "lll", x, cpr_upd, cpr_zap);
    return (x);
}

    /* A version in which you can specify a client and a CP id separately. */
void *cpr_new2(void *w, void *cpid, void (*fn))
{
    t_cpr *x =(t_cpr *)(getbytes(sizeof(t_cpr)));
    x->b_who = w;
    x->b_cpid = cpid;
    x->b_fn = fn;
    h_vmess(cpid, &s_connect, "lll", x, cpr_upd, cpr_zap);
    return (x);
}
