#ifndef lint
static char rcsid[] =
    "$Revision: 2.9 $ IRCAM $Date: 1994/05/10 10:51:55 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.9 $ IRCAM $Date: 1994/05/10 10:51:55 $
 *
 * FTS by Miller Puckette
 *
 */


#include "m_mess.h"
#include "t_mac.h"
#include "p_patcher.h"
extern t_symbol s_message, s_newobj, s_newex, s_comment,
    s_click, s_update, s_set, s_save, s_key, s_patcher,
    s_restore, s_psave, s_append, s_dblclick, s_new, s__set,
    s_eval, s_obj, s_objfix, s_symbol, s_free, s_setcp, s_vmessage,
    s__active;
extern int memislow;
extern char inISR, lockout;
void box_defaultfree(struct box *b);
extern void *patcher_class;

extern t_object qnewobj;

void *binbuf_make(void *x, int ac, struct atom *av, void *to);
void *patchbox(void *p, void *(*fn)( /* ??? */ ), int ac, struct atom *av,
               int defwidth);

void *textbox(void *p, void *(*fn)( /* ??? */ ), int ac, t_atom *av)
{
    int x, y, w, cpno = patcher_getcp(p);
    void *ret;
    if (ac < 4 ||
        av[0].a_type != A_LONG ||
        av[1].a_type != A_LONG ||
        av[2].a_type != A_LONG || av[3].a_type != A_LONG)
    {
        error("textbox: bad args");
        return (0);
    }
    ret = (*fn) (p,
                 (int) (av[0].a_w.w_long),
                 (int) (av[1].a_w.w_long),
                 (int) (av[2].a_w.w_long),
                 (int) (av[3].a_w.w_long), ac - 4, av + 4);
    if (ret && cpno >= 0)
        mess2(ret, &s_setcp, cpno, CP_PUT);
    return (ret);
}

static int p_txtwidth(void)
{
    int was = t_getcurrentfont(), width;
    t_textsize(t_getdeffont());
    width = t_stringwidth("sig~ 440") + 5;
    t_textsize(was);
    return (width);
}

void vmessage_cp();

/***************** text update mechanism for vmessage object below ******/
  /* this and the qlist mechanism should be unified.  Search for 
     definitions of SP_FIRST. */

#define SP_FIRST 1              /* first update in sequence */
#define SP_LAST 2               /* last update in sequence */

typedef struct textcpr {
    void *t_cpr;                /* CP responder */
    char **t_textfromcp;        /* incoming text from CP */
    long t_sizefromcp;          /* its size */
    long t_handlesize;          /* its allocated size */
    void *t_client;
    t_method t_function;
} t_textcpr;

/* CP->host update, host side */
void textcpr_cpr(t_textcpr *x, char *buf, int size)
{
    int flags = *buf;
    char *s1 = buf + 1;
    int cplength = strlen(s1), newlength;
    if (flags & SP_FIRST)
    {
        if (x->t_textfromcp)
            t_disposehandle((void **) x->t_textfromcp);
        x->t_textfromcp = (char **) t_newhandle(1L);
        **x->t_textfromcp = 0;
        x->t_sizefromcp = 0;
        x->t_handlesize = 1;
    }
    else if (!x->t_textfromcp)
    {
        bug("textcpr_cpr");
        return;
    }
    newlength = cplength + x->t_sizefromcp;
    if (newlength > x->t_handlesize)
    {
        if (t_growhandle((void **) x->t_textfromcp,
                         x->t_handlesize = newlength + (newlength >> 2)))
        {
            ouch("out of space");
            x->t_textfromcp = 0;
            return;
        }
    }
    strncpy(*x->t_textfromcp + x->t_sizefromcp, s1, cplength);
    x->t_sizefromcp = newlength;
    if (flags & SP_LAST)
    {
        /* post("settext %c %c %c ... %d",
           (*x->t_textfromcp)[0], 
           (*x->t_textfromcp)[1], 
           (*x->t_textfromcp)[2], newlength); */

        (*x->t_function) (x->t_client, x->t_textfromcp, (long) newlength);
        t_disposehandle((void **) x->t_textfromcp);
        x->t_textfromcp = 0;
    }
}

void *cpr_new2();

void textcpr_free(t_textcpr *x)
{
    cpr_free(x->t_cpr);
    freebytes(x, sizeof(*x));
}

t_textcpr *textcpr_new(void *client, t_method function)
{
    t_textcpr *x = getbytes(sizeof(*x));
    x->t_cpr = cpr_new2(x, client, textcpr_cpr);
    x->t_textfromcp = 0;
    x->t_client = client;
    x->t_function = function;
    return (x);
}

/********************* vmessage object *********************/

typedef struct vmessage {
    struct box t_box;
    t_textcpr *t_textupd;
} t_vmessage;

void vmessage_bang(t_vmessage *x)
{
    binbuf_eval(x->t_box.b_binbuf, 0, NIL, x->t_box.b_ob.o_outlet);
}

void vmessage_int(t_vmessage *x, long int n)
{
    t_atom at;
    at.a_type = A_LONG;
    at.a_w.w_long = n;
    binbuf_eval(x->t_box.b_binbuf, 1, &at, x->t_box.b_ob.o_outlet);
}

void vmessage_float(t_vmessage *x, double f)
{
    t_atom at;
    at.a_type = A_FLOAT;
    at.a_w.w_float = f;
    binbuf_eval(x->t_box.b_binbuf, 1, &at, x->t_box.b_ob.o_outlet);
}

void vmessage_symbol(t_vmessage *x, t_symbol *s)        /* <a> message added to send a symbol */
{
    t_atom at;
    at.a_type = A_SYM;
    at.a_w.w_sym = s;
    binbuf_eval(x->t_box.b_binbuf, 1, &at, x->t_box.b_ob.o_outlet);
}

void vmessage_list(t_vmessage *x, t_symbol *s, int argc, t_atom *argv)
{
    binbuf_eval(x->t_box.b_binbuf, argc, argv, x->t_box.b_ob.o_outlet);
}

void vmessage_eval(t_vmessage *x)
{
    int cpno = patcher_getcp(x->t_box.b_patcher);
    patcher_baglines(x->t_box.b_patcher, x, 0);
    if (cpno >= 0)
    {
        t_atom at[260];
        int ac;
        ac = binbuf_toatoms(x->t_box.b_binbuf, at);
        h_mess(x, &s__set, ac, at);
    }
}

inbox(t_box *b, Rect *r)
{
    Rect *r2 = &b->b_rect;
    r->top = r2->top + 2;
    r->left = r2->left + 1;
    r->bottom = r2->bottom - 2;
    r->right = r2->right - 1;
}

vmessdragpoint(t_vmessage *x, Point pt, int but)
{
    if (!but)
    {
        Rect r;
        TEHandle teh = x->t_box.b_un.b_teh;
        inbox((t_box *) x, &r);
        t_eraserect(r.left, r.top, r.right, r.bottom);
        te_update(teh);
    }
}

void vmessage_click(t_vmessage *x)
{
    Rect r;
    static Point pt = { 0, 0 };
    char savelock = lockout;
    inbox((t_box *) x, &r);
    lockout = 1;
    if (patcher_getcp(x->t_box.b_patcher) >= 0)
        h_vmess(x, &s_bang, "");
    lockout = savelock;
    t_paintrect(r.left, r.top, r.right, r.bottom);
    box_drag(x, vmessdragpoint, pt);
}

void vmessage_update(t_vmessage *x)
{
}

void vmessage_psave(t_vmessage *x, void *z)
{
    Rect *r = &x->t_box.b_rect;
    binbuf_savebox(x->t_box.b_binbuf, z, &s_message,
                   r->left, r->top, r->right - r->left, x->t_box.b_fsize);
}

#define BS 256

void vmessage_set(t_vmessage *x, t_symbol *s, int argc, t_atom *argv)
{
    if (inISR)
        error("message setting not suported at interrupt");
    else
        box_settext(x, argc, argv);
}

void vmessage_append(t_vmessage *x, t_symbol *s, int argc, t_atom *argv)
{
    if (inISR)
        error("message setting not suported at interrupt");
    else
        box_appendtext(x, argc, argv);
}

void vmessage_fromcp(t_vmessage *x, void **h, long n)
{
    binbuf_text(x->t_box.b_binbuf, h, n);
    if (x->t_box.b_un.b_teh)
    {
        box_toed(x);
        box_erase(x);
    }
}

void vmessage_active(t_vmessage *x, int n)
{
    if (n)
    {
        if (x->t_textupd)
            bug("vmessage_active");
        x->t_textupd = textcpr_new(x, vmessage_fromcp);
    }
    else
    {
        if (!x->t_textupd)
            bug("vmessage_active 2");
        textcpr_free(x->t_textupd);
        x->t_textupd = 0;
    }
}

void vmessage_setcp(t_vmessage *x, int n, int flags)
{
    if (flags & CP_UNPUT)
    {
        if (x->t_textupd)
            vmessage_active(x, 0);
        h_free(x);
    }
    if (flags & CP_PUT)
    {
        t_atom at[260];
        int ac;
        ac = binbuf_toatoms(x->t_box.b_binbuf, at);
        h_new(x, n, &s_vmessage, ac, at);
    }
}

void *vmessage_class;
void vmessage_setup()
{
    c_new(&s_vmessage, NIL, sizeof(t_vmessage), 0, 0);
    c_addbang(vmessage_bang);
    c_addint(vmessage_int);
    c_addfloat(vmessage_float);
    c_addmess(vmessage_symbol, &s_symbol, A_SYM, 0);
    c_addmess(vmessage_list, &s_list, A_GIMME, 0);
    c_addmess(vmessage_psave, &s_psave, A_CANT, 0);
    c_addmess(vmessage_click, &s_click, A_CANT, 0);
    c_addmess(vmessage_update, &s_update, A_CANT, 0);
    c_addmess(vmessage_set, &s_set, A_GIMME, 0);
    c_addmess(vmessage_append, &s_append, A_GIMME, 0);
    c_addmess(vmessage_eval, &s_eval, A_CANT, 0);
    c_addmess(vmessage_setcp, &s_setcp, A_CANT, 0);
    c_addmess(vmessage_active, &s__active, A_CANT, 0);
}

void *binbuf();

void *xmessage(void *patcher, int x, int y, int w, int f, int argc,
               t_atom *argv)
{
    t_vmessage *p;
    if (memislow)
        return (0);
    p = (t_vmessage *) obj_new((t_messlist **) & vmessage_class,
                               vmessage_setup);
    box(p, patcher, F_DRAWFIRSTIN, x, y, x + w, y + SIZE1);
    box_binbuf(p, 2, f);
    outlet(p, NIL);
    p->t_box.b_firstin = p;
    p->t_textupd = 0;
    if (argc)
        box_settext(p, argc, argv);
    box_ready(p);
    return (p);
}

void *mmessage(void *patcher, int x, int y, int f)
{
    return (xmessage(patcher, x, y, p_txtwidth(), f, 0, NIL));
}

void *patcher_message(void *p, t_symbol *s, int ac, t_atom *av)
{
    return (textbox(p, xmessage, ac, av));
}

extern void *newest;

void vnewobj_dblclick(t_vnewobj *n)
{
    t_method fn;
    if (n->n_box.b_firstin)
    {
        if ((fn = egetfn(n->n_box.b_firstin, &s_dblclick)) != nullfn)
            (*fn) (n->n_box.b_firstin);
    }
}

#define ISPATCH 1               /* flag fields returned from binbuf_misc */
#define GOTSEMIS 2
extern void *mcp_id, *mcp_obj;
extern int mcp_cpno;

void vnewobj_setinlet(t_vnewobj *n, void *obj, int cpno)
{
}

void vnewobj_eval(t_vnewobj *n)
{
    void *was = n->n_box.b_firstin;
    int flags = binbuf_misc(n->n_box.b_binbuf),
        cpno = patcher_getcp(n->n_box.b_patcher), bagged = 0;
    if (was)
    {
        int waspatch = (ob_messlist(was) == patcher_class);
        /* <a> special case -- if it's a patcher and the new one is too,
           don't remake; pass the message on to the patcher. */
        if ((flags & ISPATCH) && !(flags & GOTSEMIS) &&
            waspatch && !patcher_isclass(was))
        {
            /* trick: patcher takes a "patcher" message to set title */
            binbuf_eval(n->n_box.b_binbuf, 0, NIL, was);
            return;
        }
        patcher_baglines(n->n_box.b_patcher, n, 1);
        if (cpno >= 0)
            (*egetfn(was, &s_setcp)) (was, -1, CP_UNPUT);
        freeobject((t_object *) was);
        if (cpno >= 0)
            h_free(was);
        bagged = 1;
    }
    else
    {
        if (n->n_box.b_ob.o_inlet || n->n_box.b_ob.o_outlet)
        {
            patcher_baglines(n->n_box.b_patcher, n, 1);
            bagged = 1;
        }
        n->n_box.b_ob.o_inlet = 0;
        n->n_box.b_ob.o_outlet = 0;
    }
    newest = 0;
    /* <a> check added; refuses messages with commas or semis */
    if (flags & GOTSEMIS)
        error("object box has comma or semicolon");
    else
    {
        binbuf_make(n->n_box.b_binbuf, 0, NIL, &qnewobj);
#ifdef CAREFUL
        if (newest && NOGOOD(newest))
            newest = 0;
#endif
        /* <a> added to pass patchers message to set their title */
        if (newest && ob_messlist(newest) == patcher_class &&
            !patcher_isclass(newest))
        {
            binbuf_eval(n->n_box.b_binbuf, 0, NIL, newest);
        }
    }
    if (newest && cpno >= 0)
    {
        if (ob_messlist(newest) == patcher_class)
            h_vnew(newest, cpno, &s_patcher, "");
        else
        {
            mcp_cpno = cpno;
            mcp_id = newest;
            binbuf_eval(n->n_box.b_binbuf, 0, NIL, mcp_obj);
        }
        (*egetfn(newest, &s_setcp)) (newest, cpno, CP_PUT);
    }
    box_setinlet(n, newest);
    if (newest && bagged)
        patcher_restorelines(n->n_box.b_patcher, n);
    newest = 0;
}

void vnewobj_update(t_vnewobj *n)
{
    Rect *r = &n->n_box.b_rect;

    t_line(r->left, r->top + 2, r->right - 1, r->top + 2);
    t_line(r->left, r->bottom - 3, r->right - 1, r->bottom - 3);
}

void vnewobj_psave(t_vnewobj *x, void *w)
{
    Rect *r = &x->n_box.b_rect;
    void *it;
    t_method fn;

    if ((it = x->n_box.b_firstin) &&
        (fn = egetfn(it, &s_save)) != nullfn
        && (ob_messlist(it) != patcher_class || !patcher_isclass(it)))
    {
        (*fn) (x->n_box.b_firstin, w, 12L);
        binbuf_savebox(x->n_box.b_binbuf, w, &s_newobj,
                       r->left, r->top, r->right - r->left,
                       x->n_box.b_fsize);
    }
    else
        binbuf_savebox(x->n_box.b_binbuf, w, &s_newex,
                       r->left, r->top, r->right - r->left,
                       x->n_box.b_fsize);
}

void vnewobj_set(t_vnewobj *n, t_symbol *s, int argc, t_atom *argv)
{
    box_settext(n, argc, argv);
}

void *box_outlet(struct box *b, struct outlet *po),
    *box_inlet(struct box *b, struct inlet *pi);

/* add or remove a copy on a remote CPU */
void vnewobj_setcp(t_vnewobj *x, int cpno, int flags)
{
    if (x->n_box.b_firstin)
    {
        if (flags & CP_RESTART)
        {
            (*egetfn(x->n_box.b_firstin, &s_setcp))
                (x->n_box.b_firstin, -1, CP_RESTART);
        }
        if (flags & CP_UNPUT)
        {
            (*egetfn(x->n_box.b_firstin, &s_setcp))
                (x->n_box.b_firstin, -1, CP_UNPUT);
            h_free(x->n_box.b_firstin);
        }
        if (flags & CP_PUT)
        {
            if (ob_messlist(x->n_box.b_firstin) == patcher_class)
                h_vnew(x->n_box.b_firstin, cpno, &s_patcher, "");
            else
            {
                mcp_cpno = cpno;
                mcp_id = x->n_box.b_firstin;
                binbuf_eval(x->n_box.b_binbuf, 0, NIL, mcp_obj);
            }
            (*egetfn(x->n_box.b_firstin, &s_setcp))
                (x->n_box.b_firstin, cpno, CP_PUT);
        }
    }
}

void vnewobj_ff(t_vnewobj *n)
{
    if (n->n_box.b_firstin)
    {
        freeobject((t_object *) n->n_box.b_firstin);
        n->n_box.b_ob.o_inlet = 0;
        n->n_box.b_ob.o_outlet = 0;
    }
}

void *vnewobj_class;

void vnewobj_setup()
{
    c_new(&s_newobj, vnewobj_ff, sizeof(t_vnewobj), 0, 0);
    c_addmess(vnewobj_psave, &s_psave, A_CANT, 0);
    c_addmess(vnewobj_dblclick, &s_dblclick, 0);
    c_addmess(vnewobj_eval, &s_eval, 0);
    c_addmess(vnewobj_update, &s_update, A_CANT, 0);
    c_addmess(vnewobj_set, &s_set, A_GIMME, 0);
    c_addmess(vnewobj_setcp, &s_setcp, A_CANT, 0);
}

void *xnewobj(void *patcher, int x, int y, int w, int f, int argc,
              t_atom *argv)
{
    t_vnewobj *p;
    if (memislow)
        return (0);
    p = (t_vnewobj *) obj_new((t_messlist **) & vnewobj_class,
                              vnewobj_setup);
    box(p, patcher, 0, x, y, x + w, y + SIZE1);
    box_binbuf(p, 3, f);
    if (argc)
        box_settext(p, argc, argv);
    box_ready(p);
    return (p);
}

void *mnewobj(void *patcher, int x, int y, int f)
{
    return (xnewobj(patcher, x, y, p_txtwidth(), f, 0, NIL));
}

void *patcher_newobj(void *p, t_symbol *s, int ac, t_atom *av)
{
    t_vnewobj *x = (t_vnewobj *) textbox(p, xnewobj, ac, av);
    if (!x)
        return (0);             /* <b> added failure check */
    if (newest)
    {
        int cpno = patcher_getcp(x->n_box.b_patcher);
        box_setinlet(x, newest);
        if (cpno >= 0)
            vnewobj_setcp(x, cpno, CP_PUT);
        /* <a> added to pass patchers message to set their title */
        if (ob_messlist(newest) == patcher_class)
        {
            binbuf_eval(x->n_box.b_binbuf, 0, NIL, newest);
        }
        newest = 0;
    }
    return (x);
}

void *patcher_newex(void *p, t_symbol *s, int ac, t_atom *av)
{
    t_vnewobj *x = (t_vnewobj *) textbox(p, xnewobj, ac, av);
    if (!x)
        return (0);             /* <b> added failure check */
    x->n_box.b_firstin = 0;
    vnewobj_eval(x);
    return (x);
}

typedef struct vcomment {
    struct box t_box;
} t_vcomment;

void vcomment_psave(t_vcomment *x, void *w, long int n,
                    t_symbol *patchersym)
{
    Rect *r = &x->t_box.b_rect;
    binbuf_savebox(x->t_box.b_binbuf, w, &s_comment,
                   r->left, r->top, r->right - r->left, x->t_box.b_fsize);
}

void vcomment_update(t_vcomment *x)
{
}

void vcomment_set(t_vcomment *x, t_symbol *s, int argc, t_atom *argv)
{
    box_settext(x, argc, argv);
}

void vcomment_append(t_vmessage *x, t_symbol *s, int argc, t_atom *argv)
{
    box_appendtext(x, argc, argv);
}

void vcomment_setcp(t_vcomment *x)
{
}

void *vcomment_class;
void vcomment_setup()
{
    c_new(&s_comment, NIL, sizeof(t_vcomment), 0, 0);
    c_addmess(vcomment_update, &s_update, A_CANT, 0);
    c_addmess(vcomment_psave, &s_psave, A_CANT, 0);
    c_addmess(vcomment_set, &s_set, A_GIMME, 0);
    c_addmess(vcomment_append, &s_append, A_GIMME, 0);
    c_addmess(vcomment_setcp, &s_setcp, A_CANT, 0);
}

void *xcomment(void *patcher, int x, int y, int w, int f, int argc,
               t_atom *argv)
{
    t_vcomment *p;
    if (memislow)
        return (0);
    p = (t_vcomment *) obj_new((t_messlist **) & vcomment_class,
                               vcomment_setup);
    box(p, patcher, F_NODRAWBOX, x, y, x + w, y + SIZE1);
    box_binbuf(p, 1, f);
    if (argc)
        box_settext(p, argc, argv);
    box_ready(p);
    return (p);
}

void *patcher_comment(void *p, t_symbol *s, int ac, t_atom *av)
{
    return (textbox(p, xcomment, ac, av));
}

void *mcomment(void *patcher, int x, int y, int f)
{
    return (xcomment(patcher, x, y, p_txtwidth(), f, 0, NIL));
}
