
/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.6 $ IRCAM $Date: 1993/12/10 15:44:40 $
 *
 * FTS by Miller Puckette
 *
 */


#define POX 10                  /* patcher outlet width and height */
#define POY 3
#define SIZE1 15                /* frequently used control dimensions */
#define SIZE2 50
#define UNIT 256
#define USHIFT 8

#define CP_PUT  1               /* flags for setcp message */
#define CP_UNPUT 2
#define CP_RESTART 4

#define F_DRAWFIRSTIN   1       /* draw first inlet */
#define F_GROWY     2           /* can grow in y direction by dragging */
#define F_NODRAWBOX   4         /* don't draw the box  */
#define F_SPOOLED     010
#define F_DRAWN     020

extern void *patcher_class;

struct symbol *numtosym();
void *inlet(void *op, void *who, struct symbol *s1, struct symbol *s2);
void *outlet(void *op, struct symbol *s2);

#ifndef _t_textEdit_
typedef void *TEHandle;
#endif

typedef struct box {
    struct object b_ob;
    unsigned int b_inlet:1;     /* this box is an inlet */
    unsigned int b_outlet:1;    /* this box is an outlet */
    unsigned int b_textdirty:1; /* text has been changed */
    unsigned int b_drawfirstin:1;       /* draw inlet for the real object */
    unsigned int b_outline:1;   /* draw the box */
    unsigned int b_drawn:1;     /* has been drawn */
    unsigned int b_spooled:1;   /* is spooled for drawing */
    unsigned int b_growy:1;     /* can grow in y direction */
    unsigned int b_inset:3;     /* top-and-bottom inset for text */
    unsigned int b_selected:1;  /* on if selected */
    unsigned int b_fsize:3;     /* font size */
    short b_temp;               /* temporary space */
    struct box *b_upd;          /* update list link */
    Rect b_rect;                /* location */
    struct box *b_next;         /* next box in patcher */
    struct patcher *b_patcher;  /* owning patcher */
    void *b_firstin;            /*  */
    void *b_binbuf;             /* contained message in binary */
    union {
        struct outlet *b_vpout; /* patchoutlet in this patcher's visobj */
        struct inlet *b_vpin;   /* patchinlet in this patcher's visobj */
        TEHandle b_teh;         /* text editor handle */
    } b_un;
} t_box;

typedef struct vnewobj {
    t_box n_box;
} t_vnewobj;

extern struct symbol s__Pat;    /* the newest patcher */
extern long boxdragref;         /* drag offset for boxes */

void box_active(t_box * b, int n);

#define patchercheck(x, y)
#define boxcheck(x, y)
