#ifndef lint
static char rcsid[] =
    "$Revision: 1.15 $ IRCAM $Date: 1994/01/29 07:49:41 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.15 $ IRCAM $Date: 1994/01/29 07:49:41 $
 *
 * FTS by Miller Puckette
 *
 */


#define DELAY 30
#include <stdio.h>
#include "m_mess.h"
#include "t_mac.h"
#include "t_wind.h"
#include "t_menu.h"
#include "p_patcher.h"
#include "m_inout.h"
#include "p_patcher2.h"
#include "p_pic.h"
#include "h_cp.h"

#define HTOL 3

extern int binbuf_error;
extern struct patcher *patcher_saving;
extern char lockout;

void linedragpoint(struct patchline *l, Point pt, int but);
void *qelem_new();
void *lowload(char *name, t_symbol * volume, int ac, struct atom *av,
              int couldedit);

extern struct symbol s_patcher, s_psave, s_vpatcher, s_front, s_dblclick,
    s__New, s_filename, s_imbed, s_hook, s_eval, s_save, s_pop, s_connect,
    s_button, s_toggle, s_slider,
    s_message, s_newobj, s_newex, s_comment, s_number, s_flonum,
    s_inlet, s_outlet, s_setcp, s_setparentcp, s_stretch, s_pchild,
    s__active;

extern int memislow;
extern void *copybuf;
extern void *vnewobj_class, *vslider_class, *patcher_class;
#define ISPOT(x) (ob_messlist(x) == vslider_class)
t_symbol *t_getpath(), *t_getdefpath();
extern void *newest;
#define CPBARNO 6               /* number of CPs appearing in bar */

struct binbuf;
extern void binbuf_insert(struct binbuf *x, struct symbol *s, int argc,
                          struct atom *argv);

void patchlist_del(struct patcher *p);

void patcher_button(void *p, struct symbol *s, int ac, struct atom *av);
void patcher_toggle(void *p, struct symbol *s, int ac, struct atom *av);
void patcher_slider(void *p, struct symbol *s, int ac, struct atom *av);
void patcher_message(void *p, t_symbol * s, int ac, t_atom * av);
void patcher_newobj(void *p, t_symbol * s, int ac, t_atom * av);
void patcher_newex(void *p, t_symbol * s, int ac, t_atom * av);
void patcher_comment(void *p, t_symbol * s, int ac, t_atom * av);
void patcher_number(void *p, struct symbol *s, int ac, struct atom *av);
void patcher_flonum(void *p, struct symbol *s, int ac, struct atom *av);
void patcher_inlet(void *p, struct symbol *s, int ac, struct atom *av);
void patcher_outlet(void *p, struct symbol *s, int ac, struct atom *av);
void patcher_click(struct patcher *p, Point pt, int dclick, int modifiers);
void patcher_key(struct patcher *p, int k);
void patcher_activate(struct patcher *p, int active);
void patcher_update(struct patcher *p, int margin);
void patcher_saveto(struct patcher *p, char *fn, t_symbol * vol);
void patcher_clear(struct patcher *p);
void patcher_copy(struct patcher *p);
void patcher_close(struct patcher *p);
void patcher_paste(struct patcher *p);
void patcher_idle(struct patcher *p, Point pt);
void patcher_dialog(struct patcher *p);
void patcher_cut(struct patcher *p);
void patcher_invis(struct patcher *p);
void *patcher_help();
void patcher_dup(struct patcher *p);
void patcher_undo(struct patcher *p);
void patcher_edit(struct patcher *p);
void patcher_lineup(struct patcher *p);
void patcher_fixwidth(struct patcher *p);

void *patcher_class;

void *mtoggle(void *patcher, long int x, long int y);
void *mbutton(void *patcher, long int x, long int y);
void *mslider(void *patcher, long int x, long int y);
void *mnumber(void *patcher, long int x, long int y, int f);
void *mflonum(void *patcher, long int x, long int y, int f);
void *mmessage(void *patcher, long int x, long int y, int f);
void *mcomment(void *patcher, long int x, long int y, int f);
void *mnewobj(void *patcher, long int x, long int y, int f);
void *minlet(void *patcher, long int x, long int y);
void *moutlet(void *patcher, long int x, long int y);
void *msiginlet(void *patcher, long int x, long int y);
void *msigoutlet(void *patcher, long int x, long int y);

void *(*patchreslist[])() = {
    mnewobj,
    mmessage,
    mcomment,
    mbutton,
    mtoggle,
    mnumber,
    mflonum,
    mslider,
    minlet,
    moutlet,
    msiginlet,
    msigoutlet,
};

#define NBOXTYPE (sizeof(patchreslist)/sizeof(patchreslist[0]))
#define BARX (16+16*NBOXTYPE)   /* width of palette at top of window */
#define BOXW (BARY)             /* units per CP box */
#define CPSENDX1 240
#define CPSENDX2 (CPSENDX1 + CPBARNO * BOXW + 1)

/* Intersecting this rectangle causes a redraw of the `palette' area */
/* It covers both the palette and the CP box region */
Rect barrect = { 0, 0, BARY, CPSENDX2 };


/* <a> the "botcher" class added to keep pushing and popping fake patchers when
   aborting a load because of memislow flag */
typedef struct botcher {
    struct tinyobject bo_ob;
    void *bo_pushed;
} t_botcher;

int patcher_noselect(struct patcher *p);
int patcher_nolspool(struct patcher *p);
int patcher_nobspool(struct patcher *p);
int patcher_drawbar(struct patcher *p, int lock);
int patcher_sendtocp(struct patcher *p, struct box *b, int cpno,
                     int flags);
int ispatcher(struct object *x);
int patcher_becomecurrent(struct patcher *p);
int patcher_deseltext(struct patcher *p);
int patcher_deselectbox(struct patcher *p, struct box *b);
int patcher_deselectline(struct patcher *p, struct patchline *l);
int patcher_nonum(struct patcher *p);
int patcher_span(struct patcher *p);
int patcher_isclass(struct patcher *p);
void helpstring(char *s);
int patcher_spoolbox(struct patcher *p, struct box *b);
int patcher_spoolline(struct patcher *p, struct patchline *l);
int patcher_spoolbar(struct patcher *p);
int patcher_spooldraw(struct patcher *p);

struct qelem;                   /* in m_sched.c */

void *botcher_pop(t_botcher *x)
{
    s__Pat.s_thing = x->bo_pushed;
    newest = x;
    return (x);
}

void *botcher_class;
botcher_setup()
{
    c_new(&s_patcher, NIL, sizeof(t_botcher), 1, 0);
    c_addmess((t_method) botcher_pop, &s_pop, A_GIMME, 0);
    c_addmess(nullfn, &s_anything, A_GIMME, 0);
}

void *botcher()
{
    struct botcher *x =
        (struct botcher *) obj_new((t_messlist **) & botcher_class,
                                   (t_method) botcher_setup);
    x->bo_pushed = s__Pat.s_thing;
    s__Pat.s_thing = (struct object *) x;
    return (x);
}

/* flip the box and line lists backward, recursively.  Since new boxes
   and lines are inserted in the front, saving and restarting FTS should
   do their work in backward order.  Those two operations are bracketted by
   calls to this routine. */
void patcher_flip(t_patcher *p)
{
    t_patchline *l, *l2, *l3;
    t_box *b, *b2, *b3;
    if (l = p->p_line)
    {
        l2 = 0;
        while (l)
        {
            l3 = l->l_next;
            l->l_next = l2;
            l2 = l;
            l = l3;
        }
        p->p_line = l2;
    }
    if (b = p->p_box)
    {
        b2 = 0;
        while (b)
        {
            b3 = b->b_next;
            b->b_next = b2;
            b2 = b;
            b = b3;
        }
        p->p_box = b2;
    }
    for (b = p->p_box; b; b = b->b_next)
        if (b->b_firstin && ob_messlist(b->b_firstin) == patcher_class)
            patcher_flip(b->b_firstin);
}

GrafPort *patcher_setport(struct patcher *p)
{
    return (wind_setport(p->p_wind));
}

void patcher_chkmenu(struct patcher *p, struct menuinfo *m)
{
    int issel = p->p_nselect;
    struct patchline *l;
    struct box *b;
    int size = 0, gotsize = 0;
    m->i_save = 1;
    if (p->p_noedit)
        return;
    m->i_dup = (issel != 0);
    if (!p->p_noedit)
        m->i_edit = (p->p_lock ? 1 : 2);
    if (p->p_nselect > 1)
        m->i_lineup = 1;
    if (!issel)
        for (l = p->p_line; l; l = l->l_next)
            if (l->l_selected)
            {
                issel = 1;
                break;
            }
    for (b = p->p_box; b; b = b->b_next)
        if (b->b_selected)
        {
            if (ISPOT(b))
                m->i_range = 1;
            if (b->b_binbuf)
                m->i_fixwidth = 1;
            if (gotsize)
            {
                if (b->b_fsize != size)
                    gotsize = 2;
            }
            else
            {
                size = b->b_fsize;
                gotsize = 1;
            }
        }
    m->i_cut = (issel != 0);
    if (p->p_seltext)
        m->i_paste = canpastetext();
    else
        m->i_paste = (copybuf != 0);
    if (gotsize == 1)
        m->i_size = size;
    else if (gotsize == 2)
        m->i_size = 100;
}

void patcher_dirty(struct patcher *p, int flag)
{
    wind_dirty(p->p_wind, flag);
    while (p->p_vnewobj)
    {
        p = ((struct box *) (p->p_vnewobj))->b_patcher;
        wind_dirty(p->p_wind, flag);
    }
}

void patcher_lock(struct patcher *p, int lock)
{
    GrafPort *gp;
    struct box *b;
    struct patchline *l;

    patchercheck(p, "patcher_fix");
    gp = patcher_setport(p);
    if (gp)
    {
        if (lock)
        {
            patcher_noselect(p);        /* clear selection */
            for (b = p->p_box; b; b = b->b_next)
            {
                Rect *r = box_bigrect(b);
                t_eraserect(r->left, r->top, r->right, r->bottom);
            }
            p->p_lock = 1;
            for (l = p->p_line; l; l = l->l_next)
                patchline_draw(l);
            for (b = p->p_box; b; b = b->b_next)
            {
                if (ISPOT(b))
                    t_eraserect(b->b_rect.left, b->b_rect.top,
                                b->b_rect.right, b->b_rect.bottom);
                box_draw(b);
            }
        }
        else
        {
            p->p_lock = 0;
            for (b = p->p_box; b; b = b->b_next)
                box_draw(b);
            for (l = p->p_line; l; l = l->l_next)
                patchline_draw(l);
        }
        patcher_nolspool(p);
        patcher_nobspool(p);
        t_resetport(gp);
    }
    if (gp = wind_marginport(p->p_wind))
    {
        if (lock)
            patcher_undrawbar(p);
        else
            patcher_drawbar(p, 0);
        t_resetport(gp);
    }
    p->p_lock = lock;
}

/* set the CP of boxes within this patcher (i.e. p->p_cpno). */

void patcher_setchildcp(struct patcher *p, int cp)
{
    struct box *b;
    struct patchline *l;
    GrafPort *gp;
    if (cp == p->p_cpno)
        return;
    if (p->p_cpno >= 0 && p->p_cpno < h_nproc)  /* if was on a CP, remove */
    {
        for (l = p->p_line; l; l = l->l_next)
            patchline_setcp(l, -1);
        for (b = p->p_box; b; b = b->b_next)
            patcher_sendtocp(p, b, -1, CP_UNPUT);
        h_free(&p->p_cpno);
        p->p_cpno = cp;
    }
    else
    {
        for (b = p->p_box; b; b = b->b_next)
            if (b->b_firstin && ob_messlist(b->b_firstin) == patcher_class)
                patcher_setchildcp(b->b_firstin, -1);
    }
    if (cp >= 0 && cp < h_nproc)        /* if new cp exists, put it on */
    {
        p->p_cpno = cp;
        h_vnew(&p->p_cpno, cp, &s_pchild, "ss", p->p_vol, p->p_searchpath);
        h_vmess(&p->p_cpno, &s_int, "l", 0);
        for (b = p->p_box; b; b = b->b_next)
            patcher_sendtocp(p, b, cp, CP_PUT);
        for (l = p->p_line; l; l = l->l_next)
            patchline_setcp(l, cp);
    }
    else
    {
        for (b = p->p_box; b; b = b->b_next)
            if (b->b_firstin && ob_messlist(b->b_firstin) == patcher_class)
                patcher_setchildcp(b->b_firstin, cp);
    }
    p->p_cpno = cp;
    if (gp = patcher_setport(p))
    {
        patcher_drawbar(p, p->p_lock);
        t_resetport(gp);
    }
}

/* Set the CP of the patcher as an object -- not the CP of contained
   boxes which is set via patcher_setchildcp above. */

void patcher_setcp(struct patcher *p, int cp, int flags)
{
    struct box *b;
    if (flags & CP_UNPUT)
    {
        if (p->p_noedit)
            patcher_setchildcp(p, -1);
        for (b = p->p_box; b; b = b->b_next)
            (*egetfn((struct object *) b, &s_setparentcp)) (b, -1);
    }
    if (flags & CP_PUT)
    {
        if (p->p_noedit)
            patcher_setchildcp(p, cp);
        for (b = p->p_box; b; b = b->b_next)
            (*egetfn((struct object *) b, &s_setparentcp)) (b, cp);
    }
}

patcher_dorestartfts(t_patcher *p)      /* warn the patcher that FTS has been restarted */
{
    struct box *b;
    struct patchline *l;
    int cpno = p->p_cpno;
    /* tell all boxes that they're not really instantiated yet */
    for (b = p->p_box; b; b = b->b_next)
        mess2((struct object *) b, &s_setcp, -1, CP_RESTART);
    for (b = p->p_box; b; b = b->b_next)
        if (b->b_firstin && ispatcher(b->b_firstin))
            patcher_dorestartfts(b->b_firstin);
    if (cpno >= 0 && cpno < h_nproc)
    {
        h_vnew(&p->p_cpno, cpno, &s_pchild, "ss", p->p_vol,
               p->p_searchpath);
        patcher_becomecurrent(p);
        for (b = p->p_box; b; b = b->b_next)
        {
            if (!p->p_noedit)
                mess2(b, &s_setcp, cpno, CP_PUT);
            if (p->p_wind->w_vis)
                (*egetfn(b, &s__active)) (b, 1);
        }
        for (l = p->p_line; l; l = l->l_next)
            patchline_setcp(l, cpno);
    }
}

void patcher_restartfts(t_patcher *p)   /* do the above if not a subpatch */
{
    if (p->p_vnewobj)
        return;                 /* only do it for root patchers */
    loadbang__doit(0);
    patcher_flip(p);
    patcher_dorestartfts(p);
    patcher_flip(p);
    loadbang__doit(1);
}

patcher_cpbutton(struct patcher *p, int x, int y)
{
    int cp = (x - CPSENDX1) / BOXW;
    if (cp < 0)
        cp = 0;
    else if (cp >= CPBARNO)
        cp = CPBARNO - 1;
#ifdef NEXTSTEP
    if (cp == p->p_cpno)
        cp = -1;
    if (NXRunAlertPanel(NIL,
                        (cp >= 0 ?
                         "send this window (and all subwindows) to CP %d?"
                         :
                         "remove this window (and all subwindows) from FTS?"),
                        NIL, "Cancel", NIL, cp + 1) == 1)
        patcher_setchildcp(p, cp);
#else
    if (cp == p->p_cpno)
        patcher_setchildcp(p, -1);
    else
        patcher_setchildcp(p, cp);
#endif
}

patcher_getcp(struct patcher *p)
{
    return (p->p_cpno < h_nproc ? p->p_cpno : -1);
}

patcher_sendtocp(struct patcher *p, struct box *b, int cpno, int flags)
{
    mess2(b, &s_setcp, cpno, flags);
    if (flags == CP_PUT && p->p_wind->w_vis)
        (*egetfn(b, &s__active)) (b, 1);
    if (b->b_firstin && ob_messlist(b->b_firstin) == patcher_class)
        patcher_setchildcp(b->b_firstin, cpno);
}

patcher_undrawbar(struct patcher *p)
{
    t_eraserect(17, 0, BARX, BARY);
}

patcher_drawbar(struct patcher *p, int lock)
{
    int i, max = (lock ? 1 : 11);
    GrafPort *gp = wind_marginport(p->p_wind);
    if (gp)
    {
        t_eraserect(0, 0, BARX, BARY - 5);
        t_drawbits(PICPATCH, 1, 0, 0, 0, (lock ? 16 : BARX), BARY);
        t_drawbits(PICSEND, 0, 0, CPSENDX1, 0, CPSENDX2, BARY);
        for (i = h_nproc; i < CPBARNO; i++)
        {
            int xx = CPSENDX1 + i * BOXW;
            t_line(xx, 0, xx + BARY, BARY);
            t_line(xx, BARY, xx + BARY, 0);
        }
        if (p->p_cpno >= 0)
            t_invertrect(CPSENDX1 + p->p_cpno * BOXW + 1, 0,
                         CPSENDX1 + (p->p_cpno + 1) * BOXW, BARY - 1);
        t_resetport(gp);
    }
}

patcher_selectbox(struct patcher *p, struct box *b)
{
    if (b->b_selected)
        return;
    b->b_selected = 1;
    if (p->p_seltext)
        patcher_deseltext(p);
    p->p_nselect++;
    if (b->b_drawn && !p->p_seltext)
        t_invertrect(b->b_rect.left + 1, b->b_rect.top + 1,
                     b->b_rect.right - 1, b->b_rect.bottom - 1);
}

patcher_seltext(struct patcher *p, struct box *b)
{
    p->p_seltext = b;
    te_setselect(b->b_un.b_teh, 0L, te_length(b->b_un.b_teh));
    te_activate(b->b_un.b_teh);
    box_correctheight(b);
}

patcher_selectline(struct patcher *p, struct patchline *l)
{
    if (l->l_selected)
        return;
    l->l_selected = 1;
    patchline_erase(l);
}

patcher_noselect(struct patcher *p)
{
    struct box *b;
    struct patchline *l;

    for (b = p->p_box; b; b = b->b_next)
        if (b->b_selected)
            patcher_deselectbox(p, b);
    for (l = p->p_line; l; l = l->l_next)
        if (l->l_selected)
            patcher_deselectline(p, l);
    p->p_pasted = 0;
    p->p_nselect = 0;
}

patcher_deselectbox(struct patcher *p, struct box *b)
{
    if (!b->b_selected)
        return;
    box_erase(b);
    if (p->p_seltext == b)
        patcher_deseltext(p);
    b->b_selected = 0;
    if (--p->p_nselect < 0)
        bug("select count");
}

patcher_deseltext(struct patcher *p)
{
    struct box *b = p->p_seltext;
    char savelock = lockout;
    if (!b)
        return;
    te_deactivate(b->b_un.b_teh);
    if (b->b_binbuf)
    {
        lockout = 1;
        if (te_changed())
            patcher_setuntype(p);
        binbuf_text(b->b_binbuf, te_text(b->b_un.b_teh),
                    te_length(b->b_un.b_teh));
        lockout = savelock;
    }
    box_correctheight(b);
    if (!b->b_drawn)
    {
        Rect *br = box_bigrect(b);
        t_eraserect(br->left, br->top, br->right, br->bottom);
    }
    /* if (b->b_textdirty) */
    if (te_changed())
    {
        t_symbol *vwas = defvolume, *pwas = t_getpath();
        defvolume = p->p_vol;
        patcher_becomecurrent(p);
        lockout = 1;
        (*(egetfn(b, &s_eval))) (b);
        lockout = savelock;
        defvolume = vwas;
        t_setpath(pwas);
#ifdef XMAX
        box_correctwidth(b);
        box_correctheight(b);
#endif
        b->b_textdirty = 0;
    }
    if (b->b_selected && b->b_drawn)
        t_invertrect(b->b_rect.left + 1, b->b_rect.top + 1,
                     b->b_rect.right - 1, b->b_rect.bottom - 1);
    p->p_seltext = 0;
}

patcher_deselectline(struct patcher *p, struct patchline *l)
{
    patchline_erase(l);
    l->l_selected = 0;
}

void patcher_selectall(struct patcher *p)
{
    struct box *b;
    if (p->p_lock)
        patcher_lock(p, 0);
    if (p->p_seltext)
        patcher_noselect(p);
    for (b = p->p_box; b; b = b->b_next)
        if (!b->b_selected)
            patcher_selectbox(p, b);
}

patcher_nonum(struct patcher *p)
{
    if (p->p_typeat)
    {
        Rect r, *r2 = &p->p_typeat->b_rect;
        t_eraserect(r2->left + 1, r2->top + 2, r2->right - 1,
                    r2->bottom - 2);
        mess0(p->p_typeat, &s_update);
        p->p_typeat = 0;
    }
}

void patcher_activate(struct patcher *p, int active)
{
    struct box *b = p->p_seltext;
    if (active)
    {
        if (b)
        {
            te_setselect(b->b_un.b_teh, 0L, te_length(b->b_un.b_teh));
            te_activate(b->b_un.b_teh);
        }
    }
    else
    {
        if (b)
            te_deactivate(b->b_un.b_teh);
    }
}

void patcher_print(struct patcher *p)
{
    struct box *b;
    patchercheck(p, "patcher_print");
    post("box: ");
    for (b = p->p_box; b; b = b->b_next)
        post("   %s", ob_name(b));
}

void patcher_save(struct patcher *p, void *x)
{
    struct box *b;
    long n, nbox;
    struct patchline *l;
    struct windpub *w = p->p_wind;
    int scrollx, scrolly;
    wind_getscroll(p->p_wind, &scrollx, &scrolly);
    /* idiotic way to get scroll state to save correctly.
       Translate each of the boxes to their displayed position before saving;
       then translate them back. */
    if (scrollx || scrolly)
        for (b = p->p_box; b; b = b->b_next)
            b->b_rect.left -= scrollx, b->b_rect.right -= scrollx,
                b->b_rect.top -= scrolly, b->b_rect.bottom -= scrolly;
    binbuf_error = 0;
    patchercheck(p, "patcher_psave");
    if (p->p_cpno)
        vfun(x, binbuf_insert, NIL, "sslllll", &s__New, &s_vpatcher,
             (long) w->w_x1, (long) w->w_y1, (long) w->w_x2,
             (long) w->w_y2, (long) p->p_cpno);
    else
        vfun(x, binbuf_insert, NIL, "ssllll", &s__New, &s_vpatcher,
             (long) w->w_x1, (long) w->w_y1, (long) w->w_x2,
             (long) w->w_y2);
    for (nbox = -1, b = p->p_box; b; b = b->b_next)
        nbox++;
    for (n = 0, b = p->p_box; b && !binbuf_error; b = b->b_next, n++)
    {
        mess1(b, &s_psave, x);
        b->b_temp = nbox - n;
    }
    for (l = p->p_line; l && !binbuf_error; l = l->l_next)
    {
        long pono = 0, pino = 0;
        struct outlet *po;
        struct inlet *pi;
        for (po = l->l_box1->b_ob.o_outlet; po && po != l->l_outlet;
             po = po->o_next, pono++);
        b = l->l_box2;
        if (!b->b_drawfirstin ||
            l->l_inlet != (struct inlet *) (b->b_firstin))
        {
            if (b->b_drawfirstin)
                pino++;
            for (pi = b->b_ob.o_inlet; pi && pi != l->l_inlet;
                 pi = pi->i_next, pino++);
        }
        vfun(x, binbuf_insert, NIL, "ssllll", &s__Pat, &s_connect,
             (long) (l->l_box1->b_temp), pono,
             (long) (l->l_box2->b_temp), pino);
    }
    if (!binbuf_error)
    {
        if (p->p_wind->w_vis && p->p_vnewobj && p != patcher_saving)
            vfun(x, binbuf_insert, NIL, "ssl", &s__Pat, &s_pop, 1L);
        else
            vfun(x, binbuf_insert, NIL, "ss", &s__Pat, &s_pop);
    }
    if (scrollx || scrolly)
    {
        for (b = p->p_box; b; b = b->b_next)
        {
            b->b_rect.left += scrollx;
            b->b_rect.right += scrollx;
            b->b_rect.top += scrolly;
            b->b_rect.bottom += scrolly;
        }
    }
}

patcher_linkbox(struct patcher *p, struct box *b)
{
    b->b_next = p->p_box;
    p->p_box = b;
}

patcher_unlinkbox(struct patcher *p, struct box *b)
{
    struct box *b2;
    struct box stub;
    stub.b_next = p->p_box;
    for (b2 = &stub; b2; b2 = b2->b_next)
    {
        if (b2->b_next == b)
        {
            b2->b_next = b->b_next;
            p->p_box = stub.b_next;
            return;
        }
    }
    bug("unlink");
}

#define NONO(s) {error(s); return; }
#define NONO2(s, t) {error(s, t); return; }
#define NONO3(s,t,u) {error(s,t,u); return; }

/* connect n1th outlet of x1th box to n2th inlet of x2th box */
void patcher_connect(struct patcher *p, long int x1, long int n1,
                     long int x2, long int n2)
{
    struct outlet *po;
    struct inlet *pi;
    struct patchline *l;
    struct box *b1 = 0, *b2 = 0;
    struct box *b;
    long count;
    if (x1 < 0 || x2 < 0 || n1 < 0 || n2 < 0 || x1 == x2 || memislow)
        return;
    if (x1 < x2)
    {
        x2 -= x1;
        for (b = p->p_box; b; b = b->b_next)
        {
            if (!(x1--))
            {
                b1 = b;
                break;
            }
        }
        for (; b; b = b->b_next)
        {
            if (!(x2--))
            {
                b2 = b;
                break;
            }
        }
        if (!b2)
            NONO("connection out of range");
    }
    else
    {
        x1 -= x2;
        for (b = p->p_box; b; b = b->b_next)
        {
            if (!(x2--))
            {
                b2 = b;
                break;
            }
        }
        for (; b; b = b->b_next)
        {
            if (!(x1--))
            {
                b1 = b;
                break;
            }
        }
        if (!b1)
            NONO("connection out of range");
    }
    if (!b1 || !b2)
        NONO("connect bug");
    /* find the n1th outlet */
    for (po = b1->b_ob.o_outlet, count = n1;
         count-- && po; po = po->o_next);
    if (!po)
    {
        if (!b1->b_firstin)
        {
            /* if there are not enough outlets, but if the box is
               empty, add outlets as needed to make the connection.
               unfortunately, you must add the extra outlets to the end
               of the list; you can't just insert them, because existing
               outlets could already be conected */
            t_outlet *po2, ostub;
            ostub.o_next = b1->b_ob.o_outlet;
            b1->b_ob.o_outlet = 0;
            for (po2 = &ostub, count = n1;
                 po = po2->o_next; po2 = po, count--);
            po = outlet_new(b1, NIL);
            count--;
            for (; count >= 0; count--)
                outlet_new(b1, NIL);
            po2->o_next = b1->b_ob.o_outlet;
            b1->b_ob.o_outlet = ostub.o_next;
            box_io(b1);
        }
        else
            NONO("patcher_connect: outlet out of range");
    }
    count = n2;
    if (b2->b_drawfirstin && !(count--))
        pi = b2->b_firstin;
    else
        for (pi = b2->b_ob.o_inlet; count-- && pi; pi = pi->i_next);
    if (!pi)
    {
        if (!b2->b_firstin)
        {
            /* same as for outlets */
            t_inlet *pi2, istub;
            istub.i_next = b2->b_ob.o_inlet;
            b2->b_ob.o_inlet = 0;
            for (pi2 = &istub, count = n2;
                 pi = pi2->i_next; pi2 = pi, count--);
            pi = inlet_new(b2, b2, NIL, NIL);
            count--;
            for (; count >= 0; count--)
                inlet_new(b2, b2, NIL, NIL);
            pi2->i_next = b2->b_ob.o_inlet;
            b2->b_ob.o_inlet = istub.i_next;
            box_io(b2);
        }
        else
            NONO("patcher_connect: inlet out of range");
    }
    if (outlet_add(po, pi))
        NONO("patcher_connect: inlet and outlet don't match");
    l = patchline(p, b1, po);
    if (p->p_cpno >= 0 && p->p_cpno < h_nproc &&
        b1->b_firstin && b2->b_firstin)
        h_connect(b1->b_firstin, n1, b2->b_firstin, n2);
    l->l_inlet = pi;
    l->l_box2 = b2;
    patchline_newends(l);
}

static Point refpoint;
static int movedit, wasnew;

void boxdragpoint(struct patcher *p, Point pt, int but)
{
    int dx, dy;
    struct box *b, stub1, stub2, *b1, *b2;
    patchercheck(p, "boxdragpoint");
    if (!but)
    {
        /* resort the list */
        stub1.b_next = stub2.b_next = 0;
        b1 = &stub1;
        b2 = &stub2;
        for (b = p->p_box; b; b = b->b_next)
            if (b->b_selected)
                b1->b_next = b, b1 = b;
            else
                b2->b_next = b, b2 = b;
        b1->b_next = b2->b_next = 0;
        p->p_box = stub2.b_next;
        for (b = stub1.b_next; b; b = b1)
        {
            b1 = b->b_next;
            patcher_linkbox(p, b);
        }
        if (p->p_nselect == 1)
        {
            for (b = p->p_box; b; b = b->b_next)
                if (b->b_selected)
                {
                    if (b->b_binbuf)
                    {
                        box_erase(b);
                        patcher_seltext(p, b);
                    }
                    break;
                }
        }
        patcher_span(p);
    }
    else if (movedit || pt.h >= refpoint.h + 2 || pt.h <= refpoint.h - 2
             || pt.v >= refpoint.v + 2 || pt.v <= refpoint.v - 2)
    {
        if (pt.h == refpoint.h && pt.v == refpoint.v)
            return;
        patcher_dirty(p, 1);
        if (!movedit)
            patcher_setunmove(p, wasnew), movedit = 1;
        for (b = p->p_box; b; b = b->b_next)
            if (b->b_selected)
                box_erase(b);
        /* GetMouse(&pt); *//* too bad about this */
        dx = pt.h - refpoint.h;
        dy = pt.v - refpoint.v;
        for (b = p->p_box; b; b = b->b_next)
            if (b->b_selected)
                box_move(b, b->b_rect.left + dx, b->b_rect.top + dy);
        refpoint = pt;
    }
}

patcher_drag(struct patcher *p, Point pt, int new)
{
    refpoint = pt;
    movedit = 0;
    wasnew = new;
    wind_drag(p->p_wind, boxdragpoint, (void *) p);
}

void boxdragp2(struct patcher *p, Point pt, int but)
{
    int dx, dy, w, new;
    struct box *b;
    patchercheck(p, "boxdrag2");
    if (!but)
        return;
    patcher_dirty(p, 1);
    if (!movedit)
        patcher_setunstretch(p), movedit = 1;
    dx = pt.h - refpoint.h;
    dy = pt.v - refpoint.v;
    for (b = p->p_box; b; b = b->b_next)
    {
        if (b->b_selected)
        {
            Rect *r = &b->b_rect;
            int w = r->right - r->left;
            int neww = w + dx;
            int h = r->bottom - r->top;
            if (neww < 11)
                neww = 11;
            if (b->b_growy)
                h = neww;
            if (w != neww)
                box_size(b, neww, h);
        }
    }
    refpoint = pt;
}

patcher_drag2(struct patcher *p, Point pt)
{
    refpoint = pt;
    movedit = 0;
    wind_drag(p->p_wind, boxdragp2, (void *) p);
}

void dragp3(struct patcher *p, Point pt, int but)
{
    static int drawn = 0;
    static Rect r;
    struct box *b;
    struct patchline *l;
    if (drawn)
    {
        Rect r2;
        t_unframerect(r.left, r.top, r.right, r.bottom);
        r2 = r;
        for (l = p->p_line; l; l = l->l_next)
            if (seghitsrect(l->l_x1, l->l_y1, l->l_x2, l->l_y2, &r2))
                patchline_spool(l);
        r2.bottom++;
        for (b = p->p_box; b; b = b->b_next)
            if (interrect(&r2, &b->b_rect))
                box_spool(b);
    }
    if (refpoint.h > pt.h)
    {
        r.left = pt.h;
        r.right = refpoint.h;
    }
    else
    {
        r.left = refpoint.h;
        r.right = pt.h;
    }
    if (refpoint.v > pt.v)
    {
        r.top = pt.v;
        r.bottom = refpoint.v;
    }
    else
    {
        r.top = refpoint.v;
        r.bottom = pt.v;
    }
    if (but)
        t_framerect(r.left, r.top, r.right, r.bottom), drawn = 1;
    if (!but)
    {
        for (b = p->p_box; b; b = b->b_next)
            if (!b->b_selected && interrect(&r, &b->b_rect))
                patcher_selectbox(p, b);
        drawn = 0;
    }
}

void patcher_idle(struct patcher *p, Point pt)
{
    GrafPort *gp;
    t_method dfn = wind_getdrag();
    if (p->p_seltext && t_ptinrect(pt, box_terect(p->p_seltext)))
    {
        editcursor();
        if (!p->p_seltext->b_binbuf)
            bug("teidle");
        te_idle(p->p_seltext->b_un.b_teh);
    }
    else if (p->p_lock)
        arrowcursor();
    else if (dfn && dfn != linedragpoint)
        arrowcursor();
    else
    {
        t_box *b;
        for (b = p->p_box; b; b = b->b_next)
        {
            Rect br, *b9 = box_bigrect(b);
            t_setrect(&br, b9->left, b9->top, b9->right, b9->bottom);
            if (!p->p_lock)
                br.bottom++;
            if (t_ptinrect(pt, &br))
            {
                struct outlet *po;
                if (dfn)
                {
                    connectcursor();
                    return;
                }
                for (po = b->b_ob.o_outlet; po; po = po->o_next)
                {
                    Rect *r = box_outrect(b, po);
                    if (pt.h >= r->left && pt.h < r->right &&
                        pt.v >= r->top && pt.v <= r->bottom)
                    {
                        connectcursor();
                        return;
                    }
                }
                if (pt.h >= br.right - 5 && pt.v >= br.bottom - 8
                    && pt.v < br.bottom - 4)
                    growcursor();
                else
                    arrowcursor();
                return;
            }
        }
    }
    arrowcursor();
}

void patcher_click(struct patcher *p, Point pt, int dclick, int modifiers)
{
    int shift = (modifiers & shiftKey) != 0;
    int command = (modifiers & cmdKey) != 0;
    int alt = (modifiers & optionKey) != 0;
    struct box *b;
    struct patchline *l;
    int x;

    if (modifiers & inMargin)
    {
        /* -1. check if it's in an edit box */
        if (pt.h < BARX && pt.v <= BARY)
        {
            static int warned;
            int which = pt.h >> 4;
            if (which > NBOXTYPE)
                which = NBOXTYPE;
            if (!which)
            {
                if (!p->p_noedit || warned
#ifdef NEXTSTEP
                    ||
                    (NXRunAlertPanel
                     (NIL,
                      "warning -- changes to abstractions don't get saved",
                      NIL, "Cancel", NIL, NIL) == (warned = 1))
#endif
                    )
                    patcher_lock(p, !p->p_lock);
            }
            else if (!p->p_lock)
            {
                patcher_noselect(p);
                (*(patchreslist[which - 1])) (p, (long) (pt.h),
                                              (long) (pt.v),
                                              t_getdeffont());
                if (p->p_cpno >= 0)
                {
                    struct box *bbb = p->p_box;
                    if (!bbb->b_selected)
                        bug("cp");
                    patcher_sendtocp(p, bbb, p->p_cpno, CP_PUT);
                }
                patcher_drag(p, pt, 1);
                patcher_dirty(p, 1);
            }
            p->p_pasted = 0;
        }
        /* ircasm */
        else if (pt.h >= CPSENDX1 && pt.h < CPSENDX2 && pt.v <= BARY)
            patcher_cpbutton(p, pt.h, pt.v);
        return;
    }
    /* 0. alt-click gets help */
    if (alt)
    {
        for (b = p->p_box; b; b = b->b_next)
            if (t_ptinrect(pt, box_bigrect(b)))
            {
                if (ob_messlist(b) == vnewobj_class)
                {
                    t_atom foo;
                    long x1 = 0, x2 = 0;
                    binbuf_getatom(b->b_binbuf, &x1, &x2, &foo);
                    if (foo.a_type == A_SYM)
                        helpstring(foo.a_w.w_sym->s_name);
                    else
                        helpstring(ob_name(b));
                }
                else
                    helpstring(ob_name(b));
                return;
            }
        return;
    }
    /* 1. check if it's in a box */
    for (b = p->p_box; b; b = b->b_next)
    {
        Rect br, *b9 = box_bigrect(b);
        t_setrect(&br, b9->left, b9->top, b9->right, b9->bottom);
        if (!p->p_lock)
            br.bottom++;
        if (t_ptinrect(pt, &br))
        {
            if (p->p_lock || command)
            {
                t_method fn;
                if (/* dclick && */ (fn = egetfn(b, &s_dblclick)) != nullfn)
                    (*fn) (b);
                else
                    box_click(b, pt);
                return;
            }
            else
            {
                struct outlet *po;
                for (po = b->b_ob.o_outlet; po; po = po->o_next)
                {
                    Rect *r = box_outrect(b, po);
                    if (pt.h >= r->left && pt.h < r->right &&
                        pt.v >= r->top && pt.v <= r->bottom)
                    {
                        /* in an outlet; make a line and drag it */
                        void *l, *was = b->b_firstin;
                        patcher_dirty(p, 1);
                        patcher_noselect(p);
                        /* bug fix - unselecting might zap the outlet
                           we just found. If so the object would change. */
                        if (was != b->b_firstin)
                            return;
                        l = patchline(p, b, po);
                        wind_drag(p->p_wind, linedragpoint, (void *) l);
                        return;
                    }
                }
                if (p->p_seltext == b && t_ptinrect(pt, box_terect(b)))
                    te_click(b->b_un.b_teh, pt, shift);
                else
                {
                    if (shift)
                    {
                        if (b->b_selected)
                            patcher_deselectbox(p, b);
                        else
                            patcher_selectbox(p, b);
                    }
                    else
                    {
                        if (!b->b_selected)
                        {
                            patcher_noselect(p);
                            patcher_selectbox(p, b);
                        }
                        if (pt.h >= br.right - 5 && pt.v >= br.bottom - 8
                            && pt.v < br.bottom - 4)
                            patcher_drag2(p, pt);
                        else
                            patcher_drag(p, pt, 0);
                    }
                }
                return;
            }
        }
    }
    p->p_pasted = 0;            /* reset just-pasted flag */
    /* 3. check if it's a line */
    if (!p->p_lock)
        for (l = p->p_line; l; l = l->l_next)
        {
            Rect *r = patchline_rect(l);
            if (ptnearseg
                (pt.h, pt.v, r->left, r->top, r->right, r->bottom))
            {
                if (shift)
                {
                    if (l->l_selected)
                        patcher_deselectline(p, l);
                    else
                        patcher_selectline(p, l);
                }
                else
                {
                    if (!l->l_selected)
                    {
                        patcher_noselect(p);
                        patcher_selectline(p, l);
                    }
                }
                return;
            }
        }
    if (!p->p_lock)
    {
        if (!shift)
            patcher_noselect(p);
        refpoint = pt;
        wind_drag(p->p_wind, dragp3, (void *) p);
    }
}

void patcher_edit(struct patcher *p)
{
    patcher_lock(p, !p->p_lock);
}

patcher_numdrag(struct patcher *p, struct box *b)
{
    if (!p->p_lock)
        return;
    p->p_typeat = b;
    p->p_notypetime = logicaltime + TYPEINTER;
}

void patcher_drawwind(struct patcher *p)
{
    wind_update(p->p_wind);
}

/* one if to draw the margin (nonscrolled part) */
void patcher_update(struct patcher *p, int margin)
{
    struct box *b;
    struct patchline *l;
    struct windpub *w = p->p_wind;

    if (!w->w_vis)
        bug("wind");
    if (margin)
    {
        if (!p->p_topasteboard && !p->p_wind->w_printing)
            patcher_drawbar(p, p->p_lock);
    }
    else if (p->p_topasteboard) /* if actually copying to pasteboard */
    {
        int lockwas = p->p_lock;
        p->p_lock = 1;
        for (b = p->p_box; b; b = b->b_next)
            if (b->b_selected)
            {
                /* remember if it was "drawn" */
                int drawn = b->b_drawn;
                /* lie to the box so it draws an unselected version */
                b->b_selected = 0;
                box_draw(b);
                b->b_selected = 1;
                b->b_drawn = drawn;
            }
        for (l = p->p_line; l; l = l->l_next)
            if (l->l_selected ||
                l->l_box1->b_selected && l->l_box2->b_selected)
            {
                int drawn = l->l_flags & F_DRAWN;
                l->l_selected = 0;
                patchline_draw(l);
                l->l_selected = 1;
                l->l_flags |= drawn;
            }
        p->p_lock = lockwas;
    }
    else
    {
        Rect r;
        wind_getupdaterect(p->p_wind, &r.left, &r.top, &r.right,
                           &r.bottom);
        for (b = p->p_box; b; b = b->b_next)
        {
            if (box_isvisible(b) && interrect(&r, box_bigrect(b)))
                box_draw(b);
        }
        for (l = p->p_line; l; l = l->l_next)
        {
            /* if (patchline_isvisible(l)) */
            if (seghitsrect(l->l_x1, l->l_y1, l->l_x2, l->l_y2, &r))
                patchline_draw(l);
        }
        for (b = p->p_box; b; b = b->b_next)
        {
            if (ISPOT(b) && interrect(&r, box_bigrect(b)))
            {
                t_eraserect(b->b_rect.left, b->b_rect.top,
                            b->b_rect.right, b->b_rect.bottom);
                box_draw(b);
            }
        }
    }
}

patcher_nolspool(struct patcher *p)     /* unspool all lines */
{
    struct patchline *l;
    for (l = p->p_lineupd; l; l = l->l_upd)
        l->l_flags &= ~F_SPOOLED;
    p->p_lineupd = 0;
}

patcher_nobspool(struct patcher *p)     /* unspool all boxes */
{
    struct box *b;
    for (b = p->p_boxupd; b; b = b->b_upd)
        b->b_spooled = 0;
    p->p_boxupd = 0;
}

patcher_bagline(struct patcher *p, int x1, int y1, int x2, int y2)
{
    struct box *b;
    struct patchline *l;
    if (!p->p_wind->w_vis)
        return;
    for (b = p->p_box; b; b = b->b_next)
        if (seghitsrect(x1, y1, x2, y2, box_bigrect(b)))
            patcher_spoolbox(p, b);
    for (l = p->p_line; l; l = l->l_next)
        if (segscross(x1, y1, x2, y2, l->l_x1, l->l_y1, l->l_x2, l->l_y2))
            patcher_spoolline(p, l);
    if (seghitsrect(x1, y1, x2, y2, &barrect))
        patcher_spoolbar(p);
    patcher_spooldraw(p);
}

patcher_spoolbox(struct patcher *p, struct box *b)
{
    if (!p->p_wind->w_vis || b->b_spooled)
        return;
    b->b_upd = p->p_boxupd;
    p->p_boxupd = b;
    b->b_spooled = 1;
    if (!p->p_wantupd)
    {
        qelem_set(p->p_qelem);
        p->p_wantupd = 1;
    }
}

patcher_spoolline(struct patcher *p, struct patchline *l)
{
    if (!p->p_wind->w_vis || (l->l_flags & F_SPOOLED))
        return;
    l->l_upd = p->p_lineupd;
    p->p_lineupd = l;
    l->l_flags |= F_SPOOLED;
    if (!p->p_wantupd)
    {
        qelem_set(p->p_qelem);
        p->p_wantupd = 1;
    }
}

patcher_spoolbar(struct patcher *p)
{
    if (!p->p_wantupd)
    {
        qelem_set(p->p_qelem);
        p->p_wantupd = 1;
    }
    p->p_dirtybar = 1;
}

patcher_unspoolbox(struct patcher *p, struct box *b)
{
    struct box *b2, *b3, stub;
    if (!p->p_wind->w_vis)
        return;
    stub.b_upd = p->p_boxupd;
    for (b2 = &stub; b3 = b2->b_upd;)
    {
        if (b3 == b)
            b2->b_upd = b3->b_upd;
        else
            b2 = b3;
    }
    p->p_boxupd = stub.b_upd;
    b->b_spooled = 0;
}

patcher_unspoolline(struct patcher *p, struct patchline *l)
{
    struct patchline *l2, *l3, stub;
    if (!p->p_wind->w_vis)
        return;
    stub.l_upd = p->p_lineupd;
    for (l2 = &stub; l3 = l2->l_upd;)
    {
        if (l3 == l)
            l2->l_upd = l->l_upd;
        else
            l2 = l3;
    }
    p->p_lineupd = stub.l_upd;
    l->l_flags &= ~F_SPOOLED;
}

patcher_spooldraw(struct patcher *p)
{
    if (!p->p_wind->w_vis)
        return;
    if (!p->p_wantupd)
    {
        qelem_set(p->p_qelem);
        p->p_wantupd = 1;
    }
}

void patcher_draw(struct patcher *p)
{
    struct box *b;
    struct patchline *l;
    GrafPort *gp;
    if (!p->p_wind->w_vis)
        return;
    gp = patcher_setport(p);
    for (b = p->p_boxupd; b; b = b->b_upd)
        box_draw(b);
    for (l = p->p_lineupd; l; l = l->l_upd)
        patchline_draw(l);
    if (p->p_dirtybar && !p->p_noedit)
        patcher_drawbar(p, p->p_lock);
    patcher_nobspool(p);
    patcher_nolspool(p);
    p->p_dirtybar = 0;
    p->p_wantupd = 0;
    t_resetport(gp);
}

/* tell the patcher that it's actually a box in some other
 * patcher.  We then have to go through all the "inlet" and
 * "outlet" boxes and draw corresponding inlets and outlets
 * in the new box. At this point the boxes' vpin and vpout
 * fields are replaced by the vinlet and voutlet routines.
 */

void patcher_imbed(struct patcher *p, void *x)
{
    struct box *b;
    if (p->p_vnewobj)
        NONO("patcher: already in a box");
    if (ob_messlist(x) != vnewobj_class)
        NONO("patcher_box: not newobj");
    p->p_vnewobj = x;
    p->p_wind->w_refcount = 1;
    for (b = p->p_box; b; b = b->b_next)
    {
        if (b->b_inlet)
            box_inlet(x, b->b_un.b_vpin);
        else if (b->b_outlet)
            box_outlet(x, b->b_un.b_vpout);
    }
    if (!p->p_noedit)
        wind_issubpatch(p->p_wind);
}

void *patcher_vnewobj(struct patcher *p)
{
    return (p->p_vnewobj);
}

void patcher_invis(struct patcher *p)
{
    if (p->p_wind->w_vis)
    {
        struct box *b;
        if (!p->p_lock)
            patcher_lock(p, 1);
        for (b = p->p_box; b; b = b->b_next)
        {
            box_invis(b);
            if (p->p_cpno >= 0 && p->p_cpno < h_nproc)
                (*egetfn(b, &s__active)) (b, 0);
        }
        qelem_set(p->p_qelem);
        p->p_wantupd = 0;
    }
}

void patcher_vis(struct patcher *p)
{
    if (!p->p_wind->w_vis)
    {
        struct box *b;
        void *v;
        GrafPort *gp;
        struct patchresource *pr;
        long x = SIZE1 - 1;
        int count = 0;
        wind_visnoupdate(p->p_wind);
        gp = patcher_setport(p);
        for (b = p->p_box; b; b = b->b_next)
        {
            if (!(count++ & 3) && t_freemem() < 2048)
            {                   /* check every 4 boxes */
                struct box *b2;
                /* not enough mem: invis them all back */
                for (b2 = p->p_box; b2 != b; b2 = b2->b_next)
                    box_invis(b2);
                /* invis the winow back */
                wind_invis(p->p_wind);
                memouch();
                goto shit;
            }
            box_vis(b);
            if (p->p_cpno >= 0 && p->p_cpno < h_nproc)
                (*egetfn(b, &s__active)) (b, 1);
        }
        patcher_drawwind(p);
        patcher_span(p);
      shit:
        t_resetport(gp);
    }
    else
        wind_vis(p->p_wind);
}

void patcher_visparent(struct patcher *p)
{
    t_box *b = p->p_vnewobj;
    if (b)
        patcher_vis(b->b_patcher);
}

void patcher_front(struct patcher *p)
{
    patcher_vis(p);
}

void patcher_dblclick(struct patcher *p)
{
    patcher_vis(p);
}

#ifdef XMAX
void patcher_chkscroll(struct patcher *p)
{
    int offleft, offright, offtop, offbottom;
    struct windpub *w = p->p_wind;
    offleft = 4 - p->p_span.left;
    offright = 4 + SBARWIDTH + p->p_span.right + w->w_x1 - w->w_x2;
    offtop = 4 + BARY - p->p_span.top;
    offbottom = 4 + SBARWIDTH + p->p_span.bottom + w->w_y1 - w->w_y2;
    if (offright < 0)
        offright = 0;
    if (offbottom < 0)
        offbottom = 0;
    if (offleft < 0)
        offleft = 0;
    if (offtop < 0)
        offtop = 0;
    wind_setsmax(p->p_wind, offright + offleft, offbottom + offtop);
    wind_setsval(p->p_wind, offleft, offtop);
    p->p_scroll.h = w->w_xoffset;
    p->p_scroll.v = w->w_yoffset;
}

#if OLD
void patcher_scroll(p)
struct patcher *p;
{
    struct windpub *w = p->p_wind;
    Rect r, currentBar, wholeBarTop, rightOfBar;
    RgnHandle oldClip, scrollRgn, rightOfBarRgn, theBarRgn;
    int dx = p->p_scroll.h - w->w_xoffset,
        dy = p->p_scroll.v - w->w_yoffset;

    {
        struct box *b;
        struct patchline *l;
        if (!dx && !dy)
            return;
        for (b = p->p_box; b; b = b->b_next)
        {
            t_offsetrect(&b->b_rect, dx, dy);
            if (b->b_binbuf)
                fixteh(b);
        }
        for (l = p->p_line; l; l = l->l_next)
            l->l_x1 += dx, l->l_x2 += dx, l->l_y1 += dy, l->l_y2 += dy;
        t_offsetrect(&p->p_span, dx, dy);
    }
    patcher_setport(p);
    oldClip = NewRgn();
    scrollRgn = NewRgn();
    theBarRgn = NewRgn();
    rightOfBarRgn = NewRgn();
    GetClip(oldClip);
    t_setrect(&r, 0, BARY, w->w_x2 - w->w_x1, w->w_y2 - w->w_y1);
    t_setrect(&wholeBarTop, 0, 0, (w->w_x2 - w->w_x1) - SBARWIDTH, BARY);
    t_setrect(&currentBar, 0, 0, p->p_lock ? 16 : BARX, BARY);
    t_setrect(&rightOfBar, currentBar.right, 0,
              (w->w_x2 - w->w_x1) - SBARWIDTH, BARY);
    RectRgn(theBarRgn, &currentBar);
    DiffRgn(oldClip, theBarRgn, theBarRgn);
    SetClip(theBarRgn);
    ScrollRect(&r, dx, dy, scrollRgn);
    RectRgn(rightOfBarRgn, &rightOfBar);
    UnionRgn(rightOfBarRgn, scrollRgn, scrollRgn);
    SetClip(scrollRgn);
    EraseRect(&rightOfBar);
    patcher_drawwind(p);
    SetClip(oldClip);
    DisposeRgn(scrollRgn);
    DisposeRgn(oldClip);
    DisposeRgn(theBarRgn);
    DisposeRgn(rightOfBarRgn);
    patcher_chkscroll(p);
}
#endif                          /* OLD */
#endif                          /* XMAX */

patcher_span(struct patcher *p)
{
    int lox, hix, loy, hiy;
    if (!p->p_box)
        lox = hix = loy = hiy = 5 + BARY;
    else
    {
        struct box *b;
        hix = hiy = -32767;
        lox = loy = 32767;
        for (b = p->p_box; b; b = b->b_next)
        {
            if (b->b_rect.left < lox)
                lox = b->b_rect.left;
            if (b->b_rect.right > hix)
                hix = b->b_rect.right;
            if (b->b_rect.top < loy)
                loy = b->b_rect.top;
            if (b->b_rect.bottom > hiy)
                hiy = b->b_rect.bottom;
        }
    }
    p->p_span.left = lox;
    p->p_span.right = hix;
    p->p_span.top = loy;
    p->p_span.bottom = hiy;
    wind_setscrollrect(p->p_wind, p->p_span.left, p->p_span.top,
                       p->p_span.right, p->p_span.bottom);
}

void patcher_scroll(struct patcher *p)
{
#if 0
    /* deal with this later ... */
    struct windpub *w = p->p_wind;
    Rect r, currentBar, wholeBarTop, rightOfBar;
    RgnHandle oldClip, scrollRgn, rightOfBarRgn, theBarRgn;
    int dx = p->p_scroll.h - w->w_xoffset,
        dy = p->p_scroll.v - w->w_yoffset;

    {
        struct box *b;
        struct patchline *l;
        if (!dx && !dy)
            return;
        for (b = p->p_box; b; b = b->b_next)
        {
            t_offsetrect(&b->b_rect, dx, dy);
            if (b->b_binbuf)
                fixteh(b);
        }
        for (l = p->p_line; l; l = l->l_next)
            l->l_x1 += dx, l->l_x2 += dx, l->l_y1 += dy, l->l_y2 += dy;
        t_offsetrect(&p->p_span, dx, dy);
    }
    patcher_setport(p);
    oldClip = NewRgn();
    scrollRgn = NewRgn();
    theBarRgn = NewRgn();
    rightOfBarRgn = NewRgn();
    GetClip(oldClip);
    t_setrect(&r, 0, BARY, w->w_x2 - w->w_x1, w->w_y2 - w->w_y1);
    t_setrect(&wholeBarTop, 0, 0, (w->w_x2 - w->w_x1) - SBARWIDTH, BARY);
    t_setrect(&currentBar, 0, 0, p->p_lock ? 16 : BARX, BARY);
    t_setrect(&rightOfBar, currentBar.right, 0,
              (w->w_x2 - w->w_x1) - SBARWIDTH, BARY);
    RectRgn(theBarRgn, &currentBar);
    DiffRgn(oldClip, theBarRgn, theBarRgn);
    SetClip(theBarRgn);
    ScrollRect(&r, dx, dy, scrollRgn);
    RectRgn(rightOfBarRgn, &rightOfBar);
    UnionRgn(rightOfBarRgn, scrollRgn, scrollRgn);
    SetClip(scrollRgn);
    EraseRect(&rightOfBar);
    patcher_drawwind(p);
    SetClip(oldClip);
    DisposeRgn(scrollRgn);
    DisposeRgn(oldClip);
    DisposeRgn(theBarRgn);
    DisposeRgn(rightOfBarRgn);
    patcher_chkscroll(p);
#endif
}

void patcher_font(struct patcher *p, int n)     /* called from window to set font size */
{
    if (n < 0)
    {                           /* FONTBOMB */
        t_box *b;
        GrafPort *gp;
#ifdef NEXTSTEP
        if (n == -1 && NXRunAlertPanel(NIL,
                                       "set all text (including in subpatchers) to %d points?",
                                       NIL, "Cancel", NIL,
                                       t_realfontsize(t_getdeffont())) !=
            1)
            return;
#endif
        gp = patcher_setport(p);
        for (b = p->p_box; b; b = b->b_next)
        {
            b->b_fsize = t_getdeffont();
            if (gp)
            {
                box_erase(b);
                box_invis(b);
                box_vis(b);
            }
            if (b->b_firstin
                && ob_messlist(b->b_firstin) == patcher_class
                && !patcher_isclass(b->b_firstin))
                patcher_font(b->b_firstin, -2);
        }
        if (gp)
            t_resetport(gp);
    }
    else if (p->p_nselect)
    {
        struct box *b;
        struct patchline *l;
        for (b = p->p_box; b; b = b->b_next)
        {
            if (b->b_selected)
            {
                b->b_fsize = n;
                box_erase(b);
                box_invis(b);
                box_vis(b);
            }
        }
        for (l = p->p_line; l; l = l->l_next)
            if (l->l_box1->b_selected)
                patchline_newends(l);
    }
    else
        t_setdeffont(n);
}

void patcher_stretch(struct patcher *p, int squeeze)    /* "grow" the patch, recursively */
{
    t_box *b;
    GrafPort *gp = patcher_setport(p);
    int factor = (squeeze ? 9 : 11);
    for (b = p->p_box; b; b = b->b_next)
    {
        int x1 = b->b_rect.left * factor / 10;
        int x2 = b->b_rect.right * factor / 10;
        int y1 = b->b_rect.top * factor / 10;
        int y2 = b->b_rect.bottom * factor / 10;
        box_move(b, x1, y1);
        if (b->b_binbuf)
        {
            box_size(b, x2 - x1, y2 - y1);
            if (b->b_firstin && ob_messlist(b->b_firstin) == patcher_class
                && !patcher_isclass(b->b_firstin))
                patcher_stretch(b->b_firstin, squeeze);
        }
    }
    if (gp)
        t_resetport(gp);
}

void patcher_filename(struct patcher *p, char *name, t_symbol *vol,
                      int bin)
{
    wind_filename(p->p_wind, name, vol, bin);
}

void patcher__help()
{
    helpstring("jimmies");
    helpstring("lib");
    helpstring("intro");
}

void helpstring(char *s)
{
    void *lowload(char *name, t_symbol * volume, int ac, struct atom *av,
                  int couldedit);
    char buf2[4096];
    char buf1[4096], *s2, *rindex(const char *, int);
    t_symbol *t_gethelppath(), *helppath;
    t_symbol *t_getpath(), *pathwas = t_getpath();
    void *x;
    if (s2 = rindex(s, '/'))
    {
        strncpy(buf1, s, 1 + (s2 - s));
        s = s2 + 1;
    }
    else
        buf1[0] = 0;
    if (strlen(s) >= 4 && !strcmp(s + (strlen(s) - 4), ".pat"))
        sprintf(buf2, "help-%s", s);
    else
        sprintf(buf2, "help-%s.pat", s);
    strcat(buf1, buf2);

    loadbang__doit(0);
    x = lowload(buf1, defvolume, 0, NIL, 1);

    if (!x && strlen(buf1) >= 4
        && !strcmp(buf1 + (strlen(buf1) - 4), ".pat"))
    {
        /* If that didn't happen, try to bash ".pat" to ".abs" */
        strcat(buf1 + (strlen(buf1) - 4), ".abs");
        x = lowload(buf1, defvolume, 0, NIL, 1);
    }
    if (!x)
    {
        helppath = t_gethelppath();
        if (!*helppath->s_name)
        {
            strcpy(buf1, h_getftsdir());
            strcat(buf1, "/help");
            helppath = gensym(buf1);
        }
        x = lowload(buf2, helppath, 0, NIL, 1);
    }
    if (!x && strlen(buf2) >= 4
        && !strcmp(buf2 + (strlen(buf2) - 4), ".pat"))
    {
        strcat(buf2 + (strlen(buf2) - 4), ".pat");
        x = lowload(buf2, defvolume, 0, NIL, 1);
    }
    if (x)
    {
        (*(egetfn(x, gensym("front")))) (x);
    }
    else
        binbuf_ouch("%s: can't open", s);
    loadbang__doit(1);
    t_setpath(pathwas);
}

patcher_isclass(struct patcher *p)
{
    return (p->p_noedit);
}

patcher_setclass(struct patcher *p)
{
    struct box *b;
    p->p_noedit = 1;
    wind_unfilename(p->p_wind);
    for (b = p->p_box; b; b = b->b_next)
        if (b->b_firstin && ob_messlist(b->b_firstin) == patcher_class)
            patcher_setclass(b->b_firstin);
}

ispatcher(struct object *x)
{
    return (ob_messlist(x) == patcher_class);
}

#define OKITEM 1
#define CANCELITEM 2
#define TITLEITEM 3
#define SIZEITEM 4

void patcher_dialog(struct patcher *p)
{
    /* later ...
       DialogRecord dog;
       short hit = 2001;
       char stouched = 0;
       char buf[50];
       struct box *b;
       int foo = 0;
       long nsize;
       for (b = p->p_box; b; b = b->b_next)
       {
       if (b->b_selected && ISPOT(b))
       {
       foo = vslider_getsize(b);
       break;
       }
       }
       GetNewDialog(1002, &dog, -1L);
       sprintf(buf, "%d", foo);
       settextitem(&dog, SIZEITEM, buf);
       SelIt_text(&dog, SIZEITEM, (short)0, (short)32767);
       while (hit != OKITEM)
       {
       ModalDialog(NIL, &hit);
       if (hit == SIZEITEM) stouched = 1;
       else if (hit == CANCELITEM) goto closeit;
       }
       if (stouched);
       {
       gettextitem(&dog, SIZEITEM, buf);
       if (sscanf(buf, "%ld", &nsize) < 1)
       {
       ouch("bad size: ", buf);
       goto closeit;
       }
       if (nsize < 1) nsize = 1;
       else if (nsize > 5000) nsize = 5000;
       CloseDialog(&dog); 
       for (b = p->p_box; b; b = b->b_next)
       {
       if (b->b_selected && ISPOT(b))
       vslider_size(b, nsize);
       }
       patcher_dirty(p, 1);
       return;
       }
       closeit:
       CloseDialog(&dog);
     */
}

void *patcher_pop(struct patcher *p, long int n)
{
    patcher_becomecurrent(p->p_pushed);
    if (n && !memislow)
        patcher_vis(p);
    newest = p;
    return newest;
}

char *attostr();
/* routine to set patcher title */
void patcher_patcher(struct patcher *p, struct symbol *s, int ac,
                     struct atom *av)
{
    wind_settitle(p->p_wind, (ac
                              ? (av->a_type == A_SYM
                                 ? av->a_w.w_sym->s_name
                                 : attostr(av->a_type, &av->a_w))
                              : "sub patch"));
}

static int patcher_isabstract;  /* true if currently loading an abstraction */

patcher_setabst(int n)
{
    int was = patcher_isabstract;
    patcher_isabstract = n;
    return (was);
}

/* set #P to self; set volume both here and on CP.  (If p == 0, 
   unset #P, etc.) */
patcher_becomecurrent(struct patcher *p)
{
    if (p)
    {
        t_setpath(p->p_searchpath);
        if (s__Pat.s_thing != (struct object *) p)
        {
            s__Pat.s_thing = (struct object *) p;
            if (p->p_cpno >= 0 && p->p_cpno < h_nproc)
                h_vmess(&p->p_cpno, &s_int, "l", 1);
        }
    }
    else
    {
        struct patcher *p2 = (struct patcher *) (s__Pat.s_thing);
        if (p2 && p2->p_cpno >= 0 && p2->p_cpno < h_nproc)
            h_vmess(&p2->p_cpno, &s_int, "l", 0);
        s__Pat.s_thing = 0;
    }
}

/* <a> if deleting the patcher currently searched, disable find-again */
extern struct patcher *findpat;

void patcher_ff(struct patcher *p)
{
    struct box *b;
    struct patchline *l;
    patcher_invis(p);
    wind_invis(p->p_wind);
    while (l = p->p_line)
        freeobject((t_object *) l);
    for (b = p->p_box; b; b = b->b_next)
        box_free(b);
    if (p->p_cpno >= 0)
        patcher_setchildcp(p, -1);
    freeobject((t_object *) p->p_wind);
    qelem_free(p->p_qelem);
    if (s__Pat.s_thing == (struct object *) p)
        patcher_becomecurrent(NIL);
    if (findpat == p)
        findpat = 0;
}

void patcher_setup()
{
    c_new(&s_patcher, patcher_ff, sizeof(t_patcher), 0, 0);
    c_addmess(patcher_connect, &s_connect, A_LONG, A_LONG, A_LONG, A_LONG,
              0);
    c_addmess(patcher_button, &s_button, A_GIMME, 0);
    c_addmess(patcher_toggle, &s_toggle, A_GIMME, 0);
    c_addmess(patcher_slider, &s_slider, A_GIMME, 0);
    c_addmess(patcher_message, &s_message, A_GIMME, 0);
    c_addmess(patcher_newobj, &s_newobj, A_GIMME, 0);
    c_addmess(patcher_newex, &s_newex, A_GIMME, 0);
    c_addmess(patcher_comment, &s_comment, A_GIMME, 0);
    c_addmess(patcher_number, &s_number, A_GIMME, 0);
    c_addmess(patcher_flonum, &s_flonum, A_GIMME, 0);
    c_addmess(patcher_inlet, &s_inlet, A_GIMME, 0);
    c_addmess(patcher_outlet, &s_outlet, A_GIMME, 0);
    c_addmess(patcher_front, &s_front, 0);
    c_addmess((t_method) patcher_pop, &s_pop, A_DEFLONG, 0);
    c_addmess(patcher_patcher, &s_patcher, A_GIMME, 0);

    c_addmess(patcher_click, &s_click, A_CANT, 0);
    c_addmess(patcher_key, &s_key, A_CANT, 0);
    c_addmess(patcher_activate, &s_activate, A_CANT, 0);
    c_addmess(patcher_update, &s_update, A_CANT, 0);
    c_addmess(patcher_saveto, &s_saveto, A_CANT, 0);
    c_addmess(patcher_close, &s_close, A_CANT, 0);
    c_addmess(patcher_clear, &s_clr, A_CANT, 0);
    c_addmess(patcher_cut, &s_cut, A_CANT, 0);
    c_addmess(patcher_copy, &s_copy, A_CANT, 0);
    c_addmess(patcher_paste, &s_paste, A_CANT, 0);
    c_addmess(patcher_dup, &s_dup, A_CANT, 0);
    c_addmess(patcher_undo, &s_undo, A_CANT, 0);
    c_addmess(patcher_idle, &s_idle, A_CANT, 0);
    c_addmess(patcher_dialog, &s_dialog, A_CANT, 0);
    c_addmess(patcher_invis, &s_invis, A_CANT, 0);
    c_addmess(patcher_chkmenu, &s_chkmenu, A_CANT, 0);
    c_addmess(patcher_dblclick, &s_dblclick, A_CANT, 0);
#ifdef XMAX
    c_addmess(patcher_scroll, &s_scroll, A_CANT, 0);
    c_addmess(patcher_chkscroll, &s_wsize, A_CANT, 0);
#endif
    c_addmess(patcher_save, &s_save, A_CANT, 0);
    c_addmess(patcher_imbed, &s_imbed, A_OBJ, 0);
    c_addmess(patcher_filename, &s_filename, A_CANT, 0);
    c_addmess(patcher_font, &s_font, A_CANT, 0);
    c_addmess(patcher_edit, &s_edit, A_CANT, 0);
    c_addmess(patcher_lineup, &s_lineup, A_CANT, 0);
    c_addmess(patcher_fixwidth, &s_fixwidth, A_CANT, 0);
    c_addmess(patcher_setcp, &s_setcp, A_CANT, 0);
    c_addmess(patcher_stretch, &s_stretch, A_CANT, 0);
#ifndef XMAX
    c_addmess(patcher_restartfts, gensym("restart_fts"), A_CANT, 0);
#endif
    c_addmess(patcher_selectall, gensym("selectall"), A_CANT, 0);
}

void *patcher_new(int x1, int y1, int x2, int y2, int frommenu, int cpno)
{
    void *v;
    Rect r;

    struct patcher *p;
    if (memislow)
        return (botcher());
    p = (struct patcher *) obj_new((t_messlist **) & patcher_class,
                                   patcher_setup);
    p->p_qelem = qelem_new(p, patcher_draw);    /* update clock */

    p->p_vol = defvolume;
    p->p_searchpath = t_getpath();
    p->p_lock = !frommenu;
    p->p_dirtybar = 0;
    p->p_span.left = p->p_span.right =
        p->p_span.top = p->p_span.bottom = 0;
    p->p_scroll.h = p->p_scroll.v = 0;
    p->p_seltext = 0;
    p->p_box = 0;               /* clear box list */
    p->p_line = 0;              /* and line list */
    p->p_boxupd = 0;            /* clear update lists */
    p->p_lineupd = 0;
    p->p_wantupd = 0;           /* when to redraw */
    p->p_vnewobj = 0;
    p->p_instr = 0;
    p->p_pasted = 0;
    p->p_nselect = 0;
    p->p_noedit = 0;
    p->p_typeat = 0;
    p->p_topasteboard = 0;
    p->p_pushed = s__Pat.s_thing;
    p->p_wind = wind_new(p, x1, y1, x2, y2,
                         WCLOSE | WSCROLLX | WSCROLLY | WGROW);
    wind_setscrollparams(p->p_wind, 0, BARY, 0, 0);
    p->p_cpno = -1;
    /* if you're not part of an abstraction, take CP number seriously;
       otherwise it will later be set to that of the owning patcher. */
    if (!patcher_isabstract)
        patcher_setchildcp(p, cpno);
    if (frommenu)
    {
        wind_setuntitled(p->p_wind);
        patcher_vis(p);
    }
    patcher_becomecurrent(p);
    return (p);
}

void *vpatcher(int x1, int y1, int x2, int y2, int cp)
{
    return patcher_new(x1, y1, x2, y2, 0, cp);
}

/* menu version */
void *patcher()
{
    return patcher_new(100, 100, 500, 500, 1, 0);
}
