#ifndef lint
static char rcsid[] = "$Revision: 1.12 $ IRCAM $Date: 93/12/21 16:06:15 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.12 $ IRCAM $Date: 93/12/21 16:06:15 $
 *
 * FTS by Miller Puckette
 *
 */


#ifdef XMAX
#include <stdio.h>
#endif

#include "m_mess.h"
#include "t_mac.h"
#include "t_wind.h"
#include "p_patcher.h"
#include "m_inout.h"
#include "p_patcher2.h"

extern int h_nproc;
extern struct symbol s_, s_imbed, s_update, s_free, s_setparentcp,
    s__active;
extern Rect barrect;
extern void *vnumber_class;
extern char lockout;
void patchline_setcp(struct patchline *l, int n);
GrafPort *patcher_setport(struct patcher *p);

int box_correctheight(struct box *b);
int box_numheight(struct box *b);
int box_toed(struct box *b);
int patchline_newends(struct patchline *l);
int box_moveoutlet(struct box *b, struct outlet *po);
int box_moveinlet(struct box *b, struct inlet *pi);
int box_io(struct box *b);
int box_inlet(struct box *b, struct inlet *pi);
int box_inrelink(struct box *b, struct inlet *pi);
int box_outlet(struct box *b, struct outlet *po);
int box_outrelink(struct box *b, struct outlet *po);
int patchline_erase(struct patchline *l);
int patchline_spool(struct patchline *l);
int patchline_index2(struct patchline *l);
int patchline_index1(struct patchline *l);

box_print(struct box *b)
{
    post("box at (%ld, %ld)", b->b_rect.top, b->b_rect.left);
}

box_click(struct box *b, Point pt)
{
    boxcheck(b, "box_click");
    (*(egetfn(b, &s_click))) (b, pt);
}

Rect *box_terect(struct box *b)
{
    static Rect r;
    int inset = b->b_inset;
    boxcheck(b, "box_terect");
    r.left = b->b_rect.left + 1;
    r.top = b->b_rect.top + inset;
    r.right = b->b_rect.right - 1;
    r.bottom = b->b_rect.bottom - inset;
    return (&r);
}

TEHandle mkteh(struct box *b)
{
    Rect *r = box_terect(b);
    Rect r2;
    t_textsize(b->b_fsize);
    /* post("mkteh %d %d %d %d", r->left, r->top-2, r->right, r->bottom); */
    t_setrect(&r2, r->left, r->top - 2, r->right, r->bottom);
    return (te_new(&r2, r));
}

fixteh(struct box *b)
{
    TEHandle t = b->b_un.b_teh;
    Rect *r = box_terect(b);
    Rect r2;
    t_setrect(&r2, r->left, r->top - 2, r->right, r->bottom);
    te_setdest(t, &r2);
    te_setview(t, r);
}

box_vis(struct box *b)
{
    int ret = 0;
    t_method fn;
    t_textfont(3);
    t_textsize(b->b_fsize);
    if (b->b_binbuf)
    {
        long size;
        int n;
        char **shit = (char **) t_newhandle(0L);
        b->b_un.b_teh = mkteh(b);
        if (binbuf_totext(b->b_binbuf, shit, &size))
            ret = 1;
        te_set(b->b_un.b_teh, shit, size);
        box_correctheight(b);
    }
    else if (ISNUM(b))
    {
        box_numheight(b);
    }
    return (ret);
}

box_invis(struct box *b)
{
    if (b->b_binbuf)
    {
        te_free(b->b_un.b_teh);
        b->b_un.b_teh = 0;
    }
}

box_isvisible(struct box *b)
{
    struct patcher *p = b->b_patcher;
    Rect *r;
    if (!p->p_wind->w_vis)
        return 0;
    r = &b->b_rect;
    return 1;
}

/* warn patcher that something inside box has been erased */
box_inval(struct box *b)
{
    struct patcher *p = b->b_patcher;
    struct box *b2;
    struct patchline *l;
    Rect r;
    r = b->b_rect;
    if (!p->p_lock)
        r.bottom += POY - 2;
    for (l = p->p_line; l; l = l->l_next)
        if (seghitsrect(l->l_x1, l->l_y1, l->l_x2, l->l_y2, &r))
            patcher_spoolline(p, l);
    if (!p->p_lock)
        r.top -= POY - 2;
    for (b2 = p->p_box; b2; b2 = b2->b_next)
        if (interrect(&r, &b2->b_rect) && b2 != b)
            patcher_spoolbox(p, b2);
    if (interrect(&r, &barrect))
        patcher_spoolbar(p);
}

box_spool(struct box *b)        /* ask patcher to draw the box */
{
    patcher_spoolbox(b->b_patcher, b);
}

box_erase(struct box *b)        /* erase the box (and inval it) */
{
    GrafPort *gp;
    struct patcher *p;
    struct box *b2;
    struct patchline *l;
    Rect *r;
    p = b->b_patcher;
    if (!p->p_wind->w_vis)
        return;
    if (!b->b_drawn)
        return;
    boxcheck(b, "box_erase");
    gp = patcher_setport(p);
    r = box_bigrect(b);
    t_eraserect(r->left, r->top, r->right, r->bottom);
    box_inval(b);
    box_spool(b);
    b->b_drawn = 0;
    t_resetport(gp);
}

Rect *box_outrect(struct box *b, struct outlet *po)
{
    static Rect r;
    int x = b->b_rect.left + po->o_xloc;
    int y = b->b_rect.bottom - 2;
    t_setrect(&r, x, y, x + POX, y + POY);
    return (&r);
}

box_draw(struct box *b)
{
    struct patcher *p = b->b_patcher;
    struct outlet *po;
    struct inlet *pi;
    Rect *r;
    if (!p->p_wind->w_vis)
        return;
    r = &b->b_rect;
    if (b->b_selected)
        t_eraserect(r->left, r->top, r->right, r->bottom);
    if (b->b_binbuf && !p->p_topasteboard)
        te_update(b->b_un.b_teh);
    for (po = b->b_ob.o_outlet; po; po = po->o_next)
    {
        if (p->p_lock)
        {
            int x = b->b_rect.left + po->o_xloc, y = b->b_rect.bottom - 2;
            t_line(x, y, x + POX - 1, y);
        }
        else
        {
            Rect *r2 = box_outrect(b, po);
            t_paintrect(r2->left, r2->top, r2->right, r2->bottom);
        }
    }
    if (b->b_drawfirstin)
    {
        int x = b->b_rect.left, y = b->b_rect.top + 1;
        t_line(x, y, x + POX - 1, y);
    }
    for (pi = b->b_ob.o_inlet; pi; pi = pi->i_next)
    {
        int x = b->b_rect.left + pi->i_xloc, y = b->b_rect.top + 1;
        t_line(x, y, x + POX - 1, y);
    }
    if (!p->p_lock)
        t_paintrect(b->b_rect.right - 4, b->b_rect.bottom - 7,
                    b->b_rect.right, b->b_rect.bottom - 4);
    (*(getfn(b, &s_update))) (b);
    if (b->b_selected)
    {
        t_invertrect(r->left, r->top, r->right, r->bottom);
        if (p->p_seltext)
        {
            Rect *br = te_viewrect(b->b_un.b_teh);
            t_invertrect(br->left, br->top, br->right, br->bottom);
        }
    }
    if (b->b_outline)
        t_framerect(r->left, r->top, r->right, r->bottom);
    b->b_drawn = 1;
}

box_move(struct box *b, int x, int y)
{
    struct patchline *l;
    struct windpub *w;
    int dx, dy;
    struct patcher *p;
    boxcheck(b, "box_move");

    p = b->b_patcher;
    w = p->p_wind;
    dx = x - b->b_rect.left;
    dy = y - b->b_rect.top;
    if (!(dx || dy))
        return;
    box_erase(b);
    t_offsetrect(&b->b_rect, dx, dy);
    for (l = p->p_line; l; l = l->l_next)
    {
        if (l->l_box1 == b || l->l_box2 == b)
            patchline_newends(l);
    }
    if (b->b_binbuf && p->p_wind->w_vis)
        fixteh(b);
    /* if the patcher has an associated box, and if this box is an
       inlet or outlet, we have to move it in the associated box */
    if (p->p_vnewobj)
    {
        if (b->b_outlet)
            box_moveoutlet(p->p_vnewobj, b->b_un.b_vpout);
        else if (b->b_inlet)
            box_moveinlet(p->p_vnewobj, b->b_un.b_vpin);
    }
}

box_size(struct box *b, int x, int y)
{
    struct outlet *po;
    struct inlet *pi;
    struct patchline *l;
    int n;
    Rect *r = &b->b_rect;
    boxcheck(b, "box_width");
    box_erase(b);
    /* if (b->b_binbuf && b->b_patcher->p_wind->w_vis) fixteh(b); */
    r->right = r->left + x;
    r->bottom = r->top + y;
    if (b->b_binbuf && b->b_patcher->p_wind->w_vis)
    {
        fixteh(b);
        box_correctwidth(b);
        box_correctheight(b);
    }
    box_io(b);
    for (l = b->b_patcher->p_line; l; l = l->l_next)
        if (l->l_box1 == b || l->l_box2 == b)
            patchline_newends(l);
}

box_checktextheight(struct box *b)
{
    TEHandle teh = b->b_un.b_teh;
    if (!teh)
        return;
    if (teh && te_height(teh) + 2 * b->b_inset
        != b->b_rect.bottom - b->b_rect.top)
        box_correctheight(b);
}

box_correctheight(struct box *b)
{
    int margin;
    TEHandle teh;
    Rect r;
    int newbottom, height, lines;
    struct patcher *p = b->b_patcher;
    struct patchline *l;
    if (!b->b_patcher->p_wind->w_vis)
        return;
    if (!b->b_binbuf)
        return;
    teh = b->b_un.b_teh;
    margin = b->b_inset;
    height = te_height(teh);
    newbottom = height + 2 * margin + b->b_rect.top;
    if (newbottom == b->b_rect.bottom)
        return;
    box_erase(b);
    b->b_rect.bottom = newbottom;
    fixteh(b);
    for (l = p->p_line; l; l = l->l_next)
        if (l->l_box1 == b)
            patchline_newends(l);
}

Rect *box_bigrect(struct box *b)
{
    boxcheck(b, "box_rect");
    if (b->b_patcher->p_lock)
        return (&b->b_rect);
    else
    {
        static Rect r;
        Rect *r2 = &b->b_rect;
        t_setrect(&r, r2->left, r2->top, r2->right, r2->bottom + POY - 2);
        return (&r);
    }
}

box_binbuf(struct box *b, int inset, int fsize)
{
    GrafPort *gp;
    b->b_inset = inset;
    b->b_binbuf = binbuf_new();
    b->b_fsize = fsize;
    if (gp = patcher_setport(b->b_patcher))
    {
        b->b_un.b_teh = mkteh(b);
        box_correctheight(b);
        t_resetport(gp);
    }
}

box_num(struct box *b, int fsize)
{
    void *gp;
    b->b_fsize = fsize;
    if (gp = patcher_setport(b->b_patcher))
    {
        box_numheight(b);
        t_resetport(gp);
    }
}

box_numheight(struct box *b)
{
    int h = t_deffontheightfor(b->b_fsize);
    b->b_rect.bottom = b->b_rect.top + h + 3;
    vnumber_fsize(b, b->b_fsize, h);
}

#define BS 512
box_settext(struct box *b, int argc, struct atom *argv)
{
    if (!b->b_binbuf)
        bug("box_settext");
    binbuf_set(b->b_binbuf, NIL, argc, argv);
    if (b->b_patcher->p_wind->w_vis)
        box_toed(b);
}

box_appendtext(struct box *b, int argc, struct atom *argv)
{
    if (!b->b_binbuf)
        bug("box_appendtext");
    binbuf_append(b->b_binbuf, NIL, argc, argv);
    if (b->b_patcher->p_wind->w_vis)
        box_toed(b);
}

box_toed(struct box *b)
{
    TEHandle teh = b->b_un.b_teh;
    GrafPort *gp = patcher_setport(b->b_patcher);
    long size;
    char **shit = (char **) t_newhandle(0L);
    binbuf_totext(b->b_binbuf, shit, &size);
    te_set(teh, shit, size);
    if (b->b_drawn)
        box_spool(b);
    if (gp)
    {
        box_correctwidth(b);
        box_correctheight(b);
    }
    t_resetport(gp);
}

box_setinlet(struct box *b, struct object *x)
{
    t_method fn;
    struct outlet *po, *outwas = b->b_ob.o_outlet;
    struct inlet *pi, *inwas = b->b_ob.o_inlet;
    int which, wasprimary = (b->b_drawfirstin) != 0, nline = 0;
    struct patcher *p = b->b_patcher;
    box_erase(b);
    b->b_drawfirstin = 0;
    b->b_firstin = x;
    b->b_ob.o_outlet = 0;
    b->b_ob.o_inlet = 0;
    if (x)
    {
        if ((fn = egetfn(x, &s_imbed)) != nullfn)
            (*fn) (x, b);
        else
        {
            /* if the box should have a primary inlet set the flag */
            if (!ob_class(x)->c_noinlet)
                b->b_drawfirstin = 1;
            box_io(b);
        }
    }
}

/* calculate the relative locations of an object's inlets and outlets */
box_io(struct box *b)
{
    struct inlet *ip;
    struct outlet *op;
    int n, primary = (b->b_drawfirstin != 0);
    long w = b->b_rect.right - b->b_rect.left - POX;
    char buf[256];
    if (b->b_firstin)
    {
        b->b_ob.o_inlet = ((struct object *) (b->b_firstin))->o_inlet;
        b->b_ob.o_outlet = ((struct object *) (b->b_firstin))->o_outlet;
    }
    for (ip = b->b_ob.o_inlet, n = primary; ip; ip = ip->i_next)
        n++;
    if (n)
    {
        int increment = ((n > 1) ? w / (n - 1) : 0), h = 0;
        if (primary)
            h = increment;
        for (ip = b->b_ob.o_inlet; ip; ip = ip->i_next, h += increment)
            ip->i_xloc = h;
    }
    for (op = b->b_ob.o_outlet, n = 0; op; op = op->o_next)
        n++;
    if (n)
    {
        int increment = ((n > 1) ? w / (n - 1) : 0), h = 0;
        for (op = b->b_ob.o_outlet; op; op = op->o_next, h += increment)
            op->o_xloc = h;
    }
}

box_vinlet(struct box *b, struct inlet *pi)     /* declare that the box is an inlet */
/* real inlet*/
{
    struct patcher *p = b->b_patcher;
    void *newobj = p->p_vnewobj;
    if (newobj)
    {
        box_inlet(newobj, pi);
        if (p->p_cpno >= 0 && p->p_cpno < h_nproc)
            mess1(b, &s_setparentcp,
                  ((struct box *) newobj)->b_patcher->p_cpno);
    }
    b->b_inlet = 1;
    b->b_un.b_vpin = pi;
}

box_drag(struct box *b, t_method fn, Point pt)
{
    wind_drag(b->b_patcher->p_wind, fn, (void *) b);
}

long box_inindex(struct box *b)
{
    long num = 0;
    struct patcher *p = b->b_patcher;
    struct inlet *pi;
    t_object *newobj = p->p_vnewobj;
    if (!newobj)
        return (0);
    for (pi = newobj->o_inlet, num = 0; pi; pi = pi->i_next, num++)
        if (pi == b->b_un.b_vpin)
            return (num);
    bug("lost inlet");
}

box_inlet(struct box *b, struct inlet *pi)
/* box to get the inlet */
/* the inlet */
{
    struct patchline *l;
    struct patcher *p = b->b_patcher;
    patchercheck(p, "box_inlet");
    boxcheck(b, "box_inlet");
    b->b_ob.o_inlet = ((struct object *) (b->b_firstin))->o_inlet;
    box_inrelink(b, pi);
    box_erase(b);
    for (l = p->p_line; l; l = l->l_next)
        if (l->l_box2 == b)
            patchline_newends(l);
}

box_moveinlet(struct box *b, struct inlet *pi)
{
    struct patcher *p = b->b_patcher;
    struct patchline *l;
    box_inrelink(b, pi);
    for (l = p->p_line; l; l = l->l_next)
        if (l->l_box2 == b)
            patchline_newends(l);
}

#define INX(x) (((struct box *) \
     (((struct outlet *)((x)->i_who))->o_owner))->b_rect.left)

box_inrelink(struct box *b, struct inlet *pi)
{
    struct inlet *pi2, *pi3;
    int t = INX(pi);
    struct inlet stub;
    stub.i_next = b->b_ob.o_inlet;
    for (pi2 = &stub; pi3 = pi2->i_next; pi2 = pi3)
    {
        if (pi3 == pi)
        {
            pi2->i_next = pi3->i_next;
            break;
        }
    }
    for (pi2 = &stub; pi2; pi2 = pi2->i_next)
    {
        if (!pi2->i_next || INX(pi2->i_next) >= t)
        {
            pi->i_next = pi2->i_next;
            pi2->i_next = pi;
            break;
        }
    }
    ((struct object *) (b->b_firstin))->o_inlet = stub.i_next;
    box_io(b);
    /* message the box (which may have to update the CP copy) */
    mess1(((struct outlet *) ((pi)->i_who))->o_owner, &s_int, (long) t);
}

freeboxinlet(struct inlet *pi)
/* the inlet */
{
    struct box *b = (struct box *) (pi->i_owner);
    freeobject((t_object *) pi);
    if (b)
        box_io(b);
}

long box_outindex(struct box *b)
{
    long num = 0;
    struct patcher *p = b->b_patcher;
    struct outlet *po;
    t_object *newobj = p->p_vnewobj;
    if (!newobj)
        return (0);
    for (po = newobj->o_outlet, num = 0; po; po = po->o_next, num++)
        if (po == b->b_un.b_vpout)
            return (num);
    bug("lost inlet");
}

box_voutlet(struct box *b, struct outlet *po)   /* declare that the box is an outlet */
/* real outlet*/
{
    struct patcher *p = b->b_patcher;
    void *newobj = p->p_vnewobj;
    if (newobj)
    {
        box_outlet(newobj, po);
        if (p->p_cpno >= 0 && p->p_cpno < h_nproc)
            mess1(b, &s_setparentcp,
                  ((struct box *) newobj)->b_patcher->p_cpno);
    }
    b->b_outlet = 1;
    b->b_un.b_vpout = po;
}

box_outlet(struct box *b, struct outlet *po)
/* box to get the outlet */
/* the outlet */
{
    struct patchline *l;
    struct patcher *p = b->b_patcher;
    patchercheck(p, "box_outlet");
    boxcheck(b, "box_outlet");
    b->b_ob.o_outlet = ((struct object *) (b->b_firstin))->o_outlet;
    box_outrelink(b, po);
    box_erase(b);
    for (l = p->p_line; l; l = l->l_next)
        if (l->l_box1 == b)
            patchline_newends(l);
}

box_moveoutlet(struct box *b, struct outlet *po)
{
    struct patcher *p = b->b_patcher;
    struct patchline *l;
    box_outrelink(b, po);
    for (l = p->p_line; l; l = l->l_next)
        if (l->l_box1 == b)
            patchline_newends(l);
}

#define OUTX(x) (((struct box *)(((struct inlet *) \
          ((x)->o_inlet))->i_owner))->b_rect.left)
box_outrelink(struct box *b, struct outlet *po)
{
    struct outlet *po2, *po3;
    int t = OUTX(po);
    struct outlet stub;
    stub.o_next = b->b_ob.o_outlet;
    for (po2 = &stub; po3 = po2->o_next; po2 = po3)
    {
        if (po3 == po)
        {
            po2->o_next = po3->o_next;
            break;
        }
    }
    for (po2 = &stub; po2; po2 = po2->o_next)
    {
        if (!po2->o_next || OUTX(po2->o_next) >= t)
        {
            po->o_next = po2->o_next;
            po2->o_next = po;
            break;
        }
    }
    ((struct object *) (b->b_firstin))->o_outlet = stub.o_next;
    box_io(b);

    /* message the box (which may have to update the CP copy) */
    mess1(((struct inlet *) (po->o_inlet))->i_owner, &s_int, (long) t);
}

box_cpoutreorder(t_box *b)
{
    struct outlet *po;
    long n;
    for (po = ((struct object *) (b->b_firstin))->o_outlet, n = 0;
         po; po = po->o_next, n++)
    {
        t_box *owner =
            (t_box *) (((struct inlet *) ((po)->o_inlet))->i_owner);
        h_vmess(owner->b_firstin, &s_int, "l", n);
    }
}

freeboxoutlet(struct outlet *po)
/* the outlet */
{
    struct box *b = (struct box *) (po->o_owner);
    freeobject((t_object *) po);
    if (b)
        box_io(b);
    if (b && (b->b_patcher->p_cpno >= 0))
        box_cpoutreorder(b);
}

void box_active(t_box *b, int n)
{
    h_vmess(b, &s__active, "l", (long) n);
}

void box_ff(struct box *b)
{
    struct patchline *l;
    struct box *b2;
    GrafPort *gp;
    struct outlet *po;
    struct inlet *pi;
    struct patcher *p = b->b_patcher;
    struct box *vnewobj = p->p_vnewobj;
    int cleanvnewobj = 0;
    if (b->b_selected)
        patcher_deselectbox(p, b);
    if (b == p->p_typeat)
        p->p_typeat = 0;
    if (gp = patcher_setport(p))
    {
        if (b->b_binbuf)
            te_free(b->b_un.b_teh);
        box_erase(b);
        t_resetport(gp);
    }
    if (b->b_binbuf)
        binbuf_free(b->b_binbuf);
    for (l = p->p_line; l; l = l->l_next)
    {
        if (l->l_box1 == b || l->l_box2 == b)
        {
            freeobject((t_object *) l);
        }
    }
    if ((b->b_inlet) && vnewobj)
    {
        for (l = vnewobj->b_patcher->p_line; l; l = l->l_next)
            if (l->l_inlet == b->b_un.b_vpin)
                freeobject((t_object *) l);
        freeobject((t_object *) b->b_un.b_vpin);
        cleanvnewobj = 1;
    }
    if ((b->b_outlet) && vnewobj)
    {
        for (l = vnewobj->b_patcher->p_line; l; l = l->l_next)
            if (l->l_outlet == b->b_un.b_vpout)
                freeobject((t_object *) l);
        freeobject((t_object *) b->b_un.b_vpout);
        cleanvnewobj = 1;
    }
    if (cleanvnewobj)
    {
        struct patcher *dad = vnewobj->b_patcher;
        struct patchline *l;
        box_io(vnewobj);
        box_erase(vnewobj);
        for (l = dad->p_line; l; l = l->l_next)
            if (l->l_box1 == vnewobj || l->l_box2 == vnewobj)
                patchline_newends(l);
    }
    patcher_unlinkbox(p, b);
    patcher_unspoolbox(p, b);
    if (b->b_patcher->p_cpno >= 0 && b->b_patcher->p_cpno < h_nproc)
        patcher_sendtocp(b->b_patcher, b, -1, CP_UNPUT);
}

box_free(struct box *b)
{
    box_ff(b);
    freeobject((t_object *) b);
}

box_defaultfree(struct box *b)
{
    freeobject((t_object *) b);
}

int box_offset = 0;             /* <a> added to do paste offset */
void *box(struct box *b, struct patcher *patcher, int flags, int x1,
          int y1, int x2, int y2)
{
    /* <a> box_offset added to all coordinates */
    b->b_rect.top = y1 + box_offset;
    b->b_rect.left = x1 + box_offset;
    b->b_rect.bottom = y2 + box_offset;
    b->b_rect.right = x2 + box_offset;
    b->b_patcher = patcher;
    b->b_inlet = 0;
    b->b_outlet = 0;
    b->b_textdirty = 0;
    b->b_outline = ((flags & F_NODRAWBOX) == 0);
    b->b_drawn = 0;
    b->b_spooled = 0;
    b->b_selected = 0;
    b->b_growy = ((flags & F_GROWY) != 0);
    b->b_drawfirstin = ((flags & F_DRAWFIRSTIN) != 0);
    b->b_binbuf = 0;
    b->b_un.b_teh = 0;
    b->b_firstin = 0;
    patcher_linkbox(patcher, b);
    patcher_spoolbox(patcher, b);
}

box_ready(struct box *b)
{
    box_io(b);
    if (!b->b_patcher->p_lock)
        patcher_selectbox(b->b_patcher, b);
}

Rect *patchline_rect(struct patchline *l)
{
    static Rect r;
    r.left = l->l_x1;
    r.top = l->l_y1;
    r.right = l->l_x2;
    r.bottom = l->l_y2;
    return (&r);
}

/* recalculate line's endpoints; erase and redraw if needed */
patchline_newends(struct patchline *l)
{
    /* if it's not a real inlet it has to be all the way left */
    Rect *r1 = &l->l_box1->b_rect;
    Rect *r2 = &l->l_box2->b_rect;
    int newx1 = r1->left + l->l_outlet->o_xloc + (POX >> 1);
    int newy1 = r1->bottom;
    int newx2 = r2->left +
        (ISINLET(l->l_inlet) ? l->l_inlet->i_xloc : 0) + (POX >> 1);
    int newy2 = r2->top - 1;
    if (l->l_x1 != newx1 || l->l_y1 != newy1 ||
        l->l_x2 != newx2 || l->l_y2 != newy2)
    {
        patchline_erase(l);
        l->l_x1 = newx1;
        l->l_y1 = newy1;
        l->l_x2 = newx2;
        l->l_y2 = newy2;
    }
}

void linedragpoint(struct patchline *l, Point pt, int but)
{
    Rect *r;
    struct patcher *p = l->l_box1->b_patcher;
    /* GrafPort *gp = patcher_setport(p); */
    r = patchline_rect(l);
    patchline_erase(l);
    if (but)
    {
        l->l_x2 = pt.h;
        l->l_y2 = pt.v;
        patchline_spool(l);
    }
    else
    {
        struct box *b;
        char savelock = lockout;
        for (b = p->p_box; b; b = b->b_next)
        {
            Rect *r2 = &b->b_rect;
            if (t_ptinrect(pt, r2) && b != l->l_box1)
            {
                struct patchline *l2;
                struct inlet *pi;
                int xinbox = pt.h - r2->left;
                /* find a inlet it might fall in */
                if (b->b_drawfirstin && (!b->b_ob.o_inlet ||
                                         xinbox <=
                                         (POY +
                                          b->b_ob.o_inlet->i_xloc) >> 1))
                {
                    pi = b->b_firstin;
                    goto gotit;
                }
                for (pi = b->b_ob.o_inlet; pi; pi = pi->i_next)
                {
                    if (!pi->i_next || xinbox <=
                        pi->i_xloc + ((POY + pi->i_next->i_xloc
                                       - pi->i_xloc) >> 1))
                        break;
                }
                /* if none, connect to box at large */
                if (!pi)
                    goto nogood;        /* inlet fix */
              gotit:
                for (l2 = p->p_line; l2; l2 = l2->l_next)
                {
                    if (l2->l_outlet == l->l_outlet && l2->l_inlet == pi)
                    {
                        post("duplicate line -- not connected");
                        goto nogood;
                    }
                }
                lockout = 1;
                if (outlet_add(l->l_outlet, pi))
                    goto nogood;
                lockout = savelock;
                l->l_inlet = pi;
                l->l_box2 = b;
                patchline_newends(l);
                patcher_selectline(p, l);
                if (p->p_cpno >= 0)
                    patchline_setcp(l, p->p_cpno);
                return;
            }
        }
      nogood:
        lockout = savelock;
        freeobject((t_object *) l);
    }
}

patchline_erase(struct patchline *l)
{
    struct patcher *p = l->l_box1->b_patcher;
    Rect *r = patchline_rect(l);
    struct box *b;
    GrafPort *gp;

    if (!p->p_wind->w_vis)
        return;
    if (!(l->l_flags & F_DRAWN))
        return;
    gp = patcher_setport(p);
    if (l->l_selected)
        t_linewidth(2);
    t_eraseline(r->left, r->top, r->right, r->bottom);
    if (l->l_selected)
        t_linewidth(1);
    patcher_bagline(p, l->l_x1, l->l_y1, l->l_x2, l->l_y2);
    if (l->l_selected)
        patcher_bagline(p, l->l_x1 + 1, l->l_y1 + 1, l->l_x2 + 1,
                        l->l_y2 + 1);
    patcher_spoolline(p, l);
    l->l_flags &= ~F_DRAWN;
    t_resetport(gp);
}

patchline_spool(struct patchline *l)
{
    patcher_spoolline(l->l_box1->b_patcher, l);
}

#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)>(b)?(a):(b))

patchline_isvisible(struct patchline *l)
{
    /* fill in later ...
       Rect r;
       t_setrect(&r,MIN(l->l_x1,l->l_x2),MIN(l->l_y1,l->l_y2),
       MAX(l->l_x1,l->l_x2),MAX(l->l_y1,l->l_y2));
       if (l->l_selected)
       InsetRect(&r,-1,-1);
       if (RectInRgn(&r,thePort->visRgn) || RectInRgn(&r,thePort->clipRgn))
       return (TRUE);
       return (FALSE);
     */
    return (1);
}


patchline_draw(struct patchline *l)
{
    if (l->l_selected)
        t_linewidth(2);
    t_line(l->l_x1, l->l_y1, l->l_x2, l->l_y2);
    if (l->l_selected)
        t_linewidth(1);
    l->l_flags |= F_DRAWN;
}

patchline_index1(struct patchline *l)
{
    int pono = 0;
    struct outlet *po;
    for (po = l->l_box1->b_ob.o_outlet; po && po != l->l_outlet;
         po = po->o_next, pono++);
    return (pono);
}

patchline_index2(struct patchline *l)
{
    int pino = 0;
    struct inlet *pi;
    struct box *b = l->l_box2;
    if (!b->b_drawfirstin || l->l_inlet != (struct inlet *) (b->b_firstin))
    {
        if ((b->b_drawfirstin))
            pino++;
        for (pi = b->b_ob.o_inlet; pi && pi != l->l_inlet;
             pi = pi->i_next, pino++);
    }
    return (pino);
}

void patchline_setcp(struct patchline *l, int n)
{
    struct outlet *po;
    struct inlet *pi;
    struct box *b1 = l->l_box1, *b2 = l->l_box2;
    long pino = 0, pono = 0;
    /* if either box isn't there don't do it (it's a connection
       to or from a phantom box that patcher_connect() put in) */
    if (!b1->b_firstin || !b2->b_firstin)
        return;
    for (po = b1->b_ob.o_outlet; po && po != l->l_outlet;
         po = po->o_next, pono++);
    if (!b2->b_drawfirstin ||
        l->l_inlet != (struct inlet *) (b2->b_firstin))
    {
        if (b2->b_drawfirstin)
            pino++;
        for (pi = b2->b_ob.o_inlet; pi && pi != l->l_inlet;
             pi = pi->i_next, pino++);
    }
    if (n >= 0)
        h_connect(b1->b_firstin, pono, b2->b_firstin, pino);
    else
        h_disconnect(b1->b_firstin, pono, b2->b_firstin, pino);
}

void patchline_ff(struct patchline *l)
{
    struct patcher *p = l->l_box1->b_patcher;
    struct patchline stub, *l2;
    patchline_erase(l);
    stub.l_next = p->p_line;
    if (l->l_selected)
        patcher_deselectline(p, l);
    if (l->l_inlet)
    {
        outlet_rm(l->l_outlet, l->l_inlet);
        if (p->p_cpno >= 0 && p->p_cpno < h_nproc)
            patchline_setcp(l, -1);
    }
    for (l2 = &stub; l2; l2 = l2->l_next)
    {
        if (l2->l_next == l)
        {
            l2->l_next = l->l_next;
            break;
        }
    }
    p->p_line = stub.l_next;
    patcher_unspoolline(p, l);
}

void *patchline_class;
void patchline_setup()
{
    c_new(&s_, patchline_ff, sizeof(t_patchline), 1, 0);
}

void *patchline(struct patcher *p, struct box *b, struct outlet *po)
{
    struct patchline *l = (struct patchline *)
        obj_new((t_messlist **) & patchline_class, patchline_setup);
    patchercheck(p, "patchline");
    boxcheck(b, "patchline");
    l->l_next = p->p_line;
    p->p_line = l;
    l->l_outlet = po;
    l->l_box1 = b;
    l->l_x1 = l->l_x2 = b->b_rect.left + po->o_xloc + (POX >> 1);
    l->l_y1 = l->l_y2 = b->b_rect.bottom;
    l->l_selected = 0;
    l->l_inlet = 0;
    l->l_box2 = 0;
    l->l_flags = 0;
    patcher_spoolline(p, l);
    return (l);
}

char *index();

box_correctwidth(struct box *b)
{
#if 0
    char *p, *q;
    int width, maxwidth;
    int margin;
    TEHandle teh;

    if (!b->b_patcher->p_wind->w_vis)
        return;
    if (!b->b_binbuf)
        return;
    teh = b->b_un.b_teh;

    maxwidth = 0;
    p = teh->t_id;
    while (*p)
    {
        if (q = index(p, '\n'))
        {
            *q = '\0';
            if ((width = t_stringwidth(p)) > maxwidth)
                maxwidth = width;
            *q = '\n';
            p = ++q;
        }
        else
        {                       /* last, or only, line */
            if ((width = t_stringwidth(p)) > maxwidth)
                maxwidth = width;
            break;
        }
    }
    width = b->b_rect.right - b->b_rect.left;
    if (width < maxwidth + 2)
    {
        teh->t_rect.right = teh->t_rect.left + maxwidth;
        b->b_rect.right = b->b_rect.left + maxwidth + 2;
    }
#endif
}
