
/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.5 $ IRCAM $Date: 1993/11/17 14:46:53 $
 *
 * FTS by Miller Puckette
 *
 */


typedef struct patchline {
    struct tinyobject l_ob;
    char l_selected;
    char l_flags;
    struct patchline *l_upd;
    struct outlet *l_outlet;
    struct box *l_box1;
    int l_x1;
    int l_y1;
    struct inlet *l_inlet;      /* could also be l_box1->b_firstin */
    struct box *l_box2;
    int l_x2;
    int l_y2;
    struct patchline *l_next;
} t_patchline;

typedef struct patcher {
    struct object p_ob;
    struct windpub *p_wind;     /* window object */
    void *p_vnewobj;            /* containing box if any */
    void *p_instr;              /* associated instrument if any graphing */
    struct box *p_boxupd;       /* list of boxes to redwraw */
    struct patchline *p_lineupd;        /* lines to redraw */
    /* selection and editing */
    void *p_qelem;              /* update clock */
    struct box *p_seltext;      /* if != 0, box to send keys to */
    /* other */
    struct box *p_box;          /* the boxes */
    struct patchline *p_line;   /* the lines */
    Rect p_span;                /* rectangle spanned by all boxes */
    Point p_scroll;             /* last known scroll values */
    void *p_pushed;             /* patcher we pushed to name this one "Pat" */
    struct box *p_typeat;       /* number-box currently typed at */
    long p_notypetime;          /* time at which to kill typing */
    int p_nselect;              /* number of selected boxes */
    t_symbol *p_vol;            /* filesys volume to look up classes in */
    t_symbol *p_searchpath;     /* search path */
    int p_cpno;                 /* CP number for IRCASM; -1 if none */
    char p_lock;                /* on if the patcher is locked */
    char p_dirtybar;            /* on if the edit bar needs drawing */
    char p_pasted;              /* just did a paste (don't edit text) */
    char p_noedit;              /* can't unlock this patcher */
    char p_wantupd;             /* want to redraw */
    char p_topasteboard;        /* draw as if to pasteboard */
} t_patcher;

Rect *box_bigrect(struct box *b);

#define box_x1(b) ((long)((b)->b_rect.left))
#define box_x2(b) ((long)((b)->b_rect.right))

extern void *vnumber_class, *vflonum_class;
#define ISNUM(x) (ob_messlist(x) == vnumber_class || \
  ob_messlist(x) == vflonum_class)

#define TYPEINTER 2000          /* interval in msec separating two keys for a numbox */

Rect *box_terect(struct box *b);
Rect *box_outrect(struct box *b, struct outlet *po);
Rect *patchline_rect(struct patchline *l);
void *patchline(struct patcher *p, struct box *b, struct outlet *po);
