#ifndef lint
static char rcsid[] =
    "$Revision: 1.12 $ IRCAM $Date: 1994/01/04 18:02:56 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.12 $ IRCAM $Date: 1994/01/04 18:02:56 $
 *
 * FTS by Miller Puckette
 *
 */


#include "m_mess.h"
#include "t_mac.h"

#ifndef GRAPHICS
#include "cp_mess.h"
#endif

#include "t_wind.h"
#include "t_menu.h"
#include "p_table.h"

void tabwind_chkscroll(struct tabwind *x);

extern t_symbol s_table, s_set, s_clear, s_const, s_filename,
    s_size, s_tabwind, s__Tab, s_connect;

#ifdef GRAPHICS

int tabwind_fixfix(struct tabwind *x, long int n1, long int n2);

void tabwind_cpr(t_tabwind *x, t_updbuf *buf, int size)
{
    long i, lo, hi;
    ELEM *bp = buf->u_shit;
    int cpno = x->w_cpno;
    lo = buf->u_x;
    hi = lo + UPCHUNK;
    if (hi > x->w_size + 1)
        hi = x->w_size;
    if (hi <= lo || lo < 0 || hi < 0 || lo >= x->w_size)
        return;
    x->w_cpno = -1;             /* hack to prevent update from getting resent to CP */
    for (i = lo; i < hi; i++)
        tabwind_fixfix(x, i, *bp++);
    x->w_cpno = cpno;
}
#else
void tabwind_hqfn(x, hq)
t_tabwind *x;
void *hq;
{
    long i, lo = x->w_nextup, hi = lo + UPCHUNK;
    t_updbuf buf;
    ELEM *bp = buf.u_shit, *tp = *x->w_tab + lo;
    /* static int count;
       if (count < 5)
       {
       count++;
       post("lo %ld, hi %ld, next %ld",
       x->w_lodirty, x->w_hidirty, x->w_nextup);
       } */
    if (hi > x->w_size + 1)
        hi = x->w_size;
    buf.u_x = lo;
    cvt_long(&buf.u_x);
    for (i = lo; i < hi; i++)
    {
        *bp = *tp++;
        cvt_long(bp++);
    }
    hq_doit(hq, &buf, sizeof(buf));
    if (x->w_lodirty >= lo && x->w_lodirty < hi)
        x->w_lodirty = hi;
    if (x->w_lodirty >= x->w_hidirty)
        x->w_nextup = -1;
    else
    {
        if (hi >= x->w_hidirty)
            x->w_nextup = x->w_lodirty;
        else
            x->w_nextup = hi;
        hq_set(hq);
    }
}

void tabwind_connect(x, ptr, fun, freefun)
t_tabwind *x;
long ptr, fun, freefun;
{
    if (ptr)
    {
        if (x->w_hq)
            bug("tabwind_connect 1");
        x->w_hq = hq_new(fun, freefun, ptr, x, tabwind_hqfn,
                         sizeof(t_updbuf), currentPort);
    }
    else
    {
        if (!x->w_hq)
            bug("tabwind_connect 2");
        else
            hq_free(x->w_hq);
        x->w_hq = 0;
    }
}

#endif

tabwind_fixfix(struct tabwind *x, long int n1, long int n2)
{
    if (n1 < 0)
        n1 = 0;
    else if (n1 >= x->w_size)
        n1 = x->w_size - 1;
#ifdef GRAPHICS
    if (x->w_wind->w_vis)
        tabwind_movepoint(x, n1, (*x->w_tab)[n1], n2);
    x->w_wind->w_dirty = 1;
    if (x->w_cpno >= 0)
        h_vmess(x, &s_list, "ll", n1, n2);
#else
    if (x->w_hq)
    {
        if (x->w_nextup < 0)
        {
            hq_set(x->w_hq);
            x->w_nextup = x->w_lodirty = n1;
            x->w_hidirty = n1 + 1;
        }
        else
        {
            if (x->w_lodirty > n1)
                x->w_lodirty = n1;
            if (n1 >= x->w_hidirty)
                x->w_hidirty = n1 + 1;
        }
    }
#endif                          /* GRAPHICS */
    (*x->w_tab)[n1] = n2;
}

void tabwind_list(struct tabwind *x, struct symbol *s, int ac,
                  struct atom *av)
{
    long n1, n2;
    char c;
    if (ac < 2)
        return;
    if ((c = av->a_type) == A_LONG)
        n1 = av->a_w.w_long;
    else if (c == A_FLOAT)
        n1 = av->a_w.w_float;
    else
        return;
    av++;
    if ((c = av->a_type) == A_LONG)
        n2 = av->a_w.w_long;
    else if (c == A_FLOAT)
        n2 = av->a_w.w_float;
    else
        return;
    tabwind_fixfix(x, n1, n2);
}

void tabwind_const(struct tabwind *x, long int n)
{
    long count;
    ELEM *tp = *(x->w_tab);
    for (count = x->w_size; count--; tp++)
        *tp = n;
#ifdef GRAPHICS
    if (x->w_wind->w_vis)
        tabwind_erase(x);
    x->w_wind->w_dirty = 1;
#else
    if (x->w_hq)
    {
        if (x->w_nextup < 0)
            hq_set(x->w_hq);
        x->w_nextup = x->w_lodirty = 0;
        x->w_hidirty = x->w_size;
    }
#endif
}

void tabwind__set(struct tabwind *x, struct symbol *s, int ac,
                  struct atom *av)
{
    int count;
    ELEM *tp;
    int onset;
    if (!ac)
        return;
    if (av->a_type != A_LONG)
    {
        error("tabwind_set: bad onset");
        return;
    }
    onset = av->a_w.w_long;
    av++;
    ac--;
    if (onset < 0)
        onset = 0;
    for (tp = *(x->w_tab) + onset; onset < x->w_size && ac--;
         onset++, tp++)
    {
        if (av->a_type != A_LONG)
        {
            error("tabwind_set: bad input");
            return;
        }
        *(tp) = (av++)->a_w.w_long;
    }
#ifdef GRAPHICS
    if (x->w_wind->w_vis)
        tabwind_erase(x);
#endif
}

void tabwind_set(struct tabwind *x, struct symbol *s, int ac,
                 struct atom *av)
{
    tabwind__set(x, s, ac, av);
#ifndef GRAPHICS
    if (x->w_hq)
    {
        if (x->w_nextup < 0)
            hq_set(x->w_hq);
        x->w_nextup = x->w_lodirty = 0;
        x->w_hidirty = x->w_size;
    }
#endif
}

void tabwind_clear(struct tabwind *x)
{
    long count;
    ELEM *tp = *(x->w_tab);
    for (count = x->w_size; count--; tp++)
        *tp = 0;
#ifdef GRAPHICS
    if (x->w_wind->w_vis)
        tabwind_erase(x);
    x->w_wind->w_dirty = 1;
#endif
}

void tabwind_size(struct tabwind *x, long n)    /* set the size of the table */
{
    if (n < 1)
        n = 1;
    if (n == x->w_size)
        return;
    if (t_growhandle((void **) x->w_tab, n * sizeof(ELEM)))
    {
        memouch();
        return;
    }
    if (n > x->w_size)
    {
        long *lp = *(x->w_tab) + x->w_size, zap = n - x->w_size;
        while (zap--)
            *(lp++) = 0;
    }
    x->w_size = n;
#ifdef GRAPHICS
    x->w_wind->w_dirty = 1;
    x->w_selstart = x->w_selend = 0;
    tabwind_chkscroll(x);
#endif
}

tabwind_handle(struct tabwind *x, long int ***hp, long int *sizep)
{
    *hp = x->w_tab;
    *sizep = x->w_size;
}

void tabwind_ff(struct tabwind *x)
{
    if (x->w_sym && x->w_sym->s_thing == (void *) x)
        x->w_sym->s_thing = 0;
    if (s__Tab.s_thing == (struct object *) x)
        s__Tab.s_thing = 0;
#ifdef GRAPHICS
    freeobject((t_object *) x->w_wind);
#endif
    DisposHandle(x->w_tab);
}

#ifdef GRAPHICS
#ifdef NEXTSTEP                 /* no inspectors in XMAX */
void tabwind_setinspector(t_tabwind *x, int put)
{
    if (put)
    {
        int domain, range, signedflag, embed, scratch;
        tabinspect_get(&domain, &range, &signedflag, &embed, &scratch);
        if (domain != x->w_size)
        {
            tabwind_size(x, domain);
            if (x->w_cpno >= 0)
                h_vmess(x, gensym("size"), "l", (long) domain);
        }
        x->w_range = range;
        x->w_signed = signedflag;
        x->w_embed = embed;
        x->w_wind->w_scratch = scratch;
        tabwind_cliprange(x);
        tabwind_chkscroll(x);
    }
    else
        tabinspect_set(1, (int) (x->w_size), (int) (x->w_range),
                       (int) x->w_signed, (int) x->w_embed,
                       (int) x->w_wind->w_scratch);
}
#endif                          /* NEXTSTEP */
#endif                          /* GRAPHICS */

#ifdef GRAPHICS
void tabwind_filename(struct tabwind *x, char *fn, t_symbol * vol,
                      int bin);
void tabwind_front(struct tabwind *x);
void tabwind_size(struct tabwind *x, long int n);
void tabwind_click(struct tabwind *x, Point pt, int dbl, int modifiers);
void tabwind_update(struct tabwind *x, int margin);
void tabwind_chkscroll(struct tabwind *x);
void tabwind_saveto(struct tabwind *x, char *fn, t_symbol * vol);
void tabwind_wsize(struct tabwind *x, int a, int b);
void tabwind_chkmenu(struct tabwind *x, struct menuinfo *m);
void tabwind_idle(struct tabwind *x, Point pt);
void tabwind_selectall(struct tabwind *x);
#endif

void *tabwind_class;

void tabwind_setup()
{
    c_new(&s_tabwind, tabwind_ff, sizeof(t_tabwind), 0, 0);

    c_addmess(tabwind_list, &s_list, A_GIMME, 0);
    c_addmess(tabwind_set, &s_set, A_GIMME, 0);
    c_addmess(tabwind_clear, &s_clear, 0);
    c_addmess(tabwind_const, &s_const, A_LONG, 0);
    c_addmess(tabwind_size, &s_size, A_LONG, 0);
#ifdef GRAPHICS
    c_addmess(tabwind_filename, &s_filename, A_CANT, 0);
    c_addmess(tabwind_front, &s_front, 0);
    c_addmess(tabwind_click, &s_click, A_CANT, 0);
    c_addmess(tabwind_update, &s_update, A_CANT, 0);
    c_addmess(tabwind_chkscroll, &s_scroll, A_CANT, 0);
    c_addmess(tabwind_saveto, &s_saveto, A_CANT, 0);
    c_addmess(freeobject, &s_close, A_CANT, 0);
    c_addmess(tabwind_wsize, &s_wsize, A_CANT, 0);
    c_addmess(tabwind_chkmenu, &s_chkmenu, A_CANT, 0);
    c_addmess(tabwind_idle, &s_idle, A_CANT, 0);
    c_addmess(tabwind_selectall, gensym("selectall"), A_CANT, 0);
#if NEXTSTEP
    c_addmess(tabwind_setinspector, gensym("setinspector"), A_CANT, 0);
#endif                          /* NEXTSTEP */
#if NOT_SUPPORTED
    c_addmess(tabwind_dialog, &s_dialog, A_CANT, 0);
    c_addmess(tabwind_copy, &s_copy, A_CANT, 0);
    c_addmess(tabwind_paste, &s_paste, A_CANT, 0);
    c_addmess(tabwind_clr, &s_clr, A_CANT, 0);
    c_addmess(tabwind_cut, &s_cut, A_CANT, 0);
#endif                          /* NOT_SUPPORTED */
#else
    c_addmess(tabwind_connect, &s_connect, A_LONG, A_LONG, A_LONG, 0);
    c_addmess(tabwind__set, gensym("_set"), A_GIMME, 0);
#endif                          /* GRAPHICS */
}

void *tabwind(long int **handle, long int size, long int range, int x1,
              int y1, int x2, int y2, int xshift, int yshift, int flags)
{
    int i;
    struct tabwind *x =
        (struct tabwind *) obj_new((t_messlist **) & tabwind_class,
                                   tabwind_setup);
    void *w;
    x->w_sym = NIL;
    x->w_tab = handle;
    x->w_size = size;
#ifdef GRAPHICS
    w = x->w_wind = wind_new(x, x1, y1, x2, y2,
                             WCLOSE | WGROW | WSCROLLX | WSCROLLY |
                             WKEEPT);
    wind_setscrollparams(x->w_wind, 0, 0, 0, 0);
    x->w_range = range;
    x->w_wind->w_xoffset = 0;
    getshift(xshift, &x->w_xshift, &x->w_xzoom);
    getshift(yshift, &x->w_yshift, &x->w_yzoom);
    tabwind_cliprange(x);
    x->w_signed = ((flags & SIGNED) != 0);
    x->w_wind->w_scratch = ((flags & SCRATCH) != 0);
    x->w_embed = ((flags & EMBED) != 0);
    x->w_dragx = 0;
    x->w_selstart = x->w_selend = 0;
    x->w_selmode = 0;
    x->w_xoff = x->w_yoff = 0;
    tabwind_chkscroll(x);
    if (flags & VIS)
        wind_vis(x->w_wind);
    x->w_cpno = -1;
    x->w_cpr = 0;
#else
    x->w_refcount = 0;
    x->w_hq = 0;
    x->w_nextup = -1;
#endif                          /* GRAPHICS */
    return (x);
}

/* make a table, initializing its contents */
void *stdtabwind(long int size, long int range, int x1, int y1, int x2,
                 int y2, int xshift, int yshift, int flags)
{
    int i;
    ELEM *tp, **handle =
        (ELEM **) t_newhandle((long) (size * sizeof(ELEM)));
    for (i = 0, tp = *handle; i < size; i++)
        tp[i] = 0;
    return (tabwind(handle, size, range,
                    x1, y1, x2, y2, xshift, yshift, flags));
}

/* make a table from predefined contents; used if a table is opened
   directly from a file; in this case you have no graphical state so
   you use the defaults. */
void *tabfromhandle(long int **handle, long int size)
/* number of items */
{
#ifdef GRAPHICS
    int xsize = (size > 30000 ? 30000 : size + LMARGIN + RMARGIN);
    return (tabwind(handle, size, (long) DEFRANGE, 0, 0, xsize,
                    STDHEIGHT, 0, 0, 0));
#else
    return (0);
#endif
}

/* make a new tabwind, given the symbol. */
void *stabwind(struct symbol *s)
{
#ifdef GRAPHICS
    struct tabwind *x = stdtabwind((long) DEFSIZE, (long) DEFRANGE,
                                   0, 0, STDWIDTH, STDHEIGHT, 0, 0, 0);
#else
    struct tabwind *x = stdtabwind((long) DEFSIZE, (long) DEFRANGE,
                                   0, 0, 0, 0, 0, 0, 0);
#endif
    if (s && !s->s_thing)
    {
        x->w_sym = s;
        s->s_thing = (struct object *) x;
#ifdef GRAPHICS
        wind_filename(x->w_wind, s->s_name, defvolume, 0);
#endif
    }
    else
        x->w_sym = 0;
#ifdef GRAPHICS
    wind_vis(x->w_wind);
#endif
    return (x);
}

/* this function creates a new object only if none of class
 * "tabwind" is already bound to the symbol.  A tabwind should
 * be cleared with "untabwind()" which frees it only when nobody
 * else is using it. */

void *gettabwind(struct symbol *s, long int size, long int range, int x1,
                 int y1, int x2, int y2, int xshift, int yshift, int flags)
{
    struct tabwind *x;
    struct binbuf *b;
    int bin;
    char s2[256];
    if (s)
    {
        if (s->s_thing)
        {
            if (ob_messlist(s->s_thing) != tabwind_class)
            {
                post("%s: already exists", s->s_name);
                s = 0;
                goto shit;
            }
            else
                x = (struct tabwind *) (s->s_thing);
        }
        else
        {
#ifdef GRAPHICS
            char **handle;
            long n;
            int bin;
            if ((flags & EMBED) || (flags & SCRATCH))
                goto std;
            b = binbuf_new();
            if (binbuf_read(b, s->s_name, defvolume, bin))
            {
                post("%s: can't open", s->s_name);
                binbuf_free(b);
                goto std;
            }
            if (binbuf_gethandle(b, &handle, &n, &s_table))
            {
                error("%s: not a function table", s->s_name);
                binbuf_free(b);
                goto std;
            }
            x = tabwind((long **) handle, n, range, x1, y1, x2, y2, xshift,
                        yshift, flags);
            binbuf_free(b);
            goto nostd;
          std:
            x = stdtabwind(size, range, x1, y1, x2, y2, xshift, yshift,
                           flags);
          nostd:
            x->w_sym = s;
            s->s_thing = (struct object *) x;
            wind_filename(x->w_wind, s->s_name, defvolume, bin);
#else
            x = stdtabwind(size, range, x1, y1, x2, y2, xshift, yshift,
                           flags);
            x->w_sym = s;
            s->s_thing = (struct object *) x;
#endif                          /* GRAPHICS */
        }
    }
    else
    {
      shit:
        x = stdtabwind(size, range, x1, y1, x2, y2, xshift, yshift, flags);
    }
#ifdef GRAPHICS
    x->w_wind->w_refcount++;
#else
    x->w_refcount++;
#endif
    return (x);
}

/* undo "gettabwind".  Decrements the window's refcount and blows it away
   if zero. */
untabwind(struct tabwind *x)
{
#ifdef GRAPHICS
    int n = --x->w_wind->w_refcount;
#else
    int n = --x->w_refcount;
#endif
    if (n < 0)
        bug("table window refcount");
    else if (!n)
    {
#ifdef GRAPHICS
        if (x->w_wind->w_dirty && !x->w_wind->w_scratch)
        {
            wind_vis(x->w_wind);
            wind_close(x->w_wind);
        }
        else
            freeobject((t_object *) x);
#else
        freeobject((t_object *) x);
#endif
    }
}
