/* Copyright (c) 1997-1999 Miller Puckette.
* For information on usage and redistribution, and for a DISCLAIMER OF ALL
* WARRANTIES, see the file, "LICENSE.txt," in this distribution.  */

#define EXTERN
/* s_sgi.c, s_nt.c, s_linux.c each implement the same API for audio
and MIDI I/O as follows: */

#define DACBLKSIZE 64

#define SENDDACS_NO 0           /* return values for sys_send_dacs() */
#define SENDDACS_YES 1
#define SENDDACS_SLEPT 2

extern int sys_hipriority;      /* real-time flag, true if priority boosted */
extern float *sys_soundout;
extern float *sys_soundin;
extern float sys_dacsr;
extern int sys_schedadvance;
EXTERN void sys_open_audio_and_midi(int midiin, int midiout,
                                    int inchans, int outchans, int rate);
EXTERN void sys_close_audio_and_midi(void);
EXTERN int sys_send_dacs(void);
EXTERN void sys_reportidle(void);
EXTERN void sys_poll_midi(void);
EXTERN void sys_set_priority(int higher);
EXTERN void sys_audiobuf(int nbufs);
EXTERN void sys_getmeters(float *inmax, float *outmax);

    /* for NT and Linux, there are additional bits of fluff as follows. */
#ifdef NT
EXTERN void nt_listdevs(void);
EXTERN void nt_soundindev(int which);
EXTERN void nt_soundoutdev(int which);
EXTERN void nt_midiindev(int which);
EXTERN void nt_midioutdev(int which);
EXTERN void nt_noresync(void);
#endif

#ifdef __linux__
    /* the following definitions allow you to switch at run time
       between three different audio APIs in Linux.  */
void linux_set_sound_api(int which);
#define API_OSS 0
#define API_ALSA 1
#define API_RME 2

void linux_frags(int n);
void linux_fragsize(int n);
void rme_soundindev(int which);
void rme_soundoutdev(int which);
void linux_alsa_blockmode(int block);
void linux_alsa_queue_size(int size);
#endif

/* m_sched.c */
EXTERN void sys_log_error(int type);
#define ERR_NOTHING 0
#define ERR_STARTUP 1
#define ERR_ADCSLEPT 2
#define ERR_DACSLEPT 3
#define ERR_RESYNC 4
#define ERR_ADCSTALL 5
