#ifndef lint
static char rcsid[] =
    "$Revision: 2.3 $ IRCAM $Date: 1993/09/16 15:36:16 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.3 $ IRCAM $Date: 1993/09/16 15:36:16 $
 *
 * FTS by Miller Puckette
 *
 */

#include "t_mac.h"

static int t_initted;
static int lwidth = 1;

void t_init()
{
    if (!t_initted)
    {
        MPSInit();
        t_initted = 1;
    }
}

void t_setrect(Rect *r, int a, int b, int c, int d)
{
    r->left = a;
    r->top = b;
    r->right = c;
    r->bottom = d;
}

void t_offsetrect(Rect *r, int a, int b)
{
    r->left += a;
    r->right += a;
    r->top += b;
    r->bottom += b;
}

int t_ptinrect(Point pt, Rect *r)
{
    return (pt.h >= r->left && pt.h < r->right &&
            pt.v >= r->top && pt.v < r->bottom);
}

void t_framerect(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSFramerect(a, b, c - a - 1, d - b - 1);
}

void t_unframerect(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSUnframerect(a, b, c - a - 1, d - b - 1);
}

void t_paintrect(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSPaintrect(a, b, c - a, d - b);
}

void t_eraserect(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSEraserect(a, b, c - a, d - b);
}

void t_invertrect(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSInvertrect(a, b, c - a, d - b);
}

void t_hiliterect(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSHiliterect(a, b, c - a, d - b);
}

void t_frameoval(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSCircle((a + c) >> 1, (b + d) >> 1, (c - a) >> 1);
}

void t_line(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSLine(a, b, c - a, d - b);
    if (lwidth > 1)
    {
        int xdiff = c - a, ydiff = d - b;
        if (xdiff < 0)
            xdiff = -xdiff;
        if (ydiff < 0)
            ydiff = -ydiff;
        if (xdiff > ydiff)
            MPSLine(a, b + 1, c - a, d - b);
        else
            MPSLine(a + 1, b, c - a, d - b);
    }
}

void t_eraseline(a, b, c, d)
{
    if (!t_initted)
        t_init();
    MPSEraseline(a, b, c - a, d - b);
    if (lwidth > 1)
    {
        int xdiff = c - a, ydiff = d - b;
        if (xdiff < 0)
            xdiff = -xdiff;
        if (ydiff < 0)
            ydiff = -ydiff;
        if (xdiff > ydiff)
            MPSEraseline(a, b + 1, c - a, d - b);
        else
            MPSEraseline(a + 1, b, c - a, d - b);
    }
}

void t_penmode(int n)
{
}

void t_linewidth(int n)
{
    lwidth = n;
}

void t_textfont(int n)
{
}
