
/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.7 $ IRCAM $Date: 1993/11/17 18:32:41 $
 *
 * FTS by Miller Puckette
 *
 */

struct _text;
#define t_text struct _text
typedef struct _text *TEHandle;

#ifndef DEF_PIC
typedef void Pict;
#endif

typedef struct _rect {
    int top;
    int left;
    int bottom;
    int right;
} Rect;

typedef struct _point {
    int v;
    int h;
} Point;

typedef Pict *PicHandle;

#ifndef DEFINEDGRAFPORT
typedef void *GrafPort;
#endif

#define _t_textEdit_

/* mouse click flag definitions */
#define shiftKey 01
#define cmdKey 02
#define optionKey 04
#define inMargin 010            /* click was outside scroll region of window */

#define patCopy 0
#define patXor 1
#define patBic 2

void t_setrect(Rect * r, int left, int top, int right, int bottom);
void t_offsetrect(Rect * r, int dx, int dy);
int t_ptinrect(Point pt, Rect * r);
void t_framerect(int left, int top, int right, int bottom);
void t_paintrect(int left, int top, int right, int bottom);
void t_eraserect(int left, int top, int right, int bottom);
void t_invertrect(int left, int top, int right, int bottom);
void t_frameoval(int left, int top, int right, int bottom);
void t_line(int left, int top, int right, int bottom);
void t_drawstring(int x, int y, char *shit);
void t_drawslong(int x, int y, long shit);
int t_charwidth(int c);
int t_stringwidth(char *s);
void t_textfont(int n);
void t_textsize(int n);
void t_penmode(int a);
void t_linewidth(int a);

t_text *te_new(Rect * a, Rect * b);
void te_free(t_text * te);
char **te_text(t_text * te);
int te_length(t_text * te);
void te_set(t_text * te, char **text, long length);
Rect *te_destrect(t_text * te);
Rect *te_viewrect(t_text * te);
void *t_setdest(t_text * te, Rect * r);
void *t_setview(t_text * te, Rect * r);
int te_lines(t_text * te);
int te_lineheight(t_text * te);
long te_selstart(t_text * te);
long te_selend(t_text * te);
void te_setselect(t_text * te, long x1, long x2);
void te_update(t_text * te);
void te_activate(t_text * te);
void te_deactivate(t_text * te);
void te_key(t_text * te, int k);
void te_click(t_text * te, Point p, int shift);
void te_idle(t_text * te);
void te_delete(t_text * te);
void te_copy(t_text * te);
void te_paste(t_text * te);
