#ifndef lint
static char rcsid[]= "$Revision: 1.4 $ IRCAM $Date: 1993/08/26 16:07:57 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.4 $ IRCAM $Date: 1993/08/26 16:07:57 $
 *
 * FTS by Miller Puckette
 *
 */

/* text doc in /NextLibrary/Documentation/NextDev/NextStep/Reference/02_Classes/AppKit/Text.rtf */

#import <appkit/Text.h>
#import <appkit/Font.h>
int te_haschanged;

@interface nx_text : Text
{
	int active;
}

- textDidGetKeys: (id)who isEmpty:(BOOL)flag;
- setactive: (int)n;
- mouseDown:(NXEvent *)theEvent;
- mouseDragged:(NXEvent *)theEvent;
- mouseEntered:(NXEvent *)theEvent;
- mouseExited:(NXEvent *)theEvent;
- mouseMoved:(NXEvent *)theEvent;
- mouseUp:(NXEvent *)theEvent;

@end

@implementation nx_text: Text
- setactive: (int)n
{
	active = n;
}

- textDidGetKeys: (id)who isEmpty:(BOOL)flag
{
	te_haschanged = 1;
	t_send_fake_key([self nextResponder]);
}

- mouseDown:(NXEvent *)theEvent
{
	if (active) [super mouseDown: theEvent];
	else [[self nextResponder] mouseDown: theEvent];
}

- mouseDragged:(NXEvent *)theEvent
{
	if (active) [super mouseDragged: theEvent];
	else [[self nextResponder] mouseDragged: theEvent];
}

- mouseEntered:(NXEvent *)theEvent
{
	if (active) [super mouseEntered: theEvent];
	else [[self nextResponder] mouseEntered: theEvent];
}

- mouseExited:(NXEvent *)theEvent
{
	if (active) [super mouseExited: theEvent];
	else [[self nextResponder] mouseExited: theEvent];
}

- mouseMoved:(NXEvent *)theEvent
{
	if (active) [super mouseMoved: theEvent];
	else [[self nextResponder] mouseMoved: theEvent];
}

- mouseUp:(NXEvent *)theEvent
{
	if (active) [super mouseUp: theEvent];
	else [[self nextResponder] mouseUp: theEvent];
}

- cut: (id)who
{
	if ([self byteLength]) [super cut: who];
	else [[self nextResponder] cut: who];
}

@end

typedef struct _rect
{
	int top;
	int left;
	int bottom;
	int right;
} Rect;

#define BS 256
#define HEIGHT 15

typedef struct text
{
	id t_id;
	Rect t_rect;
} t_text;

static int t_tsizes[] = {9, 10, 12, 14, 16, 18, 20, 24};
#define  NSIZES (sizeof(t_tsizes)/sizeof(*t_tsizes))

static id t_fontobjects[NSIZES];
static int t_currentfontsize = 0;
int t_defaultfontsize = -1;

#define DEF_TEXT
#include "t_mac.h"

char *getbytes();
#define MAXTEXT 4096

/* to backport to MAC:
	careful about te_set which takes the handle you feed it and burns the
		old one.  Also, in tesettext, will need a hack for 0-length text:
	if (!size)
	{
		if (b->b_drawn) box_erase(b);
		te_free(b->b_un.b_teh);
		mkteh(b);
	}
	else ...
	also, te_lines should return at least 1.

*/

#define CHEAT 0
char *NXGetDefaultValue(), *appname();
static char *textfont, *textfontsize;

t_setfont(s)
 char *s;
{
	textfont = s;
}

t_setfontsize(s)
 char *s;
{
	textfontsize = s;
}

t_initdeffont()
{
	char *font = "ohlfs", *fontsize = "10", *x, fontindex;
	int fi = 0;
	if (t_defaultfontsize >= 0) return;
	if (!textfont && !(textfont = NXGetDefaultValue(appname(), "NXFont")))
		textfont = "Helvetica";
	if (textfontsize) fontsize = textfontsize;
	else if (x = NXGetDefaultValue(appname(), "NXFontSize"))
		fontsize = x;
	sscanf(fontsize, "%d", &fi);
	t_defaultfontsize = t_getfontindex(fi);
	t_textsize(t_defaultfontsize);
}

t_text *te_new(Rect *destrect, Rect *viewrect)
{
	t_text *x = (t_text *)getbytes(sizeof(t_text));
	id defaultwas = [Text getDefaultFont];
	NXRect	rect;
	NXSize sigh;
	id view = (id)t_getview();
	if (t_defaultfontsize < 0) t_initdeffont();
	NXSetRect(&rect, (float)(viewrect->left), (float)viewrect->top,
		(float)(CHEAT + viewrect->right - viewrect->left) ,
		(float)(viewrect->bottom - viewrect->top));
	x->t_rect = *viewrect;
	/* [x->t_id setFont: t_fontobjects[t_currentfontsize]]; */
	[Text setDefaultFont: t_fontobjects[t_currentfontsize]];
	x->t_id = [nx_text newFrame:&rect
			text:""
			alignment:NX_LEFTALIGNED];

	sigh.width = sigh.height = 10000;
	[x->t_id setAutodisplay: NO];
	[x->t_id setMaxSize: &sigh];
	[x->t_id setVertResizable: YES];
	te_fix(x);
	[x->t_id setDelegate: x->t_id];
	[view addSubview:x->t_id];
	[Text setDefaultFont: defaultwas];
	return (x);
}

void te_free(x)
 t_text *x;
{
	[x->t_id free];
	freebytes(x, sizeof(t_text));
}

te_fix(x)
 t_text *x;
{
	NXSize sz;
	[x->t_id calcLine];
	sz.width = CHEAT + x->t_rect.right - x->t_rect.left;
	sz.height = 0;
	[x->t_id setMinSize: &sz];
	sz.height = 10000;
	[x->t_id setMaxSize: &sz];
	[x->t_id sizeToFit];
	sz.width = sz.height = 0;
	[x->t_id setMinSize: &sz];
	sz.width = sz.height = 10000;
	[x->t_id setMaxSize: &sz];
}

static char *te_shitp;
static char te_shit[MAXTEXT];

char **te_text(x)
 t_text *x;
{
	int len = [x->t_id getSubstring: te_shit start: 0 length: MAXTEXT];
	if (len < 0) len = 0;
	te_shitp = te_shit;
	return (&te_shitp);
}

int te_length(x)
 t_text *x;
{
	int len = [x->t_id byteLength];
	if (len < 0) len = 0;
	return (len);
}

void te_set(x, h, n)
 t_text *x;
 char **h;
 long n;
{
	char shit[MAXTEXT];
	int i;
	if (n >= MAXTEXT) n = MAXTEXT-1;
	for (i = 0; i < n; i++) shit[i] = (*h)[i];
	shit[n] = 0;
	[x->t_id setText: shit];
	te_fix(x);
}

Rect *te_destrect(x)
 t_text *x;
{
	return(&x->t_rect);
}

Rect *te_viewrect(x)
 t_text *x;
{
	return(&x->t_rect);
}

void te_setdest(x, r)
 t_text *x;
 Rect *r;
{
}

void te_setview(x, r)
 t_text *x;
 Rect *r;
{
	x->t_rect = *r;
	[x->t_id sizeTo: (float)(CHEAT + r->right - r->left):
		(float)(r->bottom - r->top)];
	[x->t_id moveTo: (float)(r->left): (float)r->top];
	te_fix(x);
}

int te_height(x)
 t_text *x;
{
	NXRect nr;
	[x->t_id getFrame: &nr];
	return ((int)(nr.size.height + .99));
}

int te_lineheight(x)
 t_text *x;
{
	return ((int)[x->t_id lineHeight]);
}

long te_selstart(x)
 t_text *x;
{
	return (0);
}

long te_selend(x)
 t_text *x;
{
	return (0);
}

void te_setselect(x, b, e)
 t_text *x;
 long b, e;
{
	/* on mac: TESetSelect(b, e, x) */
}

#define NOVIEW ((id)1)

void te_update(x)	/* this is idiotic */
 t_text *x;
{
	id view = (id)t_getview();
	if (view != NOVIEW) [view unlockFocus]; 
	[x->t_id display];
	if (view != NOVIEW) [view lockFocus]; 
}

void te_activate(x)
 t_text *x;
{
	te_haschanged = 0;
	[x->t_id setAutodisplay: YES];
	[x->t_id setactive: 1];
	[x->t_id setSel: 0 :10000000];
	[x->t_id setactive: 1];
	[[x->t_id window] makeFirstResponder: x->t_id];
}

void te_deactivate(x)
 t_text *x;
{
	[x->t_id setAutodisplay: NO];
	[x->t_id setactive: 0];
	[[x->t_id window] makeFirstResponder: [x->t_id nextResponder]];
}

int te_changed()
{
	return (te_haschanged);
}

void te_key(x, k)
 t_text *x;
{
}

void te_click(x, pt, shift)	/* reverse args for MAC */
 t_text *x;
 Point pt;
{
  post("te click?");
}

void te_delete(x)
 t_text *x;
{
}

void te_copy(x)
 t_text *x;
{
}

void te_paste(x)
 t_text *x;
{
}

void te_idle(x)
 t_text *x;
{
}

/*** stuff to draw strings, without bothering with a whole "text" obj ***/

void t_drawstring(a, b, s)
 char *s;
{
	char buf[256];
	sprintf(buf, "(%s)", s);
	t_init();
	if (t_defaultfontsize < 0) t_initdeffont();
	[t_fontobjects[t_currentfontsize] set];	
	MPSDrawstring(a, b, s);
}

void t_drawlong(a, b, n)
 long n;
{
	char buf[20];
	t_printi(buf, n);
	t_drawstring(a, b, buf);
}

t_charwidth(c)
{
	char s[2];
	s[0] = c;
	s[1] = 0;
	if (t_defaultfontsize < 0) t_initdeffont();
	return ((int)[t_fontobjects[t_currentfontsize] getWidthOf: s]);
}

t_stringwidth(s)
 char *s;
{
	if (t_defaultfontsize < 0) t_initdeffont();
	return ((int)[t_fontobjects[t_currentfontsize] getWidthOf: s]);
}

t_deffontheight()
{
	/* NXFontMetrics *m; */
	if (t_defaultfontsize < 0) t_initdeffont();
	/* m = [t_fontobjects[t_currentfontsize]
		readMetrics: NX_FONTMETRICS | NX_FONTHEADER]; */
	/* return ((int)(10 * (m->capHeight - m->descender))); */
	return ((int)([t_fontobjects[t_currentfontsize] pointSize]));
}

void t_textsize(n)
{
	if (n >= NSIZES) n = NSIZES-1;
	else if (n < 0) n = 0;
	if (t_defaultfontsize < 0) t_initdeffont();
	t_currentfontsize = n;
	if (!t_fontobjects[n]) 
		t_fontobjects[n] = [Font newFont:textfont size:t_tsizes[n]];
}

t_getfontindex(pointsize)
{
	int n;
	for (n = 0; n < NSIZES-1 && t_tsizes[n] < pointsize; n++);
	return (n);
}

t_getdeffont()
{
	if (t_defaultfontsize < 0) t_initdeffont();
	return (t_defaultfontsize);
}

t_getcurrentfont()
{
	if (t_defaultfontsize < 0) t_initdeffont();
	return (t_currentfontsize);
}

t_setdeffont(n)
{
	t_textsize(n);
	t_defaultfontsize = t_currentfontsize;
}

t_realfontsize(n)
{
	if (n >= NSIZES) n = NSIZES-1;
	else if (n < 0) n = 0;
	return (t_tsizes[n]);
}

