#ifndef lint
static char rcsid[] =
    "$Revision: 1.9 $ IRCAM $Date: 1994/01/29 07:49:49 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.9 $ IRCAM $Date: 1994/01/29 07:49:49 $
 *
 * FTS by Miller Puckette
 *
 */


#include "m_mess.h"
#include "h_cp.h"
#include "cp_mess.h"
#include "t_mac.h"
#include "p_patcher.h"
#include <strings.h>
extern t_symbol s_declare, s_loadbang, s__declare, s__loadbang, s__Pat,
    s_setcp;
extern int h_nproc;

typedef struct declare {
    t_object d_ob;
    struct declare *d_next;
    long d_n;
    t_symbol **d_stuff;
    void *d_patcher;
} t_declare;

void *patcher_getmain();
t_symbol *atom_getsym(t_atom * at);
char *t_getdefpathstring();

#ifdef GRAPHICS

void declare__doit(x, s, ac, av)
void *x;
t_symbol *s;
t_atom *av;
{
    int ouchedfornproc = 0;
    int fixsettings = 0;
    int stopped = 0;
    char *newpath = 0;
    int uselib = -1;
    for (; ac--; av++)
    {
        char s1[80], *s2, *arg = atom_getsym(av)->s_name;
        int where;
        s2 = index(arg, '=');
        if (s2)
        {
            where = s2 - arg;
            if (where >= 80)
                where = 79;
            strncpy(s1, arg, where);
            s1[where] = 0;
            s2++;
        }
        else
        {
            s2 = "";
            strncpy(s1, arg, 79);
            s1[79] = 0;
        }
        if (!strcmp(s1, "sr"))
        {
            float f, h_getrate();
            if (sscanf(s2, "%f", &f) < 1)
                error("declare: %s: bad sample rate", arg);
            else
            {
                if (f != h_getrate())
                {
                    if (!stopped)
                        h_restartdacs(0), stopped = 1;
                    post("changing sample rate to %f", f);
                    h_setrate(f);
                }
                fixsettings = 1;
            }
        }
        else if (!strcmp(s1, "ch"))
        {
            int channels[MAXCP / 2], narg = MAXCP / 2;
            if (h_getint(s2, channels, &narg) || narg < 1)
                error("declare: %s: bad channel declaration", arg);
            else
            {
                int nboards = (h_nproc + 1) / 2, currentchans[MAXCP / 2],
                    i, doit = 0;
                if (!stopped)
                    h_restartdacs(0), stopped = 1;
                if (narg > nboards)
                {
                    if (!ouchedfornproc)
                    {
                        ouch("warning: patch declares %d boards; I only see %d", narg, nboards);
                        ouchedfornproc = 1;
                    }
                    narg = nboards;
                }
                h_getchans(currentchans);
                for (i = 0; i < narg; i++)
                    if (currentchans[i] != channels[i])
                        doit = 1, currentchans[i] = channels[i];
                if (doit)
                {
                    post("changing channel counts to:");
                    for (i = 0; i < nboards; i++)
                    {
                        postlong((long) (currentchans[i]));
                        if (i != nboards - 1)
                            poststring(":");
                    }
                    h_setchans(currentchans);
                }
                fixsettings = 1;
            }
        }
        else if (!strcmp(s1, "throttle"))
        {
            h_setthrottlestring(s2);
            fixsettings = 1;
        }
        else if (!strcmp(s1, "advance"))
        {
            h_setadvancesstring(s2);
            fixsettings = 1;
        }
        else if (!strcmp(s1, "path"))
            newpath = s2;
        else if (!strcmp(s1, "uselib"))
            uselib = atoi(s2);
        else
            error("declare: %s: unknown declaration", arg);
    }
    if ((uselib >= 0) || newpath)
        t_setpathandlib((newpath ? newpath : t_getdefpathstring()),
                        (uselib >= 0 ? uselib : t_getusestandardibs()));
    if (stopped)
        h_restartdacs(1);
#ifndef XMAX
    if (fixsettings)
        settings_reflect();
#endif
}
#endif

void *declare_class;

declare__getforpatcher(void *p, int *acp, t_symbol ***avp)
{
    int gotone = 0;
    if (s__declare.s_thing
        && ob_messlist(s__declare.s_thing) == declare_class)
    {
        t_declare *y;
        for (y = (t_declare *) (s__declare.s_thing); y; y = y->d_next)
        {
            if (y->d_patcher == p)
            {
                if (gotone)
                    post("warning: extra 'declare' ignored");
                else
                {
                    *acp = y->d_n;
                    *avp = y->d_stuff;
                    gotone = 1;
                }
            }
        }
    }
    if (!gotone)
        *acp = 0;
}

void declare_ff(t_declare *x)
{
#ifdef GRAPHICS
    if (s__declare.s_thing
        && ob_messlist(s__declare.s_thing) == declare_class)
    {
        t_declare stub, *y, *z;
        stub.d_next = (t_declare *) (s__declare.s_thing);
        for (y = &stub; z = y->d_next; y = z)
        {
            if (z == x)
            {
                y->d_next = z->d_next;
                break;
            }
        }
        s__declare.s_thing = (t_object *) (stub.d_next);
    }
    if (x->d_stuff)
        freebytes(x->d_stuff, x->d_n * sizeof(*x->d_stuff));
#endif
}

void declare_setup()
{
    c_new(&s_declare, declare_ff, sizeof(t_declare), 0, 1);
}

extern void *patcher_class;

void *declare_new(t_symbol *s, int ac, t_atom *av)
{
    t_symbol **sp;
    t_declare *x =
        (t_declare *) obj_new((t_messlist **) & declare_class,
                              declare_setup);
#ifdef GRAPHICS
    void *p = s__Pat.s_thing;
    if (!p || ob_messlist(p) != patcher_class)
    {
        bug("declare: can't find patcher");
        x->d_patcher = 0;
    }
    else
        x->d_patcher = patcher_getmain(p);
    x->d_n = ac;
    if (!(x->d_stuff = (t_symbol **) getbytes(ac * sizeof(*x->d_stuff))))
        error("declare_new: out of space");
    else
    {
        sp = x->d_stuff;
        while (ac--)
            *sp++ = atom_getsym(av++);
    }
    if (s__declare.s_thing
        && ob_messlist(s__declare.s_thing) != declare_class)
        bug("%s: not a declaration", s__declare.s_name);
    else
    {
        x->d_next = (t_declare *) s__declare.s_thing;
        s__declare.s_thing = (t_object *) x;
    }
#endif
    return (x);
}

typedef struct loadbang {
    t_object l_ob;
    struct loadbang *l_next;
    void *l_pat;
} t_loadbang;
void *loadbang_class;

#ifdef GRAPHICS
static int buildingit = 0;

loadbang__doit(flag)
{
    if (flag)
    {
        t_loadbang *x = (t_loadbang *) (gensym("#_loadbang_")->s_thing);
        if (x)
        {
            if (ob_messlist(x) == loadbang_class)
            {
                while (x)
                {
                    if (patcher_getcp(x->l_pat) >= 0)
                        h_vmess(x, &s_bang, "");
                    x = x->l_next;
                }
            }
            else
                error("#_loadbang_: not a loadbang");
        }
        gensym("#_loadbang_")->s_thing = 0;
        buildingit = 0;
    }
    else
    {
        if (buildingit)
            bug("loadbang__doit");
        buildingit = 1;
    }
}

void loadbang_setcp(x, cpno, flags)
t_loadbang *x;
{
    if (buildingit && (flags & CP_PUT))
    {
        t_symbol *s2 = gensym("#_loadbang_");
        t_loadbang *y = (t_loadbang *) s2->s_thing;
        if (y && ob_messlist(y) != loadbang_class)
        {
            error("#_loadbang_: not a loadbang");
            x->l_next = 0;
        }
        else
        {
            x->l_next = y;
            s2->s_thing = (t_object *) x;
        }
    }
}

#endif

void loadbang_ff(t_loadbang *x)
{
    gensym("#_loadbang_")->s_thing = 0;
}

void loadbang_bang(t_loadbang *x)
{
    outlet_bang(x->l_ob.o_outlet);
}

void loadbang_setup()
{
    c_new(&s_loadbang, loadbang_ff, sizeof(t_loadbang), 0, 1);
    c_addbang(loadbang_bang);
#ifdef GRAPHICS
    c_addmess(loadbang_setcp, &s_setcp, A_CANT, 0);
#endif
}

void *loadbang_new(t_symbol *s, int ac, t_atom *av)
{
    t_loadbang *x;
#ifdef GRAPHICS
    void *p = s__Pat.s_thing;
    if (!p || ob_messlist(p) != patcher_class)
    {
        bug("loadbang: can't find patcher");
        return (0);
    }
    x = (t_loadbang *) obj_new((t_messlist **) & loadbang_class,
                               loadbang_setup);
    x->l_pat = p;
#else
    x = (t_loadbang *) obj_new((t_messlist **) & loadbang_class,
                               loadbang_setup);
#endif
    outlet_new(x, &s_int);
    return (x);
}
