#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1993/11/19 10:51:48 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1993/11/19 10:51:48 $
 *
 * FTS by Miller Puckette
 *
 */


#include <stdio.h>
#include "m_mess.h"
#include "t_mac.h"
#include "t_wind.h"
#include "x_explode.h"
#include "p_pic.h"
#include "p_patcher.h"

extern t_symbol s_explode, s_update, s_append;

void *qelem_new();
void *explode_new(), explode_int(), explode_float(),
explode_in1(), explode_in2(), explode_in3(), explode_in4(),
explode_nth(), explode_startat(), explode_followat(),
explode_update(), explode_click(), explode_dblclick(),
explode_wsize(), explode_chkscroll(),
explode_save(), explode_list(), explode_params(),
explode_clear(), explode_start(), explode_follow(),
explode_next(), explode_record(), explode_stop(),
explode_key(), explode_setcp(),
explode_dispose(), explode_cut(), explode_copy(), explode_paste(),
explode_clr(), explode_chkmenu(), explode_saveto(), explode_selectall();

void *explode_class;
void explode_init()
{
    long i;

    /* set up the class creator's arguments and the inst size */
    c_new(&s_explode, explode_dispose, sizeof(t_explode), 0, 0);
    c_addmess(explode_next, gensym("next"), 0);
    c_addint(explode_int);      /* "int" method */
    c_addfloat(explode_float);  /* "float" method */
    c_addinx(explode_in1, 1);   /* "int" in 4 inlets */
    c_addinx(explode_in2, 2);
    c_addinx(explode_in3, 3);
    c_addinx(explode_in4, 4);

    c_addmess(explode_nth, gensym("nth"), A_DEFLONG, 0);
    c_addmess(explode_list, gensym("list"), A_GIMME, 0);
    c_addmess(explode_clear, gensym("clear"), 0);
    c_addmess(explode_start, gensym("start"), 0);
    c_addmess(explode_record, gensym("record"), 0);

    c_addmess(explode_stop, gensym("stop"), 0);
    c_addmess(explode_follow, gensym("follow"), A_DEFLONG, 0);
    c_addmess(explode_startat, gensym("startat"), A_LONG, A_LONG, A_LONG,
              0);
    c_addmess(explode_followat, gensym("followat"), A_LONG, A_LONG, A_LONG,
              0);
    c_addmess(explode_update, gensym("update"), A_CANT, 0);
    c_addmess(explode_click, gensym("click"), A_CANT, 0);
    c_addmess(explode_dblclick, gensym("dblclick"), A_CANT, 0);
    c_addmess(explode_dblclick, gensym("filename"), A_CANT, 0);

    c_addmess(explode_chkscroll, gensym("chkscroll"), A_CANT, 0);
    c_addmess(explode_chkscroll, gensym("wsize"), A_CANT, 0);
    c_addmess(explode_record, gensym("restore"), 0);
    c_addmess(explode_save, gensym("save"), A_CANT, 0);
    c_addmess(explode_key, gensym("key"), A_CANT, 0);
    c_addmess(explode_saveto, gensym("saveto"), A_CANT, 0);
    c_addmess(explode_cut, gensym("cut"), A_CANT, 0);
    c_addmess(explode_copy, gensym("copy"), A_CANT, 0);
    c_addmess(explode_paste, gensym("paste"), A_CANT, 0);
    c_addmess(explode_clr, gensym("clr"), A_CANT, 0);
    c_addmess(explode_chkmenu, gensym("chkmenu"), A_CANT, 0);
    c_addmess(explode_setcp, gensym("setcp"), A_CANT, 0);
    c_addmess(explode_params, gensym("params"), A_LONG, A_LONG, A_LONG, 0);
    c_addmess(explode_selectall, gensym("selectall"), A_CANT, 0);

    post("explode version 0.05/NeXT");
    RestoreA4();
}

t_pointinrect(x, y, a, b, c, d)
{
    return (x >= a && x < c && y >= b && y < d);
}

t_printi(s, n)
char *s;
long n;
{
    sprintf(s, "%ld", n);
}

long t_scani(s)
char *s;
{
    long n = 0;
    sscanf(s, "%ld", &n);
    return (n);
}

long YVAL(x, pix)
t_explode *x;
{
    if (x->x_whatgrid)
        return (((BOTTOM(x) - (long) (pix)) * (x)->x_yscale) >> YSH);
    else
    {
        /* int key = ((CZERO + 1) - pix)/3; */
        int key = (BOTTOM(x) - (long) (pix + 3)) / 3;
        long midino = (12 * key + 5) / 7;
        return ((midino * (x)->x_yscale) >> 2);
    }
}

                                /*static*/ int sharp;
                                /* flag that YLOC calc gave a sharp */
#define TOPY (XLABELMARGIN+7)

YLOC(x, t)
t_explode *x;
long t;
{
    if (x->x_whatgrid)
    {
        int mofo = (((long) (t)) << YSH) / (x)->x_yscale;
        sharp = 0;
        return (mofo < 0 ? BOTTOM(x) :
                (mofo >= BOTTOM(x) - TOPY ? TOPY : BOTTOM(x) - mofo));
    }
    else
    {
        int mofo, xxx = (((long) (t)) << 2) / (x)->x_yscale;
        int key = (7 * xxx + 1) / 12, pix;
        /* if (key < 0) key = 0;
           else if (key >= MAXKEY) key = MAXKEY - 1; */
        sharp = !(key - (7 * xxx - 6) / 12);
        mofo = 3 * key + 3;
        return (mofo < 0 ? BOTTOM(x) :
                (mofo >= BOTTOM(x) - TOPY ? TOPY : BOTTOM(x) - mofo));
    }
}

explode_drawpic(x, n, x1, y1, a, b, c, d)
t_explode *x;
{
    t_drawbits(n, x1, y1, a, b, c, d);
}

explode_drawpanel(x, erasetoggles)
t_explode *x;
char erasetoggles;
{
    long ix;
    int pix, x1, y1, sub;
    GrafPort *goo = wind_marginport(x->x_wind);
    /* draw control panel */
    t_textsize(1);
    t_eraserect(ERASEMODEX1, ERASEMODEY1, ERASEMODEX2, ERASEMODEY2);
    if (erasetoggles)
        t_eraserect(TOGGLEX1, TOGGLEY1, TOGGLEX2, TOGGLEY2);
    explode_drawpic(x, PICPANEL, 0, 0, -1, -1,
                    PANELWIDTH + 1, TOPSCROLLMARGIN - TIMELABEL);
    /* indicate mode */
    switch (x->x_mode)
    {
    case MDRAW:
        t_invertrect(DRAWX1 + 1, DRAWY1 + 1, DRAWX2, DRAWY2);
        break;
    case MVERT:
        t_invertrect(VERTX1 + 1, VERTY1 + 1, VERTX2, VERTY2);
        break;
    case MHORIZ:
        t_invertrect(HORIZX1 + 1, HORIZY1 + 1, HORIZX2, HORIZY2);
        break;
    case MPLAY:
        t_invertrect(PLAYX1 + 1, PLAYY1 + 1, PLAYX2, PLAYY2);
        break;
    case MRECORD:
        t_invertrect(RECORDX1 + 1, RECORDY1 + 1, RECORDX2, RECORDY2);
        break;
    case MFOLLOW:
        t_invertrect(FOLLOWX1 + 1, FOLLOWY1 + 1, FOLLOWX2, FOLLOWY2);
        break;
    }
    /* indicate toggle settings */
    if (x->x_showgrid)
        t_paintrect(BOXX1, BOXY1, BOXX1 + PARAMHEIGHT,
                    BOXY1 + PARAMHEIGHT);
    if (x->x_editrange)
        t_paintrect(BOXX1, BOXY1 + 20, BOXX1 + PARAMHEIGHT,
                    BOXY1 + 20 + PARAMHEIGHT);
    /* draw parameter fields */
    explode_drawfields(x);
    /* blacken edit field settings */
    y1 = PSELECTY1 + PARAMHEIGHT * x->x_yshow;
    t_paintrect(PSELECTX1, y1, PSELECTX1 + PARAMHEIGHT, y1 + PARAMHEIGHT);
    y1 = PSELECTY1 + PARAMHEIGHT * x->x_wshow;
    t_paintrect(PSELECTX1 + PARAMHEIGHT, y1, PSELECTX1 + 2 * PARAMHEIGHT,
                y1 + PARAMHEIGHT);
    if (x->x_nshow >= 0)
    {
        y1 = PSELECTY1 + PARAMHEIGHT * x->x_nshow,
            t_paintrect(PSELECTX1 + 2 * PARAMHEIGHT, y1,
                        PSELECTX1 + 3 * PARAMHEIGHT, y1 + PARAMHEIGHT);
    }
    /* draw rectangle for edit area (done on NeXT by scrollview) */
    /* t_framerect(0, TOPSCROLLMARGIN, W_WIDTH(x->x_wind),
       TOPSCROLLMARGIN + 1); */
    /* erase rectangle to draw y coordinates */
    t_eraserect(0, TOPSCROLLMARGIN, LEFTSCROLLMARGIN - 1,
                TOPSCROLLMARGIN + BOTTOM(x));
    /* draw y coordinates */
    sub = (x->x_whatgrid == GRID10 ? BGHEIGHT10 :
           (x->x_whatgrid == GRID12 ? BGHEIGHT12 : BGHEIGHTCLEF));
    for (ix = BOTTOM(x) - (x->x_whatgrid == GRIDCLEF ? 24 : 0);
         ix > YMARGIN; ix -= sub)
        t_drawlong(2, (int) (ix + 4) + TOPSCROLLMARGIN, YVAL(x, (int) ix));
    /* draw get-send buttons */
    explode_drawgetsend(x);
    t_resetport(goo);
}

explode_drawfields(x)           /* update selected parameter values */
t_explode *x;
{
    int gotone, i;
    GrafPort *goo = wind_marginport(x->x_wind);
    /* if editing the range, print ranges and units */
    t_textsize(1);
    if (x->x_editrange)
    {
        for (i = 0; i < NPARAM; i++)
        {
            int y = PARAMHEIGHT * i + (PARAMY1 + 1);
            long val = (x->x_bullet == i && x->x_gotkeys ?
                        (x->x_typenum << 2) : x->x_scale[i]);
            t_eraserect(PARAMX1 + 1, y, PRANGEARROWX1, y + 11);
            if (val >= 4)
            {
                t_drawstring(PARAMX1 + PPRINTX, y + 9, "1:");
                t_drawlong(PARAMX1 + PPRINTRANGEX, y + 9, val >> 2);
            }
            else if (val >= 2)
                t_drawstring(PARAMX1 + PPRINTX, y + 9, "2:1");
            else
                t_drawstring(PARAMX1 + PPRINTX, y + 9, "4:1");
            explode_drawpic(x, PICARROWS, 0, 0,
                            PRANGEARROWX1, y, PRANGEMODEX1, y + 11);
            if (i)
                explode_drawpic(x, PICCLEF + x->x_paramgrid[i], 0, 0,
                                PRANGEMODEX1, y, PARAMX2, y + 11);
        }
    }
    else                        /* otherwise print out parameter values */
    {
        t_evt *e;
        char same[NPARAM];
        for (i = 0; i < NPARAM; i++)
            same[i] = 1;
        for (gotone = 0, e = x->x_evt; e; e = e->e_next)
            if (e->e_selected)
            {
                long *lp1, *lp2;
                char *sc;
                if (!gotone)
                {
                    for (lp1 = x->x_param, lp2 = &e->e_time, i = NPARAM;
                         i--;)
                        *lp1++ = *lp2++;
                    gotone = 1;
                }
                else
                {
                    for (lp1 = x->x_param, lp2 = &e->e_time, sc = same, i =
                         NPARAM; i--; sc++)
                        if (*lp1++ != *lp2++)
                            *sc = 0;
                }
            }
        if (x->x_bullet >= 0 && x->x_gotkeys)
            x->x_param[x->x_bullet] = x->x_typenum;
        for (i = 0; i < NPARAM; i++)
        {
            int y = PARAMHEIGHT * i + (PARAMY1 + 1);
            t_eraserect(PARAMX1 + 1, y, PARAMX2, y + 11);
            if (same[i])
                t_drawlong(PARAMX1 + PPRINTX, y + 9, x->x_param[i]);
            else
                t_drawstring(PARAMX1 + 2, y + 9, "*");
        }
    }
    /* paint the bullet if any */
    if (x->x_bullet >= 0)
    {
        int y = PARAMHEIGHT * x->x_bullet + PARAMY1;
        t_paintrect(PARAMX1 + BULLETX1, y + BULLETY1, PARAMX1 + BULLETX2,
                    y + BULLETY2);
    }
    t_resetport(goo);
}

/* explode_normalclip(x)
   t_explode *x;
   {
   t_cliprect(0, 0, W_WIDTH(x->x_wind) - SBARWIDTH,
   W_HEIGHT(x->x_wind) - SBARWIDTH);
   } */

/* t_copybits(bm1, bm2, srcbounds, a, b, c, d)
   BitMap *bm1, *bm2;
   Rect *srcbounds;
   { 
   Rect r;
   r.left = a;
   r.right = b;
   r.top = c;
   r.bottom = d;
   CopyBits(bm1, bm2, srcbounds, &r, srcCopy, NIL);
   } */

explode_drawpattern(x, a, b, c, d)
t_explode *x;
{
    Rect big;
    int bgheight, i, j, wmax = W_HEIGHT(x->x_wind) - SBARWIDTH,
        waka, marginmod, which;
    if (x->x_showgrid)
    {
        if (x->x_whatgrid == GRIDCLEF)
            which = BGCLEF, bgheight = CLEFHEIGHT;
        else if (x->x_whatgrid == GRID10)
            which = BG10, bgheight = BGHEIGHT;
        else if (x->x_whatgrid == GRID12)
            which = BG12, bgheight = BGHEIGHT;
        waka = a - (XMARGIN % BGWIDTH);
        big.left = (XMARGIN % BGWIDTH) + (waka - (waka % BGWIDTH));
        waka = c + ((BGWIDTH - 1) - (XMARGIN % BGWIDTH));
        big.right = (XMARGIN % BGWIDTH) + (waka - (waka % BGWIDTH));
        waka = b - marginmod;
        big.top = YMARGIN - bgheight;
        big.bottom = BOTTOM(x) + 2;
        for (i = big.left; i < big.right; i += BGWIDTH)
        {
            for (j = big.bottom; j > big.top - bgheight; j -= bgheight)
            {
                explode_drawpic(x, which, a - i, b - j - bgheight,
                                a, b, c, d);
            }
        }
    }
    else
        t_eraserect(a, b, c, d);
}

explode_drawbg(x)
t_explode *x;
{
    int bottom = W_HEIGHT(x->x_wind) - SBARWIDTH;
    int width = W_WIDTH(x->x_wind) - SBARWIDTH;
    if (bottom > BOTTOM(x))
        bottom = BOTTOM(x);
    explode_drawpattern(x, XMARGIN, YMARGIN, width, bottom);
}

explode_drawit(x, e)
t_explode *x;
t_evt *e;
{
    int temp, x1 = EVTX(x, e) - XOFFSET(x), y = EVTY(x, e), w = EVTW(x, e);
    /* if (x1 + w < XMARGIN || x1 > W_WIDTH(x->x_wind)) return; */
    /* if (x1 < XMARGIN) w = x1 + w - XMARGIN, x1 = XMARGIN; */
    t_paintrect(x1, y, x1 + w, y + EVTDRAWDOWN(x, e));
    if (x->x_nshow >= 0)
        t_drawlong(x1, y - 2, (&(e)->e_time)[x->x_nshow]);
    if (sharp)
        t_drawstring(x1 - 7, y + 6, "#");
    e->e_dirty = 0;
}

explode_drawdirty(x)
t_explode *x;
{
    t_evt *e;
    for (e = x->x_evt; e; e = e->e_next)
        if (e->e_dirty)
            explode_drawit(x, e), e->e_dirty = 0;
}

explode_eraseit(x, e)
t_explode *x;
t_evt *e;
{
    int temp, t2, t3,
        y = EVTY(x, e), y1 = y + EVTUP(x, e), y2 = y + EVTDOWN(x, e),
        x0 = EVTX(x, e) - XOFFSET(x),
        x1 = x0 + EVTLEFT(x, e), x2 = x0 + EVTRIGHT(x, e);
    explode_eraserect(x, x1, y1, x2, y2);
}

explode_eraserect(x, x1, y1, x2, y2)
t_explode *x;
{
    t_evt *e2;
    int temp, t2, t3;
    if (y1 < XLABELMARGIN)
        y1 = XLABELMARGIN;
    explode_drawpattern(x, x1, y1, x2, y2);
    for (e2 = x->x_evt; e2; e2 = e2->e_next)
        if ((t3 = EVTY(x, e2)) + EVTUP(x, e2) < y2 &&
            y1 < t3 + EVTDOWN(x, e2) &&
            (t2 = (EVTX(x, e2) - XOFFSET(x))) < x2 &&
            x1 < t2 + EVTRIGHT(x, e2))
            e2->e_dirty = 1;
    x->x_qflags[QDRAWEVTS] = 1;
    qelem_set(x->x_qelem);
}

#if(0)
void explode_drawevts(x)
t_explode *x;
{
    int a, b, c, d;
    t_evt *e;
    t_textsize(1);
    wind_getupdaterect(x->w_wind, &a, &b, &c, &d);
    for (e = x->x_evt; e; e = e->e_next)
    {
        int left = EVTX(x, e);
        if (left > c)
            break;
        if (left + EVTRIGHT(x, e) >= a)
            explode_drawit(x, e);
    }
}
#endif

explode_nwidth(x, e)
t_explode *x;
t_evt *e;
{
    int temp, w = EVTW(x, e);
    if (x->x_nshow >= 0)
    {
        char buf[20];
        int w2;
        t_printi(buf, (&(e)->e_time)[x->x_nshow]);
        w2 = t_stringwidth(buf);
        return (w2 > w ? w2 : w);
    }
    else
        return (w);
}

void explode_remax(x)
t_explode *x;
{
    long tmax = 0, t1, ymax = 0;
    t_evt *e;
    for (e = x->x_evt; e; e = e->e_next)
    {
        if ((t1 = e->e_time * x->x_wscale +
             (&(e)->e_time)[x->x_wshow] * x->x_xscale) > tmax)
            tmax = t1;
        if ((t1 = (&(e)->e_time)[x->x_yshow]) > ymax)
            ymax = t1;
    }
    t1 = ((tmax / (x->x_xscale * x->x_wscale)) << XSH) >> SCROLLSHIFT;
    if (t1 < 0)
        t1 = 0;
    else if (t1 > 1000000)
        t1 = 1000000;
    if (x->x_wind->w_xoffset > t1)
        t1 = x->x_wind->w_xoffset;
    x->x_xmax = t1;
    x->x_ymax = (ymax / x->x_yscale << YSH) >> SCROLLSHIFT;
}

void explode_update(x, margin)
t_explode *x;
{
    if (margin)
        explode_drawpanel(x, 0);
    else
    {
        int a, b, c, d, pix, leftshow, rightshow;
        t_evt *e;
        t_textsize(1);
        wind_getupdaterect(x->x_wind, &a, &b, &c, &d);
        leftshow = a + XOFFSET(x);
        rightshow = c + XOFFSET(x);

        if (a < -1000000)
            bug("update");
        explode_drawpattern(x, a, b + XLABELMARGIN, c, d);
        for (e = x->x_evt; e; e = e->e_next)
        {
            int left = EVTX(x, e), temp;
            if (left > rightshow)
                break;
            if (left + EVTRIGHT(x, e) >= leftshow)
                explode_drawit(x, e);
        }
        /* draw x coordinates */
        t_eraserect(a, 0, c, XLABELMARGIN);
        for (pix = a - (a % (2 * BGWIDTH)); pix <= c; pix += 2 * BGWIDTH)
        {
            t_paintrect(pix, XLABELMARGIN - 2, pix + 1, XLABELMARGIN);
            t_drawlong(pix + 1, XLABELMARGIN - 2,
                       XVAL(x, (XOFFSET(x) + pix)));
        }
    }
}

void explode_dblclick(x)
t_explode *x;
{
    SetUpA4();
    wind_vis(x->x_wind);
    explode_chkscroll(x);
    RestoreA4();
}

void explode_chkscroll(x)
t_explode *x;
{
    wind_setscrollrect(x->x_wind, 0, 0, (int) x->x_xmax, (int) x->x_ymax);
}

struct binbuf;
void binbuf_insert(struct binbuf *x, struct symbol *s, int argc,
                   struct atom *argv);

void explode_save(x, w)
t_explode *x;
void *w;
{
    struct symbol *s;
    t_evt *e;
    long last;

    SetUpA4();
    last = 0;
    s = gensym("#X");
    vfun(w, binbuf_insert, NIL, "ss", gensym("#N"), gensym("explode"));
    vfun(w, binbuf_insert, NIL, "ss", s, gensym("restore"));
    for (e = x->x_evt; e; e = e->e_next)
    {
        vfun(w, binbuf_insert, NIL, "slllll",
             s, e->e_time - last, e->e_pit, e->e_vel, e->e_dur, e->e_chan);
        last = e->e_time;
    }
    vfun(w, binbuf_insert, NIL, "ss", s, gensym("stop"));
    RestoreA4();
}

explode_qfn(x)
t_explode *x;
{
    GrafPort *p;
    SetUpA4();
    p = wind_setport(x->x_wind);
    if (p)
    {
        int i;
        char qtemp[NQFLAGS];
        for (i = 0; i < NQFLAGS; i++)
            qtemp[i] = x->x_qflags[i], x->x_qflags[i] = 0;
        if (qtemp[QDRAWBG])
            explode_drawbg(x);
        if (qtemp[QDRAWEVTS])
            explode_drawdirty(x);
        if (qtemp[QDRAWPANEL])
            explode_drawpanel(x, qtemp[QERASETOGGLES]);
        if (qtemp[QREMAX])
            explode_remax(x);
        explode_chkscroll(x);
        t_resetport(p);
    }
    RestoreA4();
}

explode_clk(x)
t_explode *x;
{
    SetUpA4();
    RestoreA4();
}

explode_sendtocp(x)
t_explode *x;
{
    t_evt *e;
    long t = 0;
    h_vmess(x, &s_update, "l", (long) HC_STARTUPD);
    for (e = x->x_evt; e; e = e->e_next)
    {
        h_vmess(x, &s_append, "lllll", e->e_time - t,
                e->e_pit, e->e_vel, e->e_dur, e->e_chan);
        t = e->e_time;
    }
    h_vmess(x, &s_update, "l", (long) HC_DONEUPD);
    explode_setdiff(x, 0);
}

explode_getfromcp(x)
t_explode *x;
{
    h_vmess(x, &s_update, "l", HC_REQEVT);
    explode_record(x);
}

explode_setdiff(x, n)
t_explode *x;
{
    GrafPort *goo = wind_marginport(x->x_wind);
    x->x_cpdiff = n;
    if (goo)
    {
        explode_drawgetsend(x);
        t_resetport(goo);
    }
}

explode_drawgetsend(x)
t_explode *x;
{
    if (x->x_cpdiff && x->x_cpr)
        explode_drawpic(x, PICGETSEND, 0, 0, GETSENDX1, GETSENDY1,
                        GETSENDX1 + GETSENDW, GETSENDY1 + GETSENDH);
    else
        t_eraserect(GETSENDX1, GETSENDY1, GETSENDX1 + GETSENDW,
                    GETSENDY1 + GETSENDH);
}

void explode_cpr(x, buf, n)
t_explode *x;
long *buf;
{
    switch (buf[0])
    {
    case CH_EVENT:
        if (x->x_mode != MRECORD)
            bug("explode: not in record for update");
        else if (n < (NPARAM + 1) * sizeof(long))
            bug("explode: bad update message");
        else
        {
            x->x_n4 = buf[5];
            x->x_n3 = buf[4];
            x->x_n2 = buf[3];
            x->x_n1 = buf[2];
            x->x_set1 = x->x_set2 = x->x_set3 = 1;
            explode_int(x, buf[1]);
        }
        break;
    case CH_DONEUPD:
        explode_stop(x);
        explode_setdiff(x, 0);
        break;
    case CH_NOTDONEUPD:
        h_vmess(x, &s_update, "l", HC_REQEVT);
        break;
    case CH_DIRTY:
        explode_setdiff(x, 1);
        break;
    case CH_REQSEND:
        explode_getfromcp(x);
        break;
    }
}

explode_markdirty()
{
}

void *cpr_new();

void explode_setcp(x, n, flags)
t_explode *x;
{
    if (flags & CP_UNPUT)
    {
        if (x->x_cpr)
        {
            cpr_free(x->x_cpr);
            x->x_cpr = 0;
        }
    }
    if (flags & CP_PUT)
    {
        x->x_cpr = cpr_new(x, explode_cpr);
        explode_sendtocp(x);
    }
}

void explode_dispose(x)
t_explode *x;
{
    struct symbol *s;

    SetUpA4();
    explode_clear(x);
    obj_free(x->x_wind);
    qelem_free(x->x_qelem);
    if (x->x_sym->s_thing
        && ob_messlist(x->x_sym->s_thing) == explode_class)
    {
        t_explode stub, *y, *z;
        stub.x_next = (t_explode *) (x->x_sym->s_thing);
        for (y = &stub; z = y->x_next; y = z)
        {
            if (z == x)
            {
                y->x_next = z->x_next;
                break;
            }
        }
        x->x_sym->s_thing = (t_object *) (stub.x_next);
    }
    RestoreA4();
}

void *explode_new(t_symbol *s)
{
    t_explode *x;
    int i;

    SetUpA4();
    x = (t_explode *) obj_new((t_messlist **) & explode_class,
                              explode_init);
    explode_init1(x, s);
    x->x_wind = wind_new(x, 0, 0, 800, 380, WGROW | WCLOSE | WSCROLLX);
    wind_setscrollparams(x->x_wind, LEFTSCROLLMARGIN, TOPSCROLLMARGIN, 0,
                         0);
    wind_settitle(x->x_wind, (*s->s_name ? s->s_name : s_explode.s_name));
    x->x_qelem = qelem_new(x, explode_qfn);
    x->x_wind->w_scrollgrain = 32;
    x->x_savemode = x->x_mode;
    x->x_yshow = PPIT;
    x->x_wshow = PDUR;
    x->x_nshow = -1;
    x->x_xscale = x->x_wscale = XDIV;
    x->x_yscale = x->x_nscale = 4;
    x->x_scale[0] = XDIV;
    x->x_scale[1] = 4;
    x->x_scale[2] = 4;
    x->x_scale[3] = XDIV;
    x->x_scale[4] = 1;
    x->x_param[0] = 0;
    x->x_param[1] = 0;
    x->x_param[2] = 64;
    x->x_param[3] = 0;
    x->x_param[4] = 1;
    x->x_bullet = -1;
    x->x_gotkeys = 0;
    x->x_editrange = 0;
    x->x_showgrid = 1;
    for (i = 0; i < NQFLAGS; i++)
        x->x_qflags[i] = 0;
    x->x_paramgrid[1] = x->x_paramgrid[2] = x->x_paramgrid[3] =
        x->x_paramgrid[4] = x->x_whatgrid = GRID12;
    x->x_typenum = 0;
    x->x_scrollmax = 0;
    x->x_cpr = 0;
    x->x_cpdiff = 0;
    x->x_xmax = x->x_ymax = 0;
    explode_clear(x);
    gensym("#X")->s_thing = (struct object *) x;
    RestoreA4();
    return (x);
}
