#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1994/01/29 07:49:56 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/01/29 07:49:56 $
 *
 * FTS by Miller Puckette
 *
 */


#include "m_mess.h"
#include "t_mac.h"
#include "t_wind.h"
#include "x_explode.h"
#include "p_pic.h"

void explode_copy(), explode_paste();
/* exp3.c -- mouse and key handling */

static int modkeywas;           /* mod keys at time of last click */

explode_zap(x, e)
t_explode *x;
t_evt *e;
{
    t_evt *e2, *e3, *et;
    t_evt stub;
    long t = e->e_time, xxx;
    stub.e_next = x->x_evt;
    x->x_qflags[QREMAX] = 1;
    explode_eraseit(x, e);
    if (!x->x_cpdiff)
        explode_setdiff(x, 1);
    for (e2 = &stub; e3 = e2->e_next; e2 = e3)
    {
        if (e3 == e)
        {
            e2->e_next = e3->e_next;
            break;
        }
    }
    x->x_evt = stub.e_next;
    if (x->x_current == e)
        x->x_current = 0;
    freebytes(e, sizeof(t_evt));
}

void kdrag(x, pt, but)
t_explode *x;
Point pt;
{
    SetUpA4();
    if (but)
    {
        long wval = WVAL(x, pt.h - x->x_refpoint.h);
        t_evt *e = x->x_current;
        if (wval < 0)
            wval = 0;
        explode_eraseit(x, e);
        (&e->e_time)[x->x_wshow] = wval;
        explode_drawit(x, e);
        explode_drawfields(x);
    }
    else
        explode_remax(x);
    RestoreA4();
}

void explode_click(x, pt, dbl, mod)
t_explode *x;
Point pt;
{
    modkeywas = mod;
    /* post("click %d %d",  pt.h,  pt.v);
       post("wind %d %d", x->x_wind->w_x2 -  x->x_wind->w_x1, 
       x->x_wind->w_y2 -  x->x_wind->w_y1); */
    if (mod & inMargin)
    {
        GrafPort *gp = wind_marginport(x->x_wind);
        explode_panel(x, pt, dbl, mod);
        t_resetport(gp);
    }
    else if (pt.h > XMARGIN && pt.v > YMARGIN && pt.v <= BOTTOM(x))
    {
        switch (x->x_mode)
        {
        case MDRAW:
            explode_drawmouse(x, pt, dbl, mod);
            break;
        case MVERT:
            explode_vertmouse(x, pt, dbl, mod);
            break;
        case MHORIZ:
            explode_horizmouse(x, pt, dbl, mod);
            break;
        }
    }
}

explode_panel(x, pt, dbl, mod)
t_explode *x;
Point pt;
{
    if (t_pointinrect(pt.h, pt.v, DRAWX1, DRAWY1, DRAWX2, DRAWY2))
        explode_editmode(x, MDRAW);
    else if (t_pointinrect(pt.h, pt.v, VERTX1, VERTY1, VERTX2, VERTY2))
        explode_editmode(x, MVERT);
    else if (t_pointinrect(pt.h, pt.v, HORIZX1, HORIZY1, HORIZX2, HORIZY2))
        explode_editmode(x, MHORIZ);
    else if (pt.h >= PARAMX1 && pt.h < PARAMX2)
        explode_bullet(x, pt);
    else if (pt.h >= TOGGLEX1 && pt.h < TOGGLEX2)
        explode_toggle(x, pt);
    else if (pt.h >= PSELECTX1 && pt.h < PSELECTX2)
        explode_psel(x, pt);
    else if (pt.h >= GETSENDX1 && pt.h < GETSENDX2)
        explode_clickgetsend(x, pt);
}

explode_editmode(x, mode)
t_explode *x;
{
    x->x_savemode = mode;
    explode_stop(x);
    x->x_qflags[QERASEMODE] = 1;
    qelem_set(x->x_qelem);
}

explode_psel(x, pt)
t_explode *x;
Point pt;
{
    int what = (pt.h - PSELECTX1) / PARAMHEIGHT,
        towhat = (pt.v - PSELECTY1) / PARAMHEIGHT,
        was = (what ? (what == 1 ? x->x_wshow : x->x_nshow) : x->x_yshow);
    if (what == 2 && towhat == was)
        towhat = -1;
    else if (towhat < 0 || towhat >= NPARAM || towhat == was)
        return;
    if (!what)
        x->x_yshow = towhat, x->x_yscale = x->x_scale[towhat],
            x->x_whatgrid = x->x_paramgrid[towhat];
    else if (what == 1)
        x->x_wshow = towhat, x->x_wscale = x->x_scale[towhat];
    else
        x->x_nshow = towhat,
            x->x_nscale = (towhat >= 0 ? x->x_scale[towhat] : 1);
    t_eraserect(PSELECTX1, PSELECTY1, PSELECTX2, YMARGIN - TIMELABEL);
    explode_setportandupdate(x);
}

explode_setportandupdate(x)
t_explode *x;
{
    GrafPort *gp = wind_setport(x->x_wind);
    explode_update(x, 0);
    t_resetport(gp);
    explode_update(x, 1);
}

explode_clickgetsend(x, pt)
t_explode *x;
Point pt;
{
    if (!(x->x_cpdiff && x->x_cpr))
        return;
    if (pt.h >= BSENDX1 && pt.h < BSENDX2
        && pt.v >= BSENDY1 && pt.v < BSENDY2)
        explode_sendtocp(x);
    else if (pt.h >= BGETX1 && pt.h < BGETX2
             && pt.v >= BGETY1 && pt.v < BGETY2)
        explode_getfromcp(x);
}

explode_bullet(x, pt)
t_explode *x;
Point pt;
{
    long towhat = (pt.v - PARAMY1) / PARAMHEIGHT;
    if (towhat < 0 || towhat >= NPARAM)
        return;
    if (pt.h >= PRANGEARROWX1 && x->x_editrange)
    {
        if (pt.h >= PRANGEMODEX1)
        {
            char foo = x->x_paramgrid[towhat] + 1;
            if (foo == 3)
                foo = 0;
            x->x_paramgrid[towhat] = foo;
            if (x->x_yshow == towhat)
                x->x_whatgrid = foo;
        }
        else
        {
            long scale = x->x_scale[towhat];
            if (pt.v - (towhat * PARAMHEIGHT + PARAMY1) >= 6)
                scale <<= 1;
            else
                scale >>= 1;
            explode_setscale(x, scale, towhat);
        }
    }
    else
    {
        x->x_bullet = towhat;
        x->x_typenum = 0;
        x->x_gotkeys = 0;
    }
    explode_setportandupdate(x);
}

explode_toggle(x, pt)
t_explode *x;
Point pt;
{
    if (pt.v >= UNUSEDY)
    {
        if (pt.h <= TOGGLEX1 + 14)
        {
            x->x_wind->w_xoffset -=
                (x->x_wind->w_x2 - x->x_wind->w_x1) / 2;
            if (x->x_wind->w_xoffset < 0)
                x->x_wind->w_xoffset = 0;
            explode_setportandupdate(x);
        }
        else if (pt.h >= TOGGLEX1 + 17 && pt.h <= TOGGLEX1 + (14 + 17))
        {
            x->x_wind->w_xoffset +=
                (x->x_wind->w_x2 - x->x_wind->w_x1) / 2;
            if (x->x_wind->w_xoffset >
                x->x_xmax + x->x_wind->w_x1 - x->x_wind->w_x2 + 20)
                x->x_wind->w_xoffset =
                    x->x_xmax + x->x_wind->w_x1 - x->x_wind->w_x2 + 20;
            if (x->x_wind->w_xoffset < 0)
                x->x_wind->w_xoffset = 0;
            explode_setportandupdate(x);
        }
    }
    else if (pt.v >= EDITRANGEY)
        x->x_editrange = !x->x_editrange;
    else
    {
        GrafPort *gp = wind_setport(x->x_wind);
        x->x_showgrid = !x->x_showgrid;
        explode_setportandupdate(x);
        t_resetport(gp);
    }
    x->x_qflags[QERASETOGGLES] = x->x_qflags[QDRAWPANEL] = 1;
    qelem_set(x->x_qelem);
}

explode_link(x, e)
t_explode *x;
t_evt *e;
{
    t_evt *e2, *e3;
    t_evt stub;
    long t = e->e_time;
    stub.e_next = x->x_evt;
    for (e2 = &stub;;)
    {
        if (!(e3 = e2->e_next) || e3->e_time >= t)
        {
            e->e_next = e2->e_next;
            e2->e_next = e;
            break;
        }
        else
            e2 = e3;
    }
    x->x_evt = stub.e_next;
}

explode_drawmouse(x, pt, dbl, mod)
t_explode *x;
Point pt;
{
    long xval = XVAL(x, pt.h + XOFFSET(x));
    long yval = YVAL(x, pt.v);
    t_evt *e = (t_evt *) getbytes(sizeof(t_evt));
    if (!(mod & shiftKey))
        explode_noselect(x);
    e->e_time = xval;
    e->e_pit = yval;
    e->e_dur = 0;
    e->e_vel = x->x_param[PVEL];
    e->e_chan = x->x_param[PCHAN];
    explode_link(x, e);
    explode_select(x, e);
    explode_drawit(x, e);
    x->x_current = e;
    x->x_refpoint = pt;
    wind_drag(x->x_wind, kdrag, x);
    if (!x->x_cpdiff)
        explode_setdiff(x, 1);
}

explode_mergeselection(x)
t_explode *x;
{
    t_evt stub2, stub3, *e, *e2 = &stub2, *e3 = &stub3;
    /* 1. split into two lists */
    for (e = x->x_evt; e; e = e->e_next)
        if (e->e_selected)
            e2->e_next = e, e2 = e;
        else
            e3->e_next = e, e3 = e;
    e2->e_next = e3->e_next = 0;
    /* 2. remerge */
    e = &stub2;
    e2 = stub2.e_next;
    e3 = stub3.e_next;
    while (1)
    {
        if (e2)
        {
            if (e3)
            {
                if (e2->e_time < e3->e_time)
                    goto put2;
                else
                    goto put3;
            }
            else
                goto put2;
        }
        else if (e3)
            goto put3;
        else
            break;
      put2:
        e->e_next = e2;
        e = e2;
        e2 = e2->e_next;
        goto doneput;
      put3:
        e->e_next = e3;
        e = e3;
        e3 = e3->e_next;
      doneput:;
    }
    e->e_next = 0;
    x->x_evt = stub2.e_next;
}

explode_offset(x, diff, which)
t_explode *x;
long diff, which;
{
    t_evt *e;
    for (e = x->x_evt; e; e = e->e_next)
        if (e->e_selected)
        {
            explode_eraseit(x, e);
            (&(e)->e_time)[which] += diff;
            e->e_dirty = 1;
        }
    /* if changing times resort */
    if (which == PTIME)
        explode_mergeselection(x);
    explode_drawfields(x);
    if (!x->x_cpdiff)
        explode_setdiff(x, 1);
}

void dragp1(x, pt, but)
t_explode *x;
Point pt;
{
    t_evt *e;
    long diff, pixdiff, pval, state, shift;

    SetUpA4();
    if (!but)
    {
        explode_remax(x);
        goto done;
    }
    if (x->x_dragstate < 0)
    {
        int doit = 0;
        if (pt.v > x->x_refpoint.v + 2 || pt.v < x->x_refpoint.v - 2)
            x->x_dragstate =
                (x->x_mode == MVERT ? x->x_yshow : x->x_nshow),
                x->x_dragvert = 1, doit = 1;
        else if (pt.h > x->x_refpoint.h + 2 || pt.h < x->x_refpoint.h - 2)
            x->x_dragstate = (x->x_mode == MVERT ? PTIME : x->x_wshow),
                x->x_dragvert = 0, doit = 1;
        if (x->x_dragstate < 0)
        {
            if (doit)
                wind_nodrag();
            goto done;
        }
        if ((x->x_mode == MVERT) && (modkeywas & optionKey))
            explode_copy(x), explode_paste(x);
    }
    pixdiff =
        (x->x_dragvert ? x->x_refpoint.v - pt.v : pt.h - x->x_refpoint.h);
    state = x->x_dragstate;
    shift = (x->x_dragvert ? YSH : XSH);
    pval = (pixdiff * x->x_scale[state]) >> shift;
    diff = pval - x->x_refval;
    if (diff)
    {
        x->x_refval = pval;
        explode_offset(x, diff, state);
    }
    /* not needed because of explode_offset() above? */
    /* x->x_qflags[QDRAWPANEL] = 1; qelem_set(x->x_qelem); */
  done:
    RestoreA4();
}

void explode_dragp3(x, pt, but)
t_explode *x;
Point pt;
{
    static int drawn = 0;
    static Rect r;
    int temp;

    SetUpA4();
    if (drawn)
        explode_eraserect(x, r.left, r.top, r.right, r.bottom);
    if (x->x_refpoint.h > pt.h)
        r.left = pt.h, r.right = x->x_refpoint.h;
    else
        r.left = x->x_refpoint.h, r.right = pt.h;
    if (x->x_refpoint.v > pt.v)
        r.top = pt.v, r.bottom = x->x_refpoint.v;
    else
        r.top = x->x_refpoint.v, r.bottom = pt.v;
    if (r.top < XLABELMARGIN)
        r.top = XLABELMARGIN;
    if (r.bottom < XLABELMARGIN)
        r.bottom = XLABELMARGIN;
    if (but && r.top != r.bottom && r.left != r.right)
        t_framerect(r.left, r.top, r.right, r.bottom), drawn = 1;
    if (!but)
    {
        t_evt *e;
        for (e = x->x_evt; e; e = e->e_next)
        {
            int x1 = EVTX(x, e) - XOFFSET(x),
                x2 = x1 + EVTW(x, e), y = EVTY(x, e);
            if (!e->e_selected && x2 >= r.left && x1 <= r.right &&
                y >= r.top && y <= r.bottom)
                explode_select(x, e);
        }
        drawn = 0;
    }
    RestoreA4();
}

explode_horizmouse(x, pt, dbl, mod)
t_explode *x;
Point pt;
{
    t_evt *e;
    x->x_refpoint = pt;
    /* for (e = x->x_evt; e; e = e->e_next) e->e_selected = 0; */
    for (e = x->x_evt; e; e = e->e_next)
    {
        int temp, t2, x1 = EVTX(x, e) - XOFFSET(x),
            y = EVTY(x, e), x2 = x1 + EVTW(x, e);
        if (y + 2 >= pt.v && y <= pt.v && x1 <= pt.h && x2 >= pt.h)
        {
            if ((mod & shiftKey) && e->e_selected)
                explode_unselect(x, e);
            else
            {
                if (!e->e_selected)
                    explode_noselect(x);
                explode_select(x, e);
                x->x_dragstate = -1;
                x->x_refval = 0;
                wind_drag(x->x_wind, dragp1, x);
            }
            return;
        }
    }
    if (!(mod & shiftKey))
        explode_noselect(x);
    wind_drag(x->x_wind, explode_dragp3, x);
}

explode_vertmouse(x, pt, dbl, mod)
t_explode *x;
Point pt;
{
    explode_horizmouse(x, pt, dbl, mod);
}

explode_select(x, e)
t_explode *x;
t_evt *e;
{
    e->e_selected = 1;
    x->x_qflags[QDRAWPANEL] = 1;
    qelem_set(x->x_qelem);
    explode_drawit(x, e);
}

explode_unselect(x, e)
t_explode *x;
t_evt *e;
{
    explode_eraseit(x, e);
    e->e_selected = 0;
    x->x_qflags[QDRAWPANEL] = 1;
    qelem_set(x->x_qelem);
}

explode_noselect(x)
t_explode *x;
{
    t_evt *e;
    for (e = x->x_evt; e; e = e->e_next)
        if (e->e_selected)
        {
            explode_eraseit(x, e);
            e->e_selected = 0;
        }
    explode_drawpanel(x, 0);
}

explode_selectall(x)
t_explode *x;
{
    t_evt *e;
    for (e = x->x_evt; e; e = e->e_next)
        if (!e->e_selected)
            explode_select(x, e);
}

explode_setscale(x, val, which)
t_explode *x;
long val, which;
{
    long oldval;
    if (val <= 0)
        val = 1;
    else if (val > 64000)
        val = 64000;
    if (!which)
        oldval = XVAL(x, (XOFFSET(x) + XMARGIN));
    x->x_scale[which] = val;
    if (x->x_yshow == which)
        x->x_yscale = val;
    if (x->x_wshow == which)
        x->x_wscale = val;
    if (x->x_nshow == which)
        x->x_nscale = val;
    if (!which)
    {
        x->x_xscale = val;
        (x)->x_wind->w_xoffset =
            (XLOC(x, oldval) - XMARGIN) >> SCROLLSHIFT;
        if (x->x_wshow)
            explode_setscale(x, val, (long) (x->x_wshow));
    }
    if (x->x_wshow == which)
        explode_remax(x);
}

void explode_clr();

void explode_key(x, k)
t_explode *x;
{
    SetUpA4();
    if (k == 8)
        explode_clr(x);
    else if (k >= '0' && k <= '9')
    {
        if (x->x_bullet >= 0)
        {
            x->x_gotkeys = 1;
            x->x_typenum = x->x_typenum * 10 + (k - '0');
            explode_drawfields(x);
        }
    }
    else if (k >= LEFTARROW && k <= DOWNARROW)
    {
        long which, diff;
        int vert = 0, neg = 0;
        if (k == LEFTARROW)
            neg = 1;
        else if (k == UPARROW)
            vert = 1;
        else if (k == DOWNARROW)
            neg = 1, vert = 1;
        if (vert)
            which = x->x_yshow, diff = x->x_yscale;
        else
            which = 0, diff = x->x_xscale;
        if (which >= 0)
        {
            diff >>= 2;
            if (!diff)
                diff = 1;
            if (neg)
                diff = -diff;
            explode_offset(x, diff, which);
            explode_remax(x);
        }
    }
    else if (k == '\r')
    {
        t_evt *e;
        long bullet = x->x_bullet;
        if (bullet >= 0)
        {
            if (x->x_editrange)
            {
                if (x->x_typenum <= 0)
                    x->x_typenum = 1;
                explode_setscale(x, x->x_typenum << 2, bullet);
                explode_setportandupdate(x);
            }
            else
            {
                int gotone = 0;
                for (e = x->x_evt; e; e = e->e_next)
                    if (e->e_selected)
                    {
                        explode_eraseit(x, e);
                        (&(e)->e_time)[bullet] = x->x_typenum;
                        e->e_dirty = 1;
                        gotone = 1;
                        if (!x->x_cpdiff)
                            explode_setdiff(x, 1);
                    }
                if (gotone)
                {
                    if (bullet == PTIME)
                        explode_mergeselection(x);
                }
                else
                {
                    if (bullet == PTIME)        /* cheesy scroll */
                    {
                        x->x_wind->w_xoffset =
                            (XLOC(x, x->x_typenum) -
                             XMARGIN) >> SCROLLSHIFT;
                        explode_setportandupdate(x);
                    }
                }
                x->x_param[bullet] = x->x_typenum;
                explode_drawfields(x);
            }
        }
        x->x_typenum = 0;
        x->x_gotkeys = 0;
    }

    RestoreA4();
}

void *explode_saveto(x, fn, vol)
t_explode *x;
char *fn;
t_symbol *vol;
{
    void *b;
    int ret;
    SetUpA4();
    b = binbuf_new();
    explode_save(x, b, 1L);
    ret = binbuf_write(b, fn, vol, 1);
    binbuf_free(b);
    RestoreA4();
    return ((void *) ret);
}

long TEScrpLength;
char **TEScrpHandle;

#define MAXTEXT 32700
void explode_copy(t_explode *x)
{
    long n, asize, index, tsize;
    t_evt *e;

    SetUpA4();
    if (!TEScrpHandle)
    {
        TEScrpHandle = (char **) t_newhandle(0L);
        TEScrpLength = 0;
    }
    asize = TEScrpLength;
    index = 0;
    for (e = x->x_evt; e; e = e->e_next)
        if (e->e_selected)
        {
            long i;
            for (i = 0; i < NPARAM; i++)
            {
                long val = (&e->e_time)[i];
                char buf[256], *bp1, *bp2;
                long len, lc;
                t_printi(buf, val);
                len = strlen(buf);
                buf[len++] = (i == NPARAM - 1 ? '\r' : ' ');
                if (len + index + 1 > asize)
                {
                    if (asize >= MAXTEXT - 20)
                    {
                        ouch("sorry: truncated to %ld items", n);
                        break;
                    }
                    asize += 1000;
                    if (asize > MAXTEXT)
                        asize = MAXTEXT;
                    t_growhandle((void **) TEScrpHandle, asize);
                }
                for (bp1 = buf, bp2 = *TEScrpHandle + index, lc = len;
                     lc--;)
                    *bp2++ = *bp1++;
                index += len;
            }
        }
    t_growhandle((void **) TEScrpHandle, index);
    TEScrpLength = index;
    /* for (index = 0; index < 10; index++)
       post("%ld", (*TEScrpHandle)[index]); */
    RestoreA4();
}

void explode_clr(x)
t_explode *x;
{
    t_evt *e2, *e3, *et;
    t_evt stub;

    SetUpA4();
    explode_stop(x);
    stub.e_next = x->x_evt;
    for (e2 = x->x_evt; e2; e2 = e2->e_next)
        if (e2->e_selected)
            explode_eraseit(x, e2);
    for (e2 = &stub; e3 = e2->e_next;)
    {
        if (e3->e_selected)
        {
            e2->e_next = e3->e_next;
            freebytes(e3, sizeof(t_evt));
            if (!x->x_cpdiff)
                explode_setdiff(x, 1);
        }
        else
            e2 = e3;
    }
    x->x_evt = stub.e_next;
    explode_remax(x);
    RestoreA4();
}

void explode_cut(x)
t_explode *x;
{
    SetUpA4();
    explode_copy(x);
    explode_clr(x);
    RestoreA4();
}

void explode_paste(t_explode *x)
{
    long eaten;
    SetUpA4();
    if (!TEScrpHandle)
    {
        TEScrpHandle = (char **) t_newhandle(0L);
        TEScrpLength = 0;
    }
    eaten = 0;
    explode_noselect(x);
    while (eaten < TEScrpLength)
    {
        char buf[256], *bp, *ebuf, *sc = *TEScrpHandle + eaten;
        long index = 0, index2 = 0, nfield = 0, fields[NPARAM],
            thisfield = 0, minus = 0;
        int was = 0;
        t_evt *e;
        while (eaten < TEScrpLength && *sc != '\r' && index < 255)
            eaten++, buf[index++] = *sc++;
        buf[index++] = '\r';
        eaten++;
        for (bp = buf, ebuf = buf + index; bp < ebuf; bp++)
        {
            char c = *bp;
            if (c >= '0' && c <= '9')
            {
                thisfield = 10 * thisfield + (c - '0');
                was = 1;
            }
            else if (c == '-')
                minus = 1;
            else if (was)
            {
                was = 0;
                fields[nfield++] = (minus ? -thisfield : thisfield);
                thisfield = minus = 0;
                if (nfield >= NPARAM)
                    break;
            }
        }
        if (nfield < NPARAM)
            break;
        e = (t_evt *) getbytes(sizeof(t_evt));
        if (!e)
            break;
        for (thisfield = 0; thisfield < nfield; thisfield++)
            (&e->e_time)[thisfield] = fields[thisfield];
        for (; thisfield < NPARAM; thisfield++)
            (&e->e_time)[thisfield] = x->x_param[thisfield];
        explode_link(x, e);
        explode_select(x, e);
        explode_drawit(x, e);
    }
    explode_remax(x);
    RestoreA4();
}

void explode_chkmenu(x, m)
t_explode *x;
struct menuinfo *m;
{
/*  t_evt *e;
  m->i_paste = (TEScrpLength != 0);
  for (e = x->x_evt; e; e = e->e_next) if (e->e_selected)
  {
    m->i_cut = 1;
    break;
  }
  m->i_save = 1; */
}
