
/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.5 $ IRCAM $Date: 1994/01/04 18:03:31 $
 *
 * FTS by Miller Puckette
 *
 */


#define ROW 132
#define XDIV 200                /* default x scale */
#define XSH 3
#define YSH 3
#define XMARGIN 0
#define YMARGIN 0
#define TIMELABEL 12            /* height of time-axis labelling */
#define LEFTSCROLLMARGIN 32
#define TOPSCROLLMARGIN 72
#define BOTTOM(x) (W_HEIGHT(x->x_wind) - 2)
#define SCROLLSHIFT 0           /* scroll unit = 1 pixel */
#define XOFFSET(x) ((x)->x_wind->w_xoffset << SCROLLSHIFT)
#define XLABELMARGIN 13

extern int sharp;               /* one if the last y-location calculated was a sharp */

#define XVAL(x, pix) ((((long)(pix) - XMARGIN) * (x)->x_xscale) >> XSH)
long YVAL();
/* #define YVAL(x, pix) (((BOTTOM - (long)(pix)) * (x)->x_yscale)>>YSH) */
#define WVAL(x, pix) ((((long)(pix)) * (x)->x_wscale) >> XSH)
#define XWIDTH(x, t) ((int)((((long)(t))<<XSH)/(x)->x_wscale))
#define XLOC(x, t) ((int)(XMARGIN + (((long)(t)) << XSH)/(x)->x_xscale))
  /* y-location replaced by a subroutine */
/* #define YLOC(x, t) ((int)(BOTTOM  - (((long)(t)) << YSH)/(x)->x_yscale)) */
#define EVTX(x, e) XLOC(x, (e)->e_time)
#define EVTY(x, e) YLOC(x, (&(e)->e_time)[x->x_yshow])
#define EVTW(x, e) ((temp = ((&(e)->e_time)[x->x_wshow] << XSH)/(x)->x_wscale) \
  < 4 ? 4 : temp)
#define EVTDRAWDOWN(x, e) (2 + e->e_selected)
#define EVTUP(x, e) (x->x_nshow >= 0 ? -12 : (sharp ? -2 : 0))
#define EVTDOWN(x, e) (sharp ? 6 : EVTDRAWDOWN(x, e))
#define EVTLEFT(x, e) (sharp ? -7 : 0)
#define EVTRIGHT(x, e) (x->x_nshow >= 0 ? explode_nwidth(x, e) : EVTW(x, e))

#define BGHEIGHT 120
#define CLEFHEIGHT 84
#define BGHEIGHT10 20
#define BGHEIGHT12 24
#define BGHEIGHTCLEF 84
#define WGHEIGHT 16
#define BGWIDTH 20

#define VERTX1 0
#define VERTY1 0
#define VERTX2 20
#define VERTY2 19
#define HORIZX1 0
#define HORIZY1 19
#define HORIZX2 20
#define HORIZY2 39
#define DRAWX1 0
#define DRAWY1 39
#define DRAWX2 20
#define DRAWY2 59

#define MODEX1 VERTX1
#define MODEY1 VERTY1
#define MODEX2 DRAWX2
#define MODEY2 DRAWY2

#define RECORDX1 35
#define RECORDY1 5
#define RECORDX2 71
#define RECORDY2 14
#define FOLLOWX1 RECORDX1
#define FOLLOWY1 (RECORDY1 + 20)
#define FOLLOWX2 RECORDX2
#define FOLLOWY2 (RECORDY2 + 20)
#define PLAYX1 RECORDX1
#define PLAYY1 (RECORDY1 + 40)
#define PLAYX2 RECORDX2
#define PLAYY2 (RECORDY2 + 40)

#define ERASEMODEX1 MODEX1
#define ERASEMODEY1 MODEY1
#define ERASEMODEX2 PLAYX2
#define ERASEMODEY2 MODEY2

#define TOGGLEX1 93
#define TOGGLEY1 0
#define TOGGLEX2 165
#define TOGGLEY2 59
#define SHOWGRIDY 0
#define EDITRANGEY 20
#define UNUSEDY 40
#define BOXX1 TOGGLEX1
#define BOXY1 (TOGGLEY1 + 4)

#define PARAMX1 209
#define PARAMX2 (PARAMX1 + 69)
#define PARAMY1 (-1)
#define PARAMHEIGHT 12
#define PSELECTX1 PARAMX2
#define PSELECTX2 (PSELECTX1 + 3 * PARAMHEIGHT)
#define PSELECTY1 PARAMY1
#define BULLETX1 2              /* coords for  bullet */
#define BULLETY1 4
#define BULLETX2 4
#define BULLETY2 8
#define PPRINTX 5               /* offset for parameter printing */
#define PPRINTRANGEX 17         /* offset for printing the denominator for range */

#define PRANGEMODEX1 (PARAMX2 - 15)
#define PRANGEMODEX2 PARAMX2
#define PRANGEMODEY1 PARAMY1

#define PRANGEARROWX1 (PRANGEMODEX1 - 10)
#define PRANGEARROWX2 PRANGEMODEX1
#define PPRANGEMODEY1 PARAMY1

#define PANELWIDTH PSELECTX2
#define GETSENDX1 (PANELWIDTH + 10)
#define GETSENDY1 0
#define GETSENDX2 (GETSENDX1 + GETSENDW)
#define GETSENDY2 (GETSENDY1 + GETSENDH)
#define BGETX1 (GETSENDX1 + GETX1)
#define BGETY1 (GETSENDY1 + GETY1)
#define BGETX2 (GETSENDX1 + GETX2)
#define BGETY2 (GETSENDY1 + GETY2)
#define BSENDX1 (GETSENDX1 + SENDX1)
#define BSENDY1 (GETSENDY1 + SENDY1)
#define BSENDX2 (GETSENDX1 + SENDX2)
#define BSENDY2 (GETSENDY1 + SENDY2)

typedef struct evt {
    char e_dirty;
    char e_selected;
    short e_dummy;
    struct evt *e_next;
    long e_time;
    long e_pit;
    long e_vel;
    long e_dur;
    long e_chan;
} t_evt;

#define NPARAM 5                /* max number of parameters */
#define PTIME 0                 /* time is 0th param etc */
#define PPIT 1
#define PVEL 2
#define PDUR 3
#define PCHAN 4

/* definitions for score follower */
typedef struct skip {
    t_evt *s_evt;
    struct skip *s_next;
} t_skip;
#define NFWD 2                  /* default values for f_nfwd and f_ftime */
#define FTIME 150
#define MAXFOLLOWHANG 16

/* note-off matching for record */
typedef struct hang {
    t_evt *h_evt;
    struct hang *h_next;
} t_hang;

  /* definitions for queue requests */
#define QDRAWBG 0               /* need to draw background */
#define QDRAWEVTS 1             /* need to draw events */
#define QDRAWPANEL 2            /* need to draw panel */
#define QERASEMODE 3            /* erase mode region of panel */
#define QERASETOGGLES 4         /* erase toggles */
#define QREMAX 5                /* recalculate maximum x value for scrollbar */
#define NQFLAGS 6

#ifdef MAX_EXTERN
  /* sorry about this -- it's a MacIntosh vestige I can't get rid of */
typedef struct _point {
    int v;
    int h;
} Point;
#endif

/* WARNING -- the "explode" structure will probably change to allow
parameters to be added to the "event" structure.  I'll keep x_serial,
x_evt, x_sym, and x_next constant, though.  */

typedef struct explode {
    struct object x_ob;
    long x_serial;              /* support for explay class */
    t_evt *x_evt;               /* list of events */
    t_symbol *x_sym;            /* explode's name */
    struct explode *x_next;     /* next explode having same name */
    long x_n1;                  /* values of inlets */
    long x_n2;
    long x_n3;
    long x_n4;
    void *x_out2;               /* pointers to outlets */
    void *x_out3;
    void *x_out4;
    void *x_out5;
    char x_set1;
    char x_set2;
    char x_set3;
    long x_rectime;             /* logical time at which recording started */
    /* BELOW HERE THINGS MIGHT CHANGE */
    /* cp/host communication */
#ifndef GRAPHICS
    long x_hq;                  /* update queue for host */
    long x_hqcount;             /* number of updates to send */
    char x_dirtytohost;         /* flag to tell host we've changed state */
#endif
    t_evt *x_current;
    t_evt *x_recevt;            /* temporary location for recorded notes while
                                   waiting to update x_evt */
    /* score follower state */
    long x_matchscoretime;
    char x_oct;
    int x_nfwd;
    int x_ftime;
    int x_nhang;                /* number of hanging notes during score-follow */
    t_skip *x_skip;
    t_hang *x_hang;
    char x_mode;                /* defs below */
    char x_savemode;            /* saved edit mode for when real-time is on */
    /* support for graphics on host */
#ifdef GRAPHICS
    struct windpub *x_wind;
    int x_scrollmax;            /* range for scrollbar */
    long x_yshow;
    long x_wshow;
    long x_nshow;
    long x_xscale;
    long x_yscale;
    long x_wscale;
    long x_nscale;
    long x_bullet;              /* number of param to type at */
    long x_param[NPARAM];       /* default parameters */
    long x_scale[NPARAM];       /* their scalings */
    long x_typenum;             /* number currently being typed */
    Point x_refpoint;           /* reference point for dragging */
    long x_refval;
    short x_dragstate;
    char x_paramgrid[NPARAM];   /* if shown as y, grid type to use */
    char x_dragvert;
    char x_whatgrid;            /* defs below */
    char x_editrange;           /* in edit-range mode */
    char x_showgrid;            /* show the grid */
    char x_gotkeys;             /* have got keys since selecting bullet */
    void *x_cpr;                /* CP receiver */
    char x_cpdiff;              /* CP's list is out of sync with host */
    void *x_qelem;
    long x_xmax;                /* x and y maxima for scrolling in pixels */
    long x_ymax;
    /* on Mac, this is set at hi-pri and cleared at lo. */
    char x_qflags[NQFLAGS];
#endif
} t_explode;

#define MDRAW 0                 /* defs for x_mode */
#define MVERT 1
#define MHORIZ 2
#define MPLAY 3
#define MRECORD 4
#define MFOLLOW 5
#define MUPDATE 6               /* CP only; update in progress from host */

#define GRIDCLEF 0
#define GRID10 1
#define GRID12 2

#define SetUpA4()
#define RestoreA4()

/* defines for CP/host communication.  Messages from CP to host: */
#define CH_EVENT    1           /* an event; time slot is relative */
#define CH_DONEUPD    2         /* end of events */
#define CH_NOTDONEUPD 3         /* have more events to send */
#define CH_DIRTY    4           /* tell other side that you went out of sync */
#define CH_REQSEND    5         /* CP requests to send to host */

/* Messages from host to CP: */
#define HC_STARTUPD 1           /* host will start sending list */
#define HC_DONEUPD  2           /* host has finished sending list */
#define HC_REQEVT 3             /* host requests a "few" events from CP */

extern long explode_nextserial;
