#ifndef lint
static char rcsid[] =
    "$Revision: 2.12 $ IRCAM $Date: 1994/05/10 10:52:19 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.12 $ IRCAM $Date: 1994/05/10 10:52:19 $
 *
 * FTS by Miller Puckette
 *
 */


#include <stdio.h>
#include "m_mess.h"

void inlet_new_fast(void *owner, void *slot, t_symbol * s1);

extern t_symbol s_clock, s_print, s_int, s_INT, s_FLOAT,
    s_in1, s_in2, s_in3, s_in4, s_in5, s_in6, s_in7, s_in8, s_in9,
    s_ft1, s_ft2, s_ft3, s_ft4, s_ft5, s_ft6, s_ft7, s_ft8, s_ft9,
    s_sm1, s_sm2, s_sm3, s_sm4, s_sm5, s_sm6, s_sm7, s_sm8, s_sm9,
    s_int, s_pack, s_unpack, s_swap, s_trigger, s_, s_pipe,
    s_clear, s_flush, s_i, s_f, s_symbol;
/* the print object */

postatom(t_atom *ap)
{
    if (ap->a_type == A_SEMI)
        poststring("; ");
    else if (ap->a_type == A_SYM)
        poststring(" "), poststring(ap->a_w.w_sym->s_name);
    else if (ap->a_type == A_OBJ)
        poststring(" ("),
            poststring(ob_name(ap->a_w.w_obj)), poststring(")");
    else if (ap->a_type == A_LONG)
        poststring(" "), postlong(ap->a_w.w_long);
    else if (ap->a_type == A_FLOAT)
        poststring(" "), postfloat((double) (ap->a_w.w_float));
    else if (!ap->a_type)
        poststring("(end) ");
    else
        poststring(" ?");
}

typedef struct print {
    t_object p_ob;
    t_symbol *p_sym;
} t_print;

void print_bang(t_print *x)
{
    post("%s: bang", x->p_sym->s_name);
}

void print_int(t_print *x, long int a)
{
    post("%s: %ld", x->p_sym->s_name, a);
}

void print_symbol(t_print *x, t_symbol *s)
{
    post("%s: %s", x->p_sym->s_name, s->s_name);
}

void print_float(t_print *x, double f)
{
    /* post("%s: %lf", x->p_sym->s_name, f); */
    post("%s:", x->p_sym->s_name);
    postfloat(f);
}

void print_list(t_print *x, t_symbol *s, int argc, t_atom *argv)
{
    post("%s: ", x->p_sym->s_name);
    for (; argc--; argv++)
        postatom(argv);
}

void print_anything(t_print *x, t_symbol *s, int argc, t_atom *argv)
{
    post("%s: %s ", x->p_sym->s_name, s->s_name);
    for (; argc--; argv++)
        postatom(argv);
}

void c_print()
{
    c_new(&s_print, NIL, sizeof(t_print), 0, 0);
    c_addbang(print_bang);
    c_addint(print_int);
    c_addfloat(print_float);
    c_addsymbol(print_symbol);
    c_addlist(print_list);
    c_addanything(print_anything);
}

void *print_messlist;
void *print_new(t_symbol *sp)
{
    t_print *x =
        (t_print *) obj_new((t_messlist **) & print_messlist, c_print);
    x->p_sym = (sp == &s_ ? &s_print : sp);
    return (x);
}

/* the integer object -- store a value from an inlet;
   /* send it when receive a "bang". */

typedef struct _integer {
    t_object i_ob;
    long i_n;
} integer;

void integer_bang(integer *x)
{
    outlet_int(x->i_ob.o_outlet, x->i_n);
}

void integer_int(integer *x, long int n)
{
    outlet_int(x->i_ob.o_outlet, x->i_n = n);
}

void integer_float(integer *x, double f)
{
    outlet_int(x->i_ob.o_outlet, x->i_n = f);
}

void integer_in1(integer *x, long int n)
{
    x->i_n = n;
}

void c_integer()
{
    c_new(&s_int, NIL, sizeof(integer), 0, 0);
    c_addbang(integer_bang);
    c_addint(integer_int);
    c_addfloat(integer_float);
    c_addinx(integer_in1, 1);
}

void *integer_messlist;

void *integer_new(long int n)
{
    integer *x =
        (integer *) obj_new((t_messlist **) & integer_messlist, c_integer);
    outlet(x, &s_int);
    inlet_new_fast(x, &x->i_n, &s_int);
    /* inlet_new(x, x, &s_int, &s_in1); */
    x->i_n = n;
    return (x);
}

/* real -- like integer. */

typedef struct _real {
    t_object r_ob;
    float r_f;
} real;

void real_bang(real *x)
{
    outlet_float(x->r_ob.o_outlet, x->r_f);
}

void real_float(real *x, double f)
{
    outlet_float(x->r_ob.o_outlet, x->r_f = f);
}

void real_int(real *x, long int n)
{
    outlet_float(x->r_ob.o_outlet, x->r_f = n);
}

void real_ft1(real *x, double f)
{
    x->r_f = f;
}

void c_real()
{
    c_new(&s_float, NIL, sizeof(real), 0, 0);
    c_addbang(real_bang);
    c_addint(real_int);
    c_addfloat(real_float);
    c_addftx(real_ft1, 1);
}

void *real_messlist;

void *real_new(double f)
{
    real *x = (real *) obj_new((t_messlist **) & real_messlist, c_real);
    /* fprintf(stderr, "real_nre %lf\n", f); */
    outlet(x, &s_float);
    /* inlet(x, x, &s_float, &s_ft1); */
    inlet_new_fast(x, &x->r_f, &s_float);
    x->r_f = f;
    return (x);
}

/* pack -- make list messages */
#define NARGS 10
typedef struct pack {
    t_object p_ob;
    int p_argc;
    t_atom p_argv[NARGS];
} t_pack;

void pack_bang(t_pack *x)
{
    outlet_list(x->p_ob.o_outlet, NIL, x->p_argc, x->p_argv);
}

void pack_float(t_pack *x, double f)
{
    if (x->p_argv[0].a_type == A_LONG)
        x->p_argv[0].a_w.w_long = f;
    else if (x->p_argv[0].a_type == A_FLOAT)
        x->p_argv[0].a_w.w_float = f;
    else
        x->p_argv[0].a_w.w_sym = &s_;
    outlet_list(x->p_ob.o_outlet, NIL, x->p_argc, x->p_argv);
}

void pack_int(t_pack *x, long int n)
{
    if (x->p_argv[0].a_type == A_LONG)
        x->p_argv[0].a_w.w_long = n;
    else if (x->p_argv[0].a_type == A_FLOAT)
        x->p_argv[0].a_w.w_float = n;
    else
        x->p_argv[0].a_w.w_sym = &s_;
    outlet_list(x->p_ob.o_outlet, NIL, x->p_argc, x->p_argv);
}

void pack_symbol(t_pack *x, t_symbol *s)
{
    if (x->p_argv[0].a_type == A_SYM)
        x->p_argv[0].a_w.w_sym = s;
    else
        x->p_argv[0].a_w.w_sym = &s_;
    outlet_list(x->p_ob.o_outlet, NIL, x->p_argc, x->p_argv);
}

void pack_list(t_pack *x, t_symbol *s, int ac, t_atom *av)
{
    t_atom *ap = x->p_argv;
    char c;
    if (ac > x->p_argc)
        ac = x->p_argc;
    for (; ac--; av++, ap++)
    {
        if (ap->a_type == A_LONG)
        {
            if ((c = av->a_type) == A_LONG)
                ap->a_w.w_long = av->a_w.w_long;
            else if (c == A_FLOAT)
                ap->a_w.w_long = av->a_w.w_float;
            else
                ap->a_w.w_long = 0;
        }
        else if (ap->a_type == A_FLOAT)
        {
            if ((c = av->a_type) == A_FLOAT)
                ap->a_w.w_float = av->a_w.w_float;
            else if (c == A_LONG)
                ap->a_w.w_float = av->a_w.w_long;
            else
                ap->a_w.w_float = 0;
        }
        else
        {
            if ((c = av->a_type) == A_FLOAT)
                ap->a_w.w_sym = &s_float;
            else if (c == A_LONG)
                ap->a_w.w_sym = &s_int;
            else
                ap->a_w.w_sym = av->a_w.w_sym;
        }
    }
    outlet_list(x->p_ob.o_outlet, NIL, x->p_argc, x->p_argv);
}

void pack_in1(t_pack *x, long int n)
{
    x->p_argv[1].a_w.w_long = n;
}

void pack_in2(t_pack *x, long int n)
{
    x->p_argv[2].a_w.w_long = n;
}

void pack_in3(t_pack *x, long int n)
{
    x->p_argv[3].a_w.w_long = n;
}

void pack_in4(t_pack *x, long int n)
{
    x->p_argv[4].a_w.w_long = n;
}

void pack_in5(t_pack *x, long int n)
{
    x->p_argv[5].a_w.w_long = n;
}

void pack_in6(t_pack *x, long int n)
{
    x->p_argv[6].a_w.w_long = n;
}

void pack_in7(t_pack *x, long int n)
{
    x->p_argv[7].a_w.w_long = n;
}

void pack_in8(t_pack *x, long int n)
{
    x->p_argv[8].a_w.w_long = n;
}

void pack_in9(t_pack *x, long int n)
{
    x->p_argv[9].a_w.w_long = n;
}

void pack_ft1(t_pack *x, double f)
{
    x->p_argv[1].a_w.w_float = f;
}

void pack_ft2(t_pack *x, double f)
{
    x->p_argv[2].a_w.w_float = f;
}

void pack_ft3(t_pack *x, double f)
{
    x->p_argv[3].a_w.w_float = f;
}

void pack_ft4(t_pack *x, double f)
{
    x->p_argv[4].a_w.w_float = f;
}

void pack_ft5(t_pack *x, double f)
{
    x->p_argv[5].a_w.w_float = f;
}

void pack_ft6(t_pack *x, double f)
{
    x->p_argv[6].a_w.w_float = f;
}

void pack_ft7(t_pack *x, double f)
{
    x->p_argv[7].a_w.w_float = f;
}

void pack_ft8(t_pack *x, double f)
{
    x->p_argv[8].a_w.w_float = f;
}

void pack_ft9(t_pack *x, double f)
{
    x->p_argv[9].a_w.w_float = f;
}

void pack_sm1(t_pack *x, t_symbol *s)
{
    x->p_argv[1].a_w.w_sym = s;
}

void pack_sm2(t_pack *x, t_symbol *s)
{
    x->p_argv[2].a_w.w_sym = s;
}

void pack_sm3(t_pack *x, t_symbol *s)
{
    x->p_argv[3].a_w.w_sym = s;
}

void pack_sm4(t_pack *x, t_symbol *s)
{
    x->p_argv[4].a_w.w_sym = s;
}

void pack_sm5(t_pack *x, t_symbol *s)
{
    x->p_argv[5].a_w.w_sym = s;
}

void pack_sm6(t_pack *x, t_symbol *s)
{
    x->p_argv[6].a_w.w_sym = s;
}

void pack_sm7(t_pack *x, t_symbol *s)
{
    x->p_argv[7].a_w.w_sym = s;
}

void pack_sm8(t_pack *x, t_symbol *s)
{
    x->p_argv[8].a_w.w_sym = s;
}

void pack_sm9(t_pack *x, t_symbol *s)
{
    x->p_argv[9].a_w.w_sym = s;
}

void c_pack()
{
    c_new(&s_pack, NIL, sizeof(t_pack), 0, 0);
    c_addbang(pack_bang);
    c_addint(pack_int);
    c_addfloat(pack_float);
    c_addmess(pack_symbol, &s_symbol, A_SYM, 0);
    c_addmess(pack_list, &s_list, A_GIMME, 0);
    c_addinx(pack_in1, 1);
    c_addftx(pack_ft1, 1);
    c_addsmx(pack_sm1, 1);
    c_addinx(pack_in2, 2);
    c_addftx(pack_ft2, 2);
    c_addsmx(pack_sm2, 2);
    c_addinx(pack_in3, 3);
    c_addftx(pack_ft3, 3);
    c_addsmx(pack_sm3, 3);
    c_addinx(pack_in4, 4);
    c_addftx(pack_ft4, 4);
    c_addsmx(pack_sm4, 4);
    c_addinx(pack_in5, 5);
    c_addftx(pack_ft5, 5);
    c_addsmx(pack_sm5, 5);
    c_addinx(pack_in6, 6);
    c_addftx(pack_ft6, 6);
    c_addsmx(pack_sm6, 6);
    c_addinx(pack_in7, 7);
    c_addftx(pack_ft7, 7);
    c_addsmx(pack_sm7, 7);
    c_addinx(pack_in8, 8);
    c_addftx(pack_ft8, 8);
    c_addsmx(pack_sm8, 8);
    c_addinx(pack_in9, 9);
    c_addftx(pack_ft9, 9);
    c_addsmx(pack_sm9, 9);
}

void *pack_messlist;

static t_symbol *floatsyms[] =
    { &s_ft1, &s_ft2, &s_ft3, &s_ft4, &s_ft5, &s_ft6, &s_ft7, &s_ft8,
&s_ft9 };
static t_symbol *fixsyms[] =
    { &s_in1, &s_in2, &s_in3, &s_in4, &s_in5, &s_in6, &s_in7, &s_in8,
&s_in9 };
static t_symbol *symsyms[] =
    { &s_sm1, &s_sm2, &s_sm3, &s_sm4, &s_sm5, &s_sm6, &s_sm7, &s_sm8,
&s_sm9 };

void *pack_new(t_symbol *s, int ac, t_atom *av)
{
    t_pack *x =
        (t_pack *) obj_new((t_messlist **) & pack_messlist, c_pack);
    t_atom *ap;
    outlet(x, NIL);
    if (!ac)                    /* default to two longs */
    {
        x->p_argc = 2;
        SETLONG(x->p_argv, 0);
        SETLONG(x->p_argv + 1, 0);
        /* inlet(x, x, &s_int, &s_in1); */
        inlet_new_fast(x, &x->p_argv[1].a_w.w_long, &s_int);
    }
    else
    {
        if (ac > NARGS)
            ac = NARGS;
        ap = x->p_argv + ac;
        av += ac;
        x->p_argc = ac;
        while (ac--)
        {
            char c;
            *(--ap) = *(--av);
            if ((c = ap->a_type) == A_SYM)
            {
                if (ap->a_w.w_sym == &s_i)
                    SETLONG(ap, 0);
                else if (ap->a_w.w_sym == &s_f)
                    SETFLOAT(ap, 0);
                c = ap->a_type;
            }
            if (ac)
            {
                if (c == A_LONG)
                    inlet_new_fast(x, &x->p_argv[ac].a_w.w_long, &s_int);
                else if (c == A_FLOAT)
                    inlet_new_fast(x, &x->p_argv[ac].a_w.w_float,
                                   &s_float);
                else
                    inlet_new(x, x, &s_symbol, symsyms[ac - 1]);
            }
        }
    }
    return (x);
}

typedef struct boo {
    char b_type;
    void *b_outlet;
} t_boo;

typedef struct unpack {
    t_object u_ob;
    int u_argc;
    t_boo u_boo[NARGS];
} t_unpack;

void unpack_list(t_unpack *x, t_symbol *s, int ac, t_atom *av)
{
    t_boo *bp;
    if (ac > x->u_argc)
        ac = x->u_argc;
    av += ac;
    bp = x->u_boo + ac;
    /* checkit("unpack");
       post("addr %lx", x); */
    while (ac--)
    {
        char c = (--av)->a_type;
        bp--;
        if (c == A_LONG)
        {
            if (bp->b_type == A_LONG)
                outlet_int(bp->b_outlet, av->a_w.w_long);
            else if (bp->b_type == A_FLOAT)
                outlet_float(bp->b_outlet, (double) (av->a_w.w_long));
        }
        else if (c == A_FLOAT)
        {
            if (bp->b_type == A_FLOAT)
                outlet_float(bp->b_outlet, (double) (av->a_w.w_float));
            else if (bp->b_type == A_LONG)
                outlet_int(bp->b_outlet, (long) (av->a_w.w_float));
        }
        else
        {
            if (bp->b_type == A_SYM)
                outlet_symbol(bp->b_outlet, av->a_w.w_sym);
        }
    }
}

void unpack_int(t_unpack *x, long int n)
{
    if (x->u_boo[0].b_type == A_LONG)
        outlet_int(x->u_boo[0].b_outlet, n);
    else
        outlet_float(x->u_boo[0].b_outlet, (double) n);
}

void unpack_float(t_unpack *x, double f)
{
    if (x->u_boo[0].b_type == A_LONG)
        outlet_int(x->u_boo[0].b_outlet, (long) f);
    else
        outlet_float(x->u_boo[0].b_outlet, (double) f);
}

void c_unpack()
{
    c_new(&s_unpack, NIL, sizeof(t_unpack), 0, 0);
    c_addmess(unpack_list, &s_list, A_GIMME, 0);
    c_addint(unpack_int);
    c_addfloat(unpack_float);
}

void *unpack_messlist;

void *unpack_new(t_symbol *s, int ac, t_atom *av)
{
    t_unpack *x =
        (t_unpack *) obj_new((t_messlist **) & unpack_messlist, c_unpack);
    t_atom *ap;
    if (!ac)                    /* default to two longs */
    {
        x->u_argc = 2;
        x->u_boo[0].b_type = x->u_boo[1].b_type = A_LONG;
        x->u_boo[1].b_outlet = outlet(x, &s_int);
        x->u_boo[0].b_outlet = outlet(x, &s_int);
    }
    else
    {
        t_boo *bp;
        if (ac > NARGS)
            ac = NARGS;
        x->u_argc = ac;
        av += ac;
        bp = x->u_boo + ac;
        while (ac--)
        {
            char c = (--av)->a_type;
            if (c == A_SYM)
            {
                if (av->a_w.w_sym == &s_i)
                    c = A_LONG;
                else if (av->a_w.w_sym == &s_f)
                    c = A_FLOAT;
            }
            if (c == A_FLOAT)
                (--bp)->b_type = A_FLOAT,
                    bp->b_outlet = outlet(x, &s_float);
            else if (c == A_LONG)
                (--bp)->b_type = A_LONG, bp->b_outlet = outlet(x, &s_int);
            else
                (--bp)->b_type = A_SYM,
                    bp->b_outlet = outlet(x, &s_symbol);
        }
    }
    /* dodo = x; checkit("unpack"); post("addr %lx", dodo); */
    return (x);
}

/* trigger -- uses same structures as unpack */

void trigger_int(t_unpack *x, long int n)
{
    t_boo *bp = x->u_boo + x->u_argc;
    int ac = x->u_argc;
    while (ac--)
    {
        char c = (--bp)->b_type;
        if (c == A_LONG)
            outlet_int(bp->b_outlet, n);
        else if (c == A_FLOAT)
            outlet_float(bp->b_outlet, (double) n);
        else if (c == 0)
            outlet_bang(bp->b_outlet);
        else if (c == A_SYM)
            outlet_symbol(bp->b_outlet, &s_);
        else if (c == A_GIMME)
        {
            t_atom shit[1];
            SETLONG(shit, n);
            outlet_list(bp->b_outlet, NIL, 1, shit);
        }
    }
}

void trigger_float(t_unpack *x, double f)
{
    t_boo *bp = x->u_boo + x->u_argc;
    int ac = x->u_argc;
    while (ac--)
    {
        char c = (--bp)->b_type;
        if (c == A_LONG)
            outlet_int(bp->b_outlet, (long) f);
        else if (c == A_FLOAT)
            outlet_float(bp->b_outlet, f);
        else if (c == 0)
            outlet_bang(bp->b_outlet);
        else if (c == A_SYM)
            outlet_symbol(bp->b_outlet, &s_);
        else if (c == A_GIMME)
        {
            t_atom shit[1];
            SETFLOAT(shit, f);
            outlet_list(bp->b_outlet, NIL, 1, shit);
        }
    }
}

void trigger_symbol(t_unpack *x, t_symbol *s)
{
    t_boo *bp = x->u_boo + x->u_argc;
    int ac = x->u_argc;
    while (ac--)
    {
        char c = (--bp)->b_type;
        if (c == A_LONG)
            outlet_int(bp->b_outlet, 0L);
        else if (c == A_FLOAT)
            outlet_float(bp->b_outlet, 0.);
        else if (c == 0)
            outlet_bang(bp->b_outlet);
        else if (c == A_SYM)
            outlet_symbol(bp->b_outlet, s);
        else if (c == A_GIMME)
        {
            t_atom shit[1];
            SETSYM(shit, s);
            outlet_list(bp->b_outlet, NIL, 1, shit);
        }
    }
}

void trigger_list(t_unpack *x, t_symbol *s, int argc, t_atom *argv)
{
    if (!argc)
        return;
    else
    {
        t_boo *bp = x->u_boo + x->u_argc;
        int ac = x->u_argc;
        if (argv->a_type == A_LONG)
        {
            long firstVal = argv->a_w.w_long;
            while (ac--)
            {
                char c = (--bp)->b_type;
                if (c == A_LONG)
                    outlet_int(bp->b_outlet, firstVal);
                else if (c == 0)
                    outlet_bang(bp->b_outlet);
                else if (c == A_FLOAT)
                    outlet_float(bp->b_outlet, (float) firstVal);
                else if (c == A_SYM)
                    outlet_symbol(bp->b_outlet, &s_);
                else if (c == A_GIMME)
                    outlet_list(bp->b_outlet, s, argc, argv);
            }
        }
        else if (argv->a_type == A_FLOAT)
        {
            double firstVal = argv->a_w.w_float;
            while (ac--)
            {
                char c = (--bp)->b_type;
                if (c == A_LONG)
                    outlet_int(bp->b_outlet, (long) firstVal);
                else if (c == A_FLOAT)
                    outlet_float(bp->b_outlet, firstVal);
                else if (c == 0)
                    outlet_bang(bp->b_outlet);
                else if (c == A_SYM)
                    outlet_symbol(bp->b_outlet, &s_);
                else if (c == A_GIMME)
                    outlet_list(bp->b_outlet, s, argc, argv);
            }
        }
        else if (argv->a_type == A_SYM)
        {
            while (ac--)
            {
                char c = (--bp)->b_type;
                if (c == A_LONG)
                    outlet_int(bp->b_outlet, 0L);
                else if (c == A_FLOAT)
                    outlet_float(bp->b_outlet, 0.);
                else if (c == 0)
                    outlet_bang(bp->b_outlet);
                else if (c == A_SYM)
                    outlet_symbol(bp->b_outlet, argv->a_w.w_sym);
                else if (c == A_GIMME)
                    outlet_list(bp->b_outlet, s, argc, argv);
            }
        }
    }
}

void trigger_bang(t_unpack *x)
{
    trigger_int(x, 0L);
}

void c_trigger()
{
    c_new(&s_trigger, NIL, sizeof(t_unpack), 0, 0);
    c_addbang(trigger_bang);
    c_addint(trigger_int);
    c_addfloat(trigger_float);
    c_addsymbol(trigger_symbol);
    c_addmess(trigger_list, &s_list, A_GIMME, 0);
}

void *trigger_messlist;

void *trigger_new(t_symbol *s, int ac, t_atom *av)
{
    t_unpack *x =
        (t_unpack *) obj_new((t_messlist **) & trigger_messlist,
                             c_trigger);
    t_atom *ap;
    if (!ac)                    /* default to two longs */
    {
        x->u_argc = 2;
        x->u_boo[0].b_type = x->u_boo[1].b_type = A_LONG;
        x->u_boo[1].b_outlet = outlet(x, &s_int);
        x->u_boo[0].b_outlet = outlet(x, &s_int);
    }
    else
    {
        t_boo *bp;
        if (ac > NARGS)
            ac = NARGS;
        x->u_argc = ac;
        av += ac;
        bp = x->u_boo + ac;
        while (ac--)
        {
            char c = (--av)->a_type;
            if (c == A_FLOAT)
                (--bp)->b_type = A_FLOAT,
                    bp->b_outlet = outlet(x, &s_float);
            else if (c == A_SYM)
            {
                c = av->a_w.w_sym->s_name[0];
                if (c == 'i')
                    (--bp)->b_type = A_LONG,
                        bp->b_outlet = outlet(x, &s_int);
                else if (c == 'f')
                    (--bp)->b_type = A_FLOAT,
                        bp->b_outlet = outlet(x, &s_float);
                else if (c == 's')
                    (--bp)->b_type = A_SYM,
                        bp->b_outlet = outlet(x, &s_symbol);
                else if (c == 'l')
                    (--bp)->b_type = A_GIMME,
                        bp->b_outlet = outlet(x, &s_list);
                else
                    (--bp)->b_type = 0, bp->b_outlet = outlet(x, &s_bang);
            }
            else
                (--bp)->b_type = A_LONG, bp->b_outlet = outlet(x, &s_int);
        }
    }
    return (x);
}

typedef struct swap {
    t_object s_ob;
    union {
        long l;
        float f;
    } s_un1, s_un2;
    void *s_outlet;
    char s_float1;
    char s_float2;
} t_swap;

void swap_in1(t_swap *x, long int n)
{
    x->s_un2.l = n;
}

void swap_ft1(t_swap *x, double f)
{
    x->s_un2.f = f;
}

void swap_bang(t_swap *x)
{
    if (x->s_float1)
        outlet_float(x->s_outlet, (double) (x->s_un1.f));
    else
        outlet_int(x->s_outlet, x->s_un1.l);
    if (x->s_float2)
        outlet_float(x->s_ob.o_outlet, (double) (x->s_un2.f));
    else
        outlet_int(x->s_ob.o_outlet, x->s_un2.l);
}

void swap_int(t_swap *x, long int n)
{
    if (x->s_float1)
        outlet_float(x->s_outlet, (double) (x->s_un1.f = n));
    else
        outlet_int(x->s_outlet, x->s_un1.l = n);
    if (x->s_float2)
        outlet_float(x->s_ob.o_outlet, (double) (x->s_un2.f));
    else
        outlet_int(x->s_ob.o_outlet, x->s_un2.l);
}

void swap_float(t_swap *x, double f)
{
    if (x->s_float1)
        outlet_float(x->s_outlet, (double) (x->s_un1.f = f));
    else
        outlet_int(x->s_outlet, x->s_un1.l = f);
    if (x->s_float2)
        outlet_float(x->s_ob.o_outlet, (double) (x->s_un2.f));
    else
        outlet_int(x->s_ob.o_outlet, x->s_un2.l);
}

void c_swap()
{
    c_new(&s_swap, NIL, sizeof(t_swap), 0, 0);
    c_addbang(swap_bang);
    c_addint(swap_int);
    c_addfloat(swap_float);
    c_addinx(swap_in1, 1);
    c_addftx(swap_ft1, 1);
}

void *swap_class;

void *xswap(int ac, t_atom *av, int afloat)
{
    t_swap *x = (t_swap *) obj_new((t_messlist **) & swap_class, c_swap);
    if (ac > 1)
        warn("swap: too many arguments");
    if (x->s_float1 = afloat)
        x->s_un1.f = 0;
    else
        x->s_un1.l = 0;
    if (ac)
    {
        if (av->a_type == A_LONG)
            x->s_float2 = 0, x->s_un2.l = av->a_w.w_long;
        else if (av->a_type == A_FLOAT)
            x->s_float2 = 1, x->s_un2.f = av->a_w.w_float;
        else
            x->s_float2 = 0, x->s_un2.l = 0;
    }
    else
        x->s_float2 = x->s_un2.l = 0;
    x->s_outlet = outlet(x, x->s_float2 ? &s_float : &s_int);
    inlet(x, x, x->s_float2 ? &s_float : &s_int,
          x->s_float2 ? &s_ft1 : &s_in1);
    outlet(x, x->s_float2 ? &s_float : &s_int);
    return (x);
}

void *swap_new(t_symbol *s, int ac, t_atom *av)
{
    return (xswap(ac, av, 0));
}

void *fswap_new(t_symbol *s, int ac, t_atom *av)
{
    return (xswap(ac, av, 1));
}

/* <a> the pipe class is moved here to take advantage of some common
   definitions.  Code added from here to the end of the file. */

typedef struct pipe {
    t_pack p_p;
    void *p_out[NARGS];
    struct link *p_link;
    long p_size;
} t_pipe;

typedef struct link {
    void *l_clock;
    t_pipe *l_pipe;
    struct link *l_next;
    struct link *l_prev;
    union word l_shit[1];
} t_link;

void pipelink_doit(t_link *x)
{
    t_pipe *p = x->l_pipe;
    int max = p->p_p.p_argc - 1;
    union word *wp = x->l_shit + max;
    t_atom *ap = p->p_p.p_argv + max;
    void **outp = p->p_out + max;
    for (; max--;)
    {
        if ((--ap)->a_type == A_FLOAT)
            outlet_float(*(--outp), (--wp)->w_float);
        else
            outlet_int(*(--outp), (--wp)->w_long);
    }
    if (p->p_link == x)
        p->p_link = x->l_next;
    if (x->l_next)
        x->l_next->l_prev = x->l_prev;
    if (x->l_prev)
        x->l_prev->l_next = x->l_next;
    clock_free(x->l_clock);
    freebytes(x, p->p_size);
}

void pipe_bang(t_pipe *x)
{
    t_link *l = (t_link *) (getbytes(x->p_size));
    union word *wp = l->l_shit;
    t_atom *ap = x->p_p.p_argv;
    int i = x->p_p.p_argc - 1;
    long temp;
    if (x->p_link)
        x->p_link->l_prev = l;
    l->l_next = x->p_link;
    l->l_prev = 0;
    x->p_link = l;
    l->l_pipe = x;
    for (; i--;)
        *wp++ = (ap++)->a_w;
    clock_set(l->l_clock = clock_new(l, pipelink_doit),
              logicaltime + ((temp = ap->a_w.w_long) > 0 ? temp : 0));
}

void pipe_int(t_pipe *x, long int n)
{
    if (x->p_p.p_argv[0].a_type == A_FLOAT)
        x->p_p.p_argv[0].a_w.w_float = n;
    else
        x->p_p.p_argv[0].a_w.w_long = n;
    pipe_bang(x);
}

void pipe_float(t_pipe *x, double f)
{
    if (x->p_p.p_argv[0].a_type == A_FLOAT)
        x->p_p.p_argv[0].a_w.w_float = f;
    else
        x->p_p.p_argv[0].a_w.w_long = f;
    pipe_bang(x);
}

void pipe_clear(t_pipe *x)
{
    int shit = x->p_p.p_argc;
    x->p_p.p_argc = 1;
    while (x->p_link)
        pipelink_doit(x->p_link);
    x->p_p.p_argc = shit;
}

void pipe_flush(t_pipe *x)
{
    while (x->p_link)
        pipelink_doit(x->p_link);
}

void pipe_free(t_pipe *x)
{
    pipe_clear(x);
}

void c_pipe()
{
    c_new(&s_pipe, pipe_free, sizeof(t_pipe), 0, 0);
    c_addbang(pipe_bang);
    c_addint(pipe_int);
    c_addfloat(pipe_float);
    c_addmess(pipe_clear, &s_clear, 0);
    c_addmess(pipe_flush, &s_flush, 0);
    c_addinx(pack_in1, 1);
    c_addftx(pack_ft1, 1);
    c_addinx(pack_in2, 2);
    c_addftx(pack_ft2, 2);
    c_addinx(pack_in3, 3);
    c_addftx(pack_ft3, 3);
    c_addinx(pack_in4, 4);
    c_addftx(pack_ft4, 4);
    c_addinx(pack_in5, 5);
    c_addftx(pack_ft5, 5);
    c_addinx(pack_in6, 6);
    c_addftx(pack_ft6, 6);
    c_addinx(pack_in7, 7);
    c_addftx(pack_ft7, 7);
    c_addinx(pack_in8, 8);
    c_addftx(pack_ft8, 8);
    c_addinx(pack_in9, 9);
    c_addftx(pack_ft9, 9);
}

void *pipe_messlist;

void *pipe_new(t_symbol *s, int ac, t_atom *av)
{
    t_pipe *x =
        (t_pipe *) obj_new((t_messlist **) & pipe_messlist, c_pipe);
    t_atom *ap;
    t_atom av2[2];
    void **outp;
    int xxx;
    if (!ac)                    /* default to two longs */
    {
        ac = 2;
        SETLONG(av2, 0);
        SETLONG(av2 + 1, 0);
        av = av2;
    }
    else if (ac == 1)
    {
        ac = 2;
        SETLONG(av2, 0);
        av2[1] = av[0];
        av = av2;
    }
    else if (ac > NARGS)
        ac = NARGS;
    x->p_link = 0;
    x->p_size = sizeof(t_link) + (ac - 2) * sizeof(union word);
    xxx = ac - 1;
    ap = x->p_p.p_argv + ac;
    outp = x->p_out + xxx;
    av += ac;
    x->p_p.p_argc = ac;
    if ((av - 1)->a_type == A_FLOAT)
        SETLONG(av - 1, (av - 1)->a_w.w_float);
    else if ((av - 1)->a_type != A_LONG)
        SETLONG(av - 1, 0);
    while (ac--)
    {
        char c;
        *(--ap) = *(--av);
        if ((c = ap->a_type) != A_LONG && c != A_FLOAT)
            SETLONG(ap, 0);
        if (ac != xxx)
        {
            *(--outp) = outlet(x, c == A_FLOAT ? &s_float : &s_int);
        }
        if (ac)
        {
            if (c == A_FLOAT)
                inlet(x, x, &s_float, floatsyms[ac - 1]);
            else
                inlet(x, x, &s_int, fixsyms[ac - 1]);
        }
    }
    return (x);
}
