#ifndef lint
static char rcsid[] =
    "$Revision: 2.3 $ IRCAM $Date: 1993/11/19 10:51:59 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.3 $ IRCAM $Date: 1993/11/19 10:51:59 $
 *
 * FTS by Miller Puckette
 *
 */


#include <math.h>
#include <stdio.h>
double log(double x);

/* control objects relevant to synthesis */

#if 0
void logtest(int n)
{
    static int ntimes = 0;
    if (ntimes < 50)
    {
        fprintf(stderr, "test %d log %f is %f\n", n, 123., log(123));
        ntimes++;
    }
}
#endif

/*************** MIDI to frequency convertor *******************/

double mtof(double f)
{
    double xx = .057762265 * (f - 69.);
    double foo = exp(xx);
    return (440. * exp(xx));
}

#include "m_mess.h"
typedef struct _mtof {
    t_object t_ob;
} t_mtof;

extern t_symbol s_mtof;

void mtof_float(t_mtof *x, double f)
{
    float foo;
    foo = mtof((double) f);
    outlet_float(x->t_ob.o_outlet, foo);
}

void mtof_int(t_mtof *x, long int n)
{
    outlet_float(x->t_ob.o_outlet, (float) mtof((double) n));
}

void *mtof_class;
void mtof_setup()
{
    c_new(&s_mtof, NIL, sizeof(t_mtof), 0, 0);
    c_addint(mtof_int);
    c_addfloat(mtof_float);
}

void *mtof_new()                /* init vals in struc */
{
    t_mtof *x =
        (t_mtof *) obj_new((t_messlist **) & mtof_class, mtof_setup);
    outlet(x, &s_float);
    return (x);
}

/*******************************************************************/

typedef struct _ftom {
    t_object t_ob;
} t_ftom;

extern t_symbol s_ftom;

double ftom(double f)
{
    if (f > 0)
        return (69. + (1. / .057762265) * log(f / 440.));
    else
        return (-1000);
}

void ftom_float(t_ftom *x, double f)
{
    outlet_float(x->t_ob.o_outlet, ftom(f));
}

void ftom_int(t_ftom *x, long int n)
{
    outlet_float(x->t_ob.o_outlet, ftom((double) n));
}

void *ftom_class;
void ftom_setup()
{
    c_new(&s_ftom, NIL, sizeof(t_ftom), 0, 0);
    c_addint(ftom_int);
    c_addfloat(ftom_float);
}

void *ftom_new()                /* init vals in struc */
{
    t_ftom *x =
        (t_ftom *) obj_new((t_messlist **) & ftom_class, ftom_setup);
    outlet(x, &s_float);
    return (x);
}

/*******************************************************************/

/* linedrive (generate line~ controls from a pot) */

typedef struct linedrive {
    t_object t_ob;
    float t_zval;
    float t_logincr;
    long t_msec;
    float t_max;
} t_linedrive;

extern t_symbol s_linedrive, s_in1;

void linedrive_float(t_linedrive *x, double f)
{
    t_atom at[2];
    if (f > x->t_max)
        f = x->t_max;
    at[1].a_type = A_LONG;
    at[1].a_w.w_long = x->t_msec;
    at[0].a_type = A_FLOAT;
    at[0].a_w.w_float = ((f < .5) ? 0. :
                         x->t_zval * exp(f * x->t_logincr));
    outlet_list(x->t_ob.o_outlet, &s_list, 2, at);
}

void linedrive_int(t_linedrive *x, long int n)
{
    linedrive_float(x, (double) n);
}

void linedrive_in1(t_linedrive *x, long int n)
{
    x->t_msec = n;
}

void *linedrive_class;
void linedrive_setup()
{
    c_new(&s_linedrive, NIL, sizeof(t_linedrive), 0, 0);
    c_addint(linedrive_int);
    c_addinx(linedrive_in1, 1);
    c_addfloat(linedrive_float);
}

void *linedrive_new(double base, double val, double inc, double msec)
/* base input value */
/* value of output at base input */
/* value to multiply per unit increment of output */
/* slew time */
{
    t_linedrive *x =
        (t_linedrive *) obj_new((t_messlist **) & linedrive_class,
                                linedrive_setup);
    outlet(x, NIL);
    inlet(x, x, &s_int, &s_in1);
    x->t_msec = msec;
    x->t_max = base;
    if (inc < 1)
        inc = 1;
    x->t_logincr = log(inc);
    x->t_zval = val * exp(-(base * x->t_logincr));
    return (x);
}
