#ifndef lint
static char rcsid[] =
    "$Revision: 1.9 $ IRCAM $Date: 1994/01/04 18:04:56 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 1.9 $ IRCAM $Date: 1994/01/04 18:04:56 $
 *
 * FTS by Miller Puckette
 *
 */


#include <stdio.h>
#include "m_mess.h"
#include "t_mac.h"
#include "cp_mess.h"

#include "t_wind.h"
#include "p_patcher.h"

/*  DOLIST
  reentrancy protection
  */
extern t_symbol s_qlist, s_connect;
void *cpr_new();
extern t_symbol *defvolume;

struct binbuf;
extern void binbuf_insert(struct binbuf *x, struct symbol *s, int argc,
                          struct atom *argv);

/* updates from CP to host are initiated via the "flush" method.  An update
   is a packet of characters, the first of which contains a "first" flag and
   a "last" flag.  The packet is terminated by the null character.
   If an update is recieved on the host whose "first" flag
   is set, the host initializes a copy of the text and puts the first packet in.
   If "first" isn't set, the packet is appended to the text copy.
   If "last" is set in a packet, after appending the text, the text is copied to
   the "text edit" buffer.
   */

#define SP_FIRST 1              /* first update in sequence */
#define SP_LAST 2               /* last update in sequence */

#define UPDATESIZE HQ_MAX

typedef struct _qlist {
    struct object q_ob;
    void *q_binbuf;
    long q_onset;               /* onset into qlist for playback */
    long q_bon;                 /* second onset, same */
    t_symbol *q_defvolume;
#ifdef GRAPHICS
    void *q_editor;             /* text editor */
    void *q_cpr;                /* CP responder */
    char **q_textfromcp;        /* incoming text from CP */
    long q_sizefromcp;          /* its size */
    long q_handlesize;          /* its allocated size */
    t_symbol *q_filename;
    void *q_patcher;
    int q_dirty;
#else
    void *q_hq;
    char **q_sendtext;
    long q_textonset;
    long q_textsize;
#endif
    t_symbol *q_sym;
} t_qlist;

void qlist_rewind(t_qlist *x, long int n)
{
    x->q_onset = 0;
    x->q_bon = 0;
}

#define NATOM 256
void qlist_next(t_qlist *x, long int drop)
{
    struct atom av[NATOM], *ap;
    int ac;
    long x1, x2;
    void *who;
    char type = A_SEMI;

    who = 0;
    while (type)
    {
        binbuf_getatom(x->q_binbuf, &x->q_onset, &x->q_bon, av);
        if (!who)
        {
            if (av->a_type == A_FLOAT || av->a_type == A_LONG)
            {
                struct atom waka[11], *wp = waka + 1;
                long count = 1, peek1 = x->q_onset, peek2 = x->q_bon;
                waka[0] = *av;

                while (1)
                {
                    x->q_onset = peek1;
                    x->q_bon = peek2;
                    binbuf_getatom(x->q_binbuf, &peek1, &peek2, wp);
                    if (wp->a_type != A_LONG && wp->a_type != A_FLOAT)
                        break;
                    if (count < 11)
                        count++, wp++;
                }
                if (count == 1)
                {
                    if (waka[0].a_type == A_FLOAT)
                        outlet_float(x->q_ob.o_outlet, av->a_w.w_float);
                    else
                        outlet_int(x->q_ob.o_outlet, av->a_w.w_long);
                }
                else
                {
                    if (count > 10)
                        count = 10;
                    outlet_list(x->q_ob.o_outlet, NIL, (int) count, waka);
                }
                break;
            }
            else if (av->a_type == A_LONG)
            {
                outlet_int(x->q_ob.o_outlet, av->a_w.w_long);
                break;
            }
        }
        for (ac = 0, ap = av;; ac++)
        {
            if ((type = ap->a_type) == A_SEMI || type == A_COMMA || !type)
                break;
            binbuf_getatom(x->q_binbuf, &x->q_onset, &x->q_bon, ++ap);
        }
        ap = av;
#if 0                           /* debugging */
        {
            int i;
            char buf[80];
            post("=>");
            for (i = 0; i < ac; i++)
            {
                switch (av[i].a_type)
                {
                case A_LONG:
                    sprintf(buf, "(i)%ld", av[i].a_w.w_long);
                    break;
                case A_SYM:
                    sprintf(buf, "(s)%s", av[i].a_w.w_sym->s_name);
                    break;
                case A_SEMI:
                    sprintf(buf, "(;)");
                    break;
                default:
                    sprintf(buf, "(other)");
                    break;
                }
                post(buf);
                post("==");
            }
        }
#endif                          /* debugging */
        if (!who)
        {
            if (av->a_type == A_SYM)
            {
                who = av->a_w.w_sym->s_thing;
                if (!who)
                {
                    post("%s: no such object", av->a_w.w_sym->s_name);
                    continue;
                }
                ap++;
                ac--;
                if (!ac)
                    continue;
            }
            else
                continue;
        }
        if (!drop)
        {
            if (ap->a_type == A_LONG)
            {
                if (ac > 1)
                    typedmess(who, &s_list, ac, ap);
                else
                    typedmess(who, &s_int, ac, ap);
            }
            else if (ap->a_type == A_FLOAT)
            {
                if (ac > 1)
                    typedmess(who, &s_list, ac, ap);
                else
                    typedmess(who, &s_float, ac, ap);
            }
            else if (ap->a_type == A_SYM)
                typedmess(who, ap->a_w.w_sym, ac - 1, ap + 1);
        }
        if (type != A_COMMA)
            who = 0;
    }
}

#ifdef GRAPHICS
void qlist_dosave();
void qlist_textclosing(x, h, size)
t_qlist *x;
char **h;
long size;
{
    qlist_rewind(x, 0);
    binbuf_text(x->q_binbuf, h, size);
    x->q_editor = 0;
    if (x->q_cpr)
    {
        h_vmess(x, gensym("clear"), "");
        qlist_dosave(x, NIL, 1);
    }
}
#endif                          /* GRAPHICS */

#ifdef GRAPHICS
void *qtext_new();
void qlist_dblclick(t_qlist *x)
{
#ifndef XMAX
    if (x->q_editor)
        qtext_front(x->q_editor);
    else
    {
        char **handle = (char **) t_newhandle(0L);
        long len;
        binbuf_totext(x->q_binbuf, handle, &len);
        x->q_editor = qtext_new(x, handle, len, x->q_sym->s_name);
        t_disposehandle((void **) handle);
    }
#endif
}
#endif                          /* GRAPHICS */

/* if the string t contains special characters, backslash them into string s */
slasher(char *s, char *t)
{
    char c, *t2 = t;
    /* if $1-$9, backslash the $ -- otherwise $ won't bother gensym */
    if (t2[0] == '$' && (c = t2[1]) >= '1' && c <= '9' && !t2[2])
    {
        *s++ = '\\';
        while (*s++ = *t++)
            ;
        return 1;
    }
    while (c = *t2++)
    {
        if (c == ';' || c == ',' || c == '\\')
        {
            while (c = *(t++))
            {
                if (c == ';' || c == ',' || c == '$' || c == '\\')
                    *s++ = '\\';
                *s++ = c;
            }
            *s = '\0';
            return 1;
        }
    }
    return 0;
}

#ifdef GRAPHICS
#define CHUNK 20
void qlist_dosave(t_qlist *x, void *w, int tocp)
{
    long x1, x2;
    struct symbol *s_N, *s_append;
    x1 = x2 = 0;
    s_N = gensym("#X");
    s_append = gensym("append");
    if (!tocp)
    {
        if (x->q_filename)
        {
            vfun(w, binbuf_insert, NIL,
                 "sssss", gensym("#N"), gensym("qlist"), x->q_sym,
                 gensym("-f"), x->q_filename);
            return;
        }
        else
            vfun(w, binbuf_insert, NIL,
                 "sss", gensym("#N"), gensym("qlist"), x->q_sym);
    }
    while (1)
    {
        struct atom av[CHUNK + 3], *ap = av + 2;
        int ac = 0;
        SETSYM(av, s_N);
        SETSYM(av + 1, s_append);
        while (ac < CHUNK - 2)
        {
            char xx[80];
            struct symbol *sp;
            struct atom axe;
            binbuf_getatom(x->q_binbuf, &x1, &x2, &axe);
            if (!axe.a_type)
                break;
            switch (axe.a_type)
            {
            case A_LONG:
                SETLONG(ap, axe.a_w.w_long);
                break;
            case A_FLOAT:
                SETFLOAT(ap, axe.a_w.w_float);
                break;
            case A_SYM:
                sp = axe.a_w.w_sym;
                if (slasher(xx, sp->s_name))
                    SETSYM(ap, gensym(xx));
                else
                    SETSYM(ap, sp);
                break;
            case A_DOLLAR:
                sprintf(xx, "$%ld", axe.a_w.w_long);
                SETSYM(ap, gensym(xx));
                break;
            case A_COMMA:
                SETSYM(ap, gensym(","));
                break;
            case A_SEMI:
                SETSYM(ap, gensym(";"));
                break;
            }
            ap++;
            ac++;
        }
        if (!ac)
            break;
        if (tocp)
            h_mess(x, s_append, ac, av + 2);
        else
            binbuf_insert(w, NIL, ac + 2, av);
    }
}

void qlist_save(x, w)
t_qlist *x;
void *w;
{
    qlist_dosave(x, w, 0);
}

void qlist_dirty(t_qlist *x, int n)
{
#ifdef NEXTSTEP
    if (x->q_editor)
        qtext_markdirty(x->q_editor, n);
#endif
    if (n && (!x->q_filename))
        patcher_dirty(x->q_patcher, 1);
    x->q_dirty = n;
}

#endif                          /* GRAPHICS */

void qlist_append(t_qlist *x, struct symbol *s, int ac, struct atom *av)
{
    binbuf_append(x->q_binbuf, s, ac, av);
}

void qlist_set(t_qlist *x, struct symbol *s, int ac, struct atom *av)
{
    qlist_rewind(x, 0);
    binbuf_clear(x->q_binbuf);
    binbuf_append(x->q_binbuf, s, ac, av);
}

void qlist_clear(t_qlist *x)
{
    qlist_set(x, NIL, 0, NIL);
}

#ifndef GRAPHICS                /* code to flush a qlist up from CP to host */
void qlist_flush(t_qlist *x)
{
    if (!x->q_hq)
        bug("qlist_flush");
    else
    {
        if (x->q_sendtext)
            t_disposehandle((void **) x->q_sendtext);
        x->q_sendtext = (char **) t_newhandle(0L);
        x->q_textonset = 0;
        if (binbuf_totext(x->q_binbuf, x->q_sendtext, &x->q_textsize))
        {
            error("qlist_flush: not enough memory");
            t_disposehandle((void **) x->q_sendtext);
            x->q_sendtext = 0;
            return;
        }
        else
            hq_set(x->q_hq);
    }
}

void qlist_hqfn(t_qlist *x, void *hq)
{
    int bytestosend = x->q_textsize - x->q_textonset, count;
    char *s1, *s2, buf[UPDATESIZE], flag = (x->q_textonset ? 0 : SP_FIRST);
    if (bytestosend > UPDATESIZE - 2)
        bytestosend = UPDATESIZE - 2;
    if (bytestosend < 0)
    {
        bug("qlist_hq 1");
        return;
    }
    for (count = bytestosend, s1 = buf + 1, s2 =
         *x->q_sendtext + x->q_textonset; count--;)
        *s1++ = *s2++;
    *s1++ = 0;
    x->q_textonset += bytestosend;

    if (x->q_textonset >= x->q_textsize)
    {
        t_disposehandle((void **) x->q_sendtext);
        x->q_sendtext = 0;
        flag |= SP_LAST;
    }
    else
        hq_set(x->q_hq);
    buf[0] = flag;
    hq_doit(hq, buf, bytestosend + 2);
}

void qlist_connect(t_qlist *x, long int ptr, long int fun,
                   long int freefun)
{
    if (ptr)
    {
        if (x->q_hq)
            bug("qlist_connect 1");
        x->q_hq = hq_new(fun, freefun, ptr, x, qlist_hqfn,
                         UPDATESIZE, currentPort);
    }
    else
    {
        if (!x->q_hq)
            bug("qlist_connect 2");
        else
            hq_free(x->q_hq);
        x->q_hq = 0;
    }
}
#endif

/* CP->host update, host side */
#ifdef GRAPHICS
void qlist_cpr(t_qlist *x, char *buf, int size)
{
    int flags = *buf;
    char *s1 = buf + 1;
    int cplength = strlen(s1), newlength;
    if (flags & SP_FIRST)
    {
        if (x->q_textfromcp)
            t_disposehandle((void **) x->q_textfromcp);
        x->q_textfromcp = (char **) t_newhandle(1L);
        **x->q_textfromcp = 0;
        x->q_sizefromcp = 0;
        x->q_handlesize = 1;
    }
    else if (!x->q_textfromcp)
    {
        bug("qlist_cpr");
        return;
    }
    newlength = cplength + x->q_sizefromcp;
    if (newlength > x->q_handlesize)
    {
        if (t_growhandle((void **) x->q_textfromcp,
                         x->q_handlesize = newlength + (newlength >> 2)))
        {
            ouch("out of space");
            x->q_textfromcp = 0;
            return;
        }
    }
    strncpy(*x->q_textfromcp + x->q_sizefromcp, s1, cplength);
    x->q_sizefromcp = newlength;
    if (flags & SP_LAST)
    {
        /* post("settext %c %c %c ... %d",
           (*x->q_textfromcp)[0], 
           (*x->q_textfromcp)[1], 
           (*x->q_textfromcp)[2], newlength); */
#ifdef NEXTSTEP
        if (x->q_editor)
            qtext_settext(x->q_editor, x->q_textfromcp, (long) newlength);
#endif
        binbuf_text(x->q_binbuf, x->q_textfromcp, (long) newlength);
        t_disposehandle((void **) x->q_textfromcp);
        x->q_textfromcp = 0;
    }
}

void qlist_setcp(x, n, flags)
t_qlist *x;
{
    if (flags & CP_UNPUT)
    {
        if (x->q_cpr)
        {
            cpr_free(x->q_cpr);
            x->q_cpr = 0;
        }
    }
    if (flags & CP_PUT)
    {
        x->q_cpr = cpr_new(x, qlist_cpr);
        qlist_dosave(x, NIL, 1);
    }
}

#endif                          /* GRAPHICS */

void qlist_read(t_qlist *x, t_symbol *s)
{
    if (binbuf_read(x->q_binbuf, s->s_name, x->q_defvolume, 0))
        binbuf_ouch(s->s_name);
}

void qlist_write(t_qlist *x, t_symbol *s)
{
    if (binbuf_write(x->q_binbuf, s->s_name, x->q_defvolume, 0))
        binbuf_ouch(s->s_name);
}

void qlist_dispose(t_qlist *x)
{
    struct symbol *s;

#ifdef GRAPHICS
#ifdef NEXTSTEP
    if (x->q_dirty && x->q_filename)
        qtext__trytosave(x->q_binbuf);
    if (x->q_editor)
        qtext_free(x->q_editor);
#endif
#endif
    binbuf_free(x->q_binbuf);
    if ((s = gensym("#X"))->s_thing == (struct object *) x)
        s->s_thing = 0;
}

void *qlist_class;
void qlist_setup()
{
    c_new(&s_qlist, qlist_dispose, sizeof(t_qlist), 0, 0);
    c_addmess(qlist_rewind, gensym("rewind"), 0);
    c_addmess(qlist_next, gensym("next"), A_DEFLONG, 0);

#ifdef GRAPHICS
    c_addmess(qlist_dblclick, gensym("dblclick"), A_CANT, 0);
    c_addmess(qlist_save, gensym("save"), A_CANT, 0);
    c_addmess(qlist_setcp, gensym("setcp"), A_CANT, 0);
#else
    c_addmess(qlist_connect, &s_connect, A_LONG, A_LONG, A_LONG, 0);
    c_addmess(qlist_flush, gensym("flush"), 0);
    c_addmess(qlist_read, gensym("read"), A_SYM, 0);
    c_addmess(qlist_write, gensym("write"), A_SYM, 0);
#endif

    c_addmess(qlist_set, gensym("set"), A_GIMME, 0);
    c_addmess(qlist_clear, gensym("clear"), 0);
    c_addmess(qlist_append, gensym("append"), A_GIMME, 0);
}

t_symbol *atom_getsym(t_atom * at);

void *qlist_new(struct symbol *s, int ac, t_atom *av)
{
    t_symbol *name, *filename = 0;
    t_qlist *x =
        (t_qlist *) obj_new((t_messlist **) & qlist_class, qlist_setup);
    x->q_binbuf = binbuf_new();
    x->q_defvolume = defvolume;
#ifdef GRAPHICS
    x->q_editor = 0;
    x->q_cpr = 0;
    x->q_textfromcp = 0;
    x->q_sizefromcp = 0;
    x->q_handlesize = 0;
#else
    x->q_hq = 0;
    x->q_sendtext = 0;
    x->q_sendtext = 0;
    x->q_textonset = 0;
    x->q_textsize = 0;
#endif
    outlet_new(x, &s_int);
    x->q_onset = x->q_bon = 0;
    if (ac)
    {
        x->q_sym = atom_getsym(av);
        ac--;
        av++;
    }
    else
        x->q_sym = &s_qlist;
#ifdef GRAPHICS
    while (ac)
    {
        char *flag = atom_getsym(av)->s_name;
        if (!strcmp(flag, "-f"))
        {
            if (ac < 2)
            {
                error("qlist: -f option with no filename given");
            }
            else
            {
                ac--;
                av++;
                filename = atom_getsym(av);
            }
        }
        else if (!strcmp(flag, "-n"))
            filename = 0;
        else
            error("qlist: %s: unknown flag", flag);
        ac--;
        av++;
    }
    if (filename)
        qlist_read(x, filename);
    x->q_filename = filename;
    x->q_patcher = gensym("#P")->s_thing;
    x->q_dirty = 0;
#endif
    gensym("#X")->s_thing = (struct object *) x;
    return (x);
}
