#ifndef lint
static char rcsid[]= "$Revision: 2.2 $ IRCAM $Date: 1994/01/04 18:05:04 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.2 $ IRCAM $Date: 1994/01/04 18:05:04 $
 *
 * FTS by Miller Puckette
 *
 */

#import <appkit/View.h>
#import <appkit/Text.h>
#import <appkit/ScrollView.h>
#import <appkit/Window.h>
static id pwind, ptext, pscroll;
static int initted;
#define DEFWIDTH 400.
#define DEFHEIGHT 500.
#define DEFX 0.
#define DEFY 165.

@interface Qwind: Window
{
}

- find: (char *)s :(int)again;
@end

@implementation Qwind

- find: (char *)s :(int)again
{
	[delegate find: s :again];
}

@end

@interface Bordel : Object
{
	id editor;
	int edited;
	void *qlist;
}

- initEdit: (id)who qlist: (void *)x;
- windowWillClose: (id)sender;
- front;
- settext: (char **)handle: (long)size: (int)sizetofit;
- textDidChange: who;
- editor;
- find: (char *)s :(int)again;

- free;
@end

@implementation Bordel

- initEdit: (id)who qlist: (void *)x
{
	[super init];
	edited = 0;
	editor = who;
	qlist = x;
	return (self);
}

char **t_newhandle();
- windowWillClose: (id)sender
{
	char **texthandle;
	long textlength;
	textlength = [editor byteLength];
	texthandle = t_newhandle(textlength);
	[editor getSubstring: *texthandle start: 0 length: textlength];
	qlist_textclosing(qlist, texthandle, textlength);
	t_disposehandle(texthandle);
	return (self);
}

- front
{
	[[editor window] makeKeyAndOrderFront: nil];
}

- textDidChange: who
{
	qlist_dirty(qlist);
}

- editor
{
	return (editor);
}

char *t_newptr();
- find: (char *)s :(int)again
{
	char *fromtext;
	long textlength;
	int i = strlen(s);
	char *foo, *efoo;
	NXSelPt startsel, endsel;
	textlength = [editor byteLength];
	[editor getSel:&startsel :&endsel];
	fromtext = t_newptr(textlength+1);
	if (!fromtext) return;
	[editor getSubstring: fromtext start: 0 length: textlength];
	fromtext[textlength] = 0;
	for (foo = fromtext + endsel.cp, efoo = fromtext+textlength;
		foo < efoo; foo++)
	{
		if (!strncmp(foo, s, i))
		{
			[editor setSel: foo-fromtext:foo-fromtext+i];
			[editor scrollSelToVisible];
			goto done;
		}
	}
	ouch("%s: not found", s);
done:
	t_disposeptr(fromtext);
	return (0);
}

- free
{
	[[editor window] close];
}

- settext: (char **)handle: (long)size: (int)sizetofit
{
	t_growhandle(handle, size+1);
	(*handle)[size] = 0;
	[editor setText: *handle];
	if (sizetofit)
	{
		[editor sizeToFit];
		[editor display];
		[[editor window] flushWindow];
	}
}
@end

@interface Qtext : Text
{
}
-selectall: who;
@end

@implementation Qtext

-selectall: who
{
	[self setSel: 0 :10000000];
}
@end

void *qtext_new(x, handle, size, name)
 void *x;
 char **handle;
 long size;
 const char *name;
{
	NXRect	rect;
	NXRect  inside;
	NXSize sigh;
	id bordel;

	NXSetRect(&rect, DEFX, DEFY, DEFWIDTH, DEFHEIGHT);
	pwind = [Qwind newContent:&rect
			style:NX_RESIZEBARSTYLE
			backing:NX_BUFFERED
			buttonMask:(NX_MINIATURIZEBUTTONMASK | NX_CLOSEBUTTONMASK)
			defer:NO];
	[pwind setTitle:name];
	[[pwind contentView] setAutoresizeSubviews:YES];
	[pwind setBackgroundGray: 1.];

	NXSetRect(&rect, 0.0, 0.0, DEFWIDTH, DEFHEIGHT);
	/* new*/ 
	pscroll = [ScrollView newFrame:&rect];
	[pscroll setVertScrollerRequired: YES];
	[pscroll getDocVisibleRect: &rect];
	[pscroll setAutosizing: NX_WIDTHSIZABLE | NX_HEIGHTSIZABLE];
	[[pwind contentView] addSubview:pscroll]; /* was ptext */
	[pscroll setAutoresizeSubviews:YES];

	ptext = [Qtext newFrame:&rect
			text:""
			alignment:NX_LEFTALIGNED];

	bordel = [[Bordel alloc] initEdit: ptext qlist: x];
	[bordel settext: handle :size :0];

	/**/ [pscroll setDocView: ptext];

	sigh.width = 500;
	sigh.height = 10000000;
	[ptext setMaxSize: &sigh];
	sigh.width = 500;
	sigh.height = 100;
	[ptext setMinSize: &sigh];
	[ptext setVertResizable:YES];
	[ptext setHorizResizable:YES];
	[ptext setAutosizing: NX_HEIGHTSIZABLE| NX_WIDTHSIZABLE];
	[ptext setOpaque:YES];
	[ptext sizeToFit];

	[pwind display];
	[pwind orderFront:nil];
	[pwind makeKeyWindow];
	
	[pwind setDelegate: bordel];
	[ptext setDelegate: bordel];
	return (bordel);
}

qtext_free(x)
 id x;
{
	[x free];
}

qtext_front(x)
 id x;
{
	[x front];
}

qtext_settext(x, handle, size)
 id x;
 char **handle;
 long size;
{
	[x settext: handle :size :1];
}

qtext_markdirty(x, n)
 id x;
{
	[[[x editor] window] setDocEdited: n];
}

#include <sys/types.h>
#include <stdio.h>
qtext__trytosave(buf)
 void *buf;
{
		/* try to save to an editor window */
	FILE *popen(), *fd = popen("openfile", "w");
	if (fd)
	{
		char **shit = t_newhandle(0L);
		long len;
		binbuf_totext(buf, shit, &len);
		fwrite(*shit, (size_t)len, (size_t)1, fd);
		fclose(fd);
	}
}
