#ifndef lint
static char rcsid[] =
    "$Revision: 2.3 $ IRCAM $Date: 1993/11/19 10:52:06 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.3 $ IRCAM $Date: 1993/11/19 10:52:06 $
 *
 * FTS by Miller Puckette
 *
 */


#include "m_mess.h"

void *toolfile();
void *clock(), *qclock(), *outlet(), *inlet(), binbuf_set(),
binbuf_insert();
void *midiseq_stop();
#define EOF (-1)
extern struct symbol s_print, s_tick, s_record, s_start, s_stop,
    s_, s_new, s_dump, s_in1,
    s_delay, s_seq, s_read, s_write, s_follow, s_next,
    s_writeold, s_append, s_hook, s_first;

#define THREEBYTE(x) ((x & 0xe0) != 0xc0)
#define MESSLEN(x) (2 + ((x & 0xe0) != 0xc0))
#define SYSEX 0xf0
#define ENDEX 0xf7
#define NULLEVT 0xfe
#define NOTEON 0x90
#define DEFTEMPO 120
#define TIMEBASE 96

#define TPERSEC 48              /* ticks per sec to maintain default speed */
#define MSECPERT   (1000L/ 48L) /* approx msecs per tick */
#define MSECPERTSHIFT (1000L * 1024L / 48L)     /* msecs per tick << 10 */
struct msevt                    /* midi sequencer event */
{
    unsigned short e_time;      /* time since last event */
    unsigned char e_shit[4];    /* midi bytes */
};

#define BLK 16                  /* 16 events per block */
struct msblock {
    void *b_class;
    struct msblock *b_next;
    struct msevt b_e[BLK];
};

/* consistency requirements for below: t_nextev always points to
/* an event in the score unless t_nextev == t_lastinblk, in which
/* case we are at end-of-score.  The only case in which an msblock
/* can be empty is when it's the first msblock and there is no
/* score; thus if we hit the end of an msblock and its next pointer
/* is nonzero we are sure to have another event in the score. */

struct midiseq                  /* midi sequencer, one track */
{
    struct object t_ob;
    struct msblock t_block;     /* first event block */
    long t_ninlast;             /* number of events in last block */
    void *t_outlet;             /* outlet for midi bytes */
    struct msblock *t_curblk;   /* current event block */
    struct msevt *t_lastinblk;  /* last event in current block */
    struct msevt *t_nextev;     /* next event to play/record */
    long t_curtime;             /* time of statucs byte (record) */
    long t_scoretime;           /* score time of next note */
    long t_tickcount;           /* number of ticks received */
    long t_ticktime;            /* time of last tick */
    long t_timelim;             /* time limit (sync only) */
    long t_rpers;               /* tempo in 1024ths */
    void *t_clock;              /* clock object */
    char t_shit[4];             /* current partial message for recording */
    long t_ontime;              /* time at which started */
    struct symbol *t_sym;       /* filename */
    void *t_qelem;              /* <a> qelem for deferring "read" and "write" messages */
    char t_play;                /* play flag */
    char t_record;              /* record flag */
    char t_follow;              /* score following flag */
    char t_dirty;               /* flag for saving back to file */
    char t_sysex;               /* recording or playing a sysex */
    char t_nchar;               /* char count for recording */
    char t_messlength;          /* for record: expected midi message length */
    char t_filecmd;             /* <a> "read" or "write" command */
};

#define TSCALE 1024L            /* tempo units */
#define TEMPOSHIFT 10

struct object *msblock_freelist = 0;
struct class msblock_class =
    { &s_, &msblock_freelist, NIL, sizeof(struct msblock), 1 };
struct messlist msblock_messlist[] = {
    { (struct symbol *) &msblock_class },
    0L
};

struct msblock *msblock()
{
    return ((struct msblock *) newobject(msblock_messlist));
}

void *midiseq_clk(x)
struct midiseq *x;
{
    struct msevt *e = x->t_nextev;
    if (!x->t_play)
        return;
    while (1)
    {
        if (e->e_shit[0] != NULLEVT)
        {
            if (x->t_sysex || e->e_shit[0] == SYSEX)
            {
                unsigned char *sp = e->e_shit, *ep = sp + 4;
                x->t_sysex = 1;
                for (; sp < ep; sp++)
                {
                    outlet_int(x->t_outlet, (long) (*sp));
                    if (*sp == ENDEX)
                    {
                        x->t_sysex = 0;
                        break;
                    }
                }
            }
            else if (MESSLEN(e->e_shit[0]) == 2)
            {
                outlet_int(x->t_outlet, (long) (e->e_shit[0]));
                outlet_int(x->t_outlet, (long) (e->e_shit[1]));
            }
            else
            {
                outlet_int(x->t_outlet, (long) (e->e_shit[0]));
                outlet_int(x->t_outlet, (long) (e->e_shit[1]));
                outlet_int(x->t_outlet, (long) (e->e_shit[2]));
            }
        }
        if ((++e) >= x->t_lastinblk)
        {
            if (x->t_curblk = x->t_curblk->b_next)
                x->t_lastinblk = (e = x->t_curblk->b_e) +
                    (x->t_curblk->b_next ? BLK : x->t_ninlast);
            else
            {
                x->t_play = 0;
                break;
            }
        }
        if (e->e_time)
        {
            long nexttime = logicaltime +
                (e->e_time * x->t_rpers >> TEMPOSHIFT);
            if (!x->t_timelim || nexttime < x->t_timelim)
                clock_set(x->t_clock, nexttime);
            x->t_scoretime += e->e_time;
            x->t_nextev = e;
            break;
        }
    }
}

void *midiseq_clear(x)
struct midiseq *x;
{
    struct msblock *b = x->t_block.b_next, *b2;
    midiseq_stop(x);
    while (b)
    {
        b2 = b->b_next;
        freeraw(b, &msblock_class);
        b = b2;
    }
    x->t_block.b_next = 0;
    x->t_curblk = &x->t_block;
    x->t_nextev = x->t_block.b_e;
    x->t_lastinblk = x->t_nextev + BLK;
    x->t_ninlast = 0;
}

void *midiseq_record(x)
struct midiseq *x;
{
    midiseq_clear(x);
    x->t_record = 1;
    x->t_dirty = 1;
    x->t_ontime = logicaltime;
    x->t_messlength = 0;
    x->t_nchar = 0;
    x->t_sysex = 0;
}

void *midiseq_append(x, s, ac, av)
struct midiseq *x;
struct symbol *s;
struct atom *av;
{
    struct event *e;
    long deltime;
    midiseq_stop(x);
    if (x->t_nextev != x->t_lastinblk)  /* if not at end */
    {
        struct msblock *b = &x->t_block, *b2;
        while (b2 = b->b_next)
            b = b2;
        x->t_curblk = b;
        x->t_nextev = b->b_e + x->t_ninlast;
        x->t_lastinblk = b->b_e + BLK;
    }
    x->t_dirty = 1;
    /* get time 
       insert new event at time
       check syntax
       if bad, add null event; if good add teh stuff

       e = insevent(x); */
}

void *midiseq_start(x, sperr)
struct midiseq *x;
long sperr;
{
    if (sperr < 0)
        x->t_timelim = -1;
    else
        x->t_timelim = 0;
    if (sperr < 1)
        sperr = 1024;
    midiseq_stop(x);
    x->t_curblk = &x->t_block;
    x->t_nextev = x->t_block.b_e;
    x->t_lastinblk = x->t_curblk->b_e +
        (x->t_curblk->b_next ? BLK : x->t_ninlast);
    if (x->t_nextev < x->t_lastinblk)
    {
        x->t_play = 1;
        x->t_rpers = (1024L * 1024L) / sperr;
        x->t_scoretime = x->t_nextev->e_time;
        x->t_tickcount = 0;
        if (!x->t_timelim)
            clock_set(x->t_clock, logicaltime +
                      (x->t_scoretime * x->t_rpers >> TEMPOSHIFT));
    }
    x->t_sysex = 0;
}

void *midiseq_bang(x)
struct midiseq *x;
{
    midiseq_start(x, TSCALE);
}

struct msevt *insevent(x)
struct midiseq *x;
{
    struct msevt *e = x->t_nextev++;
    if (e >= x->t_lastinblk)
    {
        struct msblock *b = msblock();
        x->t_curblk->b_next = b;
        x->t_curblk = b;
        b->b_next = 0;
        x->t_lastinblk = b->b_e + BLK;
        x->t_nextev = b->b_e;
        x->t_ninlast = 0;
        e = x->t_nextev++;
    }
    x->t_ninlast++;
    return (e);
}

void *midiseq_int(x, n)
struct midiseq *x;
long n;
{
    int newsysex;
    if (!x->t_record || (n &= 0xff) == NULLEVT)
        return;
    if (newsysex = (n == SYSEX))
        x->t_sysex = 1;
    if (x->t_sysex)
    {
        if ((n & 0x80) && (!newsysex) && n != ENDEX)
        {
            post("seq: unterminated sysex");
            midiseq_int(x, 0xf7L);
            goto normal;
        }
        if (newsysex || x->t_nchar == 4)
        {
            struct msevt *e = insevent(x);
            long diff = logicaltime - x->t_ontime;
            while (diff > 0xffff)
            {
                e->e_shit[0] = NULLEVT;
                e->e_time = 0xffff;
                e = insevent(x);
                diff -= 0xffff;
            }
            e->e_time = diff;
            e->e_shit[0] = n;
            x->t_ontime = logicaltime;
            x->t_nchar = 1;
        }
        else
            (x->t_nextev - 1)->e_shit[x->t_nchar++] = n;
        if (n == ENDEX)
        {
            x->t_sysex = 0;
            x->t_nchar = 0;
        }
        return;
    }
  normal:
    if (n & 0x80)               /* status byte */
    {
        x->t_messlength = MESSLEN(n);
        if ((n & 0xf0) == 0xf0)
        {
            post("midiseq: unknown midi message");
            x->t_messlength = x->t_nchar = 0;
            return;
        }
        if (x->t_nchar > 1)
            post("midiseq: truncated midi message");
        x->t_curtime = logicaltime;
        x->t_shit[0] = n;
        x->t_nchar = 1;
    }
    else
    {
        if (!x->t_messlength)
            return;
        x->t_shit[x->t_nchar++] = n;
    }
    if (x->t_nchar >= x->t_messlength)
    {
        struct msevt *e = insevent(x);
        long diff = logicaltime - x->t_ontime;
        while (diff > 0xffff)
        {
            e->e_shit[0] = NULLEVT;
            e->e_time = 0xffff;
            e = insevent(x);
            diff -= 0xffff;
        }
        e->e_time = diff;
        *((long *) (e->e_shit)) = *((long *) (x->t_shit));
        x->t_ontime = logicaltime;      /* <a> fixed to take running status */
        x->t_nchar = 1;
    }
}

void *midiseq_stop(x)
struct midiseq *x;
{
    if (x->t_sysex)
    {
        post("seq: incomplete sysex");
        if (x->t_record)
            midiseq_int(x, 0xf7L);
        else
            outlet_int(x->t_outlet, 0xf7L);
        x->t_sysex = 0;
    }
    x->t_record = x->t_play = x->t_follow = 0;
}

void *midiseq_continue(x)       /* don't try this yet */
struct midiseq *x;
{
    if (x->t_play)
        return;
    if (x->t_record || x->t_follow)
        midiseq_stop(x);
    x->t_play = 1;
}

void *midiseq_tick(x)
struct midiseq *x;
{
    long lastwas = x->t_ticktime, interval, scoresec, scoretime, nexttime;
    x->t_ticktime = logicaltime;
    if (!x->t_play || !x->t_timelim)
        return;
    if (x->t_tickcount++)
    {
        interval = logicaltime - lastwas;
        if (interval > 30 * MSECPERT)
            interval = 30 * MSECPERT;
        else if (interval < 2)
            interval = 2;
        x->t_rpers = MSECPERTSHIFT / interval;
    }
    else
        x->t_rpers = 1024;
    scoresec = x->t_tickcount / TPERSEC;
    scoretime = 1000 * scoresec +
        (((x->t_tickcount - TPERSEC * scoresec) * MSECPERTSHIFT) >> 10);

    nexttime = logicaltime +
        ((x->t_scoretime - scoretime) * x->t_rpers >> TEMPOSHIFT);
    if (nexttime < (x->t_timelim = logicaltime + 2 * MSECPERT))
        clock_set(x->t_clock, nexttime);
}

void *midiseq_print(x)
struct midiseq *x;
{
    struct msblock *b = &x->t_block;
    struct msevt *e = b->b_e;
    int ax = b->b_next ? BLK : x->t_ninlast;
    int wasex = 0;
    if (!ax)
    {
        post("midiseq: no sequence");
        return;
    }
    post("midiseq:");
    for (; ax--; e++)
    {
        int n;
        unsigned char stat = e->e_shit[0];
        if (stat == NULLEVT)
            post("(%ld) (null)", e->e_time & 0xffffL);
        else if (stat == SYSEX || wasex)
        {
            unsigned char *sp = e->e_shit, *ep = sp + 4;
            if (wasex)
                post("(%ld)-> ", e->e_time & 0xffffL);
            else
                post("(%ld) ", e->e_time & 0xffffL);
            wasex = 1;
            for (; sp < ep; sp++)
            {
                postlong((long) (*sp));
                poststring(" ");
                if (*sp == ENDEX)
                {
                    wasex = 0;
                    break;
                }
            }
        }
        else if (THREEBYTE(stat))
            post("(%ld) %d %d %d", e->e_time & 0xffffL,
                 stat & 0xff, e->e_shit[1] & 0xff, e->e_shit[2] & 0xff);
        else
            post("(%ld) %d %d", e->e_time & 0xffffL,
                 stat & 0xff, e->e_shit[1] & 0xff);
    }
    if (b->b_next)
        post("...");
}

long readvar(fd)
void *fd;
{
    long n = 0;
    int c;
    do
    {
        c = toolfile_getc(fd);
        if (c < 0)
            return (-1);
        n = (n << 7) | (c & 0x7f);
    }
    while (c & 0x80);
    return (n);
}

midiseq_readfrom(x, name, vol)
struct midiseq *x;
char *name;
t_symbol *vol;
{
    long jitter = 0;
    long timebase = TIMEBASE;
    int tempo = DEFTEMPO;
    long ticpersec, type;
    int oldfile, wasex = 0;
    void *fd;
    if (getfiletype(name, vol, &type))
    {
        post("%s: can't open", name);
        return;
    }
    if (type != '9n8n' && type != 'Midi')
    {
        post("%s: not a MIDI file", name);
        return;
    }
    oldfile = (type == '9n8n');
    if (fd = toolfile(name, vol, 0L))
    {
        struct msevt *e;
        int i;
        long lx;
        if (!oldfile)
        {
            char *bag = "MThd", buf[8];
            short doo[3];
            for (i = 4; i--; bag++)
                if (*bag != toolfile_getc(fd))
                {
                    post("%s: bad midi file", name);
                    goto freeit;
                }
            if (toolfile_fread(fd, &lx, (long) sizeof(long)) < sizeof(long)
                || lx != 6 ||
                toolfile_fread(fd, doo, (long) sizeof(doo)) < sizeof(doo)
                || toolfile_fread(fd, buf,
                                  (long) sizeof(buf)) < sizeof(buf))
            {
                ouch("%s: bad midi file", name);
                goto freeit;
            }
            if (doo[0])
            {
                ouch("%s: sorry, I take single-track files only", name);
                goto freeit;
            }
            if (doo[2] & 0x8000)        /* SMPTE-like timebase */
            {
                int frames = -(doo[2] >> 8);
                int perframe = doo[2] & 0xff;
                timebase = frames * perframe;
            }
            else
                timebase = doo[2];      /* normal timebase */
            /* post("it's %d %d %d", doo[0], doo[1], doo[2]); */
        }
        ticpersec = (timebase * tempo) / 60;
        midiseq_clear(x);
        post("reading: %s", name);
        while (1)
        {
            int nextbyte, type;
            long df = readvar(fd);
            long dthi = (df < 1024 ? (df * 1024000L) / ticpersec :
                         1024 * ((df * 1000L) / ticpersec)) + jitter;
            long dt = dthi >> 10;
            if (df < 0 || dthi < 0)
                break;
            jitter = dthi & 1023;
            if ((nextbyte = toolfile_getc(fd)) == EOF)
                break;
            if (wasex && nextbyte != ENDEX)
                midiseq_byte(x, (char) ENDEX);
            while (dt > 0xffff)
            {
                e = insevent(x);
                e->e_shit[0] = NULLEVT;
                e->e_time = 0xffff;
                dt -= 0xffff;
            }
            if ((nextbyte & 0xf0) == 0xf0)
            {
                long len;
                if (nextbyte == SYSEX || nextbyte == ENDEX)
                {
                    len = readvar(fd);
                    x->t_ontime = dt;
                    x->t_nchar = 0;
                    if (nextbyte == SYSEX)
                        midiseq_byte(x, (char) SYSEX);
                    while (len--)
                    {
                        if ((nextbyte = toolfile_getc(fd)) == EOF
                            || (nextbyte & 0x80) && (len
                                                     || nextbyte != ENDEX))
                        {
                            midiseq_byte(x, (char) ENDEX);
                            goto freeit;
                        }
                        else
                            midiseq_byte(x, (char) nextbyte);
                    }
                    wasex = (nextbyte != ENDEX);
                }
                else
                {
                    toolfile_getc(fd);
                    len = readvar(fd);
                    while (len--)
                        toolfile_getc(fd);
                    e = insevent(x);
                    e->e_time = dt;
                    e->e_shit[0] = NULLEVT;
                    wasex = 0;
                }
            }
            else
            {
                if (nextbyte & 0x80)
                {
                    type = nextbyte;
                    if ((nextbyte = toolfile_getc(fd)) == EOF)
                        break;
                }
                e = insevent(x);
                e->e_time = dt;
                e->e_shit[0] = type & 0xff;
                e->e_shit[1] = nextbyte;
                if (THREEBYTE(type))
                    e->e_shit[2] = toolfile_getc(fd);
                wasex = 0;
            }
        }
      freeit:freeobject((t_object *) fd);
    }
    else
        post("%s: can't open", name);
}

midiseq_byte(x, b)
struct midiseq *x;
char b;
{
    struct msevt *e;
    int nc = x->t_nchar;
    post("put %d", b & 0xff);
    if (!nc)
    {
        e = insevent(x);
        e->e_time = x->t_ontime;
        x->t_ontime = 0;
    }
    else
        e = x->t_nextev - 1;
    e->e_shit[nc++] = b;
    x->t_nchar = (nc < 4 ? nc : 0);
}

void *binbuf();
void *midiseq_readascii(x, name, vol)
struct midiseq *x;
char *name;                     /* c string */
t_symbol *vol;
{
    void *buf;
    long t1 = 0, t2 = 0;
    int i, sysex = 0;
    long lx, tlast = 0;
    buf = binbuf();
    if (binbuf_read(buf, name, vol, 0))
    {
        readerror(name);
        freeobject((t_object *) buf);
        return;
    }
    midiseq_clear(x);
    while (1)
    {
        struct msevt *e;
        long time, type;
        long shit[3];
        long dt;
        struct atom a;
        if (binbuf_getlong(buf, &t1, &t2, &time))
            break;
        dt = time - tlast;
        tlast = time;
        if (binbuf_getlong(buf, &t1, &t2, &type))
            break;
        if (sysex || type == SYSEX)
        {
            if (sysex && (type & 0x80) && type != ENDEX)
                goto badfile;
            shit[0] = type;
            if (type != ENDEX)
            {
                sysex = 1;
                for (lx = 0; lx < 3; lx++)
                {
                    if (binbuf_getlong(buf, &t1, &t2, shit + lx))
                        goto badfile;
                    if (shit[lx] & 0x80)
                    {
                        shit[lx] = ENDEX;
                        sysex = 0;
                        break;
                    }
                }
            }
            else
                sysex = 0;
        }
        else
        {
            if (binbuf_getlong(buf, &t1, &t2, &shit[0]))
                goto badfile;
            if (THREEBYTE(type))
            {
                if (binbuf_getlong(buf, &t1, &t2, &shit[1]))
                    goto badfile;
            }
            if (type == NULLEVT)
                goto badfile;
        }
        while (dt > 0xffff)
            midiseq_put(x, 0xffffL, '\0'), dt -= 0xffffL;
        midiseq_put(x, dt, (char) type, (char) shit[0], (char) shit[1],
                    (char) shit[2]);
        if (binbuf_getsemi(buf, &t1, &t2))
            goto badfile;
    }
    freeobject((t_object *) buf);
    return;
  badfile:
    ouch("bad MIDI file (truncated)");
    freeobject((t_object *) buf);
}

midiseq_put(x, dt, x1, x2, x3, x4)
struct midiseq *x;
long dt;
char x1, x2, x3, x4;
{
    struct msevt *e = insevent(x);
    e->e_shit[0] = x1;
    e->e_shit[1] = x2;
    e->e_shit[2] = x3;
    e->e_shit[3] = x4;
    e->e_time = dt;
}

extern Point SFGwhere;
extern Point SFPwhere;
extern SFReply reply;

/* <a> the old midiseq_read, _write, _writeold methods fixed to queue up the request.
Replaced by midiseq_rw which queues the reauest and _qfn which does the work. */

void *midiseq_rw(x, s, ac, av)
struct midiseq *x;
struct symbol *s;
struct atom *av;
{
    if (s == &s_read)
        x->t_filecmd = 0;
    else if (s == &s_write)
        x->t_filecmd = 1;
    else if (s == &s_writeold)
        x->t_filecmd = 2;
    qelem_set(x->t_qelem);
}

void *midiseq_qfn(x)
struct midiseq *x;
{
    if (!x->t_filecmd)
    {
        void *fd;
        SFTypeList types;
        char name[256];
        t_symbol *vol;
        long type;
        name[0] = 0;
        types[0] = '9n8n';
        types[1] = 'Midi';
        types[2] = 'TEXT';
        if (!getfile(name, &vol, &type, types, 3))
        {
            if (type == '9n8n' || type == 'Midi')
                midiseq_readfrom(x, name, vol);
            else
                midiseq_readascii(x, name, vol);
        }
    }
    else
    {
        char fn[256];
        t_symbol *vol;
        int bin = 1;
        if (x->t_sym)
            strcpy(fn, x->t_sym->s_name);
        else
            *fn = 0;
        if (getnewfile(fn, &vol, &bin))
            return;
        if (bin)
            midiseq_writeto(x, fn, vol, x->t_filecmd == 2);
        else
            midiseq_writeascii(x, fn, vol);
    }
}

static long wbytes;

writevar(fd, n)
void *fd;
long n;
{
    char buf[4], *bp = buf + 4, *ep = bp;
    n &= 0xfffffff;             /* force it to 28 bits maximum */
    *(--bp) = n & 0x7f;
    while (n >>= 7)
        *(--bp) = (n & 0x7f) | 0x80;
    while (bp < ep)
        wbytes++, toolfile_putc(fd, *(bp++));
}

static char hdr26[] = { 77, 84, 104, 100, 0, 0, 0, 6, 0, 0, 0, 1, 0, 96,
    77, 84, 114, 107, 0, 0, 0, 0
};

#define HSIZE 22
#define SIZEONSET 18

midiseq_writeto(x, name, vol, oldfile)
struct midiseq *x;
char *name;                     /* c string */
t_symbol *vol;
{
    void *fd = toolfile(name, vol, oldfile ? '9n8n' : 'Midi');
    if (fd)
    {
        long df = 0, jitter = 0;
        int i, sysex = 0, newex;
        struct msblock *b;
        post("writing: %s", name);
        if (!oldfile)
            toolfile_fwrite(fd, hdr26, (long) HSIZE);
        wbytes = 0;

        for (b = &x->t_block; b; b = b->b_next)
        {
            struct msevt *e;
            int n = (b->b_next ? BLK : x->t_ninlast);
            for (e = b->b_e; n--; e++)
            {
                unsigned char status = e->e_shit[0];
                long big = (e->e_time > 60000 ?
                            ((e->e_time * 1024L) / 125) * 24 :
                            (e->e_time * (24 * 1024L)) / 125) + jitter;
                long petit = big >> 10;
                jitter = big & 1023;
                df += petit;
                if (status == NULLEVT)
                    continue;
                writevar(fd, df);

                if (newex = (status == SYSEX))
                    sysex = 1;
                if (sysex)
                {
                    unsigned char *sp = e->e_shit + newex, *ep =
                        e->e_shit + 4;
                    long nbytes = 0, stopex = 0;
                    for (; sp < ep; sp++)
                    {
                        nbytes++;
                        if (*sp == ENDEX)
                        {
                            sysex = 0;
                            break;
                        }
                    }
                    wbytes += nbytes + 1;
                    toolfile_putc(fd, newex ? (char) SYSEX : (char) ENDEX);
                    writevar(fd, nbytes);
                    for (sp = e->e_shit + newex; nbytes--; sp++)
                        toolfile_putc(fd, *sp);
                }
                else
                {
                    wbytes += 2;
                    toolfile_putc(fd, status);
                    toolfile_putc(fd, e->e_shit[1]);
                    if (THREEBYTE(status))
                        wbytes++, toolfile_putc(fd, e->e_shit[2]);
                }
                df = 0;
            }
        }
        writevar(fd, df);       /* write out end of track */
        wbytes += 3;
        toolfile_putc(fd, 0xff);
        toolfile_putc(fd, 0x2f);
        toolfile_putc(fd, 0x00);
        if (!oldfile)
        {
            toolfile_seek(fd, (long) SIZEONSET);
            toolfile_fwrite(fd, &wbytes, (long) sizeof(wbytes));
        }
        freeobject((t_object *) fd);
    }
    else
        post("%s: can't create", name);
}

#ifdef EXPERIMENT
void *midiseq_hook(x, tempo)
struct midiseq *x;
float tempo;
{
    long df = 0;
    int i, sysex = 0;
    struct msblock *b;
    float error = 0;
    for (b = &x->t_block; b; b = b->b_next)
    {
        struct msevt *e;
        int n = (b->b_next ? BLK : x->t_ninlast);
        for (e = b->b_e; n--; e++)
        {
            e->e_time *= tempo;
        }
    }
}
#endif

midiseq_writeascii(x, fn, vol)
struct midiseq *x;
char *fn;
t_symbol *vol;
{
    void *buf = binbuf();
    long df = 0;
    int i, sysex = 0;
    struct msblock *b;
    for (b = &x->t_block; b; b = b->b_next)
    {
        struct msevt *e;
        int n = (b->b_next ? BLK : x->t_ninlast);
        for (e = b->b_e; n--; e++)
        {
            df = df + e->e_time;
            if (e->e_shit[0] == NULLEVT)
                continue;
            if (e->e_shit[0] == SYSEX)
                sysex = 1;
            if (sysex)
            {
                struct atom at;
                unsigned char *sp = e->e_shit, *ep = sp + 4;
                at.a_type = A_LONG;
                at.a_w.w_long = df;
                binbuf_insq(buf, 1, &at, 1);
                for (; sp < ep; sp++)
                {
                    at.a_w.w_long = *sp;
                    binbuf_insq(buf, 1, &at, 1);
                    if (*sp == ENDEX)
                    {
                        sysex = 0;
                        break;
                    }
                }
                at.a_type = A_SEMI;
                binbuf_insq(buf, 1, &at, 1);
            }
            else if (THREEBYTE(e->e_shit[0]))
                vfun(buf, binbuf_insert, NIL, "llll", df,
                     e->e_shit[0] & 0xffL, e->e_shit[1] & 0xffL,
                     e->e_shit[2] & 0xffL);
            else
                vfun(buf, binbuf_insert, NIL, "lll", df,
                     e->e_shit[0] & 0xffL, e->e_shit[1] & 0xffL);
        }
    }
    binbuf_write(buf, fn, vol, 0);
    freeobject((t_object *) buf);
}

void *midiseq_delay(x, n)
struct midiseq *x;
long n;
{
    if (!x->t_block.b_next && !x->t_ninlast)
        warn("seq: empty");
    else if (n >= 65535)
        error("seq: delay limited to 65535");
    else
    {
        int i = 1, lim = (x->t_block.b_next ? BLK : x->t_ninlast);
        x->t_block.b_e[0].e_time = n;
        while (i < lim && !x->t_block.b_e[i].e_shit[0])
            x->t_block.b_e[i].e_time = 0;
    }
}

void *midiseq_free(x)
struct midiseq *x;
{
    midiseq_clear(x);
    freeobject((t_object *) x->t_clock);
    qelem_free(x->t_qelem);
}

struct object *midiseq_freelist = 0;
struct class midiseq_class =
    { &s_seq, &midiseq_freelist, midiseq_free, sizeof(struct midiseq) };
struct messlist midiseq_messlist[] = {
    { (struct symbol *) &midiseq_class },
    { &s_int, midiseq_int, { A_LONG, 0} },
    { &s_start, midiseq_start, { A_DEFLONG, 0} },
    { &s_tick, midiseq_tick, { 0} },
    { &s_bang, midiseq_bang, { 0} },
    { &s_delay, midiseq_delay, { A_LONG, 0} },
    { &s_print, midiseq_print, { 0} },
    { &s_stop, midiseq_stop, { 0} },
    { &s_record, midiseq_record, { 0} },
    { &s_append, midiseq_append, { 0} },
    { &s_read, midiseq_rw, { A_GIMME, 0} },
    { &s_write, midiseq_rw, { A_GIMME, 0} },
    { &s_writeold, midiseq_rw, { A_GIMME, 0} },
#ifdef EXPERIMENT
    { &s_hook, midiseq_hook, { A_FLOAT, 0} },
#endif
    { &s_float, stdfloat, { A_FLOAT, 0} },
    0L
};

void *outlet(), *qelem();
void *midiseq(s, argc, argv)
struct symbol *s;
struct atom *argv;
{
    struct midiseq *x = (struct midiseq *) newobject(midiseq_messlist);
    x->t_outlet = outlet(x, NIL, &s_int);
    x->t_clock = clock(x, midiseq_clk);
    x->t_play = x->t_record = x->t_follow = 0;
    x->t_block.b_next = 0;
    x->t_ninlast = 0;
    x->t_dirty = 0;
    x->t_sysex = 0;
    x->t_filecmd = 0;
    x->t_qelem = qelem(x, midiseq_qfn);
    if (argc && argv->a_type == A_SYM)
    {
        x->t_sym = argv->a_w.w_sym;
        midiseq_readfrom(x, x->t_sym->s_name, defvolume);
    }
    else
        x->t_sym = 0;
    return (x);
}

/* "follow". Simple score follower. */
struct skip {
    long s_time;
    int s_pitch;
};
#define NBACK 16                /* maximum a note can drift fwd */
#define NFWD 2                  /* default values for f_nfwd and f_ftime */
#define FTIME 150
struct follow {
    struct midiseq f_m;         /* be a midi sequencer */
    void *f_outlet;
    int f_nfwd;                 /* willing to look NFWD notes forward */
    int f_ftime;                /* plus FTIME milliseconds */
    long f_n;
    long f_scoretime;
    long f_matchscoretime;
    long f_realtime;
    void *f_trickinlet;         /* invisible inlet */
    void *f_noteout;
    struct skip f_skip[NBACK];
    char f_oct;                 /* insensitive to octave errors */
    char f_pit;
    char f_got144;
};

void *follow_int(x, n)
struct follow *x;
long n;
{
    struct midiseq *y = &x->f_m;
    struct msevt *evwas = y->t_nextev, *lstwas = y->t_lastinblk;
    struct msblock *blkwas = y->t_curblk;
    long nwas = x->f_n, stwas = x->f_scoretime, newn;
    long tquit;
    int count = 0, gotem = 0, nskip = 0, i;
    struct skip newskip[NBACK], *eskip = newskip + NBACK, *sp, *sp2;
    int ftime = x->f_ftime;
    /* if recording fake a midi-note-on for the sequencer */
    if (y->t_record)
    {
        midiseq_int(y, 144L);
        midiseq_int(y, n & (0x7fL));
        midiseq_int(y, 60L);
        return;
    }
    else if (!y->t_follow)
        return;
    /* check against skip array */
    for (i = NBACK, sp = x->f_skip; i--; sp++)
    {
        if (sp->s_pitch)
        {
            /* if a skip is too old (score time skipped
               (commented out:) + real time elapsed since last match
               >= FTIME) then kill it */
            if (x->f_matchscoretime - sp->s_time
                /* + logicaltime - x->f_realtime  */
                >= ftime)
                sp->s_pitch = 0;
            /* here's the payoff for the skip array:
               if the pitch is in the array eat it. */
            if (sp->s_pitch == n || x->f_oct &&
                (sp->s_pitch == n + 12 || sp->s_pitch == n - 12))
            {
                sp->s_pitch = 0;
                return;
            }
        }
    }
    sp = newskip;
    while (1)
    {
        struct msevt *e;
        if ((e = y->t_nextev) >= y->t_lastinblk)
        {
            goto restore;
        }
        if (gotem)              /* if already ate all the anytime-skippable notes */
        {
            if (x->f_scoretime > tquit)
            {
                goto restore;
            }
        }
        if (!((e->e_shit[0] & 0xf0) == NOTEON && e->e_shit[2]))
            bug("follow_check");
        /* break if got the good note */
        if (e->e_shit[1] == n || x->f_oct &&
            (e->e_shit[1] == n + 12 || e->e_shit[1] == n - 12))
            break;
        /* if you got NFWD notes already */
        if (!gotem && ++count > x->f_nfwd)
        {
            gotem = 1;
            tquit = x->f_scoretime + x->f_ftime;
        }
        /* put into skip array */
        sp->s_time = x->f_scoretime;
        sp->s_pitch = e->e_shit[1];
        nskip++;
        if (++sp >= eskip)
            sp = newskip;

        follow_fwd(x);
    }
    x->f_matchscoretime = x->f_scoretime;
    /* merge auto skip array with static one */
    sp2 = x->f_skip;
    eskip = sp2 + NBACK;
    for (; nskip < NBACK && sp2 < eskip; sp2++)
        if (sp2->s_pitch)
        {
            *(sp++) = *sp2;
            nskip++;
        }
    /* copy back to static one */
    eskip = sp;
    for (sp = newskip, sp2 = x->f_skip; sp < eskip;)
        *(sp2++) = *(sp++);
    for (eskip = x->f_skip + NBACK; sp2 < eskip;)
        (sp2++)->s_pitch = 0;
    /* set follower to point to the next event awaited */
    follow_fwd(x);
    /* record real time of most recent match */
    x->f_realtime = logicaltime;
    newn = x->f_n;
    while (newn > nwas)
        outlet_int(x->f_outlet, ++nwas);
    return;
  restore:
    /* if no match, restore state to what it was */
    y->t_nextev = evwas;
    y->t_lastinblk = lstwas;
    y->t_curblk = blkwas;
    x->f_n = nwas;
    x->f_scoretime = stwas;
}

void *follow_follow(x, n)
struct follow *x;
long n;
{
    struct midiseq *y = &x->f_m;
    midiseq_stop(x);
    follow_cskp(x);
    y->t_curblk = &y->t_block;
    y->t_nextev = y->t_block.b_e;
    y->t_lastinblk = y->t_curblk->b_e +
        (y->t_curblk->b_next ? BLK : y->t_ninlast);
    x->f_m.t_follow = 1;
    y->t_nextev--;
    x->f_n = -1;
    x->f_scoretime = x->f_matchscoretime = 0;
    follow_fwd(x);              /* scan to first note */
    x->f_realtime = logicaltime;
    while (n--)
        follow_fwd(x);
    outlet_int(x->f_outlet, x->f_n);
}

follow_fwd(x)
struct follow *x;
{
    struct midiseq *y = &x->f_m;
    if (y->t_nextev >= y->t_lastinblk)
    {
        post("still end of score");
        return;
    }
    x->f_n++;
    while (1)
    {
        struct msevt *e;
        if ((++y->t_nextev) >= y->t_lastinblk)
        {
            if (y->t_curblk = y->t_curblk->b_next)
                y->t_lastinblk = (y->t_nextev = y->t_curblk->b_e) +
                    (y->t_curblk->b_next ? BLK : y->t_ninlast);
            else
                return;
        }
        e = y->t_nextev;
        x->f_scoretime += e->e_time;
        if ((e->e_shit[0] & 0xf0) == NOTEON && e->e_shit[2])
        {
            return;
        }
    }
}

void *follow_next(x)
struct follow *x;
{
    struct msevt *e;
    follow_cskp(x);
    if (!x->f_m.t_follow)
        BAG("next: need to turn on follow");
    if ((e = x->f_m.t_nextev) < x->f_m.t_lastinblk)
    {
        if (!((e->e_shit[0] & 0xf0) == NOTEON && e->e_shit[2]))
            bug("follow_next");
        outlet_int(x->f_m.t_outlet, e->e_shit[0] & 0xffL);
        outlet_int(x->f_m.t_outlet, e->e_shit[1] & 0xffL);
        outlet_int(x->f_m.t_outlet, e->e_shit[2] & 0xffL);
        follow_fwd(x);
    }
    else
        post("end of score");
    x->f_realtime = logicaltime;
    x->f_matchscoretime = 0;
    outlet_int(x->f_outlet, x->f_n);
}

void *follow_print(x)
struct follow *x;
{
    post("score time %ld", x->f_scoretime);
}

void *follow_in1(x, n)
struct follow *x;
long n;
{
    if (n & 0x80)
    {
        if ((n & 0xf0) == 0x90)
            x->f_got144 = 1;
        else
            x->f_got144 = 0;
    }
    else if (x->f_got144 == 1)
    {
        x->f_pit = n;
        x->f_got144 = 2;
    }
    else if (x->f_got144 == 2)
    {
        outlet_int(x->f_noteout, x->f_pit & 0x7fL);
        x->f_got144 = 1;
    }
}

follow_cskp(x)                  /* clear skips */
struct follow *x;
{
    int count;
    for (count = 0; count < NBACK; count++)
        x->f_skip[count].s_pitch = 0;
}

void *follow_free(x)
struct follow *x;
{
    struct midiseq *y = &x->f_m;
    outlet_rm(y->t_outlet, x->f_trickinlet);
    freeobject((t_object *) x->f_trickinlet);
    midiseq_free(y);
    /* have to free the midiseq's outlet because
       we declared it ownerless */
    freeobject((t_object *) y->t_outlet);
}

struct object *follow_freelist = 0;
struct class follow_class =
    { &s_follow, &follow_freelist, follow_free, sizeof(struct follow) };
struct messlist follow_messlist[] = {
    { (struct symbol *) &follow_class },
    { &s_int, follow_int, { A_LONG, 0} },
    { &s_follow, follow_follow, { A_LONG, 0} },
    { &s_next, follow_next, { 0} },
    { &s_in1, follow_in1, { A_LONG, 0} },
    { &s_start, midiseq_start, { A_DEFLONG, 0} },
    { &s_delay, midiseq_delay, { A_LONG, 0} },
    { &s_stop, midiseq_stop, { 0} },
    { &s_record, midiseq_record, { 0} },
    { &s_append, midiseq_append, { 0} },
    { &s_bang, midiseq_bang, { 0} },
    { &s_read, midiseq_rw, { A_GIMME, 0} },
    { &s_write, midiseq_rw, { A_GIMME, 0} },
    { &s_writeold, midiseq_rw, { A_GIMME, 0} },
    { &s_dump, midiseq_dump, { 0} },
    { &s_print, midiseq_print, { 0} },
    { &s_float, stdfloat, { A_FLOAT, 0} },
    0
};

void *follow(s, argc, argv)
struct symbol *s;
struct atom *argv;
{                               /* copy of code for "oms" */
    struct follow *x = (struct follow *) newobject(follow_messlist);
    struct midiseq *y = &x->f_m;
    /* notice that this outlet has no owner
       (so that it isn't drawn); we'll get it to
       talk back to the follower to postprocess its output. */
    y->t_outlet = outlet(NIL, NIL, &s_int);
    y->t_clock = clock(x, midiseq_clk);
    y->t_play = y->t_record = y->t_follow = 0;
    y->t_block.b_next = 0;
    y->t_ninlast = 0;
    y->t_dirty = 0;
    y->t_sysex = 0;
    y->t_sym = 0;
    y->t_filecmd = 0;
    y->t_qelem = qelem(x, midiseq_qfn);
    x->f_oct = 0;
    if (argc && argv->a_type == A_SYM &&
        !strcmp(argv->a_w.w_sym->s_name, "-o"))
    {
        x->f_oct = 1;
        argc--;
        argv++;
    }
    if (argc)
    {
        if (argv->a_type == A_SYM)
        {
            y->t_sym = argv->a_w.w_sym;
            midiseq_readfrom(y, y->t_sym->s_name, defvolume);
        }
        else
            post("follow: bad filename");
    }
    /* and follower-specific: */
    x->f_nfwd = NFWD;
    x->f_ftime = FTIME;
    if (argc >= 2)
    {
        if ((++argv)->a_type == A_LONG)
        {
            if ((x->f_nfwd = argv->a_w.w_long) < 0)
                x->f_nfwd = 0;
        }
        else
            post("follow: third arg needs an integer");
    }
    if (argc >= 3)
    {
        if ((++argv)->a_type == A_LONG)
            x->f_ftime = argv->a_w.w_long;
        else
            post("follow: fourth arg needs an integer");
    }
    x->f_pit = x->f_got144 = 0;
    x->f_noteout = outlet(x, NIL, &s_int);
    x->f_outlet = outlet(x, NIL, &s_int);
    follow_cskp(x);
    /* send midiseq's output back to follower */
    x->f_trickinlet = inlet(NIL, x, &s_int, &s_in1);
    outlet_add(y->t_outlet, x->f_trickinlet);
    return (x);
}
