#ifndef lint
static char rcsid[] =
    "$Revision: 2.8 $ IRCAM $Date: 1994/01/04 18:05:36 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.8 $ IRCAM $Date: 1994/01/04 18:05:36 $
 *
 * max_expr.c -- the expr module for MAX
 *
 */

#define MAXMAX

typedef void *t_wind;
#include "m_mess.h"
#include "p_table.h"
#include "x_vexp.h"

/* CHANGE what is the maximum number of arguments of an object? */
#define MAXBUF  256

struct tabwind *find_tab(char *tbl);
void expr_freefun(struct expr *x);
void expr_int(struct expr *x, long int n), expr_float(struct expr *x,
                                                      double f),
expr_bang(struct expr *x), expr_list(struct expr *x, struct symbol *s,
                                     int argc, struct atom *argv),
*expr_in1(struct expr *x, long int n), *expr_in2(struct expr *x, long int n), *expr_in3(struct expr *x, long int n),
*expr_in4(struct expr *x, long int n), *expr_in5(struct expr *x, long int n), *expr_in6(struct expr *x, long int n),
*expr_in7(struct expr *x, long int n), *expr_in8(struct expr *x, long int n), *expr_in9(struct expr *x, long int n),
*expr_in1(struct expr *x, long int n), *expr_ft1(struct expr *x, double n), *expr_ft2(struct expr *x, double n),
*expr_ft3(struct expr *x, double n), *expr_ft4(struct expr *x, double n), *expr_ft5(struct expr *x, double n), *expr_ft6(struct expr *x,
                                                            double n),
*expr_ft7(struct expr *x, double n), *expr_ft8(struct expr *x, double n), *expr_ft9(struct expr *x, double n), *expr_ft1(struct expr *x,
                                                            double n);

extern struct symbol s_expr, s_params, s_, s_float, s_symbol,
    s_in1, s_in2, s_in3, s_in4, s_in5, s_in6, s_in7, s_in8, s_in9,
    s_ft1, s_ft2, s_ft3, s_ft4, s_ft5, s_ft6, s_ft7, s_ft8, s_ft9,
    s_sm1, s_sm2, s_sm3, s_sm4, s_sm5, s_sm6, s_sm7, s_sm8, s_sm9;

extern void *tabwind_class;
void *outlet(void *op, struct symbol *s2), *inlet(void *op, void *who,
                                                  struct symbol *s1,
                                                  struct symbol *s2);

void *expr_class;

int argstostr(int argc, struct atom *argv, char *buf, int size);
int expr_integer(struct expr *x, long int n, int in);
int expr_flt(struct expr *x, double n, int in);
int expr_lst(struct expr *x, int in, int argc, struct atom *argv);



/*
 * CHANGE the following two arrays are also declared in obj1.c
 */
static struct symbol *fixsyms[MAX_VARS] =
    { &s_in1, &s_in2, &s_in3, &s_in4, &s_in5, &s_in6, &s_in7, &s_in8,
&s_in9 };
static struct symbol *floatsyms[MAX_VARS] =
    { &s_ft1, &s_ft2, &s_ft3, &s_ft4, &s_ft5, &s_ft6, &s_ft7, &s_ft8,
&s_ft9 };
static struct symbol *symsyms[MAX_VARS] =
    { &s_sm1, &s_sm2, &s_sm3, &s_sm4, &s_sm5, &s_sm6, &s_sm7, &s_sm8,
&s_sm9 };

void expr_freefun(struct expr *x)
{
    int i;
    struct ex_ex *eptr;

    if (x->exp_stack)
        DisposHandle(x->exp_stack);
}

void expr_int(struct expr *x, long int n)
{
    expr_integer(x, n, 0);
    expr_bang(x);
}

void expr_float(struct expr *x, double f)
{
    expr_flt(x, f, 0);
    expr_bang(x);
}

void expr_symbol(struct expr *x, t_symbol *s)
{
    expr_sym(x, s, 0);
    expr_bang(x);
}

void
expr_list(struct expr *x, struct symbol *s, int argc, struct atom *argv)
{
    expr_lst(x, 0, argc, argv);
    expr_bang(x);
}

void expr_bang(struct expr *x)
{
    if (!ex_eval(x, *x->exp_stack, &x->exp_res))
        return;

    switch (x->exp_res.ex_type)
    {
    case ET_INT:
        outlet_int(x->exp_outlet, x->exp_res.ex_int);
        break;
    case ET_FLT:
        /* CHANGE do we need a setfloat_outlet here */
        outlet_float(x->exp_outlet, x->exp_res.ex_flt);
        break;
    case ET_SYM:
        /* CHANGE this will have to be taken care of */
    default:
        post("expr_bang: unrecognized result %ld", x->exp_res.ex_type);
    }
}

/*
 * argstostr -- transform the argc,argv argument pair of max that is
 *    passed to the creation function of an object to a string
 */
argstostr(int argc, struct atom *argv, char *buf, int size)
/* number of argument */
/* argument array */
/* the string buffer */
{
    char *p = buf;
    char *s;
    int i;

    if (size <= 0)
    {
        post("argstostr: bad size");
        return;
    }

    *p = 0;
    i = 0;
    while (argc--)
    {
        switch (argv->a_type)
        {
        case A_NOTHING:
        case A_DEFSYM:
            break;
            /*
             * CHANGE check if DEFLONG can be here
             */
        case A_DEFLONG:
        case A_LONG:
            sprintf(p, "%ld ", argv->a_w.w_long);
            while (*p)
            {
                if (++i >= size)
                {
                    *p = 0;
                    post("argstostr: args truncated");
                    return;
                }
                p++;
            }
            break;
        case A_DEFFLOAT:
        case A_FLOAT:
            t_ftoa(argv->a_w.w_float, p);
            while (*p)
            {
                if (++i >= size)
                {
                    *p = 0;
                    post("argstostr: args truncated");
                    return;
                }
                p++;
            }
            break;
        case A_SYM:
            s = argv->a_w.w_sym->s_name;
            while (*p = *s++)
            {
                if (++i >= size - 1)
                {
                    *p = 0;
                    post("argstostr: args truncated");
                    return;
                }
                p++;
            }
            *p++ = ' ';
            i++;
            *p = 0;
            break;
        case A_SEMI:
            i += 2;
            if (i >= size)
            {
                post("argstostr: args truncated");
                return;
            }
            *p++ = ';';
            *p++ = ' ';
            *p = 0;
            break;
        case A_COMMA:
            i += 2;
            if (i >= size)
            {
                post("argstostr: args truncated");
                return;
            }
            *p++ = ',';
            *p++ = ' ';
            *p = 0;
            break;
        case A_DOLLAR:
            i += 2;
            if (i >= size)
            {
                post("argstostr: args truncated");
                return;
            }
            *p++ = '$';
            *p++ = ' ';
            *p = 0;
            break;
        case A_OBJ:
        case A_GIMME:
        case A_CANT:
        default:
            post("argstostr: wrong type %ld", argv->a_type);
        }
        argv++;
    }
}

expr_integer(struct expr *x, long int n, int in)
{
    if (in > MAX_VARS)
    {
        panic("expr_integer: inlet out of range %d", in + 1, 0, 0, 0, 0);
        return;
    }
    if (x->exp_var[in].ex_type == ET_II)
        x->exp_var[in].ex_int = n;
    else if (x->exp_var[in].ex_type == ET_FI)
        x->exp_var[in].ex_flt = n;
    else if (in)
        post("expr_integer: bad type for inlet %d", in + 1);
}

expr_flt(struct expr *x, double n, int in)
{
    if (in > MAX_VARS)
    {
        panic("expr_flt: inlet out of range %d", in + 1, 0, 0, 0, 0);
        return;
    }
    if (x->exp_var[in].ex_type == ET_FI)
        x->exp_var[in].ex_flt = n;
    else if (x->exp_var[in].ex_type == ET_II)
        x->exp_var[in].ex_int = n;
    else if (in)
        post("expr_flt: bad type for inlet %d", in + 1);
}

expr_sym(struct expr *x, t_symbol *s, int in)
{
    if (in > MAX_VARS)
    {
        panic("expr_flt: inlet out of range %d", in + 1, 0, 0, 0, 0);
        return;
    }
    if (x->exp_var[in].ex_type == ET_SI)
        x->exp_var[in].ex_ptr = (char **) s;
    else if (in)
        post("expr_sym: bad type for inlet %d", in + 1);
}

expr_lst(struct expr *x, int in, int argc, struct atom *argv)
{
    if (in > MAX_VARS)
    {
        panic("expr_lst: inlet out of range %d", in + 1, 0, 0, 0, 0);
        return;
    }
    if (x->exp_var[in].ex_type == ET_SI)
    {
        if (argv->a_type != A_SYM)
            post("expr_lst: inlet %d expects a symbol", in + 1);
        else
            x->exp_var[in].ex_ptr = (char **) argv->a_w.w_sym;
    }
    else if (in)
        post("expr_lst: bad type for inlet %d", in + 1);
}

/*
 * int functions
 */

void *expr_in1(struct expr *x, long int n)
{
    expr_integer(x, n, 1);
}

void *expr_in2(struct expr *x, long int n)
{
    expr_integer(x, n, 2);
}

void *expr_in3(struct expr *x, long int n)
{
    expr_integer(x, n, 3);
}

void *expr_in4(struct expr *x, long int n)
{
    expr_integer(x, n, 4);
}

void *expr_in5(struct expr *x, long int n)
{
    expr_integer(x, n, 5);
}

void *expr_in6(struct expr *x, long int n)
{
    expr_integer(x, n, 6);
}

void *expr_in7(struct expr *x, long int n)
{
    expr_integer(x, n, 7);
}

void *expr_in8(struct expr *x, long int n)
{
    expr_integer(x, n, 8);
}

void *expr_in9(struct expr *x, long int n)
{
    expr_integer(x, n, 9);
}

/*
 * float functions
 */

void *expr_ft1(struct expr *x, double n)
{
    expr_flt(x, n, 1);
}

void *expr_ft2(struct expr *x, double n)
{
    expr_flt(x, n, 2);
}

void *expr_ft3(struct expr *x, double n)
{
    expr_flt(x, n, 3);
}

void *expr_ft4(struct expr *x, double n)
{
    expr_flt(x, n, 4);
}

void *expr_ft5(struct expr *x, double n)
{
    expr_flt(x, n, 5);
}

void *expr_ft6(struct expr *x, double n)
{
    expr_flt(x, n, 6);
}

void *expr_ft7(struct expr *x, double n)
{
    expr_flt(x, n, 7);
}

void *expr_ft8(struct expr *x, double n)
{
    expr_flt(x, n, 8);
}

void *expr_ft9(struct expr *x, double n)
{
    expr_flt(x, n, 9);
}

/*
 * list functions
 */

void *expr_sm1(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 1);
}

void *expr_sm2(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 2);
}

void *expr_sm3(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 3);
}

void *expr_sm4(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 4);
}

void *expr_sm5(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 5);
}

void *expr_sm6(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 6);
}

void *expr_sm7(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 7);
}

void *expr_sm8(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 8);
}

void *expr_sm9(struct expr *x, struct symbol *s)
{
    expr_sym(x, s, 9);
}

/*
 * functions for vexp
 */
#define ISTABLE(s, tw)          \
if (!s || !(tw = (struct tabwind *)s->s_thing)          \
    || ob_messlist(tw) != tabwind_class) {    \
optr->ex_type = ET_INT;         \
optr->ex_int = 0;         \
run_err("no such table '%s'", s->s_name);   \
return (1);           \
}

  /*
   * max_ex_tab -- evaluate this table access
   *     eptr is the name of the table and arg is the index we
   *     have to put the result in optr
   *     return 1 on error and 0 otherwise
   */
max_ex_tab(struct symbol *s, struct ex_ex *arg, struct ex_ex *optr)
/* table */
/* the argument */
/* the result pointer */
{
    struct tabwind *tw;
    long i;
    float rest;

    ISTABLE(s, tw);
    optr->ex_type = ET_INT;
    if (!tw->w_size)
    {
        optr->ex_int = 0;
        return (0);
    }
    switch (arg->ex_type)
    {
    case ET_INT:
        optr->ex_int = (*tw->w_tab)[arg->ex_int % tw->w_size];
        break;
    case ET_FLT:
        /* CHANGE are we zero based or one based? */
        i = (int) arg->ex_flt % tw->w_size;
        optr->ex_int = (*tw->w_tab)[i];
        if (i == tw->w_size - 1)
            break;
        /*
         * if the argument is float and it is not at the end of
         * the table do a interpolation with the fraction 
         */
        rest = arg->ex_flt - (int) arg->ex_flt;
        optr->ex_int += (int)
            ((float) ((*tw->w_tab)[i] - (*tw->w_tab)[i + 1]) * rest);
        break;
    default:                    /* do something with strings */
        run_err("bad argument for table '%s'", s->s_name);
        return (1);
    }
    return (0);
}

/*
 * find_tab -- find a pointer to a tabwind struct for this table
 * CHANGE -- this function is obsolete now
 */
struct tabwind *find_tab(char *tbl)
{
    struct symbol *s;
    struct tabwind *tw;

    if (!tbl)
    {
        panic("find_tab: bad table", 0, 0, 0, 0, 0);
        return ((struct tabwind *) 0);
    }
    s = gensym(tbl);
    if (!s || !(tw = (struct tabwind *) s->s_thing)
        || ob_messlist(tw) != tabwind_class)
    {
        return ((struct tabwind *) 0);
    }
    return (tw);
}

/*
 * ex_size -- find the size of a table
 */
long ex_size(long int argc, struct ex_ex *argv, struct ex_ex *optr)
{
    struct symbol *s;
    struct tabwind *tw;

    if (argv->ex_type != ET_SYM)
    {
        run_err("expr: size: need a table name");
        optr->ex_type = ET_INT;
        optr->ex_int = 0;
        return (1);
    }
    s = (struct symbol *) argv->ex_ptr;
    ISTABLE(s, tw);
    optr->ex_type = ET_INT;
    optr->ex_int = tw->w_size;
}

long ex_tablesum(struct tabwind *tw, long int min, long int max)
{
    int i;
    long sum = 0;
    long *l;

    if (min < 0)
        min = 0;
    if (max > tw->w_size || max == -1)
        max = tw->w_size;
    for (i = min, l = &((*tw->w_tab)[i]); i < max; i++)
        sum += *l++;
    return (sum);
}

/*
 * ex_sum -- calculate the sum of all elements of a table
 */
long ex_sum(long int argc, struct ex_ex *argv, struct ex_ex *optr)
{
    struct symbol *s;
    struct tabwind *tw;

    if (argv->ex_type != ET_SYM)
    {
        run_err("expr: sum: need a table name");
        optr->ex_type = ET_INT;
        optr->ex_int = 0;
        return (1);
    }
    s = (struct symbol *) argv->ex_ptr;
    ISTABLE(s, tw);
    optr->ex_type = ET_INT;
    optr->ex_int = ex_tablesum(tw, (long) 0, (long) -1);
    return (0);
}

/*
 * ex_Sum -- calculate the sum of table with the given boundries
 */
long ex_Sum(long int argc, struct ex_ex *argv, struct ex_ex *optr)
{
    struct symbol *s;
    struct tabwind *tw;

    if (argv->ex_type != ET_SYM)
    {
        run_err("expr: Sum: need a table name");
        optr->ex_type = ET_INT;
        optr->ex_int = 0;
        return (1);
    }
    s = (struct symbol *) (argv++)->ex_ptr;
    ISTABLE(s, tw);
    if (argv->ex_type != ET_INT || argv[1].ex_type != ET_INT)
    {
        run_err("expr: Sum: boundries have to be fix values");
        optr->ex_type = ET_INT;
        optr->ex_int = 0;
        return (1);
    }
    optr->ex_type = ET_INT;
    optr->ex_int = ex_tablesum(tw, argv->ex_int, argv[1].ex_int);
    return (0);
}

/*
 * ex_avg -- calculate the avarage of a table
 */
long ex_avg(long int argc, struct ex_ex *argv, struct ex_ex *optr)
{
    struct symbol *s;
    struct tabwind *tw;

    if (argv->ex_type != ET_SYM)
    {
        run_err("expr: avg: need a table name");
        optr->ex_type = ET_INT;
        optr->ex_int = 0;
        return (1);
    }
    s = (struct symbol *) argv->ex_ptr;
    ISTABLE(s, tw);
    optr->ex_type = ET_INT;
    if (!tw->w_size)
        optr->ex_int = 0;
    else
        optr->ex_int = ex_tablesum(tw, (long) 0, (long) -1) / tw->w_size;
    return (0);
}


/*
 * ex_Avg -- calculate the avarage of table with the given boundries
 */
long ex_Avg(long int argc, struct ex_ex *argv, struct ex_ex *optr)
{
    struct symbol *s;
    struct tabwind *tw;

    if (argv->ex_type != ET_SYM)
    {
        run_err("expr: Avg: need a table name");
        optr->ex_type = ET_INT;
        optr->ex_int = 0;
        return (1);
    }
    s = (struct symbol *) (argv++)->ex_ptr;
    ISTABLE(s, tw);
    if (argv->ex_type != ET_INT || argv[1].ex_type != ET_INT)
    {
        run_err("expr: Avg: boundries have to be fix values");
        optr->ex_type = ET_INT;
        optr->ex_int = 0;
        return (1);
    }
    optr->ex_type = ET_INT;
    if (argv[1].ex_int - argv->ex_int <= 0)
        optr->ex_int = 0;
    else
        optr->ex_int = ex_tablesum(tw, argv->ex_int, argv[1].ex_int) /
            (argv[1].ex_int - argv->ex_int);
    return (0);
}

/*
 * ex_store -- store a value in a table
 *         if the index is greater the size of the table, we will make a modulo the
 *         size of the table
 */
long ex_store(long int argc, struct ex_ex *argv, struct ex_ex *optr)
{
    struct symbol *s;
    struct tabwind *tw;
    int index;

    if (argv->ex_type != ET_SYM)
    {
        run_err("expr: store: need a table name");
        return (1);
    }
    s = (struct symbol *) (argv++)->ex_ptr;
    ISTABLE(s, tw);
    if (argv->ex_type != ET_INT || argv[1].ex_type != ET_INT)
    {
        run_err("expr: store: arguments have to be integer");
        optr->ex_type = ET_INT;
        optr->ex_int = 0;
        return (1);
    }
    tabwind_fixfix(tw, argv->ex_int < 0 ? 0 : argv->ex_int % tw->w_size,
                   argv[1].ex_int);
    *optr = argv[1];
    return (0);
}


ex_getsym(char *p, struct symbol **s)
{
    *s = gensym(p);
    return (*s ? 0 : 1);
}

char *ex_symname(struct symbol *s)
{
    return (s->s_name);
}

#include <stdarg.h>
void panic(char *fmt, ...)
{
    va_list args;
    char msg[256];

    post("expr PANIC: ");
    va_start(args, fmt);
    post(fmt, args);
    va_end(args);
    /*
     * CHANGE what can we do here to stop execution?
     */
}

void syn_err(char *fmt, ...)
{
    va_list args;
    char msg[256];
    post("expr syn_err: ");
    va_start(args, fmt);
    post(fmt, args);
    va_end(args);
}

void run_err(char *fmt, ...)
{
    va_list args;
    post("expr: ");
    va_start(args, fmt);
    fmt = va_arg(args, char *);
    post(fmt, args);
    va_end(args);
}

void expr_setup()
{
    c_new(&s_expr, expr_freefun, sizeof(t_expr), 0, 0);
    c_addmess(expr_int, &s_int, A_LONG, 0);
    c_addmess(expr_float, &s_float, A_FLOAT, 0);
    c_addmess(expr_symbol, &s_symbol, A_SYM, 0);
    c_addmess(expr_bang, &s_bang, 0);
    c_addmess(expr_list, &s_symbol, A_GIMME, 0);
    c_addmess(expr_in1, &s_in1, A_LONG, 0);
    c_addmess(expr_in2, &s_in2, A_LONG, 0);
    c_addmess(expr_in3, &s_in3, A_LONG, 0);
    c_addmess(expr_in4, &s_in4, A_LONG, 0);
    c_addmess(expr_in5, &s_in5, A_LONG, 0);
    c_addmess(expr_in6, &s_in6, A_LONG, 0);
    c_addmess(expr_in7, &s_in7, A_LONG, 0);
    c_addmess(expr_in8, &s_in8, A_LONG, 0);
    c_addmess(expr_in9, &s_in9, A_LONG, 0);
    c_addmess(expr_ft1, &s_ft1, A_FLOAT, 0);
    c_addmess(expr_ft2, &s_ft2, A_FLOAT, 0);
    c_addmess(expr_ft3, &s_ft3, A_FLOAT, 0);
    c_addmess(expr_ft4, &s_ft4, A_FLOAT, 0);
    c_addmess(expr_ft5, &s_ft5, A_FLOAT, 0);
    c_addmess(expr_ft6, &s_ft6, A_FLOAT, 0);
    c_addmess(expr_ft7, &s_ft7, A_FLOAT, 0);
    c_addmess(expr_ft8, &s_ft8, A_FLOAT, 0);
    c_addmess(expr_ft9, &s_ft9, A_FLOAT, 0);
    c_addmess(expr_sm1, &s_sm1, A_SYM, 0);
    c_addmess(expr_sm2, &s_sm2, A_SYM, 0);
    c_addmess(expr_sm3, &s_sm3, A_SYM, 0);
    c_addmess(expr_sm4, &s_sm4, A_SYM, 0);
    c_addmess(expr_sm5, &s_sm5, A_SYM, 0);
    c_addmess(expr_sm6, &s_sm6, A_SYM, 0);
    c_addmess(expr_sm7, &s_sm7, A_SYM, 0);
    c_addmess(expr_sm8, &s_sm8, A_SYM, 0);
    c_addmess(expr_sm9, &s_sm9, A_SYM, 0);
}

/*
 * expr -- create a new expr object
 *  CHANGE -- how do we report errors
 */
void *expr_new(struct symbol *s, int argc, struct atom *argv)
{
    struct expr *x =
        (struct expr *) obj_new((t_messlist **) & expr_class, expr_setup);
    char buf[MAXBUF];
    char i;
    struct ex_ex *eptr;
    int mark = 0;

    x->exp_stack = (struct ex_ex **) 0;
    /*
     * CHANGE
     * what happens if the following is true
     */
    if (s == &s_)
        s = 0;
    /*
     * CHANGE what do we do if argc is zero
     */
    if (!argc)
        return ((void *) 0);

    argstostr(argc, argv, buf, MAXBUF);
    /*
     * CHANGE does newobject() clear all the bits of the newly created
     *    object?
     */
    eptr = x->exp_var;
    for (i = 0; i < MAX_VARS; i++, eptr++)
    {
        eptr->ex_type = 0;
        eptr->ex_int = 0;
    }

    if (ex_new(x, buf))
    {
        freeobject((t_object *) x);
        return (0);             /* CHANGE */
    }
    for (i = MAX_VARS - 1, eptr = &x->exp_var[MAX_VARS - 1]; i > 0;
         i--, eptr--)
    {
        switch (eptr->ex_type)
        {
        case 0:
            /* nothing is using this inlet */
            /* CHANGE check the second argument of inlet() */
            if (mark)
                inlet(x, x, &s_int, fixsyms[i - 1]);
            break;
        case ET_II:
            mark++;
            inlet(x, x, &s_int, fixsyms[i - 1]);
            break;
        case ET_FI:
            mark++;
            inlet(x, x, &s_float, floatsyms[i - 1]);
            break;
        case ET_SI:
            mark++;
            inlet(x, x, &s_symbol, symsyms[i - 1]);
            break;
        default:
            panic("expr: bad type (%lx) inlet = %d\n", eptr->ex_type, i, 0,
                  0, 0);
            break;
        }
    }
    x->exp_outlet = outlet(x, NIL);
    return ((void *) x);
}
