#ifndef lint
static char rcsid[] =
    "$Revision: 2.3 $ IRCAM $Date: 1993/11/19 10:52:10 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.3 $ IRCAM $Date: 1993/11/19 10:52:10 $
 *
 * FTS by Miller Puckette
 *
 */

#include "m_mess.h"
static char version[] = "bpe version 1.4  /zeep & nort, inc. 1991";
#define MAXLEN 64
extern t_symbol s_bpe;

typedef struct bpe {
    struct object f_ob;
    long f_cunt[2][MAXLEN];
    int f_cortlen;
    int f_cortcount;
    void *f_outlet2;
    void *f_outlet3;
} t_bpe;

void bpe_next(t_bpe * x);


/* accepts list*/
void bpe_list(struct bpe *x, struct symbol *s, int argc, struct atom *argv)
{
    int i, z, b;
    z = (argc > MAXLEN) ? MAXLEN : argc;
    if (z % 2 == 1)
    {
        post("bpe expects pairs of values in list");
        z--;
    }
    for (i = 0; i < z; i++)
        if (argv[i].a_type != A_LONG)
        {
            post("bad data type(s) in list");
            return;
        }
    for (b = 0, i = 0; i < z; i++, b++)
    {
        x->f_cunt[0][b] = argv[i++].a_w.w_long;
        x->f_cunt[1][b] = argv[i].a_w.w_long;
    }
    x->f_cortlen = b;
    x->f_cortcount = 0;
}

void bpe_bang(t_bpe *x)
{
    x->f_cortcount = 0;
    bpe_next(x);
}

void bpe_next(t_bpe *x)
{
    if (x->f_cortcount == x->f_cortlen)
        outlet_bang(x->f_outlet3);      /* done */
    else
    {
        outlet_int(x->f_outlet2, x->f_cunt[1][x->f_cortcount]);
        outlet_int(x->f_ob.o_outlet, x->f_cunt[0][x->f_cortcount++]);
    }
}

void *bpe_class;
void bpe_setup()
{
    c_new(&s_bpe, NIL, sizeof(t_bpe), 0, 0);
    c_addmess(bpe_list, gensym("list"), 0);
    c_addbang(bpe_bang);
    c_addmess(bpe_next, gensym("next"), 0);
    post("%s", version);
}

/* function to create one -- should return pointer to new instance */
void *bpe_new()
{
    int i;
    t_bpe *x = (t_bpe *) obj_new((t_messlist **) & bpe_class, bpe_setup);
    for (i = 0; i < MAXLEN; i++)
    {
        x->f_cunt[1][i] = 0L;
        x->f_cunt[0][i] = 0L;
    }
    x->f_cortlen = 0;
    x->f_cortcount = 0;
    x->f_outlet3 = outlet_new(x, &s_bang);      /* create 3rd outlet */
    x->f_outlet2 = outlet_new(x, &s_int);       /* create second outlet */
    outlet_new(x, &s_int);      /* create main outlet */
    return (x);
}
