#ifndef lint
static char rcsid[] =
    "$Revision: 2.3 $ IRCAM $Date: 1993/11/19 10:52:12 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.3 $ IRCAM $Date: 1993/11/19 10:52:12 $
 *
 * FTS by Miller Puckette
 *
 */


#include "m_mess.h"
#include "t_mac.h"              /* needed by patcher.h */
#include "p_patcher.h"          /* for CP_PUT, CP_UNPUT defs */

extern struct symbol s_key, s_keyup, s_setcp;
void *key_keyout, *keyup_keyout;

typedef struct key {
    struct object k_ob;
    int k_cpno;
} t_key;

void key_setcp(t_key *x, int n, int flags)
{
    if (flags & CP_UNPUT)
        x->k_cpno = -1;
    if (flags & CP_PUT)
        x->k_cpno = n;
}

void key_int(t_key *x, long int n)
{
    if (x->k_cpno >= 0)
        h_vmess(x, &s_int, "l", n);
}

void key_ff(t_key *x)
{
    outlet_rm(key_keyout, x);
}

void *key_class;
void key_setup()
{
    c_new(&s_key, key_ff, sizeof(t_key), 0, 1);
    c_addint(key_int);
    c_addmess(key_setcp, &s_setcp, A_CANT, 0);
}

void *key_new()
{
    t_key *x = (t_key *) obj_new((t_messlist **) & key_class, key_setup);
    if (!key_keyout)
        key_keyout = outlet(NIL, &s_int);
    outlet(x, &s_int);
    outlet_add(key_keyout, x);
    x->k_cpno = -1;
    return (x);
}

void keyup_ff(t_key *x)
{
    outlet_rm(keyup_keyout, x);
}

void *keyup_class;
void keyup_setup()
{
    c_new(&s_keyup, keyup_ff, sizeof(t_key), 0, 1);
    c_addint(key_int);
    c_addmess(key_setcp, &s_setcp, A_CANT, 0);
}

void *keyup_new()
{
    t_key *x =
        (t_key *) obj_new((t_messlist **) & keyup_class, keyup_setup);
    if (!keyup_keyout)
        keyup_keyout = outlet(NIL, &s_int);
    outlet(x, &s_int);
    outlet_add(keyup_keyout, x);
    x->k_cpno = -1;
    return (x);
}
