#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1994/01/04 18:06:12 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/01/04 18:06:12 $
 *
 * FTS by Miller Puckette
 *
 */

#include "m_mess.h"
extern struct symbol s_in1, s_in2, s_absval, s_drunk, s_set;
void *outlet(void *op, struct symbol *s2);

/*      correlated random generator  <quick and rather dirty>    */

#define MAXVAL  0x7FFF

typedef struct drunk {
    struct object d_ob;
    void *d_outlet;
    long d_reg;
    float d_scaler;
    long d_range;
} t_drunk;

void drunk_bang(struct drunk *x)        /*  output a value  */
{
    int offset = 1 + (int) (x->d_scaler * (0x7FFF & rand())), newval;
    if (x->d_reg > x->d_range)
        x->d_reg = x->d_range;
    else if (x->d_reg < 0)
        x->d_reg = 0;
    offset = (rand() & 512) ? -offset : offset;
    newval = offset + x->d_reg;
    if (newval < 0 || newval > x->d_range)
        newval = x->d_reg - offset;
    outlet_int(x->d_outlet, x->d_reg = newval);
}

void drunk_int(struct drunk *x, long int n)     /*   change correlation   */
{
    if (n < 0)
        n = 0;
    else if (n > x->d_range)
        n = x->d_range;
    outlet_int(x->d_outlet, x->d_reg = n);
}

void drunk_set(struct drunk *x, long int n)     /*   change current value (position in drunk walk)  */
{
    x->d_reg = n % x->d_range;
}

void drunk_in2(struct drunk *x, long int n)     /*   change correlation   */
{
    n = (n > x->d_range / 2L) ? (x->d_range / 2L) : n;
    x->d_scaler = (float) n / MAXVAL;
}

void drunk_in1(struct drunk *x, long int n)     /*  change range -- msp  */
{
    if (n <= 0)
        n = 1;
    x->d_range = n;
    if (x->d_reg >= n)
        x->d_reg = n - 1;
}

void *drunk_class;
void drunk_setup()
{
    c_new(&s_drunk, NIL, sizeof(t_drunk), 0, 0);
    c_addbang(drunk_bang);
    c_addint(drunk_int);
    c_addmess(drunk_set, &s_set, A_LONG, 0);
    c_addfloat(stdfloat);
    c_addinx(drunk_in1, 1);
    c_addinx(drunk_in2, 2);
}

void *drunk_new(long int range, long int correlation)
{
    struct drunk *x =
        (struct drunk *) obj_new((t_messlist **) & drunk_class,
                                 drunk_setup);
    x->d_outlet = outlet(x, &s_int);
    inlet(x, x, &s_int, &s_in2);        /* set correlation */
    inlet(x, x, &s_int, &s_in1);        /* set range */
    if (range <= 0)
        range = 128;
    if (correlation <= 0)
        correlation = 1;
    correlation = (correlation > range / 2L) ? (range / 2L) : correlation;
    x->d_scaler = (float) correlation / MAXVAL;
    x->d_reg = range / 2L;
    x->d_range = range;
    return (x);
}

typedef struct absval {
    struct object a_ob;
    void *a_outlet;
} t_absval;

/*  known as abs   and returns  the absolute value  */
void absval_int(struct absval *x, long int n)
{
    outlet_int(x->a_outlet, (long) abs((int) n));
}

void *absval_class;
void absval_setup()
{
    c_new(&s_absval, NIL, sizeof(t_absval), 0, 0);
    c_addint(absval_int);
    c_addfloat(stdfloat);
}

void *absval_new()
{
    struct absval *x =
        (struct absval *) obj_new((t_messlist **) & absval_class,
                                  absval_setup);
    x->a_outlet = outlet(x, &s_int);
    return (x);
}
