#ifndef lint
static char rcsid[] =
    "$Revision: 2.5 $ IRCAM $Date: 1994/01/04 18:06:14 $";
#endif

/*
 *                      Copyright (c) 1993 by IRCAM
 *                          All rights reserved.
 *
 *  For any information regarding this and other IRCAM software, please
 *  send email to:
 *                              manager@ircam.fr
 *
 *      $Revision: 2.5 $ IRCAM $Date: 1994/01/04 18:06:14 $
 *
 * FTS by Miller Puckette
 *
 */


/* modified by DDZ to parse/format polyphonic aftertouch a0 messages */

#include "m_mess.h"

#define NOTEOFF 0x80
#define NOTEON 0x90
#define POLY 0xA0
#define CTL 0xB0
#define PGM 0xC0
#define TOUCH 0xD0
#define BEND 0xE0


extern struct symbol s_midiparse;

void *outlet(void *op, struct symbol *s2);

typedef struct midiparse {
    struct object m_obj;
    void *m_outlet1;            /* note on  */
    void *m_outlet1a;           /* poly touch */
    void *m_outlet2;            /* ctl change  */
    void *m_outlet3;            /* prog change  */
    void *m_outlet4;            /* after touch  */
    void *m_outlet5;            /* pitch bend  */
    void *m_outlet6;            /* channel no. */
    long m_status;
    long m_byte1;
} t_midiparse;


void midiparse_bang(struct midiparse *x)        /*   RESET   PARSER   */
{
    x->m_status = 0;
    x->m_byte1 = 0;
}

void midiparse_int(struct midiparse *x, long int byte)
{
    struct atom shit[2];
    if (byte > 127)
    {                           /*   status byte here   ?   */
        x->m_status = byte & 0xFFL;
        return;
    }

    switch (x->m_status & 0xF0L)
    {
    case CTL:
        if (!x->m_byte1)
            x->m_byte1 = byte & 0x7F;
        else
        {
            outlet_int(x->m_outlet6, 1 + (x->m_status & 0xF));
            SETLONG(shit, x->m_byte1);
            SETLONG(shit + 1, byte & 0x7F);
            outlet_list(x->m_outlet2, NIL, 2, shit);
            x->m_byte1 = 0;
        }
        return;
    case POLY:
        if (!x->m_byte1)
            x->m_byte1 = byte & 0x7F;
        else
        {
            outlet_int(x->m_outlet6, 1 + (x->m_status & 0xF));
            SETLONG(shit, x->m_byte1);
            SETLONG(shit + 1, byte & 0x7F);
            outlet_list(x->m_outlet1a, NIL, 2, shit);
            x->m_byte1 = 0;
        }
        return;
    case BEND:
        if (!x->m_byte1)
            x->m_byte1 = 1;
        else
        {
            outlet_int(x->m_outlet6, 1 + (x->m_status & 0xF));
            outlet_int(x->m_outlet5, byte & 0x7F);
            x->m_byte1 = 0;
        }
        return;
    case TOUCH:
        outlet_int(x->m_outlet6, 1 + (x->m_status & 0xF));
        outlet_int(x->m_outlet4, byte & 0x7F);
        return;
    case NOTEON:
        if (!x->m_byte1)
            x->m_byte1 = byte & 0x7F;
        else
        {
            outlet_int(x->m_outlet6, 1 + (x->m_status & 0xF));
            SETLONG(shit, x->m_byte1);
            SETLONG(shit + 1, byte & 0x7F);
            outlet_list(x->m_outlet1, NIL, 2, shit);
            x->m_byte1 = 0;
        }
        return;
    case PGM:
        outlet_int(x->m_outlet6, 1 + (x->m_status & 0xF));
        outlet_int(x->m_outlet3, byte & 0x7F);
        return;
    case NOTEOFF:
        if (!x->m_byte1)
            x->m_byte1 = byte & 0x7F;
        else
        {
            outlet_int(x->m_outlet6, 1 + (x->m_status & 0xF));
            SETLONG(shit, x->m_byte1);
            SETLONG(shit + 1, 0L);
            outlet_list(x->m_outlet1, NIL, 2, shit);
            x->m_byte1 = 0;
        }
        return;
    }
}

void *midiparse_class;
void midiparse_setup()
{
    c_new(&s_midiparse, NIL, sizeof(t_midiparse), 0, 0);
    c_addbang(midiparse_bang);
    c_addint(midiparse_int);
    c_addfloat(stdfloat);
}

void *midiparse_new(long int dummy)
{
    struct midiparse *x =
        (struct midiparse *) obj_new((t_messlist **) & midiparse_class,
                                     midiparse_setup);
    x->m_outlet6 = outlet(x, &s_int);
    x->m_outlet5 = outlet(x, &s_int);
    x->m_outlet4 = outlet(x, &s_int);
    x->m_outlet3 = outlet(x, &s_int);
    x->m_outlet2 = outlet(x, NIL);
    x->m_outlet1a = outlet(x, NIL);
    x->m_outlet1 = outlet(x, NIL);
    x->m_status = 0L;
    x->m_byte1 = 0L;
    return (x);
}

/*  --------------------------------------------------------------- */

#define ZKSCALER .1875
#define MIDIRANGE 128

extern struct symbol s_midiformat,
    s_in1, s_in2, s_in3, s_in4, s_in5, s_in6, s_in7;

void *inlet(void *op, void *who, struct symbol *s1, struct symbol *s2);

typedef struct midiformat {
    struct object u_obj;
    void *u_outlet;
    /* DDZ -- this order makes no sense! */
    void *u_inlet2;             /* prog change  */
    void *u_inlet3;             /* ctrl change  */
    void *u_inlet4;             /* after touch  */
    void *u_inlet5;             /* pitch bend  */
    void *u_inlet5a;            /* poly touch */
    void *u_inlet6;             /* channel no.  */
    long u_poly;
    long u_noteon;
    long u_ctl;
    long u_prog;
    long u_touch;
    long u_bend;
    long u_channel;
} t_midiformat;

void midiformat_in1(struct midiformat *x, struct symbol *s, int ac, struct atom *av)    /*   note on/off   */
{
    if (ac < 2)
        return;
    outlet_int(x->u_outlet, x->u_noteon);
    if (av->a_type == A_LONG)
        outlet_int(x->u_outlet, av->a_w.w_long);
    else if (av->a_type == A_FLOAT)
        outlet_int(x->u_outlet, (long) (av->a_w.w_float));
    else
        outlet_int(x->u_outlet, 0L);
    av++;
    if (av->a_type == A_LONG)
        outlet_int(x->u_outlet, av->a_w.w_long);
    else if (av->a_type == A_FLOAT)
        outlet_int(x->u_outlet, (long) (av->a_w.w_float));
    else
        outlet_int(x->u_outlet, 0L);
}

void midiformat_in2(struct midiformat *x, struct symbol *s, int ac, struct atom *av)    /*   ctl change   */
{
    if (ac < 2)
        return;
    outlet_int(x->u_outlet, x->u_ctl);
    if (av->a_type == A_LONG)
        outlet_int(x->u_outlet, av->a_w.w_long);
    else if (av->a_type == A_FLOAT)
        outlet_int(x->u_outlet, (long) (av->a_w.w_float));
    else
        outlet_int(x->u_outlet, 0L);
    av++;
    if (av->a_type == A_LONG)
        outlet_int(x->u_outlet, av->a_w.w_long);
    else if (av->a_type == A_FLOAT)
        outlet_int(x->u_outlet, (long) (av->a_w.w_float));
    else
        outlet_int(x->u_outlet, 0L);
}

void midiformat_in3(struct midiformat *x, long int v1)  /*   prog change   */
{
    outlet_int(x->u_outlet, x->u_prog);
    outlet_int(x->u_outlet, v1);
}

void midiformat_in4(struct midiformat *x, long int v1)  /*   after touch   */
{
    outlet_int(x->u_outlet, x->u_touch);
    outlet_int(x->u_outlet, v1);
}

void midiformat_in5(struct midiformat *x, long int v1)  /*   bend   */
{
    outlet_int(x->u_outlet, x->u_bend);
    outlet_int(x->u_outlet, (v1 > 65) ? (long) (2 * (v1 - 64)) : 0L);
    outlet_int(x->u_outlet, v1);
}

void midiformat_in6(struct midiformat *x, long int v)   /*   set channel   */
{
    x->u_noteon = (x->u_noteon & 0xF0L) + (v = ((v - 1) & 0xFL));
    x->u_ctl = (x->u_ctl & 0xF0L) + v;
    x->u_prog = (x->u_prog & 0xF0L) + v;
    x->u_touch = (x->u_touch & 0xF0L) + v;
    x->u_bend = (x->u_bend & 0xF0L) + v;
    x->u_poly = (x->u_poly & 0xF0L) + v;
}

void midiformat_in1a(struct midiformat *x, struct symbol *s, int ac, struct atom *av)   /*   poly touch  */
{
    if (ac < 2)
        return;
    outlet_int(x->u_outlet, x->u_poly);
    if (av->a_type == A_LONG)
        outlet_int(x->u_outlet, av->a_w.w_long);
    else if (av->a_type == A_FLOAT)
        outlet_int(x->u_outlet, (long) (av->a_w.w_float));
    else
        outlet_int(x->u_outlet, 0L);
    av++;
    if (av->a_type == A_LONG)
        outlet_int(x->u_outlet, av->a_w.w_long);
    else if (av->a_type == A_FLOAT)
        outlet_int(x->u_outlet, (long) (av->a_w.w_float));
    else
        outlet_int(x->u_outlet, 0L);
}

void *midiformat_class;
void midiformat_setup()
{
    c_new(&s_midiformat, NIL, sizeof(t_midiformat), 0, 1);
    c_addmess(midiformat_in1, &s_in1, A_GIMME, 0);
    c_addmess(midiformat_in1a, &s_in2, A_GIMME, 0);
    c_addmess(midiformat_in2, &s_in3, A_GIMME, 0);
    c_addmess(midiformat_in3, &s_in4, A_LONG, 0);
    c_addmess(midiformat_in4, &s_in5, A_LONG, 0);
    c_addmess(midiformat_in5, &s_in6, A_LONG, 0);
    c_addmess(midiformat_in6, &s_in7, A_LONG, 0);
}

void *midiformat_new(long int channel)
{
    struct midiformat *x =
        (struct midiformat *) obj_new((t_messlist **) & midiformat_class,
                                      midiformat_setup);
    x->u_outlet = outlet(x, &s_int);

    inlet(x, x, &s_int, &s_in7);
    inlet(x, x, &s_int, &s_in6);
    inlet(x, x, &s_int, &s_in5);
    inlet(x, x, &s_int, &s_in4);
    inlet(x, x, &s_list, &s_in3);
    inlet(x, x, &s_list, &s_in2);
    inlet(x, x, &s_list, &s_in1);
    channel = (channel == 0) ? 1L : channel;
    x->u_noteon = 0x90L + (channel = ((channel - 1) & 0xFL));
    x->u_ctl = 0xB0L + channel;
    x->u_prog = 0xC0L + channel;
    x->u_touch = 0xD0L + channel;
    x->u_bend = 0xE0L + channel;
    x->u_poly = 0xA0L + channel;
    return (x);
}
